package org.gvsig.fmap.dal;

import java.util.Collection;
import org.gvsig.tools.observer.Observable;
import org.gvsig.tools.util.UnmodifiableBasicMap;

/**
 *
 * @author jjdelcerro
 */
public interface StoresRepository 
        extends 
            UnmodifiableBasicMap<String, DataStoreParameters>,
            Observable
    {
    
    public static final String NOTIFICATION_ADDREPOSITORY = "addRepository";
    public static final String NOTIFICATION_REMOVEREPOSITORY = "removeRepository";
    public static final String NOTIFICATION_ADD = "add";
    public static final String NOTIFICATION_REMOVE = "remove";
    

    public String getID();
    
    public String getLabel();
    
    public Collection<StoresRepository> getSubrepositories();
    
    public StoresRepository getSubrepository(String Id);
    
    public boolean addRepository(StoresRepository repository);

    public boolean removeRepository(String name);
    
    public void add(String name, DataStoreParameters parameters);
    
    public boolean contains(DataStoreParameters parameters);
    
    public void remove(String name);
    
    public DataStore getStore(String name);
    
}
