package org.gvsig.fmap.dal.complements;

import java.util.List;
import org.gvsig.fmap.dal.StoresRepository;
import org.gvsig.fmap.dal.feature.Feature;
import org.gvsig.fmap.dal.feature.FeatureQuery;
import org.gvsig.fmap.dal.feature.FeatureStore;
import org.gvsig.fmap.dal.feature.FeatureType;
import org.gvsig.tools.complement.Complement;
import org.gvsig.tools.dispose.Disposable;
import org.gvsig.tools.dynobject.Tagged;

/**
 *
 * @author jjdelcerro
 */
public interface RelatedFeatures extends Complement<Tagged> {

    public interface ContextRelatedFeatures extends Disposable {
        public ContextRelatedFeatures setStoresRepository(StoresRepository repository);
        public StoresRepository getStoresRepository();
        public FeatureStore getFeatureStore();
        public FeatureType getFeatureType();
    }
    
    public static final String COMPLEMENT_MANE = "DAL.RelatedFeatures";

    public static final String DAL_RELATED_UNIQUE_FIELD_NAME = "DAL.RelatedFeatures.Unique.Field.Name";
//    public static final String DAL_RELATED_FOREING_KEY_NAME = "DAL.RelatedFeatures.Foreing.Key.Name";
    public static final String DAL_RELATED_TABLE = "DAL.RelatedFeatures.Table";
    public static final String DAL_RELATED_COLUMNS = "DAL.RelatedFeatures.Columns";

    public ContextRelatedFeatures createContext();
    
//    public String getForeingKeyName();
    
    public String getUniqueKeyName();
    
    public String getTableName();
    
    public boolean isRelatedFeatures();
    
    public boolean isRelatedFeatures(ContextRelatedFeatures context);

//    public Object getForeingKey(ContextRelatedFeatures context, Feature feature);
    
    public Object getUniqueKey(ContextRelatedFeatures context, Feature feature);
    
    public List<String> getColumns(ContextRelatedFeatures context);

    public FeatureStore getFeatureStore(ContextRelatedFeatures context);
    
    public FeatureQuery getForeingKeyQuery(ContextRelatedFeatures context, Object codeValue);

    public FeatureQuery getUniqueKeyQuery(ContextRelatedFeatures context, Object codeValue);

}
