/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.gvsig.fmap.dal.complements;

import java.util.Comparator;
import java.util.List;
import java.util.function.Predicate;
import org.apache.commons.lang3.StringUtils;
import org.gvsig.fmap.dal.feature.FeatureAttributeDescriptor;
import org.gvsig.fmap.dal.feature.FeatureType;
import org.gvsig.tools.complement.Complement;
import org.gvsig.tools.dataTypes.DataTypes;

/**
 *
 * @author jjdelcerro
 */
public interface Search extends Complement<FeatureType> {

    public static final String COMPLEMENT_MANE = "DAL.Search";

    public static final String DAL_SEARCH_ATTRIBUTE_PRIORITY = "DAL.Search.Attribute.Priority";

    public static Predicate<FeatureAttributeDescriptor> BASIC_TYPES_FILTER = FeatureType.BASIC_TYPES_FILTER;
    public static Predicate<FeatureAttributeDescriptor> ALL_FILTER = FeatureType.ALL_FILTER;
    
    public static final Comparator<FeatureAttributeDescriptor> LABEL_ORDER = new Comparator<FeatureAttributeDescriptor>() {
        @Override
        public int compare(FeatureAttributeDescriptor o1, FeatureAttributeDescriptor o2) {
            return StringUtils.compareIgnoreCase(o1.getLabel(), o2.getLabel());
        }
    };

    public static final Comparator<FeatureAttributeDescriptor> STR_INT_LONG_LABEL_ORDER = new Comparator<FeatureAttributeDescriptor>() {
        @Override
        public int compare(FeatureAttributeDescriptor o1, FeatureAttributeDescriptor o2) {
            int t1 = o1.getType();
            int t2 = o2.getType();
            if (t1 == DataTypes.STRING) {
                if (t2 == DataTypes.STRING) {
                    return StringUtils.compareIgnoreCase(o1.getLabel(), o2.getLabel());
                }
                return -1;
            } else if (t2 == DataTypes.STRING) {
                return 1;
            }
            if (t1 == DataTypes.INT || t1 == DataTypes.LONG) {
                if (t2 == DataTypes.INT || t2 == DataTypes.LONG) {
                    return StringUtils.compareIgnoreCase(o1.getLabel(), o2.getLabel());
                }
                return -1;
            } else if (t2 == DataTypes.INT || t2 == DataTypes.LONG) {
                return 1;
            }
            return StringUtils.compareIgnoreCase(o1.getLabel(), o2.getLabel());
        }
    };


    public int getPriority(FeatureAttributeDescriptor attribute); 
    
    public List<String> getResultColumnNames();
    
    public interface OrderedAttribute {
        public static final int TYPE_REGURAL = 0;
        public static final int TYPE_RECENT = 1;
        public static final int TYPE_FAVORITE = 2;
        
        public FeatureAttributeDescriptor getDescriptor();
        public int getType();
    }
    public List<OrderedAttribute> getOrderedAttributes(
            Predicate<FeatureAttributeDescriptor> filter,
            Comparator<FeatureAttributeDescriptor> comparator,
            int max
    );

    public List<FeatureAttributeDescriptor> getFavorites();
    
}
