package org.gvsig.fmap.dal.feature;

import java.util.Collection;
import org.gvsig.timesupport.Interval;

public interface FeatureStoreTimeSupport extends FeatureAttributeEmulator {

    public String getAttributeName();
    
    public int getDataType();

    /**
     * Gets the {@link Interval} of the store, that means the temporal interval
     * where the store has valid data.
     *
     * @return a time interval or null if there is not time support
     */
    public Interval getInterval();

    /**
     * Gets all the possible values of time for which the store has data.
     *
     * @return a collection of {@link Time} objects.
     */
    public Collection getTimes();

    /**
     * Gets all the possible values of time for which the store has data and
     * intersects with an interval.
     *
     * @param interval the interval of time
     * @return a collection of {@link Time} objects.
     */
    public Collection getTimes(Interval interval);

}
