package org.gvsig.fmap.dal.store.h2;

import org.apache.commons.io.FilenameUtils;
import org.gvsig.fmap.dal.DataStore;
import org.gvsig.fmap.dal.exception.InitializeException;
import org.gvsig.fmap.dal.spi.DataServerExplorerProviderServices;
import org.gvsig.fmap.dal.spi.ZipResourcesStorage;
import org.gvsig.fmap.dal.store.jdbc.JDBCServerExplorerParameters;
import org.gvsig.fmap.dal.store.jdbc2.JDBCHelper;
import org.gvsig.fmap.dal.store.jdbc2.spi.JDBCServerExplorerBase;
import org.gvsig.tools.resourcesstorage.EmptyResourcesStorage;
import org.gvsig.tools.resourcesstorage.ResourcesStorage;

/**
 *
 * @author jjdelcerro
 */
@SuppressWarnings("UseSpecificCatch")
public class H2SpatialExplorer extends JDBCServerExplorerBase {
        
    public H2SpatialExplorer(JDBCServerExplorerParameters parameters, DataServerExplorerProviderServices services, JDBCHelper helper) throws InitializeException {
        super(parameters, services, helper);
    }

    @Override
    public H2SpatialExplorerParameters getParameters() {
        return (H2SpatialExplorerParameters) super.getParameters(); 
    }

    @Override
    public ResourcesStorage getResourcesStorage(DataStore dataStore) {
        ResourcesStorage ress = super.getResourcesStorage(dataStore);
        if( ress instanceof EmptyResourcesStorage ) {
            String zipPath = this.getParameters().getFile().getAbsolutePath();
            String zipPathName = FilenameUtils.removeExtension(zipPath);
            ress = new ZipResourcesStorage(zipPathName, dataStore.getName());
        }
        return ress;
    }
    
    
}
