
package org.gvsig.fmap.dal.store.h2;

import org.gvsig.fmap.dal.DataServerExplorerParameters;
import org.gvsig.fmap.dal.exception.InitializeException;
import org.gvsig.fmap.dal.spi.DataServerExplorerProviderServices;
import org.gvsig.fmap.dal.store.jdbc.JDBCConnectionParameters;
import org.gvsig.fmap.dal.store.jdbc.JDBCServerExplorerParameters;
import org.gvsig.fmap.dal.store.jdbc2.JDBCHelper;
import org.gvsig.fmap.dal.store.jdbc2.JDBCServerExplorer;
import org.gvsig.fmap.dal.store.jdbc2.impl.JDBCServerExplorerFactory;


public class H2SpatialExplorerFactory extends JDBCServerExplorerFactory {

    public H2SpatialExplorerFactory() {
        super(
                H2SpatialLibrary.NAME,
                "H2Spatial"
        );
    }

    @Override
    public JDBCServerExplorer create(
            DataServerExplorerParameters parameters, 
            DataServerExplorerProviderServices providerServices
        ) throws InitializeException {
        JDBCHelper helper = new H2SpatialHelper((JDBCConnectionParameters) parameters);
        JDBCServerExplorer server = helper.createServerExplorer(
                (JDBCServerExplorerParameters) parameters, 
                providerServices
        );
        return server;
    }
        

    @Override
    public JDBCServerExplorerParameters createParameters() {
        JDBCServerExplorerParameters params = new H2SpatialExplorerParameters();
        return params;    
    }
    
}
