/* gvSIG. Geographic Information System of the Valencian Government
*
* Copyright (C) 2007-2008 Infrastructures and Transports Department
* of the Valencian Government (CIT)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
* MA  02110-1301, USA.
*
 */
/**
 *
 */
package org.gvsig.fmap.dal.store.h2;

import java.io.File;
import java.util.Properties;
import org.gvsig.fmap.dal.exception.ValidateDataParametersException;
import org.gvsig.fmap.dal.store.jdbc.JDBCServerExplorerParameters;

public class H2SpatialExplorerParameters extends
        JDBCServerExplorerParameters 
    implements
        H2SpatialConnectionParameters
    {
    
    private final H2SpatialConnectionParametersHelper helper;

    public H2SpatialExplorerParameters() {
        super(
                H2SpatialLibrary.NAME + "ServerExplorerParameters",
                H2SpatialLibrary.NAME
        );
        this.helper = new H2SpatialConnectionParametersHelper(this);
    }

    @Override
    public String getUrl() {
        return this.helper.getUrl();
    }
    
    @Override
    public void validate() throws ValidateDataParametersException {
        this.helper.validate();
        super.validate();
    }

    @Override
    public Properties getProperties() {
        return this.helper.getProperties();
    }

    @Override
    public File getFile() {
        return this.helper.getFile();
    }
    
    @Override
    public void setFile(File database) {
        this.helper.setFile(database);
    }

}
