
package org.gvsig.fmap.dal.store.h2;

import org.gvsig.fmap.dal.DataParameters;
import org.gvsig.fmap.dal.exception.InitializeException;
import org.gvsig.fmap.dal.spi.DataStoreProviderServices;
import org.gvsig.fmap.dal.store.jdbc.JDBCConnectionParameters;
import org.gvsig.fmap.dal.store.jdbc.JDBCStoreParameters;
import org.gvsig.fmap.dal.store.jdbc2.JDBCHelper;
import org.gvsig.fmap.dal.store.jdbc2.JDBCStoreProvider;
import org.gvsig.fmap.dal.store.jdbc2.impl.JDBCStoreProviderFactory;


public class H2SpatialStoreProviderFactory extends JDBCStoreProviderFactory {

    private static final String NAME = H2SpatialLibrary.NAME;
    
    public H2SpatialStoreProviderFactory() {
        super(
                NAME, 
                "H2Spatial store"
        );
    }

    @Override
    public JDBCStoreProvider createProvider(
            DataParameters parameters,
            DataStoreProviderServices providerServices
    ) throws InitializeException {
        JDBCHelper helper = new H2SpatialHelper((JDBCConnectionParameters) parameters);
        JDBCStoreProvider provider = helper.createProvider(
                (JDBCStoreParameters) parameters, 
                providerServices
        );
        return provider;
    }

    @Override
    public JDBCStoreParameters createParameters() {
        JDBCStoreParameters params = new H2SpatialStoreParameters();
        return params;
    }
    
}
