package org.gvsig.fmap.dal.store.h2.expressionbuilderformatter;

import java.text.MessageFormat;
import java.util.List;
import org.apache.commons.lang3.StringUtils;
import org.gvsig.expressionevaluator.ExpressionBuilder;
import org.gvsig.expressionevaluator.ExpressionBuilder.Function;
import org.gvsig.expressionevaluator.ExpressionBuilder.Value;
import org.gvsig.expressionevaluator.Formatter;
import org.gvsig.fmap.dal.SQLBuilder;

/**
 *
 * @author jjdelcerro
 */
public class ILike implements Formatter<Value> {
    
    private final SQLBuilder sqlbuilder;
    private final Formatter<Value> formatter;
    
    public ILike(SQLBuilder sqlbuilder, Formatter<Value> formatter) {
        this.sqlbuilder = sqlbuilder;
        this.formatter = formatter;
    }
    @Override
    public boolean canApply(ExpressionBuilder.Value value) {
        if (value instanceof ExpressionBuilder.BinaryOperator) {
            return StringUtils.equalsIgnoreCase(ExpressionBuilder.OPERATOR_ILIKE, ((ExpressionBuilder.BinaryOperator) value).name());
        }
        return false;
    }

    @Override
    public String format(Value value) {
        ExpressionBuilder.BinaryOperator operator = (ExpressionBuilder.BinaryOperator) value;
        String p1 = operator.left().toString(formatter);
        String p2 = operator.right().toString(formatter);
        String r = MessageFormat.format("(lcase({0}) like lcase({1}))", p1, p2);
        return r;
    }
    
}
