package org.gvsig.fmap.dal.store.h2.expressionbuilderformatter;

import java.text.MessageFormat;
import java.util.List;
import org.apache.commons.lang3.StringUtils;
import org.gvsig.expressionevaluator.Code.Constant;
import org.gvsig.expressionevaluator.ExpressionBuilder;
import static org.gvsig.expressionevaluator.ExpressionBuilder.FUNCTION_IFNULL;
import org.gvsig.expressionevaluator.ExpressionBuilder.Function;
import static org.gvsig.expressionevaluator.ExpressionBuilder.OPERATOR_IS;
import org.gvsig.expressionevaluator.ExpressionBuilder.Value;
import org.gvsig.expressionevaluator.Formatter;
import org.gvsig.fmap.dal.SQLBuilder;

/**
 *
 * @author jjdelcerro
 */
class IfNull implements Formatter<Value> {

    private final Formatter<Value> formatter;
    private final SQLBuilder builder;
    
    public IfNull(SQLBuilder builder, Formatter<Value> formatter) {
        this.builder = builder;
        this.formatter = formatter;
    }
    
    @Override
    public boolean canApply(Value value) {
        if (value instanceof Function) {
            if (value instanceof ExpressionBuilder.Function) {
                return StringUtils.equalsIgnoreCase(FUNCTION_IFNULL, ((Function) value).name());
            }
        }
        return false;
    }

    @Override
    public String format(Value function) {
            List<Value> parameters = ((Function) function).parameters();
            String p1 = parameters.get(0).toString(formatter);
            String p2 = parameters.get(1).toString(formatter);
            String p3 = parameters.get(2).toString(formatter);
            String r = MessageFormat.format(
                    "NVL2({0}, {1}, {2})",
                    p1,
                    p3,
                    p2
            );
            return r;
    }
    
}
