package org.gvsig.fmap.dal.store.h2.expressionbuilderformatter;

import java.text.MessageFormat;
import java.util.List;
import org.apache.commons.lang3.StringUtils;
import org.gvsig.expressionevaluator.Code.Constant;
import org.gvsig.expressionevaluator.ExpressionBuilder.Function;
import static org.gvsig.expressionevaluator.ExpressionBuilder.OPERATOR_IS;
import static org.gvsig.expressionevaluator.ExpressionBuilder.OPERATOR_NOT;
import org.gvsig.expressionevaluator.ExpressionBuilder.Value;
import org.gvsig.expressionevaluator.Formatter;
import org.gvsig.fmap.dal.SQLBuilder;

/**
 *
 * @author jjdelcerro
 */
class IsNotNull implements Formatter<Value> {

    private final Formatter<Value> formatter;
    private final SQLBuilder builder;
    
    public IsNotNull(SQLBuilder builder, Formatter<Value> formatter) {
        this.builder = builder;
        this.formatter = formatter;
    }
    
    @Override
    public boolean canApply(Value value_not) {
        if (value_not instanceof Function) {
            // NOT( IS( p1, NULL) )
            if( StringUtils.equalsIgnoreCase(OPERATOR_NOT, ((Function) value_not).name()) ) {
                List<Value> parameters = ((Function) value_not).parameters();
                Value value_is = parameters.get(0);
                if( value_is instanceof Function && StringUtils.equalsIgnoreCase(OPERATOR_IS, ((Function)value_is).name()) ) {
                    List<Value> parameters_is = ((Function)value_is).parameters();
                    Value is_p2 = parameters_is.get(1);
                    if( is_p2 instanceof Constant && ((Constant)is_p2).value()==null ) {
                        return true;
                    }
                }
            }
        }
        return false;
    }

    @Override
    public String format(Value value_not) {
        // NOT( IS( p1, NULL) )

        List<Value> parameters = ((Function) value_not).parameters();
        Value value_is = parameters.get(0);
        List<Value> parameters_is = ((Function)value_is).parameters();
        Value is_p1 = parameters_is.get(0);
        String r = MessageFormat.format(
                "( ({0}) IS NOT NULL )", 
                is_p1.toString(formatter)
        );
        return r;
    }
    
}
