package org.gvsig.fmap.dal.store.h2.expressionbuilderformatter;

import java.text.MessageFormat;
import java.util.List;
import org.apache.commons.lang3.StringUtils;
import org.gvsig.expressionevaluator.Code.Constant;
import org.gvsig.expressionevaluator.ExpressionBuilder.Function;
import static org.gvsig.expressionevaluator.ExpressionBuilder.OPERATOR_IS;
import org.gvsig.expressionevaluator.ExpressionBuilder.Value;
import org.gvsig.expressionevaluator.Formatter;
import org.gvsig.fmap.dal.SQLBuilder;

/**
 *
 * @author jjdelcerro
 */
class IsNull implements Formatter<Value> {

    private final Formatter<Value> formatter;
    private final SQLBuilder builder;
    
    public IsNull(SQLBuilder builder, Formatter<Value> formatter) {
        this.builder = builder;
        this.formatter = formatter;
    }
    
    @Override
    public boolean canApply(Value value) {
        if (value instanceof Function) {
            if( StringUtils.equalsIgnoreCase(OPERATOR_IS, ((Function) value).name()) ) {
                List<Value> parameters = ((Function) value).parameters();
                Value p2 = parameters.get(1);
                if( p2 instanceof Constant && ((Constant)p2).value()==null ) {
                    return true;
                }
            }
        }
        return false;
    }

    @Override
    public String format(Value function) {
        List<Value> parameters = ((Function) function).parameters();
        String p1 = parameters.get(0).toString(formatter);
        String r = MessageFormat.format("( ({0}) IS NULL )", p1);
        return r;
    }
    
}
