package org.gvsig.fmap.dal.store.h2.expressionbuilderformatter;

import java.text.MessageFormat;
import java.util.List;
import org.apache.commons.lang3.StringUtils;
import static org.gvsig.expressionevaluator.ExpressionBuilder.FUNCTION_ST_ASBINARY;
import org.gvsig.expressionevaluator.ExpressionBuilder.Function;
import org.gvsig.expressionevaluator.ExpressionBuilder.Value;
import org.gvsig.expressionevaluator.Formatter;
import org.gvsig.fmap.dal.SQLBuilder;

/**
 *
 * @author jjdelcerro
 */
class ST_AsBinary implements Formatter<Value> {

    private final Formatter<Value> formatter;
    private final SQLBuilder builder;
    
    public ST_AsBinary(SQLBuilder builder, Formatter<Value> formatter) {
        this.builder = builder;
        this.formatter = formatter;
    }
    
    @Override
    public boolean canApply(Value value) {
        if (value instanceof Function) {
            return StringUtils.equalsIgnoreCase(FUNCTION_ST_ASBINARY, ((Function) value).name());
        }
        return false;
    }

    @Override
    public String format(Value function) {
        List<Value> parameters = ((Function) function).parameters();
        String p1 = parameters.get(0).toString(formatter);
        String r = MessageFormat.format("ST_AsBinary({0})", p1);
//        String r = MessageFormat.format("NVL2({0},ST_AsBinary({0}),NULL)", p1);
        return r;
    }
    
}
