package org.gvsig.fmap.dal.store.h2.expressionbuilderformatter;

import java.text.MessageFormat;
import java.util.List;
import org.apache.commons.lang3.StringUtils;
import org.gvsig.expressionevaluator.ExpressionBuilder;
import static org.gvsig.expressionevaluator.ExpressionBuilder.FUNCTION_ST_EXTENTAGGREGATE;
import org.gvsig.expressionevaluator.ExpressionBuilder.Function;
import org.gvsig.expressionevaluator.ExpressionBuilder.Value;
import org.gvsig.expressionevaluator.Formatter;
import org.gvsig.fmap.dal.SQLBuilder;

/**
 *
 * @author jjdelcerro
 */
public class ST_ExtentAggregate implements Formatter<Value> {
    
    private final SQLBuilder sqlbuilder;
    private final Formatter<Value> formatter;
    
    public ST_ExtentAggregate(SQLBuilder sqlbuilder, Formatter<Value> formatter) {
        this.sqlbuilder = sqlbuilder;
        this.formatter = formatter;
    }
    @Override
    public boolean canApply(ExpressionBuilder.Value value) {
        if (value instanceof ExpressionBuilder.Function) {
            return StringUtils.equalsIgnoreCase(FUNCTION_ST_EXTENTAGGREGATE, ((Function) value).name());
        }
        return false;
    }

    @Override
    public String format(Value function) {
        List<Value> parameters = ((Function) function).parameters();
        String p1 = parameters.get(0).toString(formatter);
        String r = MessageFormat.format("ST_Extent({0})", p1);
        return r;
    }
    
}
