package org.gvsig.fmap.dal.store.h2.expressionbuilderformatter;

import java.text.MessageFormat;
import java.util.List;
import org.apache.commons.lang3.StringUtils;
import static org.gvsig.expressionevaluator.ExpressionBuilder.FUNCTION_ST_GEOMFROMEWKB;
import org.gvsig.expressionevaluator.ExpressionBuilder.Function;
import org.gvsig.expressionevaluator.ExpressionBuilder.Value;
import org.gvsig.expressionevaluator.Formatter;
import org.gvsig.fmap.dal.SQLBuilder;

/**
 *
 * @author jjdelcerro
 */
class ST_GeomFromEWKB implements Formatter<Value> {

    private final Formatter<Value> formatter;
    private final SQLBuilder builder;
    
    public ST_GeomFromEWKB(SQLBuilder builder, Formatter<Value> formatter) {
        this.builder = builder;
        this.formatter = formatter;
    }
    
    @Override
    public boolean canApply(Value value) {
        if (value instanceof Function) {
            return StringUtils.equalsIgnoreCase(FUNCTION_ST_GEOMFROMEWKB, ((Function) value).name());
        }
        return false;
    }

    @Override
    public String format(Value function) {
        List<Value> parameters = ((Function) function).parameters();
        String p1 = parameters.get(0).toString(formatter);
        String p2 = parameters.get(1).toString(formatter);
        String r = MessageFormat.format("ST_GeomFromWKB({0}, {1})", p1, p2);
        return r;
    }
    
}
