
package org.gvsig.fmap.dal.store.h2.operations;

import java.util.List;
import org.cresques.cts.IProjection;
import org.gvsig.fmap.dal.feature.EditableFeatureType;
import org.gvsig.fmap.dal.feature.FeatureType;
import org.gvsig.fmap.dal.store.jdbc.JDBCStoreParameters;
import org.gvsig.fmap.dal.store.jdbc2.JDBCHelper;
import org.gvsig.fmap.dal.store.jdbc2.spi.operations.AppendOperation;
import org.gvsig.fmap.dal.store.jdbc2.spi.operations.FetchFeatureTypeOperation;
import org.gvsig.fmap.dal.store.jdbc2.spi.operations.ListTablesOperation;
import org.gvsig.fmap.dal.store.jdbc2.spi.operations.OperationsFactoryBase;


public class H2SpatialOperationsFactory extends OperationsFactoryBase {
    
    public H2SpatialOperationsFactory(JDBCHelper helper) {
        super(helper);
    }

    @Override
    public FetchFeatureTypeOperation createFetchFeatureType(EditableFeatureType type, TableReference table, List<String> primaryKeys, String defaultGeometryField, IProjection crs) {
        return new H2SpatialFetchFeatureTypeOperation(
                helper, type, table, primaryKeys, 
                defaultGeometryField, crs
        );
    }  

    @Override
    public ListTablesOperation createListTables(int mode, JDBCStoreParameters baseParameters, boolean informationTables) {
        return new H2SpatialListTablesOperation(helper, mode, baseParameters, informationTables);
    }

    @Override
    public AppendOperation createAppend(TableReference table, FeatureType type) {
        return new H2SpatialAppendOperation(helper, table, type);
    }
    
    
    
}
