package org.gvsig.fmap.dal.store.jdbc;

import java.util.List;
import org.gvsig.fmap.dal.DataServerExplorer_v2;
import org.gvsig.fmap.dal.DataStore;
import org.gvsig.fmap.dal.DataStoreParameters;
import org.gvsig.fmap.dal.NewDataStoreParameters;
import org.gvsig.fmap.dal.exception.DataException;
import org.gvsig.fmap.dal.exception.RemoveException;
import org.gvsig.fmap.dal.feature.FeatureType;
import org.gvsig.fmap.dal.store.jdbc.exception.JDBCExecuteSQLException;

public interface JDBCServerExplorer extends DataServerExplorer_v2 {

    @Override
    boolean add(String providerName, NewDataStoreParameters ndsp, boolean overwrite) throws DataException;

    @Override
    boolean canAdd();

    @Override
    JDBCStoreParameters get(String name) throws DataException;

    JDBCNewStoreParameters getAddParameters() throws DataException;

    @Override
    List<String> getDataStoreProviderNames();

    FeatureType getFeatureType(DataStoreParameters dsp) throws DataException;

    DataStoreParameters getOpenParameters() throws DataException;

    @Override
    String getProviderName();

    String getStoreName();

    @Override
    List<DataStoreParameters> list(int mode) throws DataException;

    DataStore open(DataStoreParameters dsp) throws DataException;

    @Override
    void remove(DataStoreParameters dsp) throws RemoveException;

    void updateTableStatistics(String database, String schema, String table) throws JDBCExecuteSQLException;
    
    public void execute(String sql);
  
}

