package org.gvsig.fmap.dal.store.jdbc;

import org.gvsig.fmap.dal.DataServerExplorerParameters;
import org.gvsig.fmap.dal.exception.InitializeException;
import org.gvsig.fmap.dal.spi.AbstractDataServerExplorerFactory;
import org.gvsig.fmap.dal.spi.DataServerExplorerProviderServices;

public class JDBCServerExplorerFactory extends AbstractDataServerExplorerFactory {

    public JDBCServerExplorerFactory() {
        super(
                JDBCServerExplorerBase.NAME,
                "JDBC generic server"
        );
    }

    @Override
    public JDBCServerExplorerBase create(
            DataServerExplorerParameters parameters,
            DataServerExplorerProviderServices providerServices
    ) throws InitializeException {
        JDBCServerExplorerBase explorer = new JDBCServerExplorerBase(
                (JDBCServerExplorerParameters) parameters,
                providerServices
        );
        return explorer;
    }

    @Override
    public JDBCServerExplorerParameters createParameters() {
        return new JDBCServerExplorerParameters();
    }

}
