package org.gvsig.fmap.dal.store.jdbc2;

import java.util.List;
import org.gvsig.fmap.dal.DataStore;
import org.gvsig.fmap.dal.DataStoreParameters;
import org.gvsig.fmap.dal.NewDataStoreParameters;
import org.gvsig.fmap.dal.OpenDataStoreParameters;
import org.gvsig.fmap.dal.exception.DataException;
import org.gvsig.fmap.dal.exception.RemoveException;
import org.gvsig.fmap.dal.feature.FeatureType;
import org.gvsig.fmap.dal.resource.spi.ResourceConsumer;
import org.gvsig.fmap.dal.store.jdbc.JDBCNewStoreParameters;
import org.gvsig.fmap.dal.store.jdbc.JDBCServerExplorerParameters;
import org.gvsig.fmap.dal.store.jdbc.JDBCStoreParameters;
import org.gvsig.fmap.dal.store.jdbc.exception.JDBCExecuteSQLException;


public interface JDBCServerExplorer extends ResourceConsumer, org.gvsig.fmap.dal.store.jdbc.JDBCServerExplorer  {

    @Override
    public JDBCServerExplorerParameters getParameters();

    @Override
    public String getProviderName();

    @Override
    public String getStoreName();

    @Override
    public boolean canAdd();

    @Override
    public boolean add(
            String providerName, 
            NewDataStoreParameters theParams, 
            boolean overwrite
    ) throws DataException;

    @Override
    public List<DataStoreParameters> list(int mode) throws DataException;

    @Override
    public DataStore open(DataStoreParameters params) throws DataException;

    @Override
    public void remove(DataStoreParameters theParams) throws RemoveException;

    @Override
    public void updateTableStatistics(String database, String schema, String table) throws JDBCExecuteSQLException;
   
    @Override
    public JDBCNewStoreParameters getAddParameters() throws DataException;

    @Override
    public JDBCStoreParameters getOpenParameters() throws DataException;

    @Override
    public JDBCStoreParameters get(String name) throws DataException;

    @Override
    public List getDataStoreProviderNames();

    @Override
    public FeatureType getFeatureType(DataStoreParameters theParams) throws DataException;
      
}
