
package org.gvsig.fmap.dal.store.jdbc2;

import org.gvsig.fmap.dal.feature.spi.FeatureStoreProvider_v2;
import org.gvsig.fmap.dal.store.jdbc.JDBCStoreParameters;
import org.gvsig.fmap.geom.primitive.Envelope;


public interface JDBCStoreProvider extends FeatureStoreProvider_v2 {
    
    public interface CalculatedValue<T> {
        public void calculate();
        public void reset();
        public T get();
    } 

    public CalculatedValue<Long> getCountValue();
    
    public CalculatedValue<Envelope> getEnvelopeValue();
    
    public CalculatedValue<Boolean> getAllowWriteValue();

    @Override
    public JDBCStoreParameters getParameters();
    
    public JDBCHelper getHelper();
    
    @Override
    public String getSourceId();
}
