
package org.gvsig.fmap.dal.store.jdbc2;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.List;
import org.gvsig.fmap.dal.exception.DataException;
import org.gvsig.fmap.dal.feature.FeatureAttributeDescriptor;


public interface ResulSetControler extends AutoCloseable {

    public interface ResultSetEntry extends AutoCloseable {
        public ResultSet get();
        public int getID();
        public boolean isZombie();
        public String getSQL();
        public FeatureAttributeDescriptor[] getColumns();
        public String[] getExtraValueNames();
        public Object getObject(int columnIndex) throws SQLException;
        public byte[] getBytes(int columnIndex) throws SQLException;
        public boolean next() throws SQLException;
    }

    public void setTimeToZombie(long mlSeconds);

    public long getTimeToZombie();

    public ResultSetEntry create(String sql, int fetchSize, FeatureAttributeDescriptor[] columns, String[] extraValueNames ) throws DataException;

    public ResultSetEntry create(String sql, List<Object> values, int fetchSize, FeatureAttributeDescriptor[] columns, String[] extraValueNames) throws DataException;

    public int getOpenCount();
    
    public void closeAll();

    public void pack();    
}
