
package org.gvsig.fmap.dal.store.jdbc2.impl;

import org.gvsig.fmap.dal.store.jdbc2.JDBCLibrary;
import org.gvsig.fmap.dal.DataServerExplorerParameters;
import org.gvsig.fmap.dal.exception.InitializeException;
import org.gvsig.fmap.dal.spi.AbstractDataServerExplorerFactory;
import org.gvsig.fmap.dal.spi.DataServerExplorerProviderServices;
import org.gvsig.fmap.dal.store.jdbc.JDBCConnectionParameters;
import org.gvsig.fmap.dal.store.jdbc.JDBCServerExplorerParameters;
import org.gvsig.fmap.dal.store.jdbc2.JDBCHelper;
import org.gvsig.fmap.dal.store.jdbc2.JDBCServerExplorer;
import org.gvsig.fmap.dal.store.jdbc2.spi.JDBCHelperBase;


public class JDBCServerExplorerFactory extends AbstractDataServerExplorerFactory {

    private static final String NAME = JDBCLibrary.NAME;

    public JDBCServerExplorerFactory() {
        this(
                NAME,
                "JDBC generic server (2)"
        );
    }
    
    protected JDBCServerExplorerFactory(String name, String description) {
        super(name,description);
    }
    
    protected JDBCServerExplorerFactory(String name, String description, boolean hidden) {
        super(name,description, hidden);
    }

    @Override
    public JDBCServerExplorer create(
            DataServerExplorerParameters parameters, 
            DataServerExplorerProviderServices providerServices
        ) throws InitializeException {
        JDBCHelper helper = new JDBCHelperBase((JDBCConnectionParameters) parameters);
        JDBCServerExplorer server = helper.createServerExplorer(
                (JDBCServerExplorerParameters) parameters, 
                providerServices
        );
        return server;
    }
        
    @Override
    public JDBCServerExplorerParameters createParameters() {
        JDBCServerExplorerParameters params = new JDBCServerExplorerParameters(
                NAME + "ServerExplorerParameters",
                NAME 
        );
        return params;    
    }


}
