
package org.gvsig.fmap.dal.store.jdbc2.spi;

import java.sql.Connection;
import org.gvsig.fmap.dal.store.jdbc2.JDBCHelper;

public class SRSSolverDumb extends SRSSolverBase implements SRSSolver {
    
    public SRSSolverDumb(JDBCHelper helper) {
        super(helper);
    }
        
    @Override
    protected Object searchDatabaseCode(Connection connection, String applicationAbbrev) {
        try {
            String[] s = applicationAbbrev.split(":");
            String code_s = s[1].trim();
            try {
                int code_i = Integer.parseInt(code_s);
                return code_i;
            } catch(NumberFormatException e) {
                
            }
            return 0;
        } catch (Throwable ex) {
            throw new RuntimeException("Problems searching database code from '"+applicationAbbrev+"'.",ex);
        }
    }

    @Override
    protected String searchApplicationAbbrev(Connection connection, Integer databaseCode) {
        try {
            return "EPSG:" + databaseCode;
        } catch (Throwable ex) {
            throw new RuntimeException("Problems searching application abbrev from '"+databaseCode+"'.",ex);
        }
    }    
   
}
