
package org.gvsig.fmap.dal.store.jdbc2.spi.operations;

import java.sql.Connection;
import java.sql.DatabaseMetaData;
import java.sql.SQLException;
import org.gvsig.fmap.dal.exception.DataException;
import org.gvsig.fmap.dal.store.jdbc.exception.JDBCCantFetchMetadata;
import org.gvsig.fmap.dal.store.jdbc2.JDBCHelper;


public class CanCreateTablesOperation extends AbstractConnectionOperation {

    public CanCreateTablesOperation(JDBCHelper helper) {
        super(helper);
    }

    @Override
    public final Object perform(Connection conn) throws DataException {
        return canCreateTables(conn);
    }
    
    public boolean canCreateTables(
            Connection conn
        ) throws JDBCCantFetchMetadata {
        try {
            DatabaseMetaData metadata = conn.getMetaData();
            boolean readonly = metadata.isReadOnly();
            return !readonly;
        } catch (SQLException ex) {
            throw new JDBCCantFetchMetadata(ex);
        }
    }
}
