package org.gvsig.fmap.dal.store.jdbc2.spi.operations;

import java.sql.Connection;
import org.gvsig.fmap.dal.exception.DataException;
import org.gvsig.fmap.dal.store.jdbc2.JDBCHelper;
import org.gvsig.fmap.dal.store.jdbc2.OperationsFactory.TableReference;

public class CanModifyTableOperation extends AbstractConnectionOperation {

    private final TableReference table;

    public CanModifyTableOperation(
            JDBCHelper helper
        ) {
        this(helper, null);
    }

    public CanModifyTableOperation(
            JDBCHelper helper,
            TableReference table
        ) {
        super(helper);
        this.table = table;
    }

    @Override
    public Object perform(Connection conn) throws DataException {
        return this.canModifyTable(conn,table);
    }

    public boolean canModifyTable(Connection conn,TableReference table) throws DataException {
        return true;
    }

}
