package org.gvsig.fmap.dal.store.jdbc2.spi.operations;

import java.sql.Connection;
import java.sql.SQLException;
import java.sql.Statement;
import org.gvsig.fmap.dal.exception.DataException;
import org.gvsig.fmap.dal.store.jdbc2.JDBCHelper;
import org.gvsig.fmap.dal.store.jdbc2.JDBCUtils;

public class ExecuteOperation extends AbstractConnectionOperation {

    private final String sql;
    
    public ExecuteOperation(
            JDBCHelper helper,
            String sql
        ) {
        super(helper);
        this.sql = sql;
    }

    @Override
    public final Object perform(Connection conn) throws DataException {
        this.execute(conn, sql);
        return null;
    }

    public void execute(
            Connection conn,
            String sql
    ) {
        Statement st = null;
        try {
            st = conn.createStatement();
            JDBCUtils.execute(st, sql);
        } catch (SQLException ex) {
            throw new RuntimeException("Can't execute query ["+sql+"].",ex);
            
        } finally {
            JDBCUtils.closeQuietly(st);
        }

    }
}
