
package org.gvsig.fmap.dal.store.mdb.operations;

import java.util.List;
import org.cresques.cts.IProjection;
import org.gvsig.fmap.dal.feature.EditableFeatureType;
import org.gvsig.fmap.dal.feature.FeatureType;
import org.gvsig.fmap.dal.store.jdbc.JDBCStoreParameters;
import org.gvsig.fmap.dal.store.jdbc2.JDBCHelper;
import org.gvsig.fmap.dal.store.jdbc2.spi.operations.AppendOperation;
import org.gvsig.fmap.dal.store.jdbc2.spi.operations.FetchFeatureTypeOperation;
import org.gvsig.fmap.dal.store.jdbc2.spi.operations.ListTablesOperation;
import org.gvsig.fmap.dal.store.jdbc2.spi.operations.OperationsFactoryBase;


public class MdbOperationsFactory extends OperationsFactoryBase {
    
    public MdbOperationsFactory(JDBCHelper helper) {
        super(helper);
    }

    @Override
    public FetchFeatureTypeOperation createFetchFeatureType(EditableFeatureType type, String database, String schema, String table, List<String> primaryKeys, String defaultGeometryField, IProjection crs) {
        return new MdbFetchFeatureTypeOperation(
                helper, type, database, schema, table, primaryKeys, 
                defaultGeometryField, crs
        );
    }  

    @Override
    public ListTablesOperation createListTables(int mode, JDBCStoreParameters baseParameters, boolean informationTables) {
        return new MdbListTablesOperation(helper, mode, baseParameters, informationTables);
    }

    @Override
    public AppendOperation createAppend(String database, String schema, String table, FeatureType type) {
        return new MdbAppendOperation(helper, database, schema, table, type);
    }
    
    
    
}
