package org.gvsig.fmap.dal.feature.spi.simpleprovider;

import java.util.Collections;
import java.util.List;
import java.util.Map;
import org.gvsig.fmap.dal.StoresRepository;
import org.gvsig.fmap.dal.feature.OpenFeatureStoreParameters;
import org.gvsig.tools.resourcesstorage.ResourcesStorage;

/**
 *
 * @author jjdelcerro
 */
public abstract class AbstractSimpleSequentialReader implements SimpleSequentialReader {

    private final SimpleSequentialReaderFactory factory;
    private final OpenFeatureStoreParameters params;
    
    protected AbstractSimpleSequentialReader(
            SimpleSequentialReaderFactory factory,
            OpenFeatureStoreParameters params
        ) {
        this.factory = factory;
        this.params = params;
    }
    
    @Override
    public SimpleSequentialReaderFactory getFactory() {
        return this.factory;
    }

    @Override
    public OpenFeatureStoreParameters getParameters() {
        return this.params;
    }

    protected Object getParameter(String name) {
        return this.params.getDynValue(name);
    }
    
    @Override
    public String getLabel() {
        return null;
    }

    @Override
    public String getAlias() {
        return null;
    }
    
    @Override
    public String getDescription() {
        return null;
    }

    @Override
    public Map<String, String> getTags() {
        return null;
    }

    @Override
    public List<SimpleSequentialReader> getChildren() {
        return Collections.EMPTY_LIST;
    }

    @Override
    public long getRowCount() {
        return -1;
    }

    @Override
    public StoresRepository getStoresRepository() {
        return null;
    }
    
    @Override
    public ResourcesStorage getResourcesStorage() {
        return null;
    }
}
