/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.gvsig.fmap.dal.feature.spi.simpleprovider;

import java.io.File;
import org.gvsig.fmap.dal.DataServerExplorer;
import org.gvsig.fmap.dal.DataStoreParameters;
import org.gvsig.fmap.dal.exception.DataException;
import org.gvsig.fmap.dal.resource.spi.ResourceConsumer;
import org.gvsig.fmap.dal.serverexplorer.filesystem.impl.AbstractFilesystemServerExplorerProvider;
import org.gvsig.fmap.dal.serverexplorer.filesystem.spi.FilesystemServerExplorerProvider;
import org.gvsig.fmap.dal.serverexplorer.filesystem.spi.FilesystemServerExplorerProviderServices;

/**
 *
 * @author jjdelcerro
 */
public class SimpleSequentialReaderFilesystemServerProvider 
        extends AbstractFilesystemServerExplorerProvider 
        implements FilesystemServerExplorerProvider, ResourceConsumer 
    {
    
    private FilesystemServerExplorerProviderServices serverExplorer;
    private final SimpleSequentialReaderFactory readerFactory;

    public SimpleSequentialReaderFilesystemServerProvider(SimpleSequentialReaderFactory readerFactory) {
        this.readerFactory = readerFactory;
    }

    @Override
    public String getDataStoreProviderName() {
        return this.readerFactory.getName();
    }

    @Override
    public int getMode() {
        return DataServerExplorer.MODE_FEATURE | DataServerExplorer.MODE_GEOMETRY;
    }

    @Override
    public boolean accept(File file) {
        return this.readerFactory.accept(file);
    }

    @Override
    public DataStoreParameters getParameters(File file) throws DataException {
        SimpleSequentialReaderStoreParameters params = new SimpleSequentialReaderStoreParameters(this.readerFactory);
        params.setFile(file);
        return params;
    }

    @Override
    public void initialize(FilesystemServerExplorerProviderServices serverExplorer) {
        this.serverExplorer = serverExplorer;
    }

    @Override
    public String getDescription() {
        return this.readerFactory.getDescription();
    }
    
}
