/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.gvsig.fmap.dal.feature.spi.simpleprovider;

import java.io.File;
import org.gvsig.fmap.dal.DataServerExplorer;
import org.gvsig.fmap.dal.exception.InitializeException;
import org.gvsig.fmap.dal.serverexplorer.filesystem.spi.FilesystemServerExplorerProvider;
import org.gvsig.fmap.dal.serverexplorer.filesystem.spi.FilesystemServerExplorerProviderFactory;

/**
 *
 * @author jjdelcerro
 */
public class SimpleSequentialReaderFilesystemServerProviderFactory
        implements FilesystemServerExplorerProviderFactory {

    private final SimpleSequentialReaderFactory readerFactory;

    public SimpleSequentialReaderFilesystemServerProviderFactory(SimpleSequentialReaderFactory readerFactory) {
        this.readerFactory = readerFactory;
    }

    @Override
    public FilesystemServerExplorerProvider createProvider() throws InitializeException {
        return new SimpleSequentialReaderFilesystemServerProvider(this.readerFactory);
    }

    @Override
    public boolean accept(File pathname) {
        return this.readerFactory.accept(pathname);
    }

    @Override
    public String getName() {
        return this.readerFactory.getName();
    }

    @Override
    public String getDescription() {
        return this.readerFactory.getDescription();
    }

    @Override
    public int allowCreate() {
        return NO;
    }

    @Override
    public int getMode() {
        return DataServerExplorer.MODE_FEATURE | DataServerExplorer.MODE_GEOMETRY;
    }

    @Override
    public boolean isMode(int mode) {
        return this.getMode()==mode;
    }

}
