
package org.gvsig.fmap.dal.serverexplorer.filesystem;

import org.gvsig.fmap.dal.DataServerExplorerParameters;
import org.gvsig.fmap.dal.exception.InitializeException;
import org.gvsig.fmap.dal.serverexplorer.filesystem.impl.DefaultFilesystemServerExplorer;
import org.gvsig.fmap.dal.spi.AbstractDataServerExplorerFactory;
import org.gvsig.fmap.dal.spi.DataServerExplorerProviderServices;


public class FilesystemServerExplorerFactory
    extends AbstractDataServerExplorerFactory {

    public FilesystemServerExplorerFactory() {
        super(
                FilesystemServerExplorer.NAME,
                null
        );
    }

    @Override
    public int allowCreate() {
        return super.allowCreate(); //To change body of generated methods, choose Tools | Templates.
    }
    
    @Override
    public FilesystemServerExplorerParameters createParameters() {
        return new FilesystemServerExplorerParameters();
    }

    @Override
    public FilesystemServerExplorer create(
            DataServerExplorerParameters parameters, 
            DataServerExplorerProviderServices providerServices
    ) throws InitializeException {
        FilesystemServerExplorer explorer = new DefaultFilesystemServerExplorer(
                (FilesystemServerExplorerParameters) parameters, 
                providerServices);
        return explorer;
    }

}
