package org.gvsig.fmap.dal.serverexplorer.filesystem.impl;


import java.io.File;

import org.apache.commons.io.FilenameUtils;
import org.apache.commons.lang3.StringUtils;
import org.gvsig.fmap.dal.serverexplorer.filesystem.spi.FilesystemProviderServices;
import org.gvsig.fmap.dal.serverexplorer.filesystem.spi.FilesystemServerExplorerProviderFactory;

/**
 * Abstract Factory to create File System Server Explorer Providers
 * @author dmartinezizquierdo
 *
 */
public abstract class AbstractFilesystemServerExplorerProviderFactory
    implements FilesystemServerExplorerProviderFactory, FilesystemProviderServices{

    private FilesystemProviderServices services;

    public AbstractFilesystemServerExplorerProviderFactory(FilesystemProviderServices services){
        this.services=services;
    }

    @Override
    public String getName() {
        return this.services.getName();
    }

    @Override
    public String getDescription() {
        return this.services.getDescription();
    }

    @Override
    public int allowCreate() {
        return this.services.allowCreate();
    }

    @Override
    public int getMode(){
        return this.services.getMode();
    }

    @Override
    public boolean isMode(int mode){
        return this.services.isMode(mode);
    }
}
