package org.gvsig.fmap.dal.serverexplorer.filesystem.spi;

import org.gvsig.fmap.dal.DataParameters;

/**
 * Parameters to create a FilesystemServerExplorerProviderFactory
 * @author dmartinezizquierdo
 *
 */
public interface FilesystemProviderServices {//extends DataParameters
    public static final int UNKNOWN = 0;
    public static final int YES = 1;
    public static final int NO = 2;
    /**
     * Returns the name of the provider
     *
     * @return name of the provider
     */
    public String getName();

    /**
     * Return a short descripion about the provider
     *
     * @return description about the provider
     */
    public String getDescription();

    /**
     * The provider can create new stores.
     *
     * @return YES if has creation support
     */
    public int allowCreate();

    /**
     * Returns the mode supported
     * @return DataServerExplorer.MODE
     */
    public int getMode();

    /**
     * Return true if any mode in the parameter is supported.
     *
     * @param mode
     * @return boolean
     */
    public boolean isMode(int mode);

}
