package org.gvsig.fmap.dal.serverexplorer.filesystem.spi;

import java.io.FileFilter;

import org.gvsig.fmap.dal.exception.InitializeException;
import org.gvsig.tools.extensionpoint.ExtensionSingleton;

/**
 * Creates File System Server Explorer Providers
 * @author dmartinezizquierdo
 *
 */
public interface FilesystemServerExplorerProviderFactory extends ExtensionSingleton,
    FileFilter, FilesystemProviderServices {

    /**
     * Builds a specific provider
     * @param services
     * @return the provider
     * @throws org.gvsig.fmap.dal.exception.InitializeException
     */
    public FilesystemServerExplorerProvider createProvider() throws InitializeException;

}
