package org.gvsig.fmap.dal.store.shp;


import java.io.File;
import org.gvsig.fmap.dal.DataStore;
import org.gvsig.fmap.dal.OpenDataStoreParameters;
import org.gvsig.fmap.dal.spi.DataStoreProvider;
import org.gvsig.fmap.dal.store.dbf.utils.DbaseCodepage;
import org.gvsig.tools.dynobject.AbstractDynMethod;
import org.gvsig.tools.dynobject.DynObject;
import org.gvsig.tools.dynobject.exception.DynMethodException;

/**
 * gvSIG. Desktop Geographic Information System.
 *
 * Copyright (C) 2007-2013 gvSIG Association.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 3
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301, USA.
 *
 * For any additional information, do not hesitate to contact us
 * at info AT gvsig.com, or visit our website www.gvsig.com.
 */


public class SHPStoreSaveEncodingMethod extends AbstractDynMethod {

    public SHPStoreSaveEncodingMethod() {
        super("saveEncoding", "Save the current encoding in the '.cpg' file associated to this shape.");
    }
    
    @Override
    public Object invoke(DynObject self, Object[] args) throws DynMethodException {
        SHPStoreProvider provider = (SHPStoreProvider)self;
        OpenDataStoreParameters shapeOpenParameters = (OpenDataStoreParameters) provider.getParameters();
        File f = (File) shapeOpenParameters.getDynValue(SHPStoreParameters.SHPFILE_PARAMTER_NAME);
        String encoding = (String) shapeOpenParameters.getDynValue(SHPStoreParameters.ENCODING_PARAMTER_NAME);
        DbaseCodepage cp = new DbaseCodepage(f);
        cp.write(encoding);
        return true;
    }
    
}
