package org.gvsig.fmap.dal.complements.relatedfeatures;

import org.gvsig.fmap.dal.complements.RelatedFeatures;
import org.gvsig.tools.ToolsLocator;
import org.gvsig.tools.complement.AbstractComplementFactory;
import org.gvsig.tools.complement.Complement;
import org.gvsig.tools.complement.ComplementsManager;
import org.gvsig.tools.dynobject.DynObjectManager;
import org.gvsig.tools.dynobject.Tagged;

/**
 *
 * @author jjdelcerro
 */
public class RelatedFeaturesFactory extends AbstractComplementFactory<Tagged>{

    public RelatedFeaturesFactory() {
        super(RelatedFeatures.COMPLEMENT_MANE);
    }
    
    @Override
    public Complement<Tagged> createComplement(Tagged object) {
        return new RelatedFeaturesImpl(this, object);
    }
    
    
    public static void selfRegister() {
        ComplementsManager complementsManager = ToolsLocator.getComplementsManager();
        complementsManager.registerComplement(new RelatedFeaturesFactory());
        
        DynObjectManager dynObjectManager = ToolsLocator.getDynObjectManager();
        dynObjectManager.registerTag(
                RelatedFeatures.DAL_RELATED_COLUMNS, 
                "Part of a table of related features definition, stores the name of the fields to be shown in the table separated by two points."
        );
        dynObjectManager.registerTag(
                RelatedFeatures.DAL_RELATED_TABLE, 
                "Part of a table of related features definition, store the table name of features."
        );
        dynObjectManager.registerTag(
                RelatedFeatures.DAL_RELATED_UNIQUE_FIELD_NAME, 
                "Part of a table of related features definition, store the name of the field that is a unique key in the features table."
        );
//        dynObjectManager.registerTag(
//                RelatedFeatures.DAL_RELATED_FOREING_KEY_NAME, 
//                "Part of a table of related features definition, store the name of the field that is the foreing key in the features table."
//        );
    }
}
