package org.gvsig.fmap.dal.complements.search;

import org.gvsig.fmap.dal.DataManager;
import org.gvsig.fmap.dal.DataTypes;
import org.gvsig.fmap.dal.complements.Search;
import org.gvsig.fmap.dal.feature.FeatureType;
import org.gvsig.tools.ToolsLocator;
import org.gvsig.tools.complement.AbstractComplementFactory;
import org.gvsig.tools.complement.Complement;
import org.gvsig.tools.complement.ComplementsManager;
import org.gvsig.tools.dynobject.DynObjectManager;
import org.gvsig.tools.dynobject.Tagged;

/**
 *
 * @author jjdelcerro
 */
public class SearchFactory extends AbstractComplementFactory<FeatureType>{

    public SearchFactory() {
        super(Search.COMPLEMENT_MANE);
    }
    
    @Override
    public Complement<FeatureType> createComplement(FeatureType object) {
        return new SearchImpl(this, object);
    }
    
    public static void selfRegister() {
        ComplementsManager complementsManager = ToolsLocator.getComplementsManager();
        complementsManager.registerComplement(new SearchFactory());
        
        DynObjectManager dynObjectManager = ToolsLocator.getDynObjectManager();
        dynObjectManager.registerTag(
                Search.DAL_SEARCH_ATTRIBUTE_PRIORITY,
                "Priority of the field when displaying it in the searchs field lists."
        ).setType(DataTypes.INT);
        dynObjectManager.registerTag(
                DataManager.DAL_PREFERRED_COLUMNS,
                "Columns to be used when the data is shown in tabular form."
        );
    }
    
}
