
package org.gvsig.fmap.dal.feature.impl;

import org.gvsig.fmap.dal.DataParameters;
import org.gvsig.fmap.dal.DataStore;
import org.gvsig.fmap.dal.DataStoreParameters;

import org.gvsig.fmap.dal.exception.InitializeException;
import org.gvsig.fmap.dal.impl.AbstractDataStoreFactory;
import org.gvsig.fmap.dal.impl.DefaultDataManager;
import org.gvsig.fmap.dal.spi.DataStoreInitializer2;
import org.gvsig.fmap.dal.DataStoreProvider;
import org.gvsig.fmap.dal.feature.OpenFeatureStoreParameters;
import org.gvsig.tools.dynobject.DynObject;
import org.gvsig.tools.service.spi.Services;


public class FeatureStoreFactory extends AbstractDataStoreFactory {

    public static final String NAME = "FeatureStore";
    
    public FeatureStoreFactory() {
        super(NAME, "");
    }
    
    @Override
    public DynObject createParameters() {
        return null;
    }

    @Override
    public DataStore create(DynObject parameters, Services services) {
        try {
            DataStoreInitializer2 store = new DefaultFeatureStore();
            store.intialize(
                    (DefaultDataManager)services,
                    (DataStoreParameters)parameters
            );
            return store;
        } catch (InitializeException ex) {
            throw new RuntimeException(ex);
        }
    }

    @Override
    public void setProvider(DataStore store, DataStoreProvider provider) {
        ((DataStoreInitializer2)store).setProvider(provider);
    }
    
    @Override
    public boolean canUse(DataParameters parameters) {
        boolean use = parameters instanceof OpenFeatureStoreParameters;
        return use;
    }
    
}
