
package org.gvsig.fmap.dal.feature.impl.indexes.memorybasictypes;

import org.gvsig.fmap.dal.DALLocator;
import org.gvsig.fmap.dal.DataFactory;
import org.gvsig.fmap.dal.DataFactoryUnit;
import org.gvsig.fmap.dal.DataTypes;
import org.gvsig.fmap.dal.impl.DefaultDataManager;
import org.gvsig.fmap.dal.spi.AbstractDataFactory;
import org.gvsig.tools.dynobject.DynObject;
import org.gvsig.tools.service.spi.Services;


public class MemoryStringIndexProviderFactory 
    extends AbstractDataFactory
    implements DataFactory 
    {
    public static final String NAME = "MemoryStringIndexProvider";

    public MemoryStringIndexProviderFactory() {
        super(NAME, "");
    }
    
    @Override
    public DataFactoryUnit create(DynObject parameters, Services services) {
        return new MemoryBasicTypesIndexProvider<String>();
    }

    @Override
    public DynObject createParameters() {
        return null;
    }

    public static void selfRegister() {
        DefaultDataManager dataManager = (DefaultDataManager) DALLocator.getDataManager();

        if( !dataManager.getFeatureIndexRegister().exits(NAME) ) {
            dataManager.getFeatureIndexRegister().register(new MemoryStringIndexProviderFactory());
            dataManager.setDefaultFeatureIndexProviderName(
                    DataTypes.STRING, 
                    NAME
            );
        }        
    }
}
