
package org.gvsig.fmap.dal.feature.impl.indexes.memoryspatial;

import org.gvsig.fmap.dal.DALLocator;
import org.gvsig.fmap.dal.DataFactory;
import org.gvsig.fmap.dal.DataFactoryUnit;
import org.gvsig.fmap.dal.DataTypes;
import org.gvsig.fmap.dal.feature.impl.indexes.jsir.JSIRSpatialIndexProvider;
import org.gvsig.fmap.dal.feature.impl.indexes.jsir.JSIRSpatialIndexProviderFactory;
import org.gvsig.fmap.dal.impl.DefaultDataManager;
import org.gvsig.fmap.dal.spi.AbstractDataFactory;
import org.gvsig.tools.dynobject.DynObject;
import org.gvsig.tools.service.spi.Services;


public class MemorySpatialIndexProviderFactory 
    extends AbstractDataFactory
    implements DataFactory 
    {

    public static final String NAME = "MemorySpatialIndexProvider";
	
    public MemorySpatialIndexProviderFactory() {
        super(NAME, "");
    }
    
    @Override
    public DataFactoryUnit create(DynObject parameters, Services services) {
        return new MemorySpatialIndexProvider();
    }

    @Override
    public DynObject createParameters() {
        return null;
    }

    public static void selfRegister() {
        DefaultDataManager dataManager = (DefaultDataManager) DALLocator.getDataManager();

        if( !dataManager.getFeatureIndexRegister().exits(NAME) ) {
            dataManager.getFeatureIndexRegister().register(new MemorySpatialIndexProviderFactory());
            dataManager.setDefaultFeatureIndexProviderName(
                    DataTypes.GEOMETRY, 
                    NAME
            );
        }        
    }
    
}
