package org.gvsig.fmap.dal.impl.dataprofile;

import java.util.Objects;
import org.gvsig.fmap.dal.DALLocator;
import org.gvsig.fmap.dal.DataManager;
import org.gvsig.fmap.dal.feature.AbstractDataProfile;
import org.gvsig.tools.dataTypes.CoercionException;
import org.gvsig.tools.dataTypes.DataType;
import org.gvsig.tools.dynobject.Tags;

/**
 *
 * @author jjdelcerro
 */
@SuppressWarnings("UseSpecificCatch")
public class DataProfileText extends AbstractDataProfile {
    
    public DataProfileText() {
        super("Text", "Text", String.class);
    }

    @Override
    public Object createData(Object data, Tags tags) {
        return Objects.toString(data, null);
    }

    @Override
    public Object coerce(DataType dataType, Object data, Tags tags) throws CoercionException {
        String s = Objects.toString(data, null);
        if( s == null ) {
            return null;
        }    
        try {
            data = dataType.coerce(s);
            return data;
        } catch(Exception ex) {
            throw new CoercionException("Can't convert String to "+dataType.getName(), ex);            
        }
    }
    
    public static void selfRegister() {
        DataManager dataManager = DALLocator.getDataManager();
        
        dataManager.registerDataProfile(new DataProfileText());
    }
    
}
