package org.gvsig.fmap.dal.raster.impl;

import org.gvsig.fmap.dal.DataParameters;
import org.gvsig.fmap.dal.DataStore;
import org.gvsig.fmap.dal.DataStoreParameters;
import org.gvsig.fmap.dal.DataStoreProvider;
import org.gvsig.fmap.dal.impl.AbstractDataStoreFactory;
import org.gvsig.fmap.dal.impl.DefaultDataManager;
import org.gvsig.fmap.dal.raster.OpenRasterStoreParameters;
import org.gvsig.fmap.dal.spi.DataStoreInitializer2;
import org.gvsig.tools.dynobject.DynObject;
import org.gvsig.tools.service.spi.Services;

public class RasterStoreFactory extends AbstractDataStoreFactory {
    private final Class theStoreClass;

    public static final String NAME = "RasterStore";
    
    public RasterStoreFactory(Class theStoreClass) {
        super(NAME,"");
        this.theStoreClass = theStoreClass;
    }
    
    @Override
    public DynObject createParameters() {
        return null;
    }

    @Override
    public DataStore create(DynObject parameters, Services services) {
        try {
            DataStoreInitializer2 store = (DataStoreInitializer2) this.theStoreClass.newInstance();
            store.intialize(
                    (DefaultDataManager)services,
                    (DataStoreParameters)parameters
            );
            return store;
        } catch (Exception ex) {
            throw new RuntimeException(ex);
        }
    }

    @Override
    public boolean canUse(DataParameters parameters) {
        return parameters instanceof OpenRasterStoreParameters;
    }

    @Override
    public void setProvider(DataStore store, DataStoreProvider provider) {
        ((DataStoreInitializer2)store).setProvider(provider);
    }
        
}
