package org.gvsig.fmap.dal.spi;

import org.apache.commons.lang3.StringUtils;
import org.gvsig.fmap.dal.DataFactory;

public abstract class AbstractDataFactory implements DataFactory {

    private String name = null;
    private String description = "";
    private boolean hidden = false;

    protected AbstractDataFactory(String name, String description, boolean hidden) {
        this.name = name;
        this.description = description;
        this.hidden = hidden;
    }

    protected AbstractDataFactory(String name, String description) {
        this(name, description, false);
    }

    @Override
    public final String getName() {
        return this.name;
    }

    @Override
    public final String getDescription() {
        if( StringUtils.isEmpty(this.description) ) {
            return this.name;
        }
        return this.description;
    }

    @Override
    public boolean isHidden() {
        return this.hidden;
    }

}
