package org.gvsig.fmap.dal.spi;

import java.io.File;
import org.gvsig.fmap.dal.DataServerExplorerParameters;
import org.gvsig.fmap.dal.DataServerExplorer_v2;
import org.gvsig.fmap.dal.DataStore;
import org.gvsig.fmap.dal.DataStoreParameters;
import org.gvsig.fmap.dal.exception.DataException;
import org.gvsig.fmap.dal.SQLBuilder;
import org.gvsig.fmap.dal.feature.spi.SQLBuilderBase;
import org.gvsig.tools.dispose.impl.AbstractDisposable;
import org.gvsig.tools.exception.BaseException;
import org.gvsig.tools.resourcesstorage.EmptyResourcesStorage;
import org.gvsig.tools.resourcesstorage.ResourcesStorage;

public abstract class AbstractDataServerExplorer extends AbstractDisposable implements DataServerExplorer_v2 {

    private DataServerExplorerParameters parameters;
    private final DataServerExplorerProviderServices providerServices;

    protected AbstractDataServerExplorer(DataServerExplorerParameters parameters, DataServerExplorerProviderServices providerServices) {
        this.parameters = parameters;
        this.providerServices = providerServices;
    }

    public DataServerExplorerProviderServices getServerExplorerProviderServices() {
        return this.providerServices;
    }
    
    @Override
    public DataServerExplorerParameters getParameters() {
        return this.parameters;
    }

    @Override
    protected void doDispose() throws BaseException {
        this.parameters = null;
    }

    @Override
    public DataStoreParameters get(String name) throws DataException {
        return null;
    }
    
    @Override
    public boolean exists(DataStoreParameters parameters) throws DataException {
        return true;
    }
    
    @Deprecated
    @Override
    public File getResourcePath(DataStore dataStore, String resourceName) throws DataException {
        return null;
    }

    @Override
    public ResourcesStorage getResourcesStorage() {
        EmptyResourcesStorage resourcesStorage = new EmptyResourcesStorage();
        return resourcesStorage;
    }
    
    @Override
    public ResourcesStorage getResourcesStorage(DataStore dataStore) {
        EmptyResourcesStorage resourcesStorage = new EmptyResourcesStorage();
        return resourcesStorage;
    }

    @Override
    public ResourcesStorage getResourcesStorage(DataStoreParameters parameters) {
        EmptyResourcesStorage resourcesStorage = new EmptyResourcesStorage();
        return resourcesStorage;
    }

    @Override
    public SQLBuilder createSQLBuilder() {
        return new SQLBuilderBase();
    }

}
