package org.gvsig.fmap.dal.spi;

import org.gvsig.fmap.dal.DataFactoryUnit;
import org.gvsig.fmap.dal.DataServerExplorerFactory;
import org.gvsig.fmap.dal.DataServerExplorerParameters;
import static org.gvsig.fmap.dal.DataStoreProviderFactory.UNKNOWN;
import org.gvsig.fmap.dal.exception.InitializeException;
import org.gvsig.tools.dynobject.DynObject;
import org.gvsig.tools.service.spi.Services;

public abstract class AbstractDataServerExplorerFactory
    extends AbstractDataFactory
    implements DataServerExplorerFactory {

    protected AbstractDataServerExplorerFactory(String name, String description) {
        super(name, description);
    }

    protected AbstractDataServerExplorerFactory(String name, String description, boolean hidden) {
        super(name, description,hidden);
    }

    @Override
    public DataFactoryUnit create(DynObject parameters, Services services) {
        try {
            return this.create(
                (DataServerExplorerParameters) parameters,
                (DataServerExplorerProviderServices) services
            );
        } catch (InitializeException ex) {
            throw new RuntimeException(ex);
        }
    }

    @Override
    public int allowCreate() {
        return UNKNOWN;
    }

    @Override
    public int hasTabularSupport() {
        return UNKNOWN;
    }

    @Override
    public int hasVectorialSupport() {
        return UNKNOWN;
    }

    @Override
    public int hasRasterSupport() {
        return UNKNOWN;
    }
}
