package org.gvsig.fmap.dal.swing;

import javax.swing.JComponent;
import org.gvsig.expressionevaluator.Expression;
import org.gvsig.fmap.dal.DataStore;

/**
 *
 * @author jjdelcerro
 */
public abstract class AbstractDALActionFactory implements DALActionFactory {

    public static abstract class AbstractDALActionContext implements DALActionContext {

        private final String name;

        protected AbstractDALActionContext(String name) {
            this.name = name;
        }

        @Override
        public String getName() {
            return name;
        }
        
        @Override
        public DataStore getStore() {
            return null;
        }

        @Override
        public Expression getFilter() {
            return null;
        }

        @Override
        public int getSelectedsCount() {
            return 0;
        }

        @Override
        public Expression getFilterForSelecteds() {
            return null;
        }

        @Override
        public JComponent getActionButton(String actionName) {
            return null;
        }

        @Override
        public Object get(String name) {
            return null;
        }

        @Override
        public void set(String name, Object value) {

        }
        
    }
    
    private final String name;
    
    protected AbstractDALActionFactory(String name) {
        this.name = name;
    }

    @Override
    public String getName() {
        return name;
    }

    @Override
    public boolean isApplicable(DALActionContext context) {
        return true;
    }
    
}
