package org.gvsig.fmap.dal.swing;

import javax.swing.Action;
import javax.swing.JComponent;
import org.gvsig.expressionevaluator.Expression;
import org.gvsig.fmap.dal.DataStore;

/**
 *
 * @author jjdelcerro
 */
public interface DALActionFactory {

    public interface DALActionContext {
        public String getName();
        public DataStore getStore();
        public Expression getFilter();
        public int getSelectedsCount();
        public Expression getFilterForSelecteds();
        public JComponent getActionButton(String actionName);
        public Object get(String name);
        public void set(String name, Object value);
    }
    
    public String getName();

    public boolean  isApplicable(DALActionContext context);
    
    public Action createAction(DALActionContext context);
    
}
