
package org.gvsig.fmap.dal.swing.dataStoreParameters;

import org.gvsig.tools.dynobject.DynObject;


public interface DataStoreParametersPanelFactory {
    
    public static final int LOWEST_PRIORITY = 1;
    public static final int DEFAULT_PRIORITY = 100;
    
    /**
     * Create the properties panel associated to the parameters.
     * @param parameters
     * @return the properties panel.
     */
    public DataStoreParametersPanel create(DynObject parameters);

    /**
     * Return true if this factory can apply to the parameters.
     * 
     * @param parameters
     * @return true if this factory can apply to the parameters
     */
    public boolean canBeApplied(DynObject parameters);
    
    /**
     * The priority of this factory.
     * Cuando hay mas de una factoria aplicable a unos parametros es cogida la
     * de prioridad mas alta.
     * 
     * @return the priority of this factory
     */
    public int getPriority();    
}
