
package org.gvsig.fmap.dal.swing.dataStoreParameters;

import org.gvsig.tools.dynobject.DynObject;


public interface DataStoreParametersPanelManager {
    /**
     * Register a new PropertiesPageFactory in this manager.
     * 
     * @param factory 
     */
    public void registerFactory(DataStoreParametersPanelFactory factory);
    
    /**
     * Return the factory associated to the passed parameters.
     * 
     * @param parameters
     * @return the factory for the parameters 
     */
    public DataStoreParametersPanelFactory getFactory(DynObject parameters);
    
    /**
     * Create and return the panel associated to the passed parameters,
     * 
     * @param parameters
     * @return the panel for the parameters  
     */
    public DataStoreParametersPanel createDataStoreParametersPanel(DynObject parameters);    
    
    public int showPropertiesDialog(DynObject parameters);
    
    public int showPropertiesDialog(final DynObject parameters, final DataStoreParametersPanel panel);

}
