package org.gvsig.fmap.dal.swing.featuretype;

import org.gvsig.fmap.dal.feature.EditableFeatureAttributeDescriptor;
import org.gvsig.fmap.dal.feature.FeatureAttributeDescriptor;
import org.gvsig.fmap.dal.feature.FeatureType;
import org.gvsig.tools.swing.api.Component;

/**
 *
 * @author jjdelcerro
 */
public interface FeatureTypeAttributePanel extends Component {
    
    public EditableFeatureAttributeDescriptor fetch(EditableFeatureAttributeDescriptor descriptor);
    
    public void put(FeatureAttributeDescriptor descriptor);
    
    public void clean();
    
    public void setNameAsNew(FeatureType featureType);
    
    public String getName();
    
    /**
     * Sets the display mode of the panel.
     * Can be:
     * <ul>
     * <li>MODE_EDIT_ONLY_METADATA, only allows you to modify the metadata. 
     *   It can be used without being in store edition.
     * </li>
     * <li>MODE_EDIT_ALL, allows you to modify all values. 
     * The store must be in edition.
     * </li>
     * <li>MODE_SHOW_ONLY, only display the values.</li>
     * </ul>
     * 
     * @see {FeatureTypePanel.setMode}
     * 
     * @param mode 
     */
    public void setMode(int mode);

    public int getMode();
}
