package org.gvsig.fmap.dal.swing.featuretype;

import org.gvsig.fmap.dal.feature.EditableFeatureType;
import org.gvsig.fmap.dal.feature.FeatureType;
import org.gvsig.tools.swing.api.ChangeListenerSupport;
import org.gvsig.tools.swing.api.Component;

/**
 *
 * @author jjdelcerro
 */
public interface FeatureTypePanel extends Component, ChangeListenerSupport {

    public static final String CONFIGURABLE_PANEL_ID = "FeatureTypePanel";

    public static final int MODE_EDIT_ONLY_METADATA = 0;
    public static final int MODE_EDIT_ALL = 1;
    public static final int MODE_SHOW_ONLY = 2;
    
    
    public EditableFeatureType fetch(EditableFeatureType type);
    
    public void put(FeatureType type);
    
    /**
     * Sets the display mode of the panel.
     * Can be:
     * <ul>
     * <li>MODE_EDIT_ONLY_METADATA, only allows you to modify the metadata. 
     *   It can be used without being in store edition.
     * </li>
     * <li>MODE_EDIT_ALL, allows you to modify all values. 
     * The store must be in edition.
     * </li>
     * <li>MODE_SHOW_ONLY, only display the values.</li>
     * </ul>
     * 
     * @param mode 
     */    
    public void setMode(int mode);
    
    public int getMode();

    public boolean isModifyingAField();
}
