package org.gvsig.fmap.dal.swing.jdbc;

import org.gvsig.fmap.dal.store.jdbc.JDBCServerExplorerParameters;
import org.gvsig.tools.swing.api.Component;
import org.gvsig.tools.util.LabeledValue;



public interface JDBCConnectionPanel extends Component {

    public interface ConnectorFilter {
        public boolean accept(JDBCServerExplorerParameters parameters);
    }
    
    public void setServerExplorerParameters(JDBCServerExplorerParameters parameters);
    
    public void setLabeledServerExplorerParameters(LabeledValue<JDBCServerExplorerParameters> parameters);
    
    public JDBCServerExplorerParameters getServerExplorerParameters();
    
    public LabeledValue<JDBCServerExplorerParameters> getLabeledServerExplorerParameters();
    
    public boolean areTheParametersValid();
    
    public String getParametersProblems();

    public void delete();
    
    public void clear();
    
    public String getConnectionName();
    
    public boolean isNewConnection();
    
    public void setConnectorFilter(ConnectorFilter connectorFilter);

}
