
package org.gvsig.fmap.dal.swing.impl.dataStoreParameters;

import java.awt.Dimension;
import javax.swing.JComponent;
import org.gvsig.fmap.dal.swing.dataStoreParameters.AbstractDataStoreParametersPanel;
import org.gvsig.tools.dynform.DynFormLocator;
import org.gvsig.tools.dynform.JDynForm;
import org.gvsig.tools.dynobject.DynObject;


public class DataStoreDynObjectParametersPanel extends AbstractDataStoreParametersPanel {
    private final DynObject parameters;
    private JDynForm form;

    public DataStoreDynObjectParametersPanel(DynObject paramters) {
     	this.parameters = paramters;
        this.form = DynFormLocator.getDynFormManager().createJDynForm(this.parameters);
    	this.form.setLayoutMode(this.form.USE_TABS);

    }

    @Override
    public void putParameters(DynObject parameters) {
        this.form.setValues(parameters);
    }

    @Override
    public void fetchParameters(DynObject parameters) {
        this.form.getValues(parameters);
    }

    @Override
    public JComponent asJComponent() {
        JComponent x = this.form.asJComponent();
        x.setPreferredSize(new Dimension(500,250));
        return x;
    }

    @Override
    public JDynForm getForm() {
        return this.form;
    }

}
