package org.gvsig.fmap.dal.swing.impl.expressionevaluator;

import java.net.URL;
import org.gvsig.expressionevaluator.swing.Element;
import org.gvsig.expressionevaluator.swing.ExpressionBuilderConfig;
import org.gvsig.expressionevaluator.swing.ExpressionEvaluatorSwingLocator;
import org.gvsig.expressionevaluator.swing.ExpressionEvaluatorSwingManager;
import org.gvsig.expressionevaluator.swing.spi.AbstractElementFactory;
import org.gvsig.fmap.dal.feature.FeatureStore;
import org.gvsig.fmap.dal.swing.DataSwingManager;
import org.gvsig.tools.swing.api.ToolsSwingLocator;
import org.gvsig.tools.swing.icontheme.IconTheme;

/**
 *
 * @author jjdelcerro
 */
public class FeatureStoreElementFactory extends AbstractElementFactory {

    public FeatureStoreElementFactory() {
        super(DataSwingManager.FEATURE_STORE_EXPRESSION_ELEMENT, null);
    }

    @Override
    public Element createElement(Object... parameters) {
        FeatureStore store = (FeatureStore) parameters[0];
        Element e = new DefaultFeatureStoreElement2(store);
        return e;
    }
    
    public static void selfRegister() {
        ExpressionEvaluatorSwingManager manager = ExpressionEvaluatorSwingLocator.getManager();
        manager.registerElement(new FeatureStoreElementFactory());

        URL url;
        IconTheme theme = ToolsSwingLocator.getIconThemeManager().getCurrent();
        url = FeatureStoreElementFactory.class.getResource("/org/gvsig/fmap/dal/swing/impl/expressionevaluator/expressionbuilder-element-table.png");
        theme.registerDefault("ExpressionBuilder", "element", "expressionbuilder-element-table", null, url);
        url = FeatureStoreElementFactory.class.getResource("/org/gvsig/fmap/dal/swing/impl/expressionevaluator/expressionbuilder-element-table-field.png");
        theme.registerDefault("ExpressionBuilder", "element", "expressionbuilder-element-table-field", null, url);
        
    }
}
