
package org.gvsig.fmap.dal.swing.impl.featuretable.table;

import java.text.DateFormat;
import java.util.List;
import java.util.Objects;
import org.cresques.cts.IProjection;
import org.gvsig.fmap.dal.feature.DataProfile;
import org.gvsig.fmap.dal.feature.FeatureAttributeDescriptor;
import org.gvsig.fmap.dal.feature.FeatureAttributeEmulator;
import org.gvsig.fmap.dal.feature.FeatureAttributeGetter;
import org.gvsig.fmap.dal.feature.FeatureStore;
import org.gvsig.fmap.dal.feature.FeatureType;
import org.gvsig.fmap.dal.feature.ForeingKey;
import org.gvsig.fmap.geom.Geometry;
import org.gvsig.fmap.geom.type.GeometryType;
import org.gvsig.timesupport.Interval;
import org.gvsig.tools.dataTypes.CoercionException;
import org.gvsig.tools.dataTypes.DataType;
import org.gvsig.tools.dynobject.DynField;
import org.gvsig.tools.dynobject.DynField_v2;
import org.gvsig.tools.dynobject.DynMethod;
import org.gvsig.tools.dynobject.DynObject;
import org.gvsig.tools.dynobject.DynObjectValueItem;
import org.gvsig.tools.dynobject.DynStruct;
import org.gvsig.tools.dynobject.Tags;
import org.gvsig.tools.dynobject.exception.DynFieldIsNotAContainerException;
import org.gvsig.tools.dynobject.exception.DynFieldValidateException;
import org.gvsig.tools.evaluator.Evaluator;


public class DynFieldFacadeOfAFeatureAttributeDescriptor implements FeatureAttributeDescriptor {

    private DynField field;
    public DynFieldFacadeOfAFeatureAttributeDescriptor(DynField field) {
        this.field = field;
    }
    
    @Override
    public FeatureAttributeDescriptor getCopy() {
        try {
            return (FeatureAttributeDescriptor) field.clone();
        } catch (CloneNotSupportedException ex) {
            throw new RuntimeException(ex);
        }
    }

    @Override
    public String getDataTypeName() {
        return field.getDataType().getName();
    }

    @Override
    public int getSize() {
        return 1;
    }

    @Override
    public int getPrecision() {
        return 0;
    }

    @Override
    public Class getObjectClass() {
        return this.getDataType().getDefaultClass();
    }

    @Override
    public int getMinimumOccurrences() {
        return 0;
    }

    @Override
    public int getMaximumOccurrences() {
        return 0;
    }

    @Override
    public boolean isPrimaryKey() {
        return false;
    }

    @Override
    public boolean allowNull() {
        return true;
    }

    @Override
    public Evaluator getEvaluator() {
        return null;
    }

    @Override
    public IProjection getSRS() {
        return null;
    }

    @Override
    public int getGeometryType() {
        return Geometry.TYPES.GEOMETRY;
    }

    @Override
    public int getGeometrySubType() {
        return Geometry.SUBTYPES.UNKNOWN;
    }

    @Override
    public GeometryType getGeomType() {
        return null;
    }

    @Override
    public DateFormat getDateFormat() {
        return null;
    }

    @Override
    public int getIndex() {
        return -1;
    }

    @Override
    public Object getAdditionalInfo(String infoName) {
        return null;
    }

    @Override
    public boolean isAutomatic() {
        return false;
    }

    @Override
    public boolean isTime() {
        return false;
    }

    @Override
    public boolean isIndexed() {
        return false;
    }

    @Override
    public boolean allowIndexDuplicateds() {
        return false;
    }

    @Override
    public boolean isIndexAscending() {
        return false;
    }

    @Override
    public FeatureAttributeGetter getFeatureAttributeGetter() {
        return null;
    }

    @Override
    public void setFeatureAttributeGetter(FeatureAttributeGetter featureAttributeGetter) {
    }

    @Override
    public FeatureAttributeEmulator getFeatureAttributeEmulator() {
        return null;
    }

    @Override
    public String getName() {
        return this.field.getName();
    }

    @Override
    public int getType() {
        return this.field.getDataType().getType();
    }

    @Override
    public DataType getDataType() {
        return this.field.getDataType();
    }

    @Override
    public String getSubtype() {
        return null;
    }

    @Override
    public String getDescription() {
        return this.field.getDescription();
    }

    @Override
    public Object getDefaultValue() {
        return this.field.getDefaultValue();
    }

    @Override
    public String getGroup() {
        return this.field.getGroup();
    }

    @Override
    public int getOder() {
        return this.field.getOder();
    }

    @Override
    public boolean isMandatory() {
        return this.field.isMandatory();
    }

    @Override
    public boolean isPersistent() {
        return this.field.isPersistent();
    }

    @Override
    public boolean isHidden() {
        return this.field.isHidden();
    }

    @Override
    public boolean isReadOnly() {
        return this.field.isReadOnly();
    }

    @Override
    public boolean isContainer() {
        return this.field.isContainer();
    }

    @Override
    public DynObjectValueItem[] getAvailableValues() {
        return this.field.getAvailableValues();
    }

    @Override
    public Object getMinValue() {
        return this.field.getMinValue();
    }

    @Override
    public Object getMaxValue() {
        return this.field.getMaxValue();
    }

    @Override
    public Class getClassOfValue() {
        return this.field.getClassOfValue();
    }

    @Override
    public Class getClassOfItems() {
        return this.field.getClassOfItems();
    }

    @Override
    public DynField setDescription(String description) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public DynField setType(int type) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public DynField setType(DataType type) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public DynField setSubtype(String subtype) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public DynField setDefaultFieldValue(Object defaultValue) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public DynField setGroup(String groupName) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public DynField setOrder(int order) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public DynField setMandatory(boolean mandatory) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public DynField setHidden(boolean hidden) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public DynField setPersistent(boolean persistent) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public DynField setAvailableValues(DynObjectValueItem[] values) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public DynField setAvailableValues(List values) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public DynField setMinValue(Object minValue) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public DynField setMaxValue(Object maxValue) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public DynField setClassOfValue(Class theClass) throws DynFieldIsNotAContainerException {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public DynField setClassOfItems(Class theClass) throws DynFieldIsNotAContainerException {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public DynField setReadOnly(boolean isReadOnly) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public DynField getElementsType() {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public DynField setElementsType(int type) throws DynFieldIsNotAContainerException {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public DynField setElementsType(DynStruct type) throws DynFieldIsNotAContainerException {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public void validate(Object value) throws DynFieldValidateException {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public Object coerce(Object value) throws CoercionException {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public int getTheTypeOfAvailableValues() {
        return this.field.getTheTypeOfAvailableValues();
    }

    @Override
    public DynField setDefaultDynValue(Object defaultValue) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public DynField setTheTypeOfAvailableValues(int type) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public Object clone() throws CloneNotSupportedException {
        DynFieldFacadeOfAFeatureAttributeDescriptor other = (DynFieldFacadeOfAFeatureAttributeDescriptor) super.clone(); 
        other.field = (DynField) other.field.clone();
        return other;
    }

    @Override
    public boolean isComputed() {
        if( field instanceof DynField_v2 ) {
            return ((DynField_v2)field).isCalculated();
        }
        return false;
    }

    @Override
    public FeatureStore getStore() {
        return null;
    }

    @Override
    public FeatureType getFeatureType() {
        return null;
    }

    @Override
    public Interval getInterval() {
        return null;
    }

    @Override
    public String getDataProfileName() {
        return null;
    }

    @Override
    public String[] getRequiredFieldNames() {
        return null;
    }

    @Override
    public DynField setClassOfValue(DynStruct dynStrct) {
        ((DynField_v2)this.field).setClassOfValue(dynStrct);
        return this;
    }

    @Override
    public DynField setClassOfValue(String theClassNameOfValue) {
        ((DynField_v2)this.field).setClassOfValue(theClassNameOfValue);
        return this;
    }

    @Override
    public String getClassNameOfValue() {
        return ((DynField_v2)this.field).getClassNameOfValue();
    }

    @Override
    public DynStruct getDynClassOfValue() {
        return ((DynField_v2)this.field).getDynClassOfValue();
    }

    @Override
    public DynField setTypeOfItems(int type) {
        ((DynField_v2)this.field).setTypeOfItems(type);
        return this;
    }

    @Override
    public int getTypeOfItems() {
        return ((DynField_v2)this.field).getTypeOfItems();
    }

    @Override
    public DynField setClassOfItems(DynStruct dynStrct) {
        ((DynField_v2)this.field).setClassOfItems(dynStrct);
        return this;
    }

    @Override
    public DynField setClassOfItems(String theClassNameOfValue) {
        ((DynField_v2)this.field).setClassOfItems(theClassNameOfValue);
        return this;
    }

    @Override
    public String getClassNameOfItems() {
        return ((DynField_v2)this.field).getClassNameOfItems();
    }

    @Override
    public DynStruct getDynClassOfItems() {
        return ((DynField_v2)this.field).getDynClassOfItems();
    }

    @Override
    public Tags getTags() {
        return ((DynField_v2)this.field).getTags();
    }

    @Override
    public DynField setRelationType(int relationType) {
        ((DynField_v2)this.field).setRelationType(relationType);
        return this;
    }

    @Override
    public int getRelationType() {
        return ((DynField_v2)this.field).getRelationType();
    }

    @Override
    public DynField setAvailableValues(DynMethod computeAvailableValues) {
        ((DynField_v2)this.field).setAvailableValues(computeAvailableValues);
        return this;
    }

    @Override
    public DynMethod getAvailableValuesMethod() {
        return ((DynField_v2)this.field).getAvailableValuesMethod();
    }

    @Override
    public DynObjectValueItem[] getAvailableValues(DynObject self) {
        return ((DynField_v2)this.field).getAvailableValues(self);
    }

    @Override
    public boolean isAvailableValuesCalculated() {
        return ((DynField_v2)this.field).isAvailableValuesCalculated();
    }

    @Override
    public DynField setCalculateMethod(DynMethod computeValue) {
        ((DynField_v2)this.field).setCalculateMethod(computeValue);
        return this;
    }

    @Override
    public DynMethod getCalculateMethod() {
        return ((DynField_v2)this.field).getCalculateMethod();
    }

    @Override
    public boolean isCalculated() {
        return ((DynField_v2)this.field).isCalculated();
    }

    @Override
    public Object getCalculatedValue(DynObject self) {
        return ((DynField_v2)this.field).getCalculatedValue(self);
    }

    @Override
    public void copyFrom(DynField other) {
        ((DynField_v2)this.field).copyFrom(other);
    }

    @Override
    public DynField setValidateElements(boolean validate) {
        ((DynField_v2)this.field).setValidateElements(validate);
        return this;
    }

    @Override
    public boolean getValidateElements() {
        return ((DynField_v2)this.field).getValidateElements();
    }

    @Override
    public String getLabel() {
        return ((DynField_v2)this.field).getLabel();
    }

    @Override
    public DynField setLabel(String label) {
        ((DynField_v2)this.field).setLabel(label);
        return this;
    }

    @Override
    public void recentUsed() {
    }

    @Override
    public boolean isForeingKey() {
        return false;
    }

    @Override
    public ForeingKey getForeingKey() {
        return null;
    }

    @Override
    public String getShortLabel() {
        return ((DynField_v2)field).getShortLabel();
    }

    @Override
    public DynField setShortLabel(String shortLabel) {
        ((DynField_v2)field).setShortLabel(shortLabel);
        return this;
    }

    @Override
    public String getLocalizedShortLabel() {
        return ((DynField_v2)field).getLocalizedShortLabel();
    }

    @Override
    public String getLocalizedLabel() {
        return ((DynField_v2)field).getLocalizedLabel();
    }

    @Override
    public String getLabelOfValue(Object value) {
        return Objects.toString(value, "");
    }

    @Override
    public DataProfile getDataProfile() {
        return null;
    }

    @Override
    public boolean hasOnlyMetadataChanges(FeatureAttributeDescriptor other) {
        return false;
    }

}
