package org.gvsig.fmap.dal.swing.impl.featuretype;

import com.jeta.open.i18n.I18NUtils;
import com.jgoodies.forms.layout.CellConstraints;
import com.jgoodies.forms.layout.FormLayout;
import java.awt.BorderLayout;
import java.awt.ComponentOrientation;
import java.awt.Container;
import java.awt.Dimension;
import javax.swing.Box;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.JTable;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.border.EmptyBorder;


public class FeatureTypeAttributePanelView extends JPanel
{
   JLabel lblFieldName = new JLabel();
   JTextField txtFieldName = new JTextField();
   JLabel lblFieldType = new JLabel();
   JComboBox cboFieldType = new JComboBox();
   JTabbedPane tabAditionalFields = new JTabbedPane();
   JLabel lblSize = new JLabel();
   JTextField txtSize = new JTextField();
   JLabel lblPrecision = new JLabel();
   JLabel lblDefaultValue = new JLabel();
   JTextField txtPrecision = new JTextField();
   JTextField txtDefaultValue = new JTextField();
   JLabel lblDataProfile = new JLabel();
   JComboBox cboDataProfile = new JComboBox();
   JCheckBox chkVirtualField = new JCheckBox();
   JButton btnVirtualField = new JButton();
   JTextField txtVirtualField = new JTextField();
   JLabel lblGeometryType = new JLabel();
   JLabel lblGeometrySubtype = new JLabel();
   JLabel lblCRS = new JLabel();
   JComboBox cboGeometryType = new JComboBox();
   JComboBox cboGeometrySubtype = new JComboBox();
   JButton btnCRS = new JButton();
   JTextField txtCRS = new JTextField();
   JLabel lblDateFormat = new JLabel();
   JComboBox cboDateFormat = new JComboBox();
   JLabel lblInterval = new JLabel();
   JLabel lblIntervalStart = new JLabel();
   JLabel lblIntervalEnd = new JLabel();
   JTextField txtIntervalStart = new JTextField();
   JButton btnIntervalStart = new JButton();
   JButton btnIntervalEnd = new JButton();
   JTextField txtIntervalEnd = new JTextField();
   JLabel lblTagsName = new JLabel();
   JLabel lblTagsValue = new JLabel();
   JComboBox cboTagsName = new JComboBox();
   JTable tblTags = new JTable();
   JLabel lblTagsDescription = new JLabel();
   JButton btnTagsAdd = new JButton();
   JButton btnTagsUpdate = new JButton();
   JButton btnTagsRemove = new JButton();
   JComboBox cboTagsValue = new JComboBox();
   JCheckBox chkIsForeingKey = new JCheckBox();
   JLabel lblForeingKeyTableName = new JLabel();
   JLabel lblForeingKeyCodeName = new JLabel();
   JLabel lblForeingKeyLabelFormula = new JLabel();
   JComboBox cboForeingKeyTableName = new JComboBox();
   JComboBox cboForeingKeyCodeName = new JComboBox();
   JTextField txtForeingKeyFormula = new JTextField();
   JButton btnForeingKeyFormula = new JButton();
   JLabel lblIsClosedList = new JLabel();
   JCheckBox chkIsClosedList = new JCheckBox();
   JTabbedPane tabLayout = new JTabbedPane();
   JLabel lblGroup = new JLabel();
   JLabel lblOrder = new JLabel();
   JComboBox cboGroup = new JComboBox();
   JTextField txtOrder = new JTextField();
   JLabel lblHidden = new JLabel();
   JCheckBox chkHidden = new JCheckBox();
   JLabel lblLabel = new JLabel();
   JTextField txtLabel = new JTextField();
   JLabel lblDescription = new JLabel();
   JTextArea txtDescription = new JTextArea();
   JLabel lblMinValue = new JLabel();
   JTextField txtMinValue = new JTextField();
   JLabel lblMaxValue = new JLabel();
   JTextField txtMaxValue = new JTextField();
   JLabel lblAvailableValues = new JLabel();
   JButton btnAvailableValuesAdd = new JButton();
   JButton btnAvailableValuesUpdate = new JButton();
   JButton btnAvailableValuesRemove = new JButton();
   JLabel lblAvailableValuesLabel = new JLabel();
   JLabel lblAvailableValuesValue = new JLabel();
   JComboBox cboAvailableValues = new JComboBox();
   JTextField txtAvailableValuesLabel = new JTextField();
   JTextField txtAvailableValuesValue = new JTextField();
   JLabel lblIsPrimaryKey = new JLabel();
   JCheckBox chkIsPrimaryKey = new JCheckBox();
   JLabel lblIsAutomatic = new JLabel();
   JCheckBox chkIsAutomatic = new JCheckBox();
   JLabel lblAllowNulls = new JLabel();
   JCheckBox chkAllowNulls = new JCheckBox();

   /**
    * Default constructor
    */
   public FeatureTypeAttributePanelView()
   {
      initializePanel();
   }

   /**
    * Adds fill components to empty cells in the first row and first column of the grid.
    * This ensures that the grid spacing will be the same as shown in the designer.
    * @param cols an array of column indices in the first row where fill components should be added.
    * @param rows an array of row indices in the first column where fill components should be added.
    */
   void addFillComponents( Container panel, int[] cols, int[] rows )
   {
      Dimension filler = new Dimension(10,10);

      boolean filled_cell_11 = false;
      CellConstraints cc = new CellConstraints();
      if ( cols.length > 0 && rows.length > 0 )
      {
         if ( cols[0] == 1 && rows[0] == 1 )
         {
            /** add a rigid area  */
            panel.add( Box.createRigidArea( filler ), cc.xy(1,1) );
            filled_cell_11 = true;
         }
      }

      for( int index = 0; index < cols.length; index++ )
      {
         if ( cols[index] == 1 && filled_cell_11 )
         {
            continue;
         }
         panel.add( Box.createRigidArea( filler ), cc.xy(cols[index],1) );
      }

      for( int index = 0; index < rows.length; index++ )
      {
         if ( rows[index] == 1 && filled_cell_11 )
         {
            continue;
         }
         panel.add( Box.createRigidArea( filler ), cc.xy(1,rows[index]) );
      }

   }

   /**
    * Helper method to load an image file from the CLASSPATH
    * @param imageName the package and name of the file to load relative to the CLASSPATH
    * @return an ImageIcon instance with the specified image file
    * @throws IllegalArgumentException if the image resource cannot be loaded.
    */
   public ImageIcon loadImage( String imageName )
   {
      try
      {
         ClassLoader classloader = getClass().getClassLoader();
         java.net.URL url = classloader.getResource( imageName );
         if ( url != null )
         {
            ImageIcon icon = new ImageIcon( url );
            return icon;
         }
      }
      catch( Exception e )
      {
         e.printStackTrace();
      }
      throw new IllegalArgumentException( "Unable to load image: " + imageName );
   }

   /**
    * Method for recalculating the component orientation for 
    * right-to-left Locales.
    * @param orientation the component orientation to be applied
    */
   public void applyComponentOrientation( ComponentOrientation orientation )
   {
      // Not yet implemented...
      // I18NUtils.applyComponentOrientation(this, orientation);
      super.applyComponentOrientation(orientation);
   }

   public JPanel createPanel()
   {
      JPanel jpanel1 = new JPanel();
      FormLayout formlayout1 = new FormLayout("FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:GROW(1.0),FILL:4DLU:NONE","CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,FILL:DEFAULT:NONE,CENTER:2DLU:NONE");
      CellConstraints cc = new CellConstraints();
      jpanel1.setLayout(formlayout1);

      lblFieldName.setName("lblFieldName");
      lblFieldName.setText("_Field_name");
      jpanel1.add(lblFieldName,cc.xy(2,2));

      txtFieldName.setName("txtFieldName");
      jpanel1.add(txtFieldName,cc.xy(4,2));

      lblFieldType.setName("lblFieldType");
      lblFieldType.setText("_Field_type");
      jpanel1.add(lblFieldType,cc.xy(2,4));

      cboFieldType.setName("cboFieldType");
      jpanel1.add(cboFieldType,cc.xy(4,4));

      tabAditionalFields.setName("tabAditionalFields");
      tabAditionalFields.addTab("_Basic_fields",null,createPanel1());
      tabAditionalFields.addTab("_Geometry",null,createPanel3());
      tabAditionalFields.addTab("_Time",null,createPanel5());
      tabAditionalFields.addTab("_Tags",null,createPanel7());
      tabAditionalFields.addTab("_ForeingKey",null,createPanel10());
      tabAditionalFields.addTab("_Visualization",null,createPanel11());
      jpanel1.add(tabAditionalFields,cc.xywh(2,8,3,1));

      jpanel1.add(createPanel17(),cc.xy(4,6));
      addFillComponents(jpanel1,new int[]{ 1,2,3,4,5 },new int[]{ 1,2,3,4,5,6,7,8,9 });
      return jpanel1;
   }

   public JPanel createPanel1()
   {
      JPanel jpanel1 = new JPanel();
      FormLayout formlayout1 = new FormLayout("FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:GROW(1.0),FILL:4DLU:NONE","CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE");
      CellConstraints cc = new CellConstraints();
      jpanel1.setLayout(formlayout1);

      lblSize.setName("lblSize");
      lblSize.setText("_Size");
      jpanel1.add(lblSize,cc.xy(2,2));

      txtSize.setName("txtSize");
      jpanel1.add(txtSize,cc.xy(4,2));

      lblPrecision.setName("lblPrecision");
      lblPrecision.setText("_Precision");
      jpanel1.add(lblPrecision,cc.xy(2,4));

      lblDefaultValue.setName("lblDefaultValue");
      lblDefaultValue.setText("_Default_value");
      jpanel1.add(lblDefaultValue,cc.xy(2,6));

      txtPrecision.setName("txtPrecision");
      jpanel1.add(txtPrecision,cc.xy(4,4));

      txtDefaultValue.setName("txtDefaultValue");
      jpanel1.add(txtDefaultValue,cc.xy(4,6));

      lblDataProfile.setName("lblDataProfile");
      lblDataProfile.setText("_Data_profile");
      jpanel1.add(lblDataProfile,cc.xy(2,8));

      cboDataProfile.setName("cboDataProfile");
      jpanel1.add(cboDataProfile,cc.xy(4,8));

      chkVirtualField.setActionCommand("Campo virtual");
      chkVirtualField.setName("chkVirtualField");
      chkVirtualField.setText("_Virtual_field");
      jpanel1.add(chkVirtualField,cc.xy(2,10));

      jpanel1.add(createPanel2(),cc.xy(4,10));
      addFillComponents(jpanel1,new int[]{ 1,2,3,4,5 },new int[]{ 1,2,3,4,5,6,7,8,9,10 });
      return jpanel1;
   }

   public JPanel createPanel2()
   {
      JPanel jpanel1 = new JPanel();
      FormLayout formlayout1 = new FormLayout("FILL:DEFAULT:GROW(1.0),FILL:4DLU:NONE,FILL:DEFAULT:NONE","CENTER:DEFAULT:NONE");
      CellConstraints cc = new CellConstraints();
      jpanel1.setLayout(formlayout1);

      btnVirtualField.setActionCommand("...");
      btnVirtualField.setName("btnVirtualField");
      btnVirtualField.setText("...");
      EmptyBorder emptyborder1 = new EmptyBorder(2,2,2,2);
      btnVirtualField.setBorder(emptyborder1);
      jpanel1.add(btnVirtualField,cc.xy(3,1));

      txtVirtualField.setName("txtVirtualField");
      jpanel1.add(txtVirtualField,cc.xy(1,1));

      addFillComponents(jpanel1,new int[]{ 2 },new int[0]);
      return jpanel1;
   }

   public JPanel createPanel3()
   {
      JPanel jpanel1 = new JPanel();
      FormLayout formlayout1 = new FormLayout("FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:GROW(1.0),FILL:4DLU:NONE","CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE");
      CellConstraints cc = new CellConstraints();
      jpanel1.setLayout(formlayout1);

      lblGeometryType.setName("lblGeometryType");
      lblGeometryType.setText("_Geometry_type");
      jpanel1.add(lblGeometryType,cc.xy(2,2));

      lblGeometrySubtype.setName("lblGeometrySubtype");
      lblGeometrySubtype.setText("_Geometry_subtype");
      jpanel1.add(lblGeometrySubtype,cc.xy(2,4));

      lblCRS.setName("lblCRS");
      lblCRS.setText("_CRS");
      jpanel1.add(lblCRS,cc.xy(2,6));

      cboGeometryType.setName("cboGeometryType");
      jpanel1.add(cboGeometryType,cc.xy(4,2));

      cboGeometrySubtype.setName("cboGeometrySubtype");
      jpanel1.add(cboGeometrySubtype,cc.xy(4,4));

      jpanel1.add(createPanel4(),cc.xy(4,6));
      addFillComponents(jpanel1,new int[]{ 1,2,3,4,5 },new int[]{ 1,2,3,4,5,6,7 });
      return jpanel1;
   }

   public JPanel createPanel4()
   {
      JPanel jpanel1 = new JPanel();
      FormLayout formlayout1 = new FormLayout("FILL:DEFAULT:GROW(1.0),FILL:4DLU:NONE,FILL:DEFAULT:NONE","CENTER:DEFAULT:NONE");
      CellConstraints cc = new CellConstraints();
      jpanel1.setLayout(formlayout1);

      btnCRS.setActionCommand("...");
      btnCRS.setName("btnCRS");
      btnCRS.setText("...");
      EmptyBorder emptyborder1 = new EmptyBorder(2,2,2,2);
      btnCRS.setBorder(emptyborder1);
      jpanel1.add(btnCRS,cc.xy(3,1));

      txtCRS.setName("txtCRS");
      jpanel1.add(txtCRS,cc.xy(1,1));

      addFillComponents(jpanel1,new int[]{ 2 },new int[0]);
      return jpanel1;
   }

   public JPanel createPanel5()
   {
      JPanel jpanel1 = new JPanel();
      FormLayout formlayout1 = new FormLayout("FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:GROW(1.0),FILL:4DLU:NONE","CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE");
      CellConstraints cc = new CellConstraints();
      jpanel1.setLayout(formlayout1);

      lblDateFormat.setName("lblDateFormat");
      lblDateFormat.setText("_Date_format");
      jpanel1.add(lblDateFormat,cc.xy(2,2));

      cboDateFormat.setEditable(true);
      cboDateFormat.setName("cboDateFormat");
      cboDateFormat.setRequestFocusEnabled(false);
      jpanel1.add(cboDateFormat,cc.xy(4,2));

      lblInterval.setName("lblInterval");
      lblInterval.setText("_Interval");
      jpanel1.add(lblInterval,new CellConstraints(2,5,1,1,CellConstraints.DEFAULT,CellConstraints.TOP));

      jpanel1.add(createPanel6(),cc.xy(4,5));
      addFillComponents(jpanel1,new int[]{ 1,2,3,4,5 },new int[]{ 1,2,3,4,5,6 });
      return jpanel1;
   }

   public JPanel createPanel6()
   {
      JPanel jpanel1 = new JPanel();
      FormLayout formlayout1 = new FormLayout("FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:GROW(1.0),FILL:4DLU:NONE,FILL:DEFAULT:NONE","CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE");
      CellConstraints cc = new CellConstraints();
      jpanel1.setLayout(formlayout1);

      lblIntervalStart.setName("lblIntervalStart");
      lblIntervalStart.setText("_Start");
      jpanel1.add(lblIntervalStart,cc.xy(1,1));

      lblIntervalEnd.setName("lblIntervalEnd");
      lblIntervalEnd.setText("_End");
      jpanel1.add(lblIntervalEnd,cc.xy(1,3));

      txtIntervalStart.setName("txtIntervalStart");
      jpanel1.add(txtIntervalStart,cc.xy(3,1));

      btnIntervalStart.setActionCommand("...");
      btnIntervalStart.setName("btnIntervalStart");
      btnIntervalStart.setText("...");
      EmptyBorder emptyborder1 = new EmptyBorder(2,2,2,2);
      btnIntervalStart.setBorder(emptyborder1);
      jpanel1.add(btnIntervalStart,cc.xy(5,1));

      btnIntervalEnd.setActionCommand("...");
      btnIntervalEnd.setName("btnIntervalEnd");
      btnIntervalEnd.setText("...");
      EmptyBorder emptyborder2 = new EmptyBorder(2,2,2,2);
      btnIntervalEnd.setBorder(emptyborder2);
      jpanel1.add(btnIntervalEnd,cc.xy(5,3));

      txtIntervalEnd.setName("txtIntervalEnd");
      jpanel1.add(txtIntervalEnd,cc.xy(3,3));

      addFillComponents(jpanel1,new int[]{ 2,4 },new int[]{ 2 });
      return jpanel1;
   }

   public JPanel createPanel7()
   {
      JPanel jpanel1 = new JPanel();
      FormLayout formlayout1 = new FormLayout("FILL:DEFAULT:GROW(1.0)","FILL:DEFAULT:GROW(1.0)");
      CellConstraints cc = new CellConstraints();
      jpanel1.setLayout(formlayout1);

      jpanel1.add(createPanel8(),cc.xy(1,1));
      addFillComponents(jpanel1,new int[]{ 1 },new int[]{ 1 });
      return jpanel1;
   }

   public JPanel createPanel8()
   {
      JPanel jpanel1 = new JPanel();
      FormLayout formlayout1 = new FormLayout("FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:GROW(1.0),FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE","FILL:DEFAULT:GROW(1.0),CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE");
      CellConstraints cc = new CellConstraints();
      jpanel1.setLayout(formlayout1);

      lblTagsName.setName("lblTagsName");
      lblTagsName.setText("_Name");
      jpanel1.add(lblTagsName,cc.xy(2,3));

      lblTagsValue.setName("lblTagsValue");
      lblTagsValue.setText("_Value");
      jpanel1.add(lblTagsValue,cc.xy(2,5));

      cboTagsName.setEditable(true);
      cboTagsName.setName("cboTagsName");
      cboTagsName.setRequestFocusEnabled(false);
      jpanel1.add(cboTagsName,cc.xy(4,3));

      tblTags.setName("tblTags");
      JScrollPane jscrollpane1 = new JScrollPane();
      jscrollpane1.setViewportView(tblTags);
      jscrollpane1.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
      jscrollpane1.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
      jpanel1.add(jscrollpane1,cc.xywh(2,1,3,1));

      lblTagsDescription.setName("lblTagsDescription");
      jpanel1.add(lblTagsDescription,cc.xy(4,6));

      jpanel1.add(createPanel9(),cc.xywh(6,1,1,5));
      cboTagsValue.setEditable(true);
      cboTagsValue.setName("cboTagsValue");
      cboTagsValue.setRequestFocusEnabled(false);
      jpanel1.add(cboTagsValue,cc.xy(4,5));

      addFillComponents(jpanel1,new int[]{ 1,3,4,5,6,7 },new int[]{ 1,2,3,4,5,6 });
      return jpanel1;
   }

   public JPanel createPanel9()
   {
      JPanel jpanel1 = new JPanel();
      FormLayout formlayout1 = new FormLayout("FILL:DEFAULT:NONE","CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE");
      CellConstraints cc = new CellConstraints();
      jpanel1.setLayout(formlayout1);

      btnTagsAdd.setActionCommand("_Add");
      btnTagsAdd.setName("btnTagsAdd");
      btnTagsAdd.setText("_Add");
      jpanel1.add(btnTagsAdd,cc.xy(1,1));

      btnTagsUpdate.setActionCommand("_Update");
      btnTagsUpdate.setName("btnTagsUpdate");
      btnTagsUpdate.setText("_Update");
      jpanel1.add(btnTagsUpdate,cc.xy(1,3));

      btnTagsRemove.setActionCommand("_Remove");
      btnTagsRemove.setName("btnTagsRemove");
      btnTagsRemove.setText("_Remove");
      jpanel1.add(btnTagsRemove,cc.xy(1,5));

      addFillComponents(jpanel1,new int[0],new int[]{ 2,4 });
      return jpanel1;
   }

   public JPanel createPanel10()
   {
      JPanel jpanel1 = new JPanel();
      FormLayout formlayout1 = new FormLayout("FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:GROW(1.0),FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE","CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE");
      CellConstraints cc = new CellConstraints();
      jpanel1.setLayout(formlayout1);

      chkIsForeingKey.setActionCommand("_is_foreing_key");
      chkIsForeingKey.setName("chkIsForeingKey");
      chkIsForeingKey.setText("_is_foreing_key");
      jpanel1.add(chkIsForeingKey,cc.xywh(2,2,3,1));

      lblForeingKeyTableName.setName("lblForeingKeyTableName");
      lblForeingKeyTableName.setText("_Table");
      jpanel1.add(lblForeingKeyTableName,cc.xy(2,6));

      lblForeingKeyCodeName.setName("lblForeingKeyCodeName");
      lblForeingKeyCodeName.setText("_Code");
      jpanel1.add(lblForeingKeyCodeName,cc.xy(2,8));

      lblForeingKeyLabelFormula.setName("lblForeingKeyLabelFormula");
      lblForeingKeyLabelFormula.setText("_Label_formula");
      jpanel1.add(lblForeingKeyLabelFormula,cc.xy(2,10));

      cboForeingKeyTableName.setEditable(true);
      cboForeingKeyTableName.setName("cboForeingKeyTableName");
      cboForeingKeyTableName.setRequestFocusEnabled(false);
      jpanel1.add(cboForeingKeyTableName,cc.xywh(4,6,3,1));

      cboForeingKeyCodeName.setEditable(true);
      cboForeingKeyCodeName.setName("cboForeingKeyCodeName");
      cboForeingKeyCodeName.setRequestFocusEnabled(false);
      jpanel1.add(cboForeingKeyCodeName,cc.xywh(4,8,3,1));

      txtForeingKeyFormula.setName("txtForeingKeyFormula");
      jpanel1.add(txtForeingKeyFormula,cc.xy(4,10));

      btnForeingKeyFormula.setActionCommand("...");
      btnForeingKeyFormula.setName("btnForeingKeyFormula");
      btnForeingKeyFormula.setText("...");
      jpanel1.add(btnForeingKeyFormula,cc.xy(6,10));

      lblIsClosedList.setName("lblIsClosedList");
      lblIsClosedList.setText("_is_closed_list");
      jpanel1.add(lblIsClosedList,cc.xy(2,4));

      chkIsClosedList.setName("chkIsClosedList");
      jpanel1.add(chkIsClosedList,cc.xy(4,4));

      addFillComponents(jpanel1,new int[]{ 1,2,3,4,5,6,7 },new int[]{ 1,2,3,4,5,6,7,8,9,10,11 });
      return jpanel1;
   }

   public JPanel createPanel11()
   {
      JPanel jpanel1 = new JPanel();
      FormLayout formlayout1 = new FormLayout("FILL:DEFAULT:GROW(1.0)","FILL:DEFAULT:GROW(1.0)");
      CellConstraints cc = new CellConstraints();
      jpanel1.setLayout(formlayout1);

      tabLayout.setName("tabLayout");
      tabLayout.setTabPlacement(JTabbedPane.LEFT);
      tabLayout.addTab("_Basic",null,createPanel12());
      tabLayout.addTab("_Values",null,createPanel13());
      jpanel1.add(tabLayout,cc.xy(1,1));

      addFillComponents(jpanel1,new int[0],new int[0]);
      return jpanel1;
   }

   public JPanel createPanel12()
   {
      JPanel jpanel1 = new JPanel();
      FormLayout formlayout1 = new FormLayout("FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:GROW(1.0),FILL:4DLU:NONE","CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,FILL:DEFAULT:GROW(0.2)");
      CellConstraints cc = new CellConstraints();
      jpanel1.setLayout(formlayout1);

      lblGroup.setName("lblGroup");
      lblGroup.setText("_Group");
      jpanel1.add(lblGroup,cc.xy(2,2));

      lblOrder.setName("lblOrder");
      lblOrder.setText("_Order");
      jpanel1.add(lblOrder,cc.xy(2,4));

      cboGroup.setEditable(true);
      cboGroup.setName("cboGroup");
      cboGroup.setRequestFocusEnabled(false);
      jpanel1.add(cboGroup,cc.xy(4,2));

      txtOrder.setName("txtOrder");
      jpanel1.add(txtOrder,cc.xy(4,4));

      lblHidden.setName("lblHidden");
      lblHidden.setText("_Hidden");
      jpanel1.add(lblHidden,cc.xy(2,6));

      chkHidden.setName("chkHidden");
      jpanel1.add(chkHidden,cc.xy(4,6));

      lblLabel.setName("lblLabel");
      lblLabel.setText("_Label");
      jpanel1.add(lblLabel,cc.xy(2,8));

      txtLabel.setName("txtLabel");
      jpanel1.add(txtLabel,cc.xy(4,8));

      lblDescription.setName("lblDescription");
      lblDescription.setText("_Description");
      lblDescription.setVerticalAlignment(JLabel.TOP);
      jpanel1.add(lblDescription,new CellConstraints(2,10,1,1,CellConstraints.DEFAULT,CellConstraints.TOP));

      txtDescription.setName("txtDescription");
      JScrollPane jscrollpane1 = new JScrollPane();
      jscrollpane1.setViewportView(txtDescription);
      jscrollpane1.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
      jscrollpane1.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
      jpanel1.add(jscrollpane1,cc.xy(4,10));

      addFillComponents(jpanel1,new int[]{ 1,2,3,4,5 },new int[]{ 1,2,3,4,5,6,7,8,9,10 });
      return jpanel1;
   }

   public JPanel createPanel13()
   {
      JPanel jpanel1 = new JPanel();
      FormLayout formlayout1 = new FormLayout("FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:GROW(1.0),FILL:4DLU:NONE","CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:4DLU:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE");
      CellConstraints cc = new CellConstraints();
      jpanel1.setLayout(formlayout1);

      lblMinValue.setName("lblMinValue");
      lblMinValue.setText("_Minimum_value");
      jpanel1.add(lblMinValue,cc.xy(2,2));

      txtMinValue.setName("txtMinValue");
      jpanel1.add(txtMinValue,cc.xy(4,2));

      lblMaxValue.setName("lblMaxValue");
      lblMaxValue.setText("_Maximum_value");
      jpanel1.add(lblMaxValue,cc.xy(2,4));

      txtMaxValue.setName("txtMaxValue");
      jpanel1.add(txtMaxValue,cc.xy(4,4));

      lblAvailableValues.setName("lblAvailableValues");
      lblAvailableValues.setText("_List_of_values");
      jpanel1.add(lblAvailableValues,cc.xywh(2,6,3,1));

      jpanel1.add(createPanel14(),cc.xywh(2,7,3,1));
      addFillComponents(jpanel1,new int[]{ 1,2,3,4,5 },new int[]{ 1,2,3,4,5,6,7 });
      return jpanel1;
   }

   public JPanel createPanel14()
   {
      JPanel jpanel1 = new JPanel();
      FormLayout formlayout1 = new FormLayout("FILL:DEFAULT:GROW(1.0),FILL:4DLU:NONE,FILL:DEFAULT:NONE","CENTER:DEFAULT:NONE");
      CellConstraints cc = new CellConstraints();
      jpanel1.setLayout(formlayout1);

      jpanel1.add(createPanel15(),cc.xy(3,1));
      jpanel1.add(createPanel16(),cc.xy(1,1));
      addFillComponents(jpanel1,new int[]{ 1,2,3 },new int[]{ 1 });
      return jpanel1;
   }

   public JPanel createPanel15()
   {
      JPanel jpanel1 = new JPanel();
      FormLayout formlayout1 = new FormLayout("FILL:DEFAULT:NONE","CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,FILL:2DLU:GROW(1.0)");
      CellConstraints cc = new CellConstraints();
      jpanel1.setLayout(formlayout1);

      btnAvailableValuesAdd.setActionCommand("_Add");
      btnAvailableValuesAdd.setName("btnAvailableValuesAdd");
      btnAvailableValuesAdd.setText("_Add");
      jpanel1.add(btnAvailableValuesAdd,cc.xy(1,1));

      btnAvailableValuesUpdate.setActionCommand("_Update");
      btnAvailableValuesUpdate.setName("btnAvailableValuesUpdate");
      btnAvailableValuesUpdate.setText("_Update");
      jpanel1.add(btnAvailableValuesUpdate,cc.xy(1,3));

      btnAvailableValuesRemove.setActionCommand("_Remove");
      btnAvailableValuesRemove.setName("btnAvailableValuesRemove");
      btnAvailableValuesRemove.setText("_Remove");
      jpanel1.add(btnAvailableValuesRemove,cc.xy(1,5));

      addFillComponents(jpanel1,new int[0],new int[]{ 2,4,6 });
      return jpanel1;
   }

   public JPanel createPanel16()
   {
      JPanel jpanel1 = new JPanel();
      FormLayout formlayout1 = new FormLayout("FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:GROW(1.0)","CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE");
      CellConstraints cc = new CellConstraints();
      jpanel1.setLayout(formlayout1);

      lblAvailableValuesLabel.setName("lblAvailableValuesLabel");
      lblAvailableValuesLabel.setText("_Label");
      jpanel1.add(lblAvailableValuesLabel,cc.xy(1,3));

      lblAvailableValuesValue.setName("lblAvailableValuesValue");
      lblAvailableValuesValue.setText("_Value");
      jpanel1.add(lblAvailableValuesValue,cc.xy(1,5));

      cboAvailableValues.setName("cboAvailableValues");
      jpanel1.add(cboAvailableValues,cc.xywh(1,1,3,1));

      txtAvailableValuesLabel.setName("txtAvailableValuesLabel");
      jpanel1.add(txtAvailableValuesLabel,cc.xy(3,3));

      txtAvailableValuesValue.setName("txtAvailableValuesValue");
      jpanel1.add(txtAvailableValuesValue,cc.xy(3,5));

      addFillComponents(jpanel1,new int[]{ 2,3 },new int[]{ 2,4,6 });
      return jpanel1;
   }

   public JPanel createPanel17()
   {
      JPanel jpanel1 = new JPanel();
      FormLayout formlayout1 = new FormLayout("FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE","CENTER:DEFAULT:NONE");
      CellConstraints cc = new CellConstraints();
      jpanel1.setLayout(formlayout1);

      lblIsPrimaryKey.setName("lblIsPrimaryKey");
      lblIsPrimaryKey.setText("_Primary_key");
      jpanel1.add(lblIsPrimaryKey,cc.xy(1,1));

      chkIsPrimaryKey.setName("chkIsPrimaryKey");
      jpanel1.add(chkIsPrimaryKey,cc.xy(3,1));

      lblIsAutomatic.setName("lblIsAutomatic");
      lblIsAutomatic.setText("_Value_automatic");
      jpanel1.add(lblIsAutomatic,cc.xy(5,1));

      chkIsAutomatic.setName("chkIsAutomatic");
      jpanel1.add(chkIsAutomatic,cc.xy(7,1));

      lblAllowNulls.setName("lblAllowNulls");
      lblAllowNulls.setText("_Allow_nulls");
      jpanel1.add(lblAllowNulls,cc.xy(9,1));

      chkAllowNulls.setName("chkAllowNulls");
      jpanel1.add(chkAllowNulls,cc.xy(11,1));

      addFillComponents(jpanel1,new int[]{ 2,4,6,8,10,12 },new int[0]);
      return jpanel1;
   }

   /**
    * Initializer
    */
   protected void initializePanel()
   {
      setLayout(new BorderLayout());
      add(createPanel(), BorderLayout.CENTER);
   }


}
