package org.gvsig.fmap.dal.swing.impl.featuretype;

import com.jeta.forms.components.line.HorizontalLineComponent;
import com.jeta.open.i18n.I18NUtils;
import com.jgoodies.forms.layout.CellConstraints;
import com.jgoodies.forms.layout.FormLayout;
import java.awt.BorderLayout;
import java.awt.ComponentOrientation;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import javax.swing.Box;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.JTable;
import javax.swing.JTextArea;
import javax.swing.JTextField;


public class FeatureTypePanelView extends JPanel
{
   JTabbedPane tabFeatureType = new JTabbedPane();
   JTable tblFields = new JTable();
   HorizontalLineComponent horizontallinecomponent1 = new HorizontalLineComponent();
   JPanel pnlField = new JPanel();
   JButton btnNew = new JButton();
   JButton btnDelete = new JButton();
   JButton btnFormFieldAccept = new JButton();
   JButton btnFormFieldDiscard = new JButton();
   JButton btnFormFieldModify = new JButton();
   JLabel lblLabel = new JLabel();
   JLabel lblDescription = new JLabel();
   JTextField txtLabel = new JTextField();
   JTextArea txtDescription = new JTextArea();
   JLabel lblTags = new JLabel();
   JLabel lblTagsName = new JLabel();
   JLabel lblTagsValue = new JLabel();
   JComboBox cboTagsName = new JComboBox();
   JTable tblTags = new JTable();
   JLabel lblTagsDescription = new JLabel();
   JComboBox cboTagsValue = new JComboBox();
   JButton btnTagsAdd = new JButton();
   JButton btnTagsUpdate = new JButton();
   JButton btnTagsRemove = new JButton();
   JPanel pnlCfgActions = new JPanel();

   /**
    * Default constructor
    */
   public FeatureTypePanelView()
   {
      initializePanel();
   }

   /**
    * Main method for panel
    */
   public static void main(String[] args)
   {
      JFrame frame = new JFrame();
      frame.setSize(600, 400);
      frame.setLocation(100, 100);
      frame.getContentPane().add(new FeatureTypePanelView());
      frame.setVisible(true);

      frame.addWindowListener( new WindowAdapter()
      {
         public void windowClosing( WindowEvent evt )
         {
            System.exit(0);
         }
      });
   }

   /**
    * Adds fill components to empty cells in the first row and first column of the grid.
    * This ensures that the grid spacing will be the same as shown in the designer.
    * @param cols an array of column indices in the first row where fill components should be added.
    * @param rows an array of row indices in the first column where fill components should be added.
    */
   void addFillComponents( Container panel, int[] cols, int[] rows )
   {
      Dimension filler = new Dimension(10,10);

      boolean filled_cell_11 = false;
      CellConstraints cc = new CellConstraints();
      if ( cols.length > 0 && rows.length > 0 )
      {
         if ( cols[0] == 1 && rows[0] == 1 )
         {
            /** add a rigid area  */
            panel.add( Box.createRigidArea( filler ), cc.xy(1,1) );
            filled_cell_11 = true;
         }
      }

      for( int index = 0; index < cols.length; index++ )
      {
         if ( cols[index] == 1 && filled_cell_11 )
         {
            continue;
         }
         panel.add( Box.createRigidArea( filler ), cc.xy(cols[index],1) );
      }

      for( int index = 0; index < rows.length; index++ )
      {
         if ( rows[index] == 1 && filled_cell_11 )
         {
            continue;
         }
         panel.add( Box.createRigidArea( filler ), cc.xy(1,rows[index]) );
      }

   }

   /**
    * Helper method to load an image file from the CLASSPATH
    * @param imageName the package and name of the file to load relative to the CLASSPATH
    * @return an ImageIcon instance with the specified image file
    * @throws IllegalArgumentException if the image resource cannot be loaded.
    */
   public ImageIcon loadImage( String imageName )
   {
      try
      {
         ClassLoader classloader = getClass().getClassLoader();
         java.net.URL url = classloader.getResource( imageName );
         if ( url != null )
         {
            ImageIcon icon = new ImageIcon( url );
            return icon;
         }
      }
      catch( Exception e )
      {
         e.printStackTrace();
      }
      throw new IllegalArgumentException( "Unable to load image: " + imageName );
   }

   /**
    * Method for recalculating the component orientation for 
    * right-to-left Locales.
    * @param orientation the component orientation to be applied
    */
   public void applyComponentOrientation( ComponentOrientation orientation )
   {
      // Not yet implemented...
      // I18NUtils.applyComponentOrientation(this, orientation);
      super.applyComponentOrientation(orientation);
   }

   public JPanel createPanel()
   {
      JPanel jpanel1 = new JPanel();
      FormLayout formlayout1 = new FormLayout("FILL:4DLU:NONE,FILL:DEFAULT:GROW(1.0),FILL:4DLU:NONE","CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,FILL:DEFAULT:GROW(1.0),CENTER:2DLU:NONE");
      CellConstraints cc = new CellConstraints();
      jpanel1.setLayout(formlayout1);

      tabFeatureType.setName("tabFeatureType");
      tabFeatureType.addTab("_Main",null,createPanel1());
      tabFeatureType.addTab("_Visualization",null,createPanel4());
      jpanel1.add(tabFeatureType,cc.xy(2,3));

      jpanel1.add(createPanel7(),cc.xy(2,2));
      addFillComponents(jpanel1,new int[]{ 1,2,3 },new int[]{ 1,2,3,4 });
      return jpanel1;
   }

   public JPanel createPanel1()
   {
      JPanel jpanel1 = new JPanel();
      FormLayout formlayout1 = new FormLayout("FILL:4DLU:NONE,FILL:DEFAULT:GROW(1.0),FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE","CENTER:2DLU:NONE,FILL:DEFAULT:GROW(1.0),CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,FILL:DEFAULT:GROW(1.0),CENTER:2DLU:NONE");
      CellConstraints cc = new CellConstraints();
      jpanel1.setLayout(formlayout1);

      tblFields.setName("tblFields");
      JScrollPane jscrollpane1 = new JScrollPane();
      jscrollpane1.setViewportView(tblFields);
      jscrollpane1.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
      jscrollpane1.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
      jpanel1.add(jscrollpane1,cc.xy(2,2));

      jpanel1.add(horizontallinecomponent1,cc.xywh(2,4,3,1));

      pnlField.setName("pnlField");
      jpanel1.add(pnlField,cc.xy(2,6));

      jpanel1.add(createPanel2(),cc.xy(4,2));
      jpanel1.add(createPanel3(),cc.xy(4,6));
      addFillComponents(jpanel1,new int[]{ 1,2,3,4,5 },new int[]{ 1,2,3,4,5,6,7 });
      return jpanel1;
   }

   public JPanel createPanel2()
   {
      JPanel jpanel1 = new JPanel();
      FormLayout formlayout1 = new FormLayout("FILL:4DLU:NONE,FILL:DEFAULT:GROW(1.0),FILL:4DLU:NONE","CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,FILL:DEFAULT:GROW(1.0)");
      CellConstraints cc = new CellConstraints();
      jpanel1.setLayout(formlayout1);

      btnNew.setActionCommand("_New");
      btnNew.setName("btnNew");
      btnNew.setText("_New");
      jpanel1.add(btnNew,cc.xy(2,1));

      btnDelete.setActionCommand("_Delete");
      btnDelete.setName("btnDelete");
      btnDelete.setText("_Delete");
      jpanel1.add(btnDelete,cc.xy(2,3));

      addFillComponents(jpanel1,new int[]{ 1,3 },new int[]{ 1,2,3,4,5 });
      return jpanel1;
   }

   public JPanel createPanel3()
   {
      JPanel jpanel1 = new JPanel();
      FormLayout formlayout1 = new FormLayout("FILL:4DLU:NONE,FILL:DEFAULT:GROW(1.0),FILL:4DLU:NONE","CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,FILL:2DLU:GROW(1.0)");
      CellConstraints cc = new CellConstraints();
      jpanel1.setLayout(formlayout1);

      btnFormFieldAccept.setActionCommand("JButton");
      btnFormFieldAccept.setName("btnFormFieldAccept");
      btnFormFieldAccept.setText("_Accept");
      jpanel1.add(btnFormFieldAccept,cc.xy(2,3));

      btnFormFieldDiscard.setActionCommand("JButton");
      btnFormFieldDiscard.setName("btnFormFieldDiscard");
      btnFormFieldDiscard.setText("_Discard");
      jpanel1.add(btnFormFieldDiscard,cc.xy(2,5));

      btnFormFieldModify.setActionCommand("JButton");
      btnFormFieldModify.setName("btnFormFieldModify");
      btnFormFieldModify.setText("_Modify");
      jpanel1.add(btnFormFieldModify,cc.xy(2,1));

      addFillComponents(jpanel1,new int[]{ 1,3 },new int[]{ 1,2,3,4,5,6 });
      return jpanel1;
   }

   public JPanel createPanel4()
   {
      JPanel jpanel1 = new JPanel();
      FormLayout formlayout1 = new FormLayout("FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:GROW(1.0),FILL:4DLU:NONE","CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:GROW(0.1),CENTER:2DLU:NONE,FILL:DEFAULT:GROW(0.8),CENTER:2DLU:NONE");
      CellConstraints cc = new CellConstraints();
      jpanel1.setLayout(formlayout1);

      lblLabel.setName("lblLabel");
      lblLabel.setText("_Label");
      jpanel1.add(lblLabel,cc.xy(2,2));

      lblDescription.setName("lblDescription");
      lblDescription.setText("_Description");
      lblDescription.setVerticalAlignment(JLabel.TOP);
      jpanel1.add(lblDescription,new CellConstraints(2,4,1,1,CellConstraints.DEFAULT,CellConstraints.TOP));

      txtLabel.setName("txtLabel");
      jpanel1.add(txtLabel,cc.xy(4,2));

      txtDescription.setName("txtDescription");
      JScrollPane jscrollpane1 = new JScrollPane();
      jscrollpane1.setViewportView(txtDescription);
      jscrollpane1.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
      jscrollpane1.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
      jpanel1.add(jscrollpane1,new CellConstraints(4,4,1,1,CellConstraints.DEFAULT,CellConstraints.FILL));

      lblTags.setName("lblTags");
      lblTags.setText("_Tags");
      lblTags.setVerticalAlignment(JLabel.TOP);
      jpanel1.add(lblTags,cc.xy(2,6));

      jpanel1.add(createPanel5(),cc.xy(4,6));
      addFillComponents(jpanel1,new int[]{ 1,2,3,4,5 },new int[]{ 1,2,3,4,5,6,7 });
      return jpanel1;
   }

   public JPanel createPanel5()
   {
      JPanel jpanel1 = new JPanel();
      FormLayout formlayout1 = new FormLayout("FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:GROW(1.0),FILL:4DLU:NONE,FILL:DEFAULT:NONE","FILL:DEFAULT:GROW(1.0),CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:GROW(0.1)");
      CellConstraints cc = new CellConstraints();
      jpanel1.setLayout(formlayout1);

      lblTagsName.setName("lblTagsName");
      lblTagsName.setText("_Name");
      jpanel1.add(lblTagsName,cc.xy(1,3));

      lblTagsValue.setName("lblTagsValue");
      lblTagsValue.setText("_Value");
      jpanel1.add(lblTagsValue,cc.xy(1,5));

      cboTagsName.setEditable(true);
      cboTagsName.setName("cboTagsName");
      cboTagsName.setRequestFocusEnabled(false);
      jpanel1.add(cboTagsName,cc.xy(3,3));

      tblTags.setName("tblTags");
      JScrollPane jscrollpane1 = new JScrollPane();
      jscrollpane1.setViewportView(tblTags);
      jscrollpane1.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
      jscrollpane1.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
      jpanel1.add(jscrollpane1,cc.xywh(1,1,3,1));

      lblTagsDescription.setName("lblTagsDescription");
      jpanel1.add(lblTagsDescription,cc.xy(3,6));

      cboTagsValue.setEditable(true);
      cboTagsValue.setName("cboTagsValue");
      cboTagsValue.setRequestFocusEnabled(false);
      jpanel1.add(cboTagsValue,cc.xy(3,5));

      jpanel1.add(createPanel6(),cc.xywh(5,1,1,5));
      addFillComponents(jpanel1,new int[]{ 2,3,4,5 },new int[]{ 2,4,6 });
      return jpanel1;
   }

   public JPanel createPanel6()
   {
      JPanel jpanel1 = new JPanel();
      FormLayout formlayout1 = new FormLayout("FILL:DEFAULT:NONE","CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE");
      CellConstraints cc = new CellConstraints();
      jpanel1.setLayout(formlayout1);

      btnTagsAdd.setActionCommand("_Add");
      btnTagsAdd.setName("btnTagsAdd");
      btnTagsAdd.setText("_Add");
      jpanel1.add(btnTagsAdd,cc.xy(1,1));

      btnTagsUpdate.setActionCommand("_Update");
      btnTagsUpdate.setName("btnTagsUpdate");
      btnTagsUpdate.setText("_Update");
      jpanel1.add(btnTagsUpdate,cc.xy(1,3));

      btnTagsRemove.setActionCommand("_Remove");
      btnTagsRemove.setName("btnTagsRemove");
      btnTagsRemove.setText("_Remove");
      jpanel1.add(btnTagsRemove,cc.xy(1,5));

      addFillComponents(jpanel1,new int[0],new int[]{ 2,4 });
      return jpanel1;
   }

   public JPanel createPanel7()
   {
      JPanel jpanel1 = new JPanel();
      FormLayout formlayout1 = new FormLayout("FILL:DEFAULT:GROW(1.0),FILL:DEFAULT:NONE","CENTER:DEFAULT:NONE");
      CellConstraints cc = new CellConstraints();
      jpanel1.setLayout(formlayout1);

      pnlCfgActions.setName("pnlCfgActions");
      pnlCfgActions.setOpaque(false);
      jpanel1.add(pnlCfgActions,cc.xy(2,1));

      addFillComponents(jpanel1,new int[]{ 1 },new int[]{ 1 });
      return jpanel1;
   }

   /**
    * Initializer
    */
   protected void initializePanel()
   {
      setLayout(new BorderLayout());
      add(createPanel(), BorderLayout.CENTER);
   }


}
