package org.gvsig.fmap.dal.swing.impl.searchpanel;

import java.awt.Component;
import java.awt.FlowLayout;
import javax.swing.Icon;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTree;
import javax.swing.border.EmptyBorder;
import javax.swing.tree.DefaultTreeCellRenderer;
import javax.swing.tree.TreeCellRenderer;
import org.gvsig.fmap.dal.swing.impl.searchpanel.AdvancedAttributeSelectionTreeModel.Node;
import org.gvsig.tools.swing.api.ToolsSwingLocator;
import org.gvsig.tools.swing.icontheme.IconTheme;

/**
 *
 * @author jjdelcerro
 */
public class AdvancedAttributeSelectionTreeCellRenderer 
//        extends DefaultTreeCellRenderer 
        implements TreeCellRenderer
    {
    
    private final Icon iconTable;
    private final Icon iconColumn;
    private final Icon iconForeingKey;
    private final JPanel panel;
    private final JLabel icon;
    private final DefaultTreeCellRenderer label;
    private final IconTheme iconTheme;
    
    public AdvancedAttributeSelectionTreeCellRenderer() {
        this.iconTheme = ToolsSwingLocator.getIconThemeManager().getCurrent();
        this.iconTable = iconTheme.get("featurestore-table");
        this.iconColumn = iconTheme.get("featurestore-column");
        this.iconForeingKey = iconTheme.get("featurestore-foreing-key");
        
        this.panel = new JPanel();
        this.panel.setLayout(new FlowLayout(FlowLayout.LEADING, 3, 2));
        this.icon = new JLabel();
        this.label = new DefaultTreeCellRenderer();
        this.panel.add(this.icon);
        this.panel.add(this.label);
        this.panel.setBorder(new EmptyBorder(0, 0, 0, 0));
        this.panel.setOpaque(false);
        
    }
    
    @Override
    public Component getTreeCellRendererComponent(JTree tree, Object value, boolean sel, boolean expanded, boolean leaf, int row, boolean hasFocus) {
        JLabel theLabel = (JLabel) this.label.getTreeCellRendererComponent(tree, value, sel, expanded, leaf, row, hasFocus); 
        if( !(value instanceof Node) ) {
            return theLabel;
        }
        Node node = (Node) value;
        Icon iconElement = node.isRoot()? this.iconTable: leaf? this.iconColumn: this.iconForeingKey;
        Icon iconDataType = null;
        try {
            if( !node.isRoot() ) {
                String iconName = node.getValue().getDataType().getIconName();
                iconDataType = this.iconTheme.get(iconName);
            }
        } catch(Exception ex) {
            
        }
        this.label.setIcon(iconDataType);
        this.label.setText(node.getLabel());
        this.icon.setIcon(iconElement);
        return this.panel;
    }
    
    
}
