package org.gvsig.fmap.dal.swing.impl.searchpanel;

import com.jeta.open.i18n.I18NUtils;
import com.jgoodies.forms.layout.CellConstraints;
import com.jgoodies.forms.layout.FormLayout;
import java.awt.BorderLayout;
import java.awt.ComponentOrientation;
import java.awt.Container;
import java.awt.Dimension;
import javax.swing.Box;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.border.EmptyBorder;


public class DefaultSearchPanelView extends JPanel
{
   JTabbedPane tabSearchMode = new JTabbedPane();
   JComboBox cboValue1 = new JComboBox();
   JComboBox cboValue2 = new JComboBox();
   JComboBox cboValue3 = new JComboBox();
   JComboBox cboValue4 = new JComboBox();
   JLabel lblRelationalOperator1 = new JLabel();
   JLabel lblRelationalOperator2 = new JLabel();
   JLabel lblRelationalOperator3 = new JLabel();
   JLabel lblRelationalOperator4 = new JLabel();
   JLabel lblLogicalOperators1 = new JLabel();
   JLabel lblLogicalOperators2 = new JLabel();
   JLabel lblLogicalOperators3 = new JLabel();
   JLabel lblField1 = new JLabel();
   JLabel lblField2 = new JLabel();
   JLabel lblField3 = new JLabel();
   JLabel lblField4 = new JLabel();
   JLabel lblExtraFields1 = new JLabel();
   JLabel lblExtraFields2 = new JLabel();
   JLabel lblExtraFields3 = new JLabel();
   JLabel lblExtraFields4 = new JLabel();
   JTextField txtAdvancedExpression = new JTextField();
   JLabel lblExpressionDeBusqueda = new JLabel();
   JButton btnAdvancedExpression = new JButton();
   JButton btnAdvancedExpressionHistory = new JButton();
   JButton btnAdvancedExpressionBookmarks = new JButton();
   JTable tblResults = new JTable();
   JButton btnSearch = new JButton();
   JButton btnClear = new JButton();
   JLabel lblMsg = new JLabel();
   JPanel pnlActions = new JPanel();
   JPanel pnlCfgActions = new JPanel();

   /**
    * Default constructor
    */
   public DefaultSearchPanelView()
   {
      initializePanel();
   }

   /**
    * Adds fill components to empty cells in the first row and first column of the grid.
    * This ensures that the grid spacing will be the same as shown in the designer.
    * @param cols an array of column indices in the first row where fill components should be added.
    * @param rows an array of row indices in the first column where fill components should be added.
    */
   void addFillComponents( Container panel, int[] cols, int[] rows )
   {
      Dimension filler = new Dimension(10,10);

      boolean filled_cell_11 = false;
      CellConstraints cc = new CellConstraints();
      if ( cols.length > 0 && rows.length > 0 )
      {
         if ( cols[0] == 1 && rows[0] == 1 )
         {
            /** add a rigid area  */
            panel.add( Box.createRigidArea( filler ), cc.xy(1,1) );
            filled_cell_11 = true;
         }
      }

      for( int index = 0; index < cols.length; index++ )
      {
         if ( cols[index] == 1 && filled_cell_11 )
         {
            continue;
         }
         panel.add( Box.createRigidArea( filler ), cc.xy(cols[index],1) );
      }

      for( int index = 0; index < rows.length; index++ )
      {
         if ( rows[index] == 1 && filled_cell_11 )
         {
            continue;
         }
         panel.add( Box.createRigidArea( filler ), cc.xy(1,rows[index]) );
      }

   }

   /**
    * Helper method to load an image file from the CLASSPATH
    * @param imageName the package and name of the file to load relative to the CLASSPATH
    * @return an ImageIcon instance with the specified image file
    * @throws IllegalArgumentException if the image resource cannot be loaded.
    */
   public ImageIcon loadImage( String imageName )
   {
      try
      {
         ClassLoader classloader = getClass().getClassLoader();
         java.net.URL url = classloader.getResource( imageName );
         if ( url != null )
         {
            ImageIcon icon = new ImageIcon( url );
            return icon;
         }
      }
      catch( Exception e )
      {
         e.printStackTrace();
      }
      throw new IllegalArgumentException( "Unable to load image: " + imageName );
   }

   /**
    * Method for recalculating the component orientation for 
    * right-to-left Locales.
    * @param orientation the component orientation to be applied
    */
   public void applyComponentOrientation( ComponentOrientation orientation )
   {
      // Not yet implemented...
      // I18NUtils.applyComponentOrientation(this, orientation);
      super.applyComponentOrientation(orientation);
   }

   public JPanel createPanel()
   {
      JPanel jpanel1 = new JPanel();
      FormLayout formlayout1 = new FormLayout("FILL:4DLU:NONE,FILL:DEFAULT:GROW(1.0),FILL:4DLU:NONE","CENTER:4DLU:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,FILL:DEFAULT:GROW(1.0),CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE");
      CellConstraints cc = new CellConstraints();
      jpanel1.setLayout(formlayout1);

      tabSearchMode.setName("tabSearchMode");
      EmptyBorder emptyborder1 = new EmptyBorder(2,2,2,2);
      tabSearchMode.setBorder(emptyborder1);
      tabSearchMode.setTabPlacement(JTabbedPane.BOTTOM);
      tabSearchMode.addTab("Simplificada",null,createPanel1());
      tabSearchMode.addTab("Avanzada",null,createPanel2());
      jpanel1.add(tabSearchMode,cc.xy(2,3));

      tblResults.setName("tblResults");
      JScrollPane jscrollpane1 = new JScrollPane();
      jscrollpane1.setViewportView(tblResults);
      jscrollpane1.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
      jscrollpane1.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
      jpanel1.add(jscrollpane1,cc.xy(2,6));

      jpanel1.add(createPanel3(),cc.xy(2,4));
      jpanel1.add(createPanel4(),cc.xy(2,8));
      jpanel1.add(createPanel5(),cc.xy(2,2));
      addFillComponents(jpanel1,new int[]{ 1,2,3 },new int[]{ 1,2,3,4,5,6,7,8,9 });
      return jpanel1;
   }

   public JPanel createPanel1()
   {
      JPanel jpanel1 = new JPanel();
      FormLayout formlayout1 = new FormLayout("FILL:4DLU:NONE,FILL:12DLU:GROW(1.0),FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:12DLU:GROW(1.0),FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:12DLU:GROW(1.0),FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:12DLU:GROW(1.0),FILL:DEFAULT:NONE,FILL:4DLU:NONE","CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:4DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE");
      CellConstraints cc = new CellConstraints();
      jpanel1.setLayout(formlayout1);

      cboValue1.setEditable(true);
      cboValue1.setName("cboValue1");
      cboValue1.setRequestFocusEnabled(false);
      jpanel1.add(cboValue1,cc.xywh(2,6,3,1));

      cboValue2.setEditable(true);
      cboValue2.setName("cboValue2");
      cboValue2.setRequestFocusEnabled(false);
      jpanel1.add(cboValue2,cc.xywh(8,6,3,1));

      cboValue3.setEditable(true);
      cboValue3.setName("cboValue3");
      cboValue3.setRequestFocusEnabled(false);
      jpanel1.add(cboValue3,cc.xywh(14,6,3,1));

      cboValue4.setEditable(true);
      cboValue4.setName("cboValue4");
      cboValue4.setRequestFocusEnabled(false);
      jpanel1.add(cboValue4,cc.xywh(20,6,2,1));

      lblRelationalOperator1.setName("lblRelationalOperator1");
      lblRelationalOperator1.setText("Igual");
      lblRelationalOperator1.setHorizontalAlignment(JLabel.CENTER);
      jpanel1.add(lblRelationalOperator1,cc.xy(2,4));

      lblRelationalOperator2.setName("lblRelationalOperator2");
      lblRelationalOperator2.setText("Igual");
      lblRelationalOperator2.setHorizontalAlignment(JLabel.CENTER);
      jpanel1.add(lblRelationalOperator2,cc.xy(8,4));

      lblRelationalOperator3.setName("lblRelationalOperator3");
      lblRelationalOperator3.setText("Igual");
      lblRelationalOperator3.setHorizontalAlignment(JLabel.CENTER);
      jpanel1.add(lblRelationalOperator3,cc.xy(14,4));

      lblRelationalOperator4.setName("lblRelationalOperator4");
      lblRelationalOperator4.setText("Igual");
      lblRelationalOperator4.setHorizontalAlignment(JLabel.CENTER);
      jpanel1.add(lblRelationalOperator4,cc.xy(20,4));

      lblLogicalOperators1.setName("lblLogicalOperators1");
      lblLogicalOperators1.setText("WWWWW");
      lblLogicalOperators1.setHorizontalAlignment(JLabel.CENTER);
      jpanel1.add(lblLogicalOperators1,cc.xy(6,2));

      lblLogicalOperators2.setName("lblLogicalOperators2");
      lblLogicalOperators2.setText("WWWWW");
      lblLogicalOperators2.setHorizontalAlignment(JLabel.CENTER);
      jpanel1.add(lblLogicalOperators2,cc.xy(12,2));

      lblLogicalOperators3.setName("lblLogicalOperators3");
      lblLogicalOperators3.setText("WWWWW");
      lblLogicalOperators3.setHorizontalAlignment(JLabel.CENTER);
      jpanel1.add(lblLogicalOperators3,cc.xy(18,2));

      lblField1.setName("lblField1");
      lblField1.setHorizontalAlignment(JLabel.CENTER);
      jpanel1.add(lblField1,cc.xy(2,2));

      lblField2.setName("lblField2");
      lblField2.setHorizontalAlignment(JLabel.CENTER);
      jpanel1.add(lblField2,cc.xy(8,2));

      lblField3.setName("lblField3");
      lblField3.setHorizontalAlignment(JLabel.CENTER);
      jpanel1.add(lblField3,cc.xy(14,2));

      lblField4.setName("lblField4");
      lblField4.setHorizontalAlignment(JLabel.CENTER);
      jpanel1.add(lblField4,cc.xy(20,2));

      lblExtraFields1.setIcon(loadImage("datos/devel/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/resources/org/gvsig/fmap/dal/swing/impl/searchpanel/featurestore-column.png"));
      lblExtraFields1.setName("lblExtraFields1");
      jpanel1.add(lblExtraFields1,cc.xy(4,2));

      lblExtraFields2.setIcon(loadImage("datos/devel/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/resources/org/gvsig/fmap/dal/swing/impl/searchpanel/featurestore-column.png"));
      lblExtraFields2.setName("lblExtraFields2");
      jpanel1.add(lblExtraFields2,cc.xy(10,2));

      lblExtraFields3.setIcon(loadImage("datos/devel/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/resources/org/gvsig/fmap/dal/swing/impl/searchpanel/featurestore-column.png"));
      lblExtraFields3.setName("lblExtraFields3");
      jpanel1.add(lblExtraFields3,cc.xy(16,2));

      lblExtraFields4.setIcon(loadImage("datos/devel/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/resources/org/gvsig/fmap/dal/swing/impl/searchpanel/featurestore-column.png"));
      lblExtraFields4.setName("lblExtraFields4");
      jpanel1.add(lblExtraFields4,cc.xy(21,2));

      addFillComponents(jpanel1,new int[]{ 1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22 },new int[]{ 1,2,3,4,5,6,7 });
      return jpanel1;
   }

   public JPanel createPanel2()
   {
      JPanel jpanel1 = new JPanel();
      FormLayout formlayout1 = new FormLayout("FILL:4DLU:NONE,FILL:DEFAULT:GROW(1.0),FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE","CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE");
      CellConstraints cc = new CellConstraints();
      jpanel1.setLayout(formlayout1);

      txtAdvancedExpression.setName("txtAdvancedExpression");
      jpanel1.add(txtAdvancedExpression,cc.xy(2,4));

      lblExpressionDeBusqueda.setName("lblExpressionDeBusqueda");
      lblExpressionDeBusqueda.setText("Introduzca una expresion de busqueda");
      jpanel1.add(lblExpressionDeBusqueda,cc.xy(2,2));

      btnAdvancedExpression.setActionCommand("...");
      btnAdvancedExpression.setName("btnAdvancedExpression");
      EmptyBorder emptyborder1 = new EmptyBorder(2,2,2,2);
      btnAdvancedExpression.setBorder(emptyborder1);
      jpanel1.add(btnAdvancedExpression,cc.xy(4,4));

      btnAdvancedExpressionHistory.setActionCommand("...");
      btnAdvancedExpressionHistory.setName("btnAdvancedExpressionHistory");
      EmptyBorder emptyborder2 = new EmptyBorder(2,2,2,2);
      btnAdvancedExpressionHistory.setBorder(emptyborder2);
      jpanel1.add(btnAdvancedExpressionHistory,cc.xy(6,4));

      btnAdvancedExpressionBookmarks.setActionCommand("...");
      btnAdvancedExpressionBookmarks.setName("btnAdvancedExpressionBookmarks");
      EmptyBorder emptyborder3 = new EmptyBorder(2,2,2,2);
      btnAdvancedExpressionBookmarks.setBorder(emptyborder3);
      jpanel1.add(btnAdvancedExpressionBookmarks,cc.xy(8,4));

      addFillComponents(jpanel1,new int[]{ 1,2,3,4,5,6,7,8,9 },new int[]{ 1,2,3,4,5 });
      return jpanel1;
   }

   public JPanel createPanel3()
   {
      JPanel jpanel1 = new JPanel();
      FormLayout formlayout1 = new FormLayout("FILL:DEFAULT:GROW(1.0),FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:NONE","CENTER:DEFAULT:NONE");
      CellConstraints cc = new CellConstraints();
      jpanel1.setLayout(formlayout1);

      btnSearch.setActionCommand("Buscar");
      btnSearch.setName("btnSearch");
      btnSearch.setText("Buscar");
      jpanel1.add(btnSearch,cc.xy(4,1));

      btnClear.setActionCommand("Limpiar");
      btnClear.setName("btnClear");
      btnClear.setText("Limpiar");
      jpanel1.add(btnClear,cc.xy(2,1));

      addFillComponents(jpanel1,new int[]{ 1,3 },new int[]{ 1 });
      return jpanel1;
   }

   public JPanel createPanel4()
   {
      JPanel jpanel1 = new JPanel();
      FormLayout formlayout1 = new FormLayout("FILL:DEFAULT:GROW(1.0),FILL:4DLU:NONE,FILL:DEFAULT:NONE","CENTER:DEFAULT:NONE");
      CellConstraints cc = new CellConstraints();
      jpanel1.setLayout(formlayout1);

      lblMsg.setName("lblMsg");
      jpanel1.add(lblMsg,cc.xy(1,1));

      pnlActions.setName("pnlActions");
      jpanel1.add(pnlActions,cc.xy(3,1));

      addFillComponents(jpanel1,new int[]{ 2 },new int[0]);
      return jpanel1;
   }

   public JPanel createPanel5()
   {
      JPanel jpanel1 = new JPanel();
      FormLayout formlayout1 = new FormLayout("FILL:DEFAULT:GROW(1.0),FILL:DEFAULT:NONE","CENTER:DEFAULT:NONE");
      CellConstraints cc = new CellConstraints();
      jpanel1.setLayout(formlayout1);

      pnlCfgActions.setName("pnlCfgActions");
      pnlCfgActions.setOpaque(false);
      jpanel1.add(pnlCfgActions,cc.xy(2,1));

      addFillComponents(jpanel1,new int[]{ 1 },new int[]{ 1 });
      return jpanel1;
   }

   /**
    * Initializer
    */
   protected void initializePanel()
   {
      setLayout(new BorderLayout());
      add(createPanel(), BorderLayout.CENTER);
   }


}
