package org.gvsig.fmap.dal.swing.impl.featuretype;

import org.gvsig.fmap.dal.swing.featuretype.FeatureTypePanel;
import java.io.File;
import java.net.URL;
import org.gvsig.fmap.dal.DALLocator;
import org.gvsig.fmap.dal.DataManager;
import org.gvsig.fmap.dal.feature.FeatureStore;
import org.gvsig.fmap.dal.swing.DALSwingLocator;
import org.gvsig.fmap.dal.swing.DataSwingManager;
import org.gvsig.tools.library.impl.DefaultLibrariesInitializer;
import org.gvsig.tools.swing.api.ToolsSwingLocator;
import org.gvsig.tools.swing.api.windowmanager.Dialog;
import org.gvsig.tools.swing.api.windowmanager.WindowManager;
import org.gvsig.tools.swing.api.windowmanager.WindowManager_v2;

/**
 *
 * @author jjdelcerro
 */
public class TestNotEditable {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws Exception {
        TestNotEditable test = new TestNotEditable();
        new DefaultLibrariesInitializer().fullInitialize();
        test.run();
    }
    
    public void run() throws Exception {
        WindowManager_v2 windowManager = (WindowManager_v2) ToolsSwingLocator.getWindowManager();
        DataSwingManager manager = DALSwingLocator.getSwingManager();
        
        URL resource = this.getClass().getResource("/org/gvsig/esp_comaut/esp_comaut.dbf");
        FeatureStore store = openShape(resource);
        FeatureTypePanel panel = new DefaultFeatureTypePanel();
        panel.put(store.getDefaultFeatureType());
        
        Dialog dialog = windowManager.createDialog(
                panel.asJComponent(),
                "Test", 
                null,
                WindowManager_v2.BUTTONS_OK_CANCEL
        );
        dialog.show(WindowManager.MODE.WINDOW);        
    }
  
    public FeatureStore openShape(URL resource) throws Exception {
        DataManager dataManager = DALLocator.getDataManager();
        FeatureStore store = (FeatureStore) dataManager.openStore(
                "DBF", 
                "dbffile", new File(resource.toURI())
//                "CRS", CRSFactory.getCRS("EPSG:23030")
        );
        return store;
    }
}
