package org.gvsig.fmap.geom;

import org.cresques.cts.IProjection;

import org.gvsig.fmap.geom.primitive.Envelope;
import org.gvsig.tools.util.InformationBuilder;

public interface InformationbuilderWithGeometrySupport extends InformationBuilder {

    public interface RawElementWithGeometrySupport extends RawElement {

        public RawElementWithGeometrySupport value(Envelope env);

        public RawElementWithGeometrySupport value(Geometry geom);

        public RawElementWithGeometrySupport value(IProjection proj);

        public RawElementWithGeometrySupport valueAsWKT(IProjection proj);
    }

    public interface TextElementWithGeometrySupport extends TextElement, RawElementWithGeometrySupport {

        @Override
        public TextElementWithGeometrySupport value(Envelope env);

        @Override
        public TextElementWithGeometrySupport value(Geometry geom);

        @Override
        public TextElementWithGeometrySupport value(IProjection proj);

        @Override
        public TextElementWithGeometrySupport valueAsWKT(IProjection proj);
    }

    public interface PropertyElementWithGeometrySupport extends PropertyElement, TextElementWithGeometrySupport {

        @Override
        public PropertyElementWithGeometrySupport value(Envelope env);

        @Override
        public PropertyElementWithGeometrySupport value(Geometry geom);

        @Override
        public PropertyElementWithGeometrySupport value(IProjection proj);

        @Override
        public PropertyElementWithGeometrySupport valueAsWKT(IProjection proj);
    }

    public interface EnvelopeElement extends Element {

        public EnvelopeElement value(Envelope value);
    }

    @Override
    public InformationbuilderWithGeometrySupport backgroundColor(String color);

    @Override
    public InformationbuilderWithGeometrySupport backgroundColorTitle(String color);

    @Override
    public InformationbuilderWithGeometrySupport backgroundColorPropertyLabel(String color);

    @Override
    public InformationbuilderWithGeometrySupport backgroundColorPropertyValue1(String color);

    @Override
    public InformationbuilderWithGeometrySupport backgroundColorPropertyValue2(String color);

    @Override
    public TitleElement title();

    @Override
    public PropertyElementWithGeometrySupport property();

    @Override
    public TextElementWithGeometrySupport text();

    @Override
    public RawElementWithGeometrySupport raw();

    public EnvelopeElement envelope();

    @Override
    public String build();

}
