
package org.gvsig.fmap.geom.jts.primitive.surface.polygon;

import java.awt.Shape;
import java.awt.geom.AffineTransform;
import java.awt.geom.GeneralPath;
import org.gvsig.fmap.geom.jts.gputils.DefaultGeneralPathX;
import org.gvsig.fmap.geom.primitive.Polygon;


public class PolygonHelper {

    public static Shape getShape(Polygon polygon, AffineTransform affineTransform) {
        if( polygon.isEmpty() ) {
            // Esto no deberia de pasar, se trataria de una geometria
            // corrupta.
            return new GeneralPath();
        }
        int capacity = polygon.getNumVertices();
        for( int i = 0; i < polygon.getNumInteriorRings(); i++ ) {
            capacity += polygon.getInteriorRing(i).getNumVertices();
        }
        return new DefaultGeneralPathX(polygon.getPathIterator(affineTransform),false,0,capacity);
    }       
}
