/* gvSIG. Desktop Geographic Information System.
 *
 * Copyright  2007-2015 gvSIG Association
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 3
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301, USA.
 *
 * For any additional information, do not hesitate to contact us
 * at info AT gvsig.com, or visit our website www.gvsig.com.
 */
package org.gvsig.fmap.geom.jts.util;

import com.vividsolutions.jts.io.gml2.GMLReader;
import com.vividsolutions.jts.io.gml2.GMLWriter;
import org.gvsig.fmap.geom.Geometry;
import org.gvsig.fmap.geom.jts.GeometryJTS;

/**
 *
 * @author jjdelcerro
 */
public class GMLUtils {

    public static Geometry GML2Geometry(String gml) {
        GMLReader reader = new GMLReader();
        com.vividsolutions.jts.geom.Geometry jtsgeom;
        try {
            jtsgeom = reader.read(gml, null);
        } catch (Exception ex) {
            return null;
        }
        return JTSUtils.createGeometry(null, jtsgeom);
    }

    public static String geometry2GML(Geometry geom) {
        com.vividsolutions.jts.geom.Geometry jtsgeom = ((GeometryJTS) geom).getJTS();
        
        GMLWriter writer = new GMLWriter();
        String gml = writer.write(jtsgeom);
        return gml;
    }

}
