/**
 * gvSIG. Desktop Geographic Information System.
 *
 * Copyright (C) 2007-2013 gvSIG Association.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 3
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301, USA.
 *
 * For any additional information, do not hesitate to contact us
 * at info AT gvsig.com, or visit our website www.gvsig.com.
 */
package org.gvsig.andami.ui.mdiFrame;

import java.awt.Component;
import org.gvsig.tools.swing.api.threadsafedialogs.ThreadSafeDialogsManager;

public interface ThreadSafeDialogs extends ThreadSafeDialogsManager {
		
	public void messageDialog(String message, String messageArgs[], String title, int messageType, String msgid);
        
    public int confirmDialog(String message, String title, int optionType, int messageType, String msgid) ;

	/**
	 * Create a window with the contents and title specified as parameters
	 * and show as a dialog windows of gvSIG.
	 * 
	 * if this method is invoked out of the event dispatch thread of swing, 
	 * the dialog is presented in the thread of swing and the calling thread
	 * wait to close to continue. in this case the dialog is not presented as modal to
	 * other components of the gui.
	 * 
	 * @param contents 
	 * @param title
	 */
	public void showDialog(final Component contents, final String title);	
}
