/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.gvsig.export;

import java.util.List;
import org.gvsig.export.ExportAttributes.ExportAttribute;
import org.gvsig.export.spi.AttributeNamesTranslator;
import org.gvsig.fmap.dal.feature.FeatureAttributeDescriptor;
import org.gvsig.fmap.dal.feature.FeatureType;
import org.gvsig.tools.persistence.Persistent;
import org.gvsig.tools.util.UnmodifiableBasicList;

/**
 *
 * @author osc
 */
public interface ExportAttributes extends UnmodifiableBasicList<ExportAttribute>, Cloneable, Persistent {

    public ExportAttributes clone() throws CloneNotSupportedException;

    public void setActive(boolean b);
    
    public boolean isActive();

    public interface ExportAttribute extends Cloneable, Persistent {

        public FeatureAttributeDescriptor getDescriptor();

        public String getName();

        public String getNewName();
        
        public int getDataType();
        
        public int getNewDataType();

        public boolean isExported();
        
        public int getSize();
        
        public void setSize(int size);

        public void setNewName(String name);
        
        public void setNewType(int dataType);

        public void setExported(boolean exported);
        
        public ExportAttribute clone() throws CloneNotSupportedException;
    }

    public ExportAttribute getExportAttribute(String name);
    
    public FeatureType getTargetFeatureType(); //es el que prepara el featuretype. el del set
    
    public void setSourceFeatureType(FeatureType sourceFeatureType); //rellena
    
    public FeatureType getSourceFeatureType();

    public String getTargetName(String name);

    public String getSourceName(String name);
    
    public int getTargetType(String name);

    public int getSourceType(String name);
    
    public void setNamesTranslator(AttributeNamesTranslator attnt);

    public AttributeNamesTranslator getNamesTranslator();
    
    public boolean isAttributeNamesValid();
    
    public void fixAttributeNames();
    
    public void setExportAttributes(List<ExportAttribute>  exportAttributes);
}
