package org.gvsig.export;

import java.util.Date;
import org.gvsig.export.spi.ExportServiceFactory;
import org.gvsig.expressionevaluator.Expression;
import org.gvsig.fmap.dal.feature.FeatureStore;
import org.gvsig.fmap.dal.feature.FeatureType;
import org.gvsig.tools.persistence.Persistent;
import org.gvsig.tools.util.LabeledValue;

/**
 *
 * @author jjdelcerro
 */
public interface ExportParameters extends Cloneable, LabeledValue, Persistent  {

    public static final int USE_ALL_FEATURES = 0;
    public static final int USE_SELECTED_FEATURES = 1;
    public static final int USE_FILTERED_FEATURES = 2;

    public String getServiceName();

    public boolean needsSelectTargetProjection();

    public FeatureType getSourceFeatureType();

    public void setSourceFeatureType(FeatureType sourceFeatureType);

    public void setSourceFeatureStore(FeatureStore sourceFeatureStore);

    public FeatureStore getSourceFeatureStore();

    public int getFeaturesToUse();

    public void setFeaturesToUse(int feturesToUse);

    public Expression getFilterExpresion();

    public void setFilterExpresion(Expression expression);

    public Object getContext();

    public void setContext(Object context);

    public ExportAttributes getExportAttributes();

    public void setExportAttributes(ExportAttributes exportAttributes);
    
    public Date getCreationDate();
    
    public void setCreationDate(Date date);
    
    public ExportParameters clone() throws CloneNotSupportedException;
    
    public ExportServiceFactory getFactory();
    
    public FeatureType getTargetFeatureType();

}
