package org.gvsig.export;

import org.cresques.cts.ICoordTrans;
import org.cresques.cts.IProjection;
import org.gvsig.fmap.geom.type.GeometryType;

/**
 *
 * @author jjdelcerro
 */
public interface ExportParametersGeometry extends ExportParameters {
    
    public static final int CHECKGEOMETRY_NONE = 0;
    public static final int CHECKGEOMETRY_CHECK_IF_CORRUPT = 1;
    public static final int CHECKGEOMETRY_CHECK_IF_VALID = 2;

    public static final int CHECKGEOMETRYACTION_SET_GEOMETRY_TO_NULL = 0;
    public static final int CHECKGEOMETRYACTION_SKIP_FEATURE = 1;
    public static final int CHECKGEOMETRYACTION_ABORT = 2;
    

    public void setContextProjection(IProjection projection);
    
    public IProjection getContextProjection();
    

    public void setSourceProjection(IProjection projection);
    
    public IProjection getSourceProjection();
    
    public void setSourceTransformation(ICoordTrans transformation);
    
    public ICoordTrans getSourceTransformation();
    

    public void setTargetProjection(IProjection targetProjection);

    public IProjection getTargetProjection();
    
    public void setTargetTransformation(ICoordTrans transformation);
    
    public ICoordTrans getTargetTransformation();
    
    public ICoordTrans getTransformationToUse();
    
    
    public int getGeometryChecks();

    public int getGeometryChecksAction();

    public boolean getTryToFixGeometry();

    public void setGeometryChecks(int geometryChecks);

    public void setGeometryChecksAction(int geometryChecksAction);

    public void setTryToFixGeometry(boolean tryToFixGeometry);
    
    public String getSourceGeometryFieldName();
    
    public void setSourceGeometryFieldName(String geometryFieldName);
    
    public GeometryType getTargetGeometryType();
    
    public int getTargetGeometryTypeAsInt();
    
    public int getTargetGeometrySubtype();
    
    public void setTargetGeometryType(GeometryType type);
    
    public void setTargetGeometryType(int type);
    
    public void setTargetGeometrySubtype(int subtype);
}
