package org.gvsig.export;

import java.util.List;
import org.cresques.cts.ICoordTrans;
import org.cresques.cts.IProjection;
import org.gvsig.expressionevaluator.Expression;
import org.gvsig.fmap.dal.OpenDataStoreParameters;
import org.gvsig.fmap.dal.feature.FeatureStore;
import org.gvsig.tools.task.TaskStatus;

/**
 *
 * @author jjdelcerro
 */
public interface ExportProcess extends Runnable {

    public void setOutputFormat(String serviceName) throws ExportException;
    
    public void setSourceFeatureStore(FeatureStore store);
    
    public void setContextProjection(IProjection projection);
    
    public void setSourceProjection(IProjection projection);
    
    public void setSourceTransformation(ICoordTrans transformation);
    
    public void setFilterExpression(Expression expression);
    
    public void setFeaturesToUse(int featuresToUse);
    
    public void setParameters(ExportParameters params);
    
    public Object getContext();
    
    public void setContext(Object context);

    public ExportParameters getParameters();
    
    public TaskStatus getTaskStatus();
    
    public List<OpenDataStoreParameters> getTargetOpenStoreParameters();
    
}
