package org.gvsig.export.spi;

import org.gvsig.export.ExportAttributes;
import org.gvsig.tools.persistence.Persistent;

/**
 * This class provide the methods to translate the name of the fields
 * to the target store.
 * This class should be state-less.
 * @author osc
 */
public interface AttributeNamesTranslator extends Cloneable, Persistent {

    boolean isValidName(ExportAttributes attributes, int index, String newName);

    public String getNameSuggestion(ExportAttributes attributes, int index, String name);
    
    public String getNameSuggestion(String name);

    public AttributeNamesTranslator clone() throws CloneNotSupportedException ;

}
