package org.gvsig.export.spi;

import org.gvsig.export.ExportAttributes;
import org.gvsig.tools.ToolsLocator;
import org.gvsig.tools.dynobject.DynStruct;
import org.gvsig.tools.persistence.PersistenceManager;
import org.gvsig.tools.persistence.PersistentState;
import org.gvsig.tools.persistence.exception.PersistenceException;

public class DummyAttributeNamesTranslator implements AttributeNamesTranslator {

    public DummyAttributeNamesTranslator() {

    }

    public static void registerPersistence() {
        PersistenceManager manager = ToolsLocator.getPersistenceManager();
        if (manager.getDefinition("DummyAttributeNamesTranslator") == null) {
            DynStruct definition = manager.addDefinition(DummyAttributeNamesTranslator.class,
                    "DummyAttributeNamesTranslator", "DummyAttributeNamesTranslator persistence definition", null, null);
            definition.addDynFieldInt("a");
        }
    }

    @Override
    public void saveToState(PersistentState state) throws PersistenceException {
        state.set("a", 0);
    }

    @Override
    public void loadFromState(PersistentState state) throws PersistenceException {
        int a = state.getInt("a");
    }

    @Override
    public boolean isValidName(ExportAttributes attributes, int index, String name) {
        return true;
    }

    @Override
    public String getNameSuggestion(ExportAttributes attributes, int index, String name) {
        return name;
    }

    @Override
    public AttributeNamesTranslator clone() throws CloneNotSupportedException {
        return (AttributeNamesTranslator) super.clone();
    }

    @Override
    public String getNameSuggestion(String name) {
        return name;
    }

}
