/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.gvsig.export.impl.service;

import org.gvsig.export.ExportAttributes;
import org.gvsig.export.ExportAttributes.ExportAttribute;
import org.gvsig.export.spi.AbstractExportParameters;
import org.gvsig.export.spi.AttributeNamesTranslator;
import org.gvsig.export.spi.ExportServiceFactory;
import org.gvsig.expressionevaluator.Expression;
import org.gvsig.fmap.dal.feature.FeatureAttributeDescriptor;
import org.gvsig.tools.ToolsLocator;
import org.gvsig.tools.dynobject.DynStruct;
import org.gvsig.tools.persistence.PersistenceManager;
import org.gvsig.tools.persistence.PersistentState;
import org.gvsig.tools.persistence.exception.PersistenceException;

public class DefaultExportAttribute implements ExportAttributes.ExportAttribute {

    private FeatureAttributeDescriptor fad;
    private String newName = null;
    private int newDataType;
    private int size;
    private boolean exported;
//    private AttributeNamesTranslator translator = null;

    public DefaultExportAttribute(FeatureAttributeDescriptor fad) {
        this.fad = fad;
    }

    public DefaultExportAttribute() {

    }

    @Override
    public FeatureAttributeDescriptor getDescriptor() {
        return this.fad;
    }

    @Override
    public String getName() {
        return this.fad.getName();
    }

    @Override
    public int getDataType() {
        return this.fad.getDataType().getType();
    }

    @Override
    public String getNewName() {
        if (this.newName == null) {
            return this.getName();
        }
        return this.newName;
    }

    public int getNewDataType() {

        return this.newDataType;
    }

    @Override
    public boolean isExported() {
        return this.exported;
    }

    @Override
    public void setNewName(String name) {
        this.newName = name;
    }

    @Override
    public void setExported(boolean exported) {
        this.exported = exported;
    }

    @Override
    public void setNewType(int dataType) {
        this.newDataType = dataType;
    }

    @Override
    public int getSize() {
        return this.size;
    }

    @Override
    public void setSize(int size) {
        this.size = size;
    }

    @Override
    public ExportAttribute clone() throws CloneNotSupportedException {
        DefaultExportAttribute clone = new DefaultExportAttribute((FeatureAttributeDescriptor) fad.clone());
        clone.setExported(this.exported);
        clone.setNewName(this.newName);
        clone.setNewType(this.newDataType);
        clone.setSize(this.size);
        return clone;
    }

    public static void registerPersistence() {
        PersistenceManager manager = ToolsLocator.getPersistenceManager();
        if (manager.getDefinition("ExportAttribute") == null) {
            DynStruct definition = manager.addDefinition(DefaultExportAttribute.class,
                    "ExportAttribute", "ExportAttribute persistence definition", null, null);
            definition.addDynFieldObject("fad").setClassOfValue(FeatureAttributeDescriptor.class);
            definition.addDynFieldString("newName").setMandatory(false);
            definition.addDynFieldInt("newDataType").setMandatory(false);
            definition.addDynFieldInt("size").setMandatory(false);
            definition.addDynFieldBoolean("exported").setMandatory(false);
        }
    }

    public void saveToState(PersistentState state) throws PersistenceException {
        state.set("fad", this.fad);
        state.set("newName", this.newName);
        state.set("newDataType", this.newDataType);
        state.set("size", this.size);
        state.set("exported", this.exported);

    }

    public void loadFromState(PersistentState state) throws PersistenceException {
        FeatureAttributeDescriptor stateFad = (FeatureAttributeDescriptor) state.get("fad");
        this.fad = stateFad;
        this.newName = state.getString("newName");
        this.newDataType = state.getInt("newDataType");
        this.size = state.getInt("size");
        this.exported = state.getBoolean("exported");
    }

}
