/**
 * gvSIG. Desktop Geographic Information System.
 *
 * Copyright (C) 2007-2013 gvSIG Association.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 3
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301, USA.
 *
 * For any additional information, do not hesitate to contact us
 * at info AT gvsig.com, or visit our website www.gvsig.com.
 */
package org.gvsig.export.swing;

import org.gvsig.export.ExportParameters;
import org.gvsig.export.ExportProcess;
import org.gvsig.tools.swing.api.Component;



public interface JExportProcessPanel extends Component {

    public static final int BUTTON_BACK = 0;
    public static final int BUTTON_NEXT = 1;
    public static final int BUTTON_FINISH = 2;
    public static final int BUTTON_CANCEL = 3;
    
    public interface ExportFinishListener {

        public void cancelled(JExportProcessPanel exportPanel);
        
        public void finished(JExportProcessPanel exportPanel);
    }

    /**
     * @param listener
     */
    public void addFinishListener(ExportFinishListener listener);
    
    public void setButtonEnabled(int button, boolean enabled);
    
    public void setButtonText(int button, String text);
    
    public boolean isButtonEnabled(int button);
    
    public String getButtonText(int button);
    
    public ExportProcess getProcess();
    
    public ExportParameters getParameters();

    public int getLastAction();    

    public void nextPanel();
    
    public void previousPanel();
    
}
