package org.gvsig.export.swing.spi;

import org.gvsig.tools.swing.api.Component;

/**
 *
 * @author jjdelcerro
 */
public interface ExportPanel extends Component {

    public String getIdPanel();
    
    public String getTitlePanel();

    /**
     * Este metodo se llamo para comprobar si los datos del panel son coherentes
     * y se pueden aceptar.
     * Se invoca antes de invocar al metodo "nextPanel".
     * Devolvera false en caso de que no se deba abandonar el panel, normalmente
     * por que los datos no estan completos. En caso de que se desee presentar un
     * mensaje al usuario se podra lanzar la excecion ExportPanelValidationException
     * indicando en ella el mensaje.
     * 
     * @return true si va todo bien, false si no se debe abandonar el panel.
     * @throws ExportPanelValidationException 
     */
    public boolean validatePanel() throws ExportPanelValidationException;
    
    /**
     * Este metodo se llama cada vez que se va a presenta un panel al usuario,
     * indistintamente si llego a el por ir hacia delante o hacia atras.
     */
    public void enterPanel();

    /**
     * Este metodo se llama sobre el panel que abandona el usuario cuando
     * pulsa en el boton "siguiente".
     */
    public void nextPanel();
    
    /**
     * Este metodo se llama sobre el panel que abandona el usuario cuando pulsa
     * en el boton "anterior".
     */
    public void previousPanel();
    
}
