/**
 * gvSIG. Desktop Geographic Information System.
 *
 * Copyright (C) 2007-2013 gvSIG Association.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 3
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301, USA.
 *
 * For any additional information, do not hesitate to contact us
 * at info AT gvsig.com, or visit our website www.gvsig.com.
 */
package org.gvsig.export.swing.impl;

import java.net.URL;
import org.gvsig.export.swing.ExportSwingLibrary;
import org.gvsig.export.swing.ExportSwingLocator;
import org.gvsig.tools.library.AbstractLibrary;
import org.gvsig.tools.library.LibraryException;
import org.gvsig.tools.swing.api.ToolsSwingLocator;
import org.gvsig.tools.swing.icontheme.IconTheme;

/**
 * Library for Swing API initialization and configuration.
 * 
 * @author gvSIG team
 * @version $Id$
 */
public class ExportSwingLibraryImpl extends AbstractLibrary {

    @Override
    public void doRegistration() {
        registerAsImplementationOf(ExportSwingLibrary.class);
    }

    @Override
    protected void doInitialize() throws LibraryException {
        ExportSwingLocator.registerExportPanelsManager(DefaultExportPanelsManager.class);
        ExportSwingLocator.registerSwingManager(DefaultExportSwingManager.class);
    }

    @Override
    protected void doPostInitialize() throws LibraryException {
        String[][] iconNames = new String[][] {
            new String[] { "action", "common-filter" },
            new String[] { "action", "common-sortdown" },
            new String[] { "action", "common-sortup" },
            new String[] { "action", "common-check-on" },
            new String[] { "action", "common-check-off" }
        };
        IconTheme theme = ToolsSwingLocator.getIconThemeManager().getCurrent();
        for (String[] icon : iconNames) {
            URL url = this.getClass().getResource("/images/export-to/"+icon[1]+".png");
            theme.registerDefault("Export", icon[0], icon[1], null, url);
        }
        
    }

}
