package org.gvsig.export.swing.impl.panels;

import com.jeta.open.i18n.I18NUtils;
import com.jgoodies.forms.layout.CellConstraints;
import com.jgoodies.forms.layout.FormLayout;
import java.awt.BorderLayout;
import java.awt.ComponentOrientation;
import java.awt.Container;
import java.awt.Dimension;
import javax.swing.Box;
import javax.swing.ButtonGroup;
import javax.swing.ImageIcon;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;


public class CheckGeometriesPanelView extends JPanel
{
   JLabel lblHeader = new JLabel();
   JRadioButton rdbCheckNone = new JRadioButton();
   ButtonGroup buttongroup1 = new ButtonGroup();
   JRadioButton rdbCheckIsCorrupt = new JRadioButton();
   JLabel lblCheckIsCorrupt = new JLabel();
   JComboBox cboActionIsCorrupt = new JComboBox();
   JRadioButton rdbCheckIsValid = new JRadioButton();
   JLabel lblCheckIsvalid = new JLabel();
   JCheckBox chkTryFixGeometry = new JCheckBox();
   JComboBox cboActionIsValid = new JComboBox();

   /**
    * Default constructor
    */
   public CheckGeometriesPanelView()
   {
      initializePanel();
   }

   /**
    * Adds fill components to empty cells in the first row and first column of the grid.
    * This ensures that the grid spacing will be the same as shown in the designer.
    * @param cols an array of column indices in the first row where fill components should be added.
    * @param rows an array of row indices in the first column where fill components should be added.
    */
   void addFillComponents( Container panel, int[] cols, int[] rows )
   {
      Dimension filler = new Dimension(10,10);

      boolean filled_cell_11 = false;
      CellConstraints cc = new CellConstraints();
      if ( cols.length > 0 && rows.length > 0 )
      {
         if ( cols[0] == 1 && rows[0] == 1 )
         {
            /** add a rigid area  */
            panel.add( Box.createRigidArea( filler ), cc.xy(1,1) );
            filled_cell_11 = true;
         }
      }

      for( int index = 0; index < cols.length; index++ )
      {
         if ( cols[index] == 1 && filled_cell_11 )
         {
            continue;
         }
         panel.add( Box.createRigidArea( filler ), cc.xy(cols[index],1) );
      }

      for( int index = 0; index < rows.length; index++ )
      {
         if ( rows[index] == 1 && filled_cell_11 )
         {
            continue;
         }
         panel.add( Box.createRigidArea( filler ), cc.xy(1,rows[index]) );
      }

   }

   /**
    * Helper method to load an image file from the CLASSPATH
    * @param imageName the package and name of the file to load relative to the CLASSPATH
    * @return an ImageIcon instance with the specified image file
    * @throws IllegalArgumentException if the image resource cannot be loaded.
    */
   public ImageIcon loadImage( String imageName )
   {
      try
      {
         ClassLoader classloader = getClass().getClassLoader();
         java.net.URL url = classloader.getResource( imageName );
         if ( url != null )
         {
            ImageIcon icon = new ImageIcon( url );
            return icon;
         }
      }
      catch( Exception e )
      {
         e.printStackTrace();
      }
      throw new IllegalArgumentException( "Unable to load image: " + imageName );
   }

   /**
    * Method for recalculating the component orientation for 
    * right-to-left Locales.
    * @param orientation the component orientation to be applied
    */
   public void applyComponentOrientation( ComponentOrientation orientation )
   {
      // Not yet implemented...
      // I18NUtils.applyComponentOrientation(this, orientation);
      super.applyComponentOrientation(orientation);
   }

   public JPanel createPanel()
   {
      JPanel jpanel1 = new JPanel();
      FormLayout formlayout1 = new FormLayout("FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:GROW(1.0),FILL:DEFAULT:NONE","CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE");
      CellConstraints cc = new CellConstraints();
      jpanel1.setLayout(formlayout1);

      lblHeader.setName("lblHeader");
      lblHeader.setText("_check_geometries_before_export_header");
      jpanel1.add(lblHeader,cc.xywh(2,2,2,1));

      rdbCheckNone.setActionCommand("_No_realizar_ninguna_comprobacion_sobre_las_geometrias");
      rdbCheckNone.setName("rdbCheckNone");
      rdbCheckNone.setText("_No_realizar_ninguna_comprobacion_sobre_las_geometrias");
      buttongroup1.add(rdbCheckNone);
      jpanel1.add(rdbCheckNone,cc.xywh(2,4,2,1));

      rdbCheckIsCorrupt.setActionCommand("_Comprobar_que_la_geometria_no_este_corrupta");
      rdbCheckIsCorrupt.setName("rdbCheckIsCorrupt");
      rdbCheckIsCorrupt.setText("_Comprobar_que_la_geometria_no_este_corrupta");
      buttongroup1.add(rdbCheckIsCorrupt);
      jpanel1.add(rdbCheckIsCorrupt,cc.xywh(2,6,2,1));

      lblCheckIsCorrupt.setName("lblCheckIsCorrupt");
      lblCheckIsCorrupt.setText("_Cuando_la_geometria_este_corrupta");
      jpanel1.add(lblCheckIsCorrupt,cc.xy(3,8));

      cboActionIsCorrupt.setName("cboActionIsCorrupt");
      jpanel1.add(cboActionIsCorrupt,cc.xy(3,10));

      rdbCheckIsValid.setActionCommand("_Comprobar_la_validez_de_las_geometrias_antes_de_insertarlas");
      rdbCheckIsValid.setName("rdbCheckIsValid");
      rdbCheckIsValid.setText("_Comprobar_la_validez_de_las_geometrias_antes_de_insertarlas");
      buttongroup1.add(rdbCheckIsValid);
      jpanel1.add(rdbCheckIsValid,cc.xywh(2,12,2,1));

      lblCheckIsvalid.setName("lblCheckIsvalid");
      lblCheckIsvalid.setText("_Cuando_la_geometria_no_sea_valida");
      jpanel1.add(lblCheckIsvalid,cc.xy(3,14));

      chkTryFixGeometry.setActionCommand("_Intentar_reparar_la_geometria");
      chkTryFixGeometry.setName("chkTryFixGeometry");
      chkTryFixGeometry.setText("_Intentar_reparar_la_geometria");
      jpanel1.add(chkTryFixGeometry,cc.xy(3,16));

      cboActionIsValid.setName("cboActionIsValid");
      jpanel1.add(cboActionIsValid,cc.xy(3,18));

      addFillComponents(jpanel1,new int[]{ 1,2,3,4 },new int[]{ 1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19 });
      return jpanel1;
   }

   /**
    * Initializer
    */
   protected void initializePanel()
   {
      setLayout(new BorderLayout());
      add(createPanel(), BorderLayout.CENTER);
   }


}
