package org.gvsig.export.swing.impl.panels;

import com.jeta.open.i18n.I18NUtils;
import com.jgoodies.forms.layout.CellConstraints;
import com.jgoodies.forms.layout.FormLayout;
import java.awt.BorderLayout;
import java.awt.ComponentOrientation;
import java.awt.Container;
import java.awt.Dimension;
import javax.swing.Box;
import javax.swing.ButtonGroup;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTextField;
import javax.swing.border.EmptyBorder;


public class SelectFilterPanelView extends JPanel
{
   JLabel lblHeader = new JLabel();
   JRadioButton rdbAllRows = new JRadioButton();
   ButtonGroup buttongroup1 = new ButtonGroup();
   JRadioButton rdbSelectedRows = new JRadioButton();
   JRadioButton rdbFilteredRows = new JRadioButton();
   JTextField txtPicker = new JTextField();
   JButton btnPickerExp = new JButton();
   JButton btnPickerBook = new JButton();
   JButton btnPickerHis = new JButton();

   /**
    * Default constructor
    */
   public SelectFilterPanelView()
   {
      initializePanel();
   }

   /**
    * Adds fill components to empty cells in the first row and first column of the grid.
    * This ensures that the grid spacing will be the same as shown in the designer.
    * @param cols an array of column indices in the first row where fill components should be added.
    * @param rows an array of row indices in the first column where fill components should be added.
    */
   void addFillComponents( Container panel, int[] cols, int[] rows )
   {
      Dimension filler = new Dimension(10,10);

      boolean filled_cell_11 = false;
      CellConstraints cc = new CellConstraints();
      if ( cols.length > 0 && rows.length > 0 )
      {
         if ( cols[0] == 1 && rows[0] == 1 )
         {
            /** add a rigid area  */
            panel.add( Box.createRigidArea( filler ), cc.xy(1,1) );
            filled_cell_11 = true;
         }
      }

      for( int index = 0; index < cols.length; index++ )
      {
         if ( cols[index] == 1 && filled_cell_11 )
         {
            continue;
         }
         panel.add( Box.createRigidArea( filler ), cc.xy(cols[index],1) );
      }

      for( int index = 0; index < rows.length; index++ )
      {
         if ( rows[index] == 1 && filled_cell_11 )
         {
            continue;
         }
         panel.add( Box.createRigidArea( filler ), cc.xy(1,rows[index]) );
      }

   }

   /**
    * Helper method to load an image file from the CLASSPATH
    * @param imageName the package and name of the file to load relative to the CLASSPATH
    * @return an ImageIcon instance with the specified image file
    * @throws IllegalArgumentException if the image resource cannot be loaded.
    */
   public ImageIcon loadImage( String imageName )
   {
      try
      {
         ClassLoader classloader = getClass().getClassLoader();
         java.net.URL url = classloader.getResource( imageName );
         if ( url != null )
         {
            ImageIcon icon = new ImageIcon( url );
            return icon;
         }
      }
      catch( Exception e )
      {
         e.printStackTrace();
      }
      throw new IllegalArgumentException( "Unable to load image: " + imageName );
   }

   /**
    * Method for recalculating the component orientation for 
    * right-to-left Locales.
    * @param orientation the component orientation to be applied
    */
   public void applyComponentOrientation( ComponentOrientation orientation )
   {
      // Not yet implemented...
      // I18NUtils.applyComponentOrientation(this, orientation);
      super.applyComponentOrientation(orientation);
   }

   public JPanel createPanel()
   {
      JPanel jpanel1 = new JPanel();
      FormLayout formlayout1 = new FormLayout("FILL:4DLU:NONE,FILL:8DLU:NONE,FILL:8DLU:NONE,FILL:DEFAULT:GROW(1.0),FILL:4DLU:NONE","CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE");
      CellConstraints cc = new CellConstraints();
      jpanel1.setLayout(formlayout1);

      lblHeader.setName("lblHeader");
      lblHeader.setText("_Indique_que_registros_desea_exportar");
      jpanel1.add(lblHeader,cc.xywh(2,2,3,1));

      rdbAllRows.setActionCommand("_Todos_los_registros");
      rdbAllRows.setName("rdbAllRows");
      rdbAllRows.setText("_Todos_los_registros");
      buttongroup1.add(rdbAllRows);
      jpanel1.add(rdbAllRows,cc.xywh(2,4,3,1));

      rdbSelectedRows.setActionCommand("_Los_registros_seleccionados");
      rdbSelectedRows.setName("rdbSelectedRows");
      rdbSelectedRows.setText("_Los_registros_seleccionados");
      buttongroup1.add(rdbSelectedRows);
      jpanel1.add(rdbSelectedRows,cc.xywh(2,6,3,1));

      rdbFilteredRows.setActionCommand("_Los_registros_que_cumplan_el_critrio_seleccionado");
      rdbFilteredRows.setName("rdbFilteredRows");
      rdbFilteredRows.setText("_Los_registros_que_cumplan_el_critrio_seleccionado");
      buttongroup1.add(rdbFilteredRows);
      jpanel1.add(rdbFilteredRows,cc.xywh(2,8,3,1));

      jpanel1.add(createPanel1(),cc.xy(4,10));
      addFillComponents(jpanel1,new int[]{ 1,2,3,4,5 },new int[]{ 1,2,3,4,5,6,7,8,9,10,11 });
      return jpanel1;
   }

   public JPanel createPanel1()
   {
      JPanel jpanel1 = new JPanel();
      FormLayout formlayout1 = new FormLayout("FILL:67PX:GROW(1.0),FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:NONE","FILL:DEFAULT:NONE");
      CellConstraints cc = new CellConstraints();
      jpanel1.setLayout(formlayout1);

      txtPicker.setName("txtPicker");
      jpanel1.add(txtPicker,cc.xy(1,1));

      btnPickerExp.setName("btnPickerExp");
      EmptyBorder emptyborder1 = new EmptyBorder(2,2,2,2);
      btnPickerExp.setBorder(emptyborder1);
      jpanel1.add(btnPickerExp,cc.xy(2,1));

      btnPickerBook.setName("btnPickerBook");
      EmptyBorder emptyborder2 = new EmptyBorder(2,2,2,2);
      btnPickerBook.setBorder(emptyborder2);
      jpanel1.add(btnPickerBook,cc.xy(4,1));

      btnPickerHis.setName("btnPickerHis");
      EmptyBorder emptyborder3 = new EmptyBorder(2,2,2,2);
      btnPickerHis.setBorder(emptyborder3);
      jpanel1.add(btnPickerHis,cc.xy(6,1));

      addFillComponents(jpanel1,new int[]{ 3,5 },new int[0]);
      return jpanel1;
   }

   /**
    * Initializer
    */
   protected void initializePanel()
   {
      setLayout(new BorderLayout());
      add(createPanel(), BorderLayout.CENTER);
   }


}
