package org.gvsig.export.swing.impl.panels;

import com.jeta.open.i18n.I18NUtils;
import com.jgoodies.forms.layout.CellConstraints;
import com.jgoodies.forms.layout.FormLayout;
import java.awt.BorderLayout;
import java.awt.ComponentOrientation;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import javax.swing.Box;
import javax.swing.ButtonGroup;
import javax.swing.ImageIcon;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;


public class SelectGeometryFieldPanelView extends JPanel
{
   JLabel lblSelectOfTheGeometryField = new JLabel();
   JRadioButton rdoUseTheGeometryFieldByDefault = new JRadioButton();
   ButtonGroup buttongroup1 = new ButtonGroup();
   JRadioButton rdoUseNullAsTheValueOfTheGeometry = new JRadioButton();
   JRadioButton rdoSelectTheFieldToBeUsedAsGeometry = new JRadioButton();
   JComboBox cboGeometryField = new JComboBox();

   /**
    * Default constructor
    */
   public SelectGeometryFieldPanelView()
   {
      initializePanel();
   }
   public static void main(String[] args)
   {
      JFrame frame = new JFrame();
      frame.setSize(600, 400);
      frame.setLocation(100, 100);
      frame.getContentPane().add(new SelectGeometryFieldPanelView());
      frame.setVisible(true);

      frame.addWindowListener( new WindowAdapter()
      {
         public void windowClosing( WindowEvent evt )
         {
            System.exit(0);
         }
      });
   }
   /**
    * Adds fill components to empty cells in the first row and first column of the grid.
    * This ensures that the grid spacing will be the same as shown in the designer.
    * @param cols an array of column indices in the first row where fill components should be added.
    * @param rows an array of row indices in the first column where fill components should be added.
    */
   void addFillComponents( Container panel, int[] cols, int[] rows )
   {
      Dimension filler = new Dimension(10,10);

      boolean filled_cell_11 = false;
      CellConstraints cc = new CellConstraints();
      if ( cols.length > 0 && rows.length > 0 )
      {
         if ( cols[0] == 1 && rows[0] == 1 )
         {
            /** add a rigid area  */
            panel.add( Box.createRigidArea( filler ), cc.xy(1,1) );
            filled_cell_11 = true;
         }
      }

      for( int index = 0; index < cols.length; index++ )
      {
         if ( cols[index] == 1 && filled_cell_11 )
         {
            continue;
         }
         panel.add( Box.createRigidArea( filler ), cc.xy(cols[index],1) );
      }

      for( int index = 0; index < rows.length; index++ )
      {
         if ( rows[index] == 1 && filled_cell_11 )
         {
            continue;
         }
         panel.add( Box.createRigidArea( filler ), cc.xy(1,rows[index]) );
      }

   }

   /**
    * Helper method to load an image file from the CLASSPATH
    * @param imageName the package and name of the file to load relative to the CLASSPATH
    * @return an ImageIcon instance with the specified image file
    * @throws IllegalArgumentException if the image resource cannot be loaded.
    */
   public ImageIcon loadImage( String imageName )
   {
      try
      {
         ClassLoader classloader = getClass().getClassLoader();
         java.net.URL url = classloader.getResource( imageName );
         if ( url != null )
         {
            ImageIcon icon = new ImageIcon( url );
            return icon;
         }
      }
      catch( Exception e )
      {
         e.printStackTrace();
      }
      throw new IllegalArgumentException( "Unable to load image: " + imageName );
   }

   /**
    * Method for recalculating the component orientation for 
    * right-to-left Locales.
    * @param orientation the component orientation to be applied
    */
   public void applyComponentOrientation( ComponentOrientation orientation )
   {
      // Not yet implemented...
      // I18NUtils.applyComponentOrientation(this, orientation);
      super.applyComponentOrientation(orientation);
   }

   public JPanel createPanel()
   {
      JPanel jpanel1 = new JPanel();
      FormLayout formlayout1 = new FormLayout("FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:GROW(1.0),FILL:DEFAULT:NONE","CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE");
      CellConstraints cc = new CellConstraints();
      jpanel1.setLayout(formlayout1);

      lblSelectOfTheGeometryField.setName("lblSelectOfTheGeometryField");
      lblSelectOfTheGeometryField.setText("_Selection_of_the_geometry_field");
      jpanel1.add(lblSelectOfTheGeometryField,cc.xywh(2,2,2,1));

      rdoUseTheGeometryFieldByDefault.setActionCommand("_Use_the_geometry_field_by_default");
      rdoUseTheGeometryFieldByDefault.setName("rdoUseTheGeometryFieldByDefault");
      rdoUseTheGeometryFieldByDefault.setText("_Use_the_geometry_field_by_default");
      buttongroup1.add(rdoUseTheGeometryFieldByDefault);
      jpanel1.add(rdoUseTheGeometryFieldByDefault,cc.xywh(2,4,2,1));

      rdoUseNullAsTheValueOfTheGeometry.setActionCommand("_Use_null_as_the_value_of_the_geometry");
      rdoUseNullAsTheValueOfTheGeometry.setName("rdoUseNullAsTheValueOfTheGeometry");
      rdoUseNullAsTheValueOfTheGeometry.setText("_Use_null_as_the_value_of_the_geometry");
      buttongroup1.add(rdoUseNullAsTheValueOfTheGeometry);
      jpanel1.add(rdoUseNullAsTheValueOfTheGeometry,cc.xywh(2,6,2,1));

      rdoSelectTheFieldToBeUsedAsGeometry.setActionCommand("_Select_the_field_to_be_used_as_geometry");
      rdoSelectTheFieldToBeUsedAsGeometry.setName("rdoSelectTheFieldToBeUsedAsGeometry");
      rdoSelectTheFieldToBeUsedAsGeometry.setText("_Select_the_field_to_be_used_as_geometry");
      buttongroup1.add(rdoSelectTheFieldToBeUsedAsGeometry);
      jpanel1.add(rdoSelectTheFieldToBeUsedAsGeometry,cc.xywh(2,8,2,1));

      cboGeometryField.setName("cboGeometryField");
      jpanel1.add(cboGeometryField,cc.xy(3,10));

      addFillComponents(jpanel1,new int[]{ 1,2,3,4 },new int[]{ 1,2,3,4,5,6,7,8,9,10,11 });
      return jpanel1;
   }

   /**
    * Initializer
    */
   protected void initializePanel()
   {
      setLayout(new BorderLayout());
      add(createPanel(), BorderLayout.CENTER);
   }


}
