package org.gvsig.export.csv;

import org.gvsig.export.csv.service.ExportCSVServiceFactory;
import org.gvsig.export.csv.swing.ExportCSVPanelsFactory;
import org.gvsig.export.ExportLibrary;
import org.gvsig.export.ExportLocator;
import org.gvsig.export.csv.service.ExportCSVParametersImpl;
import org.gvsig.export.spi.ExportServiceManager;
import org.gvsig.export.swing.ExportSwingLibrary;
import org.gvsig.export.swing.ExportSwingLocator;
import org.gvsig.export.swing.spi.ExportPanelsManager;
import org.gvsig.tools.library.AbstractLibrary;
import org.gvsig.tools.library.LibraryException;


/**
 *
 * @author jjdelcerro
 */
public class ExportCSVLibrary extends AbstractLibrary {

    @Override
    public void doRegistration() {
        registerAsServiceOf(ExportSwingLibrary.class);
        registerAsServiceOf(ExportLibrary.class);
    }

    @Override
    protected void doInitialize() throws LibraryException {
        // Nothing to do
    }

    @Override
    protected void doPostInitialize() throws LibraryException {
        ExportServiceManager manager = ExportLocator.getServiceManager();
        ExportPanelsManager swingManager = ExportSwingLocator.getExportPanelsManager();
        
        manager.register(new ExportCSVServiceFactory());
        swingManager.register(new ExportCSVPanelsFactory());
        ExportCSVParametersImpl.registerPersistence();
    }

}
