package org.gvsig.export.csv.service;

import org.gvsig.export.ExportParameters;
import org.gvsig.export.spi.AbstractExportServiceFactory;

/**
 *
 * @author jjdelcerro
 */
public class ExportCSVServiceFactory extends AbstractExportServiceFactory {

    public static final String SERVICE_NAME = "CSV";
    
    public ExportCSVServiceFactory() {
        super(
                SERVICE_NAME,
                "CSV (CSV File)",
                "CSV, CSV File"
        );
    }
    
    @Override
    public ExportCSVService createService(ExportParameters parameters) {
        ExportCSVService service = new ExportCSVService(this, (ExportCSVParameters) parameters);
        return service;
    }

    @Override
    public ExportCSVParameters createParameters() {
        ExportCSVParameters parameters = new ExportCSVParametersImpl(this);
        return parameters;
    }

    @Override
    public boolean hasTabularSupport() {
        return true;
    }

    @Override
    public boolean hasVectorialSupport() {
        return true;
    }
    
}
