/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.gvsig.export.csv.swing;

import org.gvsig.export.csv.swing.panels.CSVExportParametersPanel;
import org.gvsig.export.ExportParameters;
import org.gvsig.export.swing.ExportSwingLocator;
import org.gvsig.export.swing.JExportProcessPanel;
import org.gvsig.export.swing.spi.AbstractExportPanels;
import org.gvsig.export.swing.spi.ExportPanels;
import org.gvsig.export.swing.spi.ExportPanelsFactory;
import org.gvsig.export.swing.spi.ExportPanelsManager;
import org.gvsig.fmap.geom.Geometry;

/**
 *
 * @author jjdelcerro
 */
public class ExportCSVPanels
        extends AbstractExportPanels
        implements ExportPanels {

    ExportCSVPanels(
            ExportPanelsFactory factory,
            JExportProcessPanel processPanel,
            ExportParameters parameters
    ) {
        super(factory, processPanel, parameters);
        this.initPanels();
    }

    private void initPanels() {
        ExportPanelsManager manager = ExportSwingLocator.getExportPanelsManager();

        this.add(new CSVExportParametersPanel(
                this.getProcessPanel(),
                this.getParameters()
        )
        );
        this.add(manager.createStandardPanel(
                ExportPanelsManager.PANEL_SELECT_OUTPUT_FILE,
                this.getProcessPanel(),
                this.getParameters()
        )
        );
        this.add(manager.createStandardPanel(
                ExportPanelsManager.PANEL_SELECT_CHARSET,
                this.getProcessPanel(),
                this.getParameters()
        )
        );

        this.add(manager.createStandardPanel(
                ExportPanelsManager.PANEL_SELECT_GEOMETRY_FIELD,
                this.getProcessPanel(),
                this.getParameters()
        )
        );
        this.add(manager.createStandardPanel(
                ExportPanelsManager.PANEL_SELECT_GEOMETRY_TYPE,
                this.getProcessPanel(),
                this.getParameters(),
                new int[]{
                    Geometry.TYPES.GEOMETRY,
                    Geometry.TYPES.POINT,
                    Geometry.TYPES.LINE,
                    Geometry.TYPES.POLYGON,
                    Geometry.TYPES.MULTIPOINT,
                    Geometry.TYPES.MULTILINE,
                    Geometry.TYPES.MULTIPOLYGON
                },
                new int[]{
                    Geometry.SUBTYPES.GEOM2D,
                    Geometry.SUBTYPES.GEOM3D,
                    Geometry.SUBTYPES.GEOM3DM
                }
        )
        );
        this.add(manager.createStandardPanel(
                ExportPanelsManager.PANEL_CHECK_GEOMETRIES,
                this.getProcessPanel(),
                this.getParameters()
        )
        );

        this.add(manager.createStandardPanel(
                ExportPanelsManager.PANEL_ATTRIBUTES_SELECTION,
                this.getProcessPanel(),
                this.getParameters()
        )
        );
    }
}
