package org.gvsig.export.dbf.service;

import org.gvsig.export.ExportLocator;
import org.gvsig.export.ExportParameters;
import org.gvsig.export.spi.AbstractExportServiceFactory;
import org.gvsig.export.spi.AttributeNamesTranslator;

/**
 *
 * @author jjdelcerro
 */
public class ExportDBFServiceFactory extends AbstractExportServiceFactory {

    public static final String SERVICE_NAME = "DBF";
    
    public ExportDBFServiceFactory() {
        super(
                SERVICE_NAME,
                "DBF (DBase File)",
                "DBF, DBase File"
        );
    }
    
    @Override
    public ExportDBFService createService(ExportParameters parameters) {
        ExportDBFService service = new ExportDBFService(this, (ExportDBFParameters) parameters);
        return service;
    }

    @Override
    public ExportDBFParameters createParameters() {
        ExportDBFParameters parameters = new ExportDBFParametersImpl(this);
        return parameters;
    }

    @Override
    public boolean hasTabularSupport() {
        return true;
    }

    @Override
    public boolean hasVectorialSupport() {
        return false;
    }
    
}
