package org.gvsig.export.jdbc;

import org.gvsig.export.jdbc.service.ExportJDBCServiceFactory;
import org.gvsig.export.jdbc.swing.ExportJDBCPanelsFactory;
import org.gvsig.export.ExportLocator;
import org.gvsig.export.jdbc.service.ExportJDBCAttributeNamesTranslator;
import org.gvsig.export.jdbc.service.ExportJDBCParametersImpl;
import org.gvsig.export.spi.ExportServiceManager;
import org.gvsig.export.swing.ExportSwingLibrary;
import org.gvsig.export.swing.ExportSwingLocator;
import org.gvsig.export.swing.spi.ExportPanelsManager;
import org.gvsig.tools.ToolsLocator;
import org.gvsig.tools.i18n.I18nManager;
import org.gvsig.tools.library.AbstractLibrary;
import org.gvsig.tools.library.LibraryException;

public class ExportJDBCLibrary extends AbstractLibrary {

    @Override
    public void doRegistration() {
        registerAsServiceOf(ExportSwingLibrary.class);
    }

    @Override
    protected void doInitialize() throws LibraryException {
        I18nManager i18nManager = ToolsLocator.getI18nManager();
        i18nManager.addResourceFamily("org.gvsig.exportto.swing.prov.jdbc",
                ExportJDBCLibrary.class.getClassLoader(),
                ExportJDBCLibrary.class.getClass().getName()
        );
    }

    @Override
    protected void doPostInitialize() throws LibraryException {
        ExportServiceManager serviceManager = ExportLocator.getServiceManager();
        ExportPanelsManager panelsManager = ExportSwingLocator.getExportPanelsManager();
        
        serviceManager.register(new ExportJDBCServiceFactory());
        panelsManager.register(new ExportJDBCPanelsFactory());
        ExportJDBCParametersImpl.registerPersistence();
        ExportJDBCAttributeNamesTranslator.registerPersistence();
    }

}
