/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.gvsig.export.jdbc.service;

import org.gvsig.export.spi.AbstractExportParametersGeometry;
import org.gvsig.fmap.dal.store.jdbc.JDBCServerExplorerParameters;
import org.gvsig.tools.ToolsLocator;
import org.gvsig.tools.dynobject.DynStruct;
import org.gvsig.tools.persistence.PersistenceManager;
import org.gvsig.tools.persistence.PersistentState;
import org.gvsig.tools.persistence.exception.PersistenceException;

/**
 *
 * @author jjdelcerro
 */
public class ExportJDBCParametersImpl
        extends AbstractExportParametersGeometry
        implements ExportJDBCParameters {

    private JDBCServerExplorerParameters explorerParameters;
    private String schema;
    private String tableName;
    private boolean canCreatetable;
    private String primaryKeyName;
    private String storeName;
    private String explorerName;
    private boolean translateIdentifiersToLowerCase;
    private boolean removeSpacesInIdentifiers;
    private boolean translateHyphens;
    private String selectRole;
    private String insertRole;
    private String updateRole;
    private String deleteRole;
    private String truncateRole;
    private String referenceRole;
    private String triggerRole;
    private String allRole;
    private String postCreatingStatement;
    private boolean createIndexInGeometryRow;
    private boolean updateTableStatistics;

    public ExportJDBCParametersImpl(ExportJDBCServiceFactory factory) {
        super(factory);
        this.exportAttributes.setNamesTranslator(new ExportJDBCAttributeNamesTranslator(this));

        this.canCreatetable = true;
        this.translateIdentifiersToLowerCase = true;
        this.removeSpacesInIdentifiers = true;
        this.translateHyphens = true;
        this.createIndexInGeometryRow = true;
        this.updateTableStatistics = true;
    }

    public ExportJDBCParametersImpl() {
        super(null);
    }

    @Override
    public String getServiceName() {
        return ExportJDBCServiceFactory.SERVICE_NAME;
    }

    /**
     * @return the explorerParameters
     */
    @Override
    public JDBCServerExplorerParameters getExplorerParameters() {
        return explorerParameters;
    }

    /**
     * @param explorerParameters the explorerParameters to set
     */
    @Override
    public void setExplorerParameters(JDBCServerExplorerParameters explorerParameters) {
        this.explorerParameters = explorerParameters;
    }

    /**
     * @return the schema
     */
    @Override
    public String getSchema() {
        return schema;
    }

    /**
     * @param schema the schema to set
     */
    @Override
    public void setSchema(String schema) {
        this.schema = schema;
    }

    /**
     * @return the tableName
     */
    @Override
    public String getTableName() {
        return tableName;
    }

    /**
     * @param tableName the tableName to set
     */
    @Override
    public void setTableName(String tableName) {
        this.tableName = tableName;
    }

    /**
     * @return the canCreatetable
     */
    @Override
    public boolean canCreatetable() {
        return canCreatetable;
    }

    /**
     * @param canCreatetable the canCreatetable to set
     */
    @Override
    public void setCanCreatetable(boolean canCreatetable) {
        this.canCreatetable = canCreatetable;
    }

    /**
     * @return the primaryKeyName
     */
    @Override
    public String getPrimaryKey() {
        return primaryKeyName;
    }

    /**
     * @param primaryKey the primaryKeyName to set
     */
    @Override
    public void setPrimaryKey(String primaryKey) {
        this.primaryKeyName = primaryKey;
    }

    /**
     * @return the storeName
     */
    @Override
    public String getStoreName() {
        return storeName;
    }

    /**
     * @param storeName the storeName to set
     */
    @Override
    public void setStoreName(String storeName) {
        this.storeName = storeName;
    }

    /**
     * @return the explorerName
     */
    @Override
    public String getExplorerName() {
        return explorerName;
    }

    /**
     * @param explorerName the explorerName to set
     */
    @Override
    public void setExplorerName(String explorerName) {
        this.explorerName = explorerName;
    }

    /**
     * @param translateIdentifiersToLowerCase the
     * translateIdentifiersToLowerCase to set
     */
    @Override
    public void setTranslateIdentifiersToLowerCase(boolean translateIdentifiersToLowerCase) {
        if (translateIdentifiersToLowerCase != this.translateIdentifiersToLowerCase) {
            this.translateIdentifiersToLowerCase = translateIdentifiersToLowerCase;
            this.exportAttributes.fixAttributeNames();
        }
    }

    /**
     * @param removeSpacesInIdentifiers the removeSpacesInIdentifiers to set
     */
    @Override
    public void setRemoveSpacesInIdentifiers(boolean removeSpacesInIdentifiers) {
        if (removeSpacesInIdentifiers != this.removeSpacesInIdentifiers) {
            this.removeSpacesInIdentifiers = removeSpacesInIdentifiers;
            this.exportAttributes.fixAttributeNames();
        }
    }

    /**
     * @param translateHyphens the translateHyphens to set
     */
    @Override
    public void setTranslateHyphens(boolean translateHyphens) {
        if (translateHyphens != this.translateHyphens) {
            this.translateHyphens = translateHyphens;
            this.exportAttributes.fixAttributeNames();
        }
    }

    /**
     * @return the selectRole
     */
    @Override
    public String getSelectRole() {
        return selectRole;
    }

    /**
     * @param selectRole the selectRole to set
     */
    @Override
    public void setSelectRole(String selectRole) {
        this.selectRole = selectRole;
    }

    /**
     * @return the insertRole
     */
    @Override
    public String getInsertRole() {
        return insertRole;
    }

    /**
     * @param insertRole the insertRole to set
     */
    @Override
    public void setInsertRole(String insertRole) {
        this.insertRole = insertRole;
    }

    /**
     * @return the updateRole
     */
    @Override
    public String getUpdateRole() {
        return updateRole;
    }

    /**
     * @param updateRole the updateRole to set
     */
    @Override
    public void setUpdateRole(String updateRole) {
        this.updateRole = updateRole;
    }

    /**
     * @return the deleteRole
     */
    @Override
    public String getDeleteRole() {
        return deleteRole;
    }

    /**
     * @param deleteRole the deleteRole to set
     */
    @Override
    public void setDeleteRole(String deleteRole) {
        this.deleteRole = deleteRole;
    }

    /**
     * @return the truncateRole
     */
    @Override
    public String getTruncateRole() {
        return truncateRole;
    }

    /**
     * @param truncateRole the truncateRole to set
     */
    @Override
    public void setTruncateRole(String truncateRole) {
        this.truncateRole = truncateRole;
    }

    /**
     * @return the referenceRole
     */
    @Override
    public String getReferenceRole() {
        return referenceRole;
    }

    /**
     * @param referenceRole the referenceRole to set
     */
    @Override
    public void setReferenceRole(String referenceRole) {
        this.referenceRole = referenceRole;
    }

    /**
     * @return the triggerRole
     */
    @Override
    public String getTriggerRole() {
        return triggerRole;
    }

    /**
     * @param triggerRole the triggerRole to set
     */
    @Override
    public void setTriggerRole(String triggerRole) {
        this.triggerRole = triggerRole;
    }

    /**
     * @return the allRole
     */
    @Override
    public String getAllRole() {
        return allRole;
    }

    /**
     * @param allRole the allRole to set
     */
    @Override
    public void setAllRole(String allRole) {
        this.allRole = allRole;
    }

    /**
     * @return the postCreatingStatement
     */
    @Override
    public String getPostCreatingStatement() {
        return postCreatingStatement;
    }

    /**
     * @param postCreatingStatement the postCreatingStatement to set
     */
    @Override
    public void setPostCreatingStatement(String postCreatingStatement) {
        this.postCreatingStatement = postCreatingStatement;
    }

    /**
     * @return the createIndexInGeometryRow
     */
    @Override
    public boolean getCreateIndexInGeometryRow() {
        return createIndexInGeometryRow;
    }

    /**
     * @param createIndexInGeometryRow the createIndexInGeometryRow to set
     */
    @Override
    public void setCreateIndexInGeometryRow(boolean createIndexInGeometryRow) {
        this.createIndexInGeometryRow = createIndexInGeometryRow;
    }

    /**
     * @return the updateTableStatistics
     */
    @Override
    public boolean getUpdateTableStatistics() {
        return updateTableStatistics;
    }

    /**
     * @param updateTableStatistics the updateTableStatistics to set
     */
    @Override
    public void setUpdateTableStatistics(boolean updateTableStatistics) {
        this.updateTableStatistics = updateTableStatistics;
    }

    @Override
    public boolean getTranslateHyphens() {
        return this.translateHyphens;
    }

    @Override
    public boolean getTranslateIdentifiersToLowerCase() {
        return this.translateIdentifiersToLowerCase;
    }

    @Override
    public boolean getRemoveSpacesInIdentifiers() {
        return this.removeSpacesInIdentifiers;
    }

    @Override
    public ExportJDBCParameters clone() throws CloneNotSupportedException {
        ExportJDBCParameters clone = (ExportJDBCParameters) super.clone();
        clone.setExplorerParameters((JDBCServerExplorerParameters) this.explorerParameters.getCopy());
        return clone;
    }

        public static void registerPersistence() {

        PersistenceManager manager = ToolsLocator.getPersistenceManager();
        if (manager.getDefinition("ExportJDBCParametersImpl") == null) {
            DynStruct definition = manager.addDefinition(ExportJDBCParametersImpl.class,
                    "ExportJDBCParametersImpl", "ExportJDBCParametersImpl persistence definition", null, null);
            definition.addDynFieldObject("explorerParameters").setClassOfValue(JDBCServerExplorerParameters.class);
            definition.addDynFieldString("schema");
            definition.addDynFieldString("tableName");
            definition.addDynFieldBoolean("canCreatetable");
            definition.addDynFieldString("primaryKeyName");
            definition.addDynFieldString("storeName");
            definition.addDynFieldString("explorerName");
            definition.addDynFieldBoolean("translateIdentifiersToLowerCase");
            definition.addDynFieldBoolean("removeSpacesInIdentifiers");
            definition.addDynFieldBoolean("translateHyphens");
            definition.addDynFieldString("selectRole");
            definition.addDynFieldString("insertRole");
            definition.addDynFieldString("updateRole");
            definition.addDynFieldString("deleteRole");
            definition.addDynFieldString("truncateRole");
            definition.addDynFieldString("referenceRole");
            definition.addDynFieldString("triggerRole");
            definition.addDynFieldString("allRole");
            definition.addDynFieldString("postCreatingStatement");
            definition.addDynFieldBoolean("createIndexInGeometryRow");
            definition.addDynFieldBoolean("updateTableStatistics");
            definition.extend(manager.getDefinition("AbstractExportParametersGeometry"));
        }
    }

    @Override
    public void saveToState(PersistentState state) throws PersistenceException {
        super.saveToState(state);
        state.set("explorerParameters", explorerParameters);
        state.set("schema", schema);
        state.set("tableName", tableName);
        state.set("canCreatetable", canCreatetable);
        state.set("primaryKeyName", primaryKeyName);
        state.set("storeName", storeName);
        state.set("explorerName", explorerName);
        state.set("translateIdentifiersToLowerCase", translateIdentifiersToLowerCase);
        state.set("removeSpacesInIdentifiers", removeSpacesInIdentifiers);
        state.set("translateHyphens", translateHyphens);
        state.set("selectRole", selectRole);
        state.set("insertRole", insertRole);
        state.set("updateRole", updateRole);
        state.set("deleteRole", deleteRole);
        state.set("truncateRole", truncateRole);
        state.set("referenceRole", referenceRole);
        state.set("triggerRole", triggerRole);
        state.set("allRole", allRole);
        state.set("postCreatingStatement", postCreatingStatement);
        state.set("createIndexInGeometryRow", createIndexInGeometryRow);
        state.set("updateTableStatistics", updateTableStatistics);
    }

    @Override
    public void loadFromState(PersistentState state) throws PersistenceException {
        super.loadFromState(state);
        this.explorerParameters = (JDBCServerExplorerParameters) state.get("explorerParameters");
        this.schema = state.getString("schema");
        this.tableName = state.getString("tableName");
        this.canCreatetable = state.getBoolean("canCreatetable");
        this.primaryKeyName = state.getString("primaryKeyName");
        this.storeName = state.getString("storeName");
        this.explorerName = state.getString("explorerName");
        this.translateIdentifiersToLowerCase = state.getBoolean("translateIdentifiersToLowerCase");
        this.removeSpacesInIdentifiers = state.getBoolean("removeSpacesInIdentifiers");
        this.translateHyphens = state.getBoolean("translateHyphens");
        this.selectRole = state.getString("selectRole");
        this.insertRole = state.getString("insertRole");
        this.updateRole = state.getString("updateRole");
        this.deleteRole = state.getString("deleteRole");
        this.truncateRole = state.getString("truncateRole");
        this.referenceRole = state.getString("referenceRole");
        this.triggerRole = state.getString("triggerRole");
        this.allRole = state.getString("allRole");
        this.postCreatingStatement = state.getString("postCreatingStatement");
        this.createIndexInGeometryRow = state.getBoolean("createIndexInGeometryRow");
        this.updateTableStatistics = state.getBoolean("updateTableStatistics");
        
        ExportJDBCAttributeNamesTranslator nameTranslator = (ExportJDBCAttributeNamesTranslator) this.exportAttributes.getNamesTranslator();
        nameTranslator.setParameters(this);
    }
}
