package org.gvsig.export.jdbc.service;

import org.gvsig.export.ExportParameters;
import org.gvsig.export.spi.AbstractExportServiceFactory;
import org.gvsig.export.spi.AttributeNamesTranslator;

/**
 *
 * @author jjdelcerro
 */
public class ExportJDBCServiceFactory extends AbstractExportServiceFactory {

    public static final String SERVICE_NAME = "JDBC";

    public ExportJDBCServiceFactory() {
        super(
                SERVICE_NAME,
                "Database (Throws JDBC)",
                "Database (Throws JDBC)"
        );
    }

    @Override
    public ExportJDBCService createService(ExportParameters parameters) {
        ExportJDBCService service = new ExportJDBCService(this, (ExportJDBCParameters) parameters);
        return service;
    }

    @Override
    public ExportJDBCParameters createParameters() {
        ExportJDBCParameters parameters = new ExportJDBCParametersImpl(this);
        return parameters;
    }

    @Override
    public boolean hasTabularSupport() {
        return true;
    }

    @Override
    public boolean hasVectorialSupport() {
        return true;
    }

}
