/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.gvsig.export.jdbc.swing;

import org.gvsig.export.jdbc.service.ExportJDBCParameters;
import org.gvsig.export.jdbc.swing.panels.GeometryIndexPanel;
import org.gvsig.export.jdbc.swing.panels.IdentifiersOptionsPanel;
import org.gvsig.export.jdbc.swing.panels.JDBCConnectionPanel;
import org.gvsig.export.jdbc.swing.panels.PermissionsPanel;
import org.gvsig.export.jdbc.swing.panels.PostCreatingStatementPanel;
import org.gvsig.export.jdbc.swing.panels.SelectPkPanel;
import org.gvsig.export.jdbc.swing.panels.SelectTableNamePanel;
import org.gvsig.export.jdbc.swing.panels.UpdateTableStatisticsPanel;
import org.gvsig.export.ExportParameters;
import org.gvsig.export.swing.ExportSwingLocator;
import org.gvsig.export.swing.JExportProcessPanel;
import org.gvsig.export.swing.spi.AbstractExportPanels;
import org.gvsig.export.swing.spi.ExportPanels;
import org.gvsig.export.swing.spi.ExportPanelsFactory;
import org.gvsig.export.swing.spi.ExportPanelsManager;
import org.gvsig.fmap.geom.Geometry;

/**
 *
 * @author jjdelcerro
 */
public class ExportJDBCPanels
        extends AbstractExportPanels
        implements ExportPanels {

    ExportJDBCPanels(
            ExportPanelsFactory factory,
            JExportProcessPanel processPanel,
            ExportParameters parameters
    ) {
        super(factory, processPanel, parameters);
        this.initPanels();
    }

    @Override
    public ExportJDBCParameters getParameters() {
        return (ExportJDBCParameters) super.getParameters();
    }

    private void initPanels() {
        ExportPanelsManager manager = ExportSwingLocator.getExportPanelsManager();

        this.add(new IdentifiersOptionsPanel(
                getProcessPanel(),
                getParameters()
        )
        );
        this.add(new JDBCConnectionPanel(
                getProcessPanel(),
                getParameters()
        )
        );
        this.add(new SelectTableNamePanel(
                getProcessPanel(),
                getParameters()
        )
        );
        this.add(new SelectPkPanel(
                getProcessPanel(),
                getParameters()
        )
        );
        this.add(new GeometryIndexPanel(
                getProcessPanel(),
                getParameters()
        )
        );
        this.add(manager.createStandardPanel(
                ExportPanelsManager.PANEL_ATTRIBUTES_SELECTION,
                this.getProcessPanel(),
                this.getParameters()
        ));
        this.add(manager.createStandardPanel(
                ExportPanelsManager.PANEL_SELECT_GEOMETRY_FIELD,
                this.getProcessPanel(),
                this.getParameters()
        )
        );
        this.add(manager.createStandardPanel(
                ExportPanelsManager.PANEL_SELECT_GEOMETRY_TYPE,
                this.getProcessPanel(),
                this.getParameters(),
                new int[]{
                    Geometry.TYPES.GEOMETRY,
                    Geometry.TYPES.POINT,
                    Geometry.TYPES.LINE,
                    Geometry.TYPES.POLYGON,
                    Geometry.TYPES.MULTIPOINT,
                    Geometry.TYPES.MULTILINE,
                    Geometry.TYPES.MULTIPOLYGON
                },
                new int[]{
                    Geometry.SUBTYPES.GEOM2D,
                    Geometry.SUBTYPES.GEOM2DM,
                    Geometry.SUBTYPES.GEOM3D,
                    Geometry.SUBTYPES.GEOM3DM
                }
        )
        );
        this.add(manager.createStandardPanel(
                ExportPanelsManager.PANEL_CHECK_GEOMETRIES,
                this.getProcessPanel(),
                this.getParameters()
        )
        );
        this.add(new PermissionsPanel(
                getProcessPanel(),
                getParameters()
        )
        );
        this.add(new UpdateTableStatisticsPanel(
                getProcessPanel(),
                getParameters()
        )
        );
        this.add(new PostCreatingStatementPanel(
                getProcessPanel(),
                getParameters()
        )
        );

    }
}
