/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.gvsig.export.jdbc.swing.panels;

import javax.swing.JComponent;
import org.gvsig.export.jdbc.service.ExportJDBCParameters;
import org.gvsig.export.swing.JExportProcessPanel;
import org.gvsig.export.swing.spi.ExportPanel;
import org.gvsig.export.swing.spi.ExportPanelValidationException;
import org.gvsig.tools.ToolsLocator;
import org.gvsig.tools.i18n.I18nManager;

/**
 *
 * @author usuario
 */
public class IdentifiersOptionsPanel
        extends IdentifiersOptionsPanelView
        implements ExportPanel {

    private static final long serialVersionUID = -6390855050271511346L;

    private final ExportJDBCParameters parameters;
    private final JExportProcessPanel processPanel;

    public IdentifiersOptionsPanel(
            JExportProcessPanel processPanel,
            ExportJDBCParameters parameters
    ) {
        this.processPanel = processPanel;
        this.parameters = parameters;
        initComponents();
    }

    private void initComponents() {
        this.chkRemoveSpaces.setSelected(true);
        this.chkTraslateToLowerCase.setSelected(true);

        this.translate();
    }

    private void translate() {
        I18nManager i18nManager = ToolsLocator.getI18nManager();

        this.chkRemoveSpaces.setText(i18nManager.getTranslation("_Trasladar_espacios_a_guiones"));
        this.chkTraslateToLowerCase.setText(i18nManager.getTranslation("_Trasladar_identificadores_a_minusculas"));
        this.chkTraslateHyphens.setText(i18nManager.getTranslation("_Trasladar_guiones_en_los_identificadores_a_guion_bajo"));
        this.lblHeader.setText("<html>" + i18nManager.getTranslation("_Table_and_fields_name_options_header") + "<html>");
    }

    @Override
    public String getIdPanel() {
        return this.getClass().getCanonicalName();
    }

    @Override
    public String getTitlePanel() {
        I18nManager i18nManager = ToolsLocator.getI18nManager();
        return i18nManager.getTranslation("_Table_and_fields_name_options");
    }

    @Override
    public void previousPanel() {

    }

    @Override
    public void nextPanel() {
        ExportJDBCParameters params = this.parameters;
        params.setRemoveSpacesInIdentifiers(this.chkRemoveSpaces.isSelected());
        params.setTranslateIdentifiersToLowerCase(this.chkTraslateToLowerCase.isSelected());
        params.setTranslateHyphens(this.chkTraslateHyphens.isSelected());
    }

    @Override
    public boolean validatePanel() throws ExportPanelValidationException {
        return true;
    }

    @Override
    public void enterPanel() {
       this.chkRemoveSpaces.setSelected(this.parameters.getRemoveSpacesInIdentifiers());
       this.chkTraslateHyphens.setSelected(this.parameters.getTranslateHyphens());
       this.chkTraslateToLowerCase.setSelected(this.parameters.getTranslateIdentifiersToLowerCase());

    }

    @Override
    public JComponent asJComponent() {
        return this;
    }

    public boolean getTranslateToLowerCase() {
        return this.chkTraslateToLowerCase.isSelected();
    }

    public boolean getRemoveSpacesInTableName() {
        return this.chkRemoveSpaces.isSelected();
    }

    public boolean getTranslateHyphens() {
        return this.chkTraslateHyphens.isSelected();
    }

}
