package org.gvsig.export.shape;

import org.gvsig.export.ExportLibrary;
import org.gvsig.export.ExportLocator;
import org.gvsig.export.shape.service.ExportShapeParametersImpl;
import org.gvsig.export.shape.service.ExportShapeServiceFactory;
import org.gvsig.export.shape.swing.ExportShapePanelsFactory;
import org.gvsig.export.spi.ExportServiceManager;
import org.gvsig.export.swing.ExportSwingLibrary;
import org.gvsig.export.swing.ExportSwingLocator;
import org.gvsig.export.swing.spi.ExportPanelsManager;
import org.gvsig.tools.library.AbstractLibrary;
import org.gvsig.tools.library.LibraryException;

/**
 *
 * @author jjdelcerro
 */
public class ExportShapeLibrary extends AbstractLibrary {

    @Override
    public void doRegistration() {
        registerAsServiceOf(ExportSwingLibrary.class);
        registerAsServiceOf(ExportLibrary.class);
    }

    @Override
    protected void doInitialize() throws LibraryException {
        // Nothing to do
    }

    @Override
    protected void doPostInitialize() throws LibraryException {
        ExportServiceManager manager = ExportLocator.getServiceManager();
        ExportPanelsManager swingManager = ExportSwingLocator.getExportPanelsManager();
        
        manager.register(new ExportShapeServiceFactory());
        swingManager.register(new ExportShapePanelsFactory());
        ExportShapeParametersImpl.registerPersistence();
    }

    
}
