package org.gvsig.export.shape.service;

import org.gvsig.export.ExportParameters;
import org.gvsig.export.spi.AbstractExportServiceFactory;

/**
 *
 * @author jjdelcerro
 */
public class ExportShapeServiceFactory
        extends AbstractExportServiceFactory {

    public static final String SERVICE_NAME = "Shape";

    public ExportShapeServiceFactory() {
        super(
                SERVICE_NAME,
                "Shape file",
                "Shape file"
        );
    }

    @Override
    public ExportShapeService createService(ExportParameters parameters) {
        ExportShapeService service = new ExportShapeService(this, (ExportShapeParameters) parameters);
        return service;
    }

    @Override
    public ExportShapeParameters createParameters() {
        ExportShapeParameters parameters = new ExportShapeParametersImpl(this);
        return parameters;
    }

    @Override
    public boolean hasTabularSupport() {
        return true;
    }

    @Override
    public boolean hasVectorialSupport() {
        return true;
    }
}
