package org.gvsig.export.shape.swing;

import org.gvsig.export.dbf.swing.panels.EncodingPanel;
import org.gvsig.export.ExportParameters;
import org.gvsig.export.shape.swing.panels.SelectSimplifiedExport;
import org.gvsig.export.shape.swing.panels.UseSimplifiedExportWrapper;
import org.gvsig.export.swing.ExportSwingLocator;
import org.gvsig.export.swing.JExportProcessPanel;
import org.gvsig.export.swing.spi.AbstractExportPanels;
import org.gvsig.export.swing.spi.ExportPanels;
import org.gvsig.export.swing.spi.ExportPanelsFactory;
import org.gvsig.export.swing.spi.ExportPanelsManager;
import org.gvsig.fmap.geom.Geometry;

/**
 *
 * @author jjdelcerro
 */
public class ExportShapePanels
        extends AbstractExportPanels
        implements ExportPanels {

    ExportShapePanels(
            ExportPanelsFactory factory,
            JExportProcessPanel processPanel,
            ExportParameters parameters
    ) {
        super(factory, processPanel, parameters);
        this.initPanels();
    }

    private void initPanels() {
        ExportPanelsManager manager = ExportSwingLocator.getExportPanelsManager();

        this.add(
                new SelectSimplifiedExport(
                        this.getProcessPanel(),
                        this.getParameters()
                )
        );
        this.add(new UseSimplifiedExportWrapper(
                manager.createStandardPanel(
                        ExportPanelsManager.PANEL_SELECT_GEOMETRY_FIELD,
                        this.getProcessPanel(),
                        this.getParameters()
                ),
                this.getProcessPanel(),
                this.getParameters()
        )
        );
        this.add(new UseSimplifiedExportWrapper(
                manager.createStandardPanel(
                        ExportPanelsManager.PANEL_SELECT_GEOMETRY_TYPE,
                        this.getProcessPanel(),
                        this.getParameters(),
                        new int[]{
                            Geometry.TYPES.GEOMETRY,
                            Geometry.TYPES.POINT,
                            Geometry.TYPES.LINE,
                            Geometry.TYPES.POLYGON,
                            Geometry.TYPES.MULTIPOINT,
                            Geometry.TYPES.MULTILINE,
                            Geometry.TYPES.MULTIPOLYGON
                        },
                        new int[]{
                            Geometry.SUBTYPES.GEOM2D,
                            Geometry.SUBTYPES.GEOM3D,
                            Geometry.SUBTYPES.GEOM3DM
                        }
                ),
                this.getProcessPanel(),
                this.getParameters()
        )
        );
        this.add(new UseSimplifiedExportWrapper(
                manager.createStandardPanel(
                        ExportPanelsManager.PANEL_CHECK_GEOMETRIES,
                        this.getProcessPanel(),
                        this.getParameters()
                ),
                this.getProcessPanel(),
                this.getParameters()
        )
        );
        this.add(new UseSimplifiedExportWrapper(
                new EncodingPanel(
                        this.getProcessPanel(),
                        this.getParameters()
                ),
                this.getProcessPanel(),
                this.getParameters()
        )
        );
        this.add(new UseSimplifiedExportWrapper(
                manager.createStandardPanel(
                        ExportPanelsManager.PANEL_ATTRIBUTES_SELECTION,
                        this.getProcessPanel(),
                        this.getParameters()
                ),
                this.getProcessPanel(),
                this.getParameters()
        )
        );
        this.add(manager.createStandardPanel(
                ExportPanelsManager.PANEL_SELECT_OUTPUT_FILE,
                this.getProcessPanel(),
                this.getParameters()
        )
        );
    }

}
