package org.gvsig.expressionevaluator;

import java.util.List;
import org.gvsig.tools.lang.Cloneable;

public interface Compiler extends Cloneable {
    
    public void setLexicalAnalyzer(LexicalAnalyzer lex);

    public LexicalAnalyzer getLexicalAnalyzer();
    
    public void setCodeBuilder(CodeBuilder codeBuilder);
    
    public CodeBuilder getCodeBuilder();
    
    public Code compileExpression(String expression);

    @Override
    public Compiler clone() throws CloneNotSupportedException;

    public boolean isObjectAccessSupported();

    public void setObjectAccessSupported(boolean objectAccessSupported);
    
    public GrammarSet getGrammars();
}
