/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.gvsig.expressionevaluator;

import org.gvsig.tools.persistence.Persistent;
import org.gvsig.tools.script.Script;
import org.gvsig.tools.util.UnmodifiableBasicList;

/**
 *
 * @author jjdelcerro
 */
public interface Expression extends Persistent, Cloneable {
    public void clear();
    
    /**
     * This symbol table don't persist with the expression.
     * 
     * @return the symbol table of the expression
     */
    public SymbolTable getSymbolTable();
    
    public String getPhrase();
    
//    public Script getUserScript(); 
//    
//    public UnmodifiableBasicList<Script> getScripts();

    public Expression setPhrase(String phrase);
    
//    public Expression setUserScript(String code, String languaje);
//    
//    public Expression setUserScript(String code);
//    
//    public Expression setUserScript(Script script);
//    
//    public void removeAllScripts();
//    
//    public Expression addScript(Script script);
    
    public Object execute(SymbolTable symbolTable);
    
    public void link(SymbolTable symbolTable);    
    
    public Code getCode();
    
    public String toJSON();
    
    public void fromJSON(String json);
    
    public Expression clone() throws CloneNotSupportedException;
    
    public boolean isPhraseEmpty();
    
    public boolean isEmpty();
    
    public void setSQLCompatible(boolean sqlCompatible);
    
    public boolean isSQLCompatible();

    public void setUseBracketsForIdentifiers(boolean useBracketsForIdentifiers);
    
    public boolean getUseBracketsForIdentifiers();
}
