package org.gvsig.expressionevaluator;

import org.cresques.ProjectionLibrary;
import org.gvsig.fmap.geom.Geometry;
import org.gvsig.fmap.geom.GeometryLibrary;
import org.gvsig.tools.ToolsLibrary;
import org.gvsig.tools.ToolsLocator;
import org.gvsig.tools.dataTypes.DataTypesManager;
import org.gvsig.tools.library.AbstractLibrary;
import org.gvsig.tools.library.LibraryException;

public class ExpressionEvaluatorLibrary extends AbstractLibrary {

    @Override
    public void doRegistration() {
        registerAsAPI(ExpressionEvaluatorLibrary.class);
        require(ToolsLibrary.class);
        require(ProjectionLibrary.class);
        require(GeometryLibrary.class);
    }

    @Override
    protected void doInitialize() throws LibraryException {
    }

    @Override
    protected void doPostInitialize() throws LibraryException {
        DataTypesManager dataTypesManager = ToolsLocator.getDataTypesManager();
        dataTypesManager.addtype(DataTypes.EXPRESSION, "Expression", "Expression",
            Expression.class, null);

    }
}

