package org.gvsig.expressionevaluator;

import org.gvsig.tools.locator.AbstractLocator;
import org.gvsig.tools.locator.LocatorException;


public class ExpressionEvaluatorLocator extends AbstractLocator {

    private static final String LOCATOR_NAME = "ExpressionEvaluatorLocator";

    public static final String MANAGER_NAME = "ExpressionEvaluatorManager";

    private static final String MANAGER_DESCRIPTION = "ExpressionEvaluator of gvSIG";

    /**
     * Unique instance.
     */
    private static final ExpressionEvaluatorLocator instance = new ExpressionEvaluatorLocator();

    /**
     * Return the singleton instance.
     *
     * @return the singleton instance
     */
    public static ExpressionEvaluatorLocator getInstance() {
        return instance;
    }

    /**
     * Returns the Locator name.
     *
     * @return String containing the locator name.
     */
    @Override
    public String getLocatorName() {
        return LOCATOR_NAME;
    }

    public static ExpressionEvaluatorManager getManager() throws LocatorException {
        return (ExpressionEvaluatorManager) getInstance().get(MANAGER_NAME);
    }

    public static ExpressionEvaluatorManager getExpressionEvaluatorManager() throws LocatorException {
        return getManager();
    }

    public static void registerManager(Class clazz) {
        getInstance().register(MANAGER_NAME, MANAGER_DESCRIPTION, clazz);
    }

    public static void registerDefaultManager(Class clazz) {
        getInstance().registerDefault(MANAGER_NAME, MANAGER_DESCRIPTION, clazz);
    }

}
