package org.gvsig.expressionevaluator;

/**
 *
 * @author jjdelcerro
 */
public class ExpressionRuntimeException extends RuntimeException {

    private final Code code;
    private String tip;
    
    public ExpressionRuntimeException(Code code) {
        super();
        this.code = code;
    }

    public ExpressionRuntimeException(Code code, String message) {
        super(message);
        this.code = code;
    }

    public ExpressionRuntimeException(Code code, String message, String tip) {
        super(message);
        this.code = code;
        this.tip = tip;
    }

    public ExpressionRuntimeException(String message, String tip) {
        super(message);
        this.code = null;
        this.tip = tip;
    }

    public ExpressionRuntimeException(String message) {
        super(message);
        this.code = null;
    }

    public ExpressionRuntimeException(Code code, String message, Throwable cause) {
        super(message,cause);
        this.code = code;
    }
    
    public ExpressionRuntimeException(String message, Throwable cause) {
        super(message,cause);
        this.code = null;
    }
    
    public Code getCode() {
        return this.code;
    }
    
    public String getTip() {
        return this.tip;
    }
}
