package org.gvsig.expressionevaluator;

import java.util.Iterator;
import java.util.List;
import org.gvsig.expressionevaluator.Statement.StatementContext;
import org.gvsig.tools.util.UnmodifiableBasicList;
        
/**
 *
 * @author jjdelcerro
 */
public interface Grammar extends Iterable<Statement> {

    public String getName();

    public List<Statement> getStatements();

    public Statement createStatement(String name);

    public void addStatement(Statement statement);

    public Statement getApplicableStatement(StatementContext context);

    public void addReservedWord(String id);
    
    public boolean isReservedWord(String id);

    @Override
    public Iterator<Statement> iterator();
    
}
