package org.gvsig.expressionevaluator;

import java.util.Collection;

import org.gvsig.tools.lang.Cloneable;

public interface SymbolTable extends Iterable<Function>, Cloneable {

    public String getName();
    
    public boolean addSymbolTable(SymbolTable symbolTable);

    public boolean removeSymbolTable(SymbolTable symbolTable);

    public boolean containsSymbolTable(SymbolTable symbolTable);

    public Function function(String name);

    public boolean exists(String name);

    public Object value(String name);
    
    public boolean isSQLCompatible(String name);

    public Collection<String> variables();

    public Collection<String> localvariables();

    public Collection<Function> functions();
    
    public Collection<Function> localfunctions();

//    public Collection<Script> scripts();

    @Override
    public SymbolTable clone() throws CloneNotSupportedException;

}
