package org.gvsig.expressionevaluator.impl;

import org.gvsig.expressionevaluator.ExpressionEvaluatorLocator;
import org.gvsig.expressionevaluator.SymbolTable;
import org.gvsig.expressionevaluator.spi.AbstractSymbolTable;

/**
 *
 * @author jjdelcerro
 */
public class InmutableSymbolTable 
        extends AbstractSymbolTable
        implements SymbolTable {
    
    private boolean locked;
    public InmutableSymbolTable() {
        this.locked = false;
        this.init();
    }
    
    private void init() {
        DefaultExpressionEvaluatorManager manager = (DefaultExpressionEvaluatorManager) ExpressionEvaluatorLocator.getManager();
        manager.populateSymbolTable(this);
        this.locked = true;
    }

    @Override
    public boolean addSymbolTable(SymbolTable symbolTable) {
        if( this.locked ) {
            throw new UnsupportedOperationException();
        }
        return super.addSymbolTable(symbolTable); 
    }

    @Override
    public boolean removeSymbolTable(SymbolTable symbolTable) {
        throw new UnsupportedOperationException();
    }

    
}
