package org.gvsig.expressionevaluator.impl;

import java.lang.reflect.Method;
import org.apache.commons.lang3.StringUtils;


/**
 *
 * @author jjdelcerro
 */
public class InstanceUtils {
    
    public static Object callmethod(Object instance, String methodName, Object args[]) throws Exception {
        if( StringUtils.isBlank(methodName) ) {
            throw new NullPointerException("A method name was expected to invoke and a null was received");
        }
        if( instance==null ) {
            throw new NullPointerException("An object pointer was expected to invoke method "+methodName+" and a null was received");
        }
        Class[] parameterTypes = new Class[args.length];
        Object[] parameters = new Object[args.length];
        for (int i = 0; i < parameters.length; i++) {
            Object parameter = args[i];
            parameters[i] = parameter;
            if( parameter==null ) {
                parameterTypes[i] = null;
            } else {
                parameterTypes[i] = parameter.getClass();
            }
        }
        Class<?> theClass = instance.getClass();
        Method method = theClass.getMethod(methodName, parameterTypes);
        Object value = method.invoke(instance, parameters);
        return value;
    }
    
}
