package org.gvsig.expressionevaluator.impl.function;

import java.util.List;
import org.apache.commons.lang3.Range;
import org.gvsig.expressionevaluator.Interpreter;
import org.gvsig.expressionevaluator.spi.AbstractFunction;
import org.gvsig.tools.script.Script;

/**
 *
 * @author jjdelcerro
 */
public class ScriptFunction extends AbstractFunction {

    private final List<Script> scripts;

    /**
     *
     * @param scripts
     * @param funcName
     */
    public ScriptFunction(List<Script> scripts, String funcName) {
        super("Script", funcName,  Range.between(1,Integer.MAX_VALUE));
        this.scripts = scripts;
        
    }
    
    @Override
    public Object call(Interpreter interpreter, Object[] args) throws Exception {
        for (Script script : this.scripts) {
            try {
                return script.invokeFunction(this.name(), args);            
            } catch(NoSuchMethodException ex) {
                // Si la funcion no existe en el script pasamos al siguiente
                // script.
            }
        }
        throw new NoSuchMethodException("Can't locate funcion '"+this.name()+"'.");
    }
    
}
