package org.gvsig.expressionevaluator.impl.function.foldersmanager;

import java.io.File;
import org.apache.commons.lang3.Range;
import org.gvsig.expressionevaluator.Interpreter;
import org.gvsig.expressionevaluator.spi.AbstractFunction;
import org.gvsig.tools.ToolsLocator;
import org.gvsig.tools.folders.FoldersManager;

public class HomeFunction extends AbstractFunction {

    public static final String NAME = "HOME";
    
    public HomeFunction() {
        super(
            "Folders", 
            NAME, 
            Range.is(0),
            "Return the folder user home", 
            NAME+"()", 
            null,
            "File", 
            false
        );
    }


    @Override
    public boolean allowConstantFolding() {
        return false;
    }
    
    @Override
    public Object call(Interpreter interpreter, Object[] args) {
        FoldersManager folderManager = ToolsLocator.getFoldersManager();
        File f = folderManager.getHome();
        return f;
    }
}
