package org.gvsig.expressionevaluator.impl.function.foldersmanager;

import java.io.File;
import org.apache.commons.lang3.Range;
import org.gvsig.expressionevaluator.Interpreter;
import org.gvsig.expressionevaluator.spi.AbstractFunction;
import org.gvsig.tools.ToolsLocator;
import org.gvsig.tools.folders.FoldersManager;

public class SetFolderFunction extends AbstractFunction {


    public static final String NAME = "SETFOLDER";
    
    public SetFolderFunction() {
        super(
            "Folders", 
            NAME, 
            Range.is(2),
            "Set the folder associated to the id. Return the new value set to the folder.", 
            NAME+"({{folderid}}, value)", 
            new String[] {
                "folderid - Identifier of the folder to set",
                "value - value set to the folder."
            }, 
            "File", 
            false
        );
    }


    @Override
    public boolean allowConstantFolding() {
        return false;
    }
    
    @Override
    public Object call(Interpreter interpreter, Object[] args) {
        FoldersManager folderManager = ToolsLocator.getFoldersManager();
        String id = getStr(args, 0);
        File value = getFile(args,1);
        folderManager.set(id, value);
        return value;
    }
}
