package org.gvsig.expressionevaluator.impl.function.foldersmanager;

import java.io.File;
import org.apache.commons.lang3.Range;
import org.gvsig.expressionevaluator.Interpreter;
import org.gvsig.expressionevaluator.spi.AbstractFunction;
import org.gvsig.tools.ToolsLocator;
import org.gvsig.tools.folders.FoldersManager;

public class SetLastPathFunction extends AbstractFunction {


    public static final String NAME = "SETLASTPATH";
    
    public SetLastPathFunction() {
        super(
            "Folders", 
            NAME, 
            Range.is(2),
            "Assigns the last value used to the indicated folder. Return the new value set to the folder.", 
            NAME+"({{folderid}}, value)", 
            new String[] {
                "folderid - Identifier of the folder to set",
                "value - Value to be assigned as the last used folder associated with the indicated identifier.."
            }, 
            "File", 
            false
        );
    }

    @Override
    public boolean allowConstantFolding() {
        return false;
    }
    
    @Override
    public Object call(Interpreter interpreter, Object[] args) {
        FoldersManager folderManager = ToolsLocator.getFoldersManager();
        String id = getStr(args, 0);
        File value = getFile(args,1);
        folderManager.setLastPath(id, value);
        return value;
    }
}
