package org.gvsig.expressionevaluator.impl.function.foldersmanager;

import java.io.File;
import org.apache.commons.lang3.Range;
import org.gvsig.expressionevaluator.Interpreter;
import org.gvsig.expressionevaluator.spi.AbstractFunction;
import org.gvsig.tools.ToolsLocator;
import org.gvsig.tools.folders.FoldersManager;

public class TemporaryFolderFunction extends AbstractFunction {

    public static final String NAME = "TEMPORARYFOLDER";
    
    public TemporaryFolderFunction() {
        super(
            "Folders", 
            NAME, 
            Range.is(0),
            "Return the file associated to the temporary folder of the application.\n" +
            "The file can't exits.", 
            NAME+"()", 
            null, 
            "File", 
            false
        );
    }

    @Override
    public boolean allowConstantFolding() {
        return false;
    }
    
    @Override
    public Object call(Interpreter interpreter, Object[] args) {
        FoldersManager folderManager = ToolsLocator.getFoldersManager();
        File f = folderManager.getTemporaryFolder();
        return f;
    }
}
