package org.gvsig.expressionevaluator.impl.function.image;

import org.apache.commons.lang3.Range;
import org.gvsig.expressionevaluator.Interpreter;
import org.gvsig.expressionevaluator.spi.AbstractFunction;

public class ImageRotateFunction extends AbstractFunction {

    public ImageRotateFunction() {
        super(
                "Image", "IMAGEROTATE", Range.between(1, 2),
                "",
                "IMAGEROTATE({{image}}, angle)",
                new String[]{
                    "image",
                    "angle"
                },
                "Image",
                false
        );
    }

    @Override
    public boolean allowConstantFolding() {
        return true;
    }

    @Override
    public Object call(Interpreter interpreter, Object[] args) {
        Object arg0 = this.getObject(args, 0);
        SimpleImage image = ImageReadFunction.createSimpleImage(arg0);
        if( image.isEmpty() ) {
            return null;
        }
        int angle = this.getInt(args, 1);
        image = image.rotate(angle);
        return image.getBufferedImage();

    }

}
