package org.gvsig.expressionevaluator.impl.function.image;

import org.apache.commons.lang3.Range;
import org.gvsig.expressionevaluator.Interpreter;
import org.gvsig.expressionevaluator.spi.AbstractFunction;

public class ImageVerticalflipFunction extends AbstractFunction {

    public ImageVerticalflipFunction() {
        super(
                "Image", "IMAGEVERTICALFLIP", Range.is(1),
                "",
                "IMAGEVERTICALFLIP({{image}})",
                new String[]{
                    "image"
                },
                "Image",
                false
        );
    }

    @Override
    public boolean allowConstantFolding() {
        return true;
    }

    @Override
    public Object call(Interpreter interpreter, Object[] args) {
        Object arg0 = this.getObject(args, 0);
        SimpleImage image = ImageReadFunction.createSimpleImage(arg0);
        if( image.isEmpty() ) {
            return null;
        }
        image = image.verticalflip();
        return image.getBufferedImage();
    }

}
