package org.gvsig.expressionevaluator.impl.function.image;

import org.apache.commons.lang3.Range;
import org.gvsig.expressionevaluator.Interpreter;
import org.gvsig.expressionevaluator.spi.AbstractFunction;

public class ImageWidthFunction extends AbstractFunction {

    public ImageWidthFunction() {
        super(
                "Image", "IMAGEWIDTH", Range.is(1),
                "",
                "IMAGEWIDTH({{source}})",
                new String[]{
                    "Value from which to load the image"
                },
                "Integer",
                false
        );
    }

    @Override
    public boolean allowConstantFolding() {
        return true;
    }

    @Override
    public Object call(Interpreter interpreter, Object[] args) {
        Object arg0 = this.getObject(args, 0);
        SimpleImage image = ImageReadFunction.createSimpleImage(arg0);
        if( image.isEmpty() ) {
            return null;
        }
        return image.getWidth();
    }
}
