package org.gvsig.expressionevaluator.impl.function.numeric;

import org.apache.commons.lang3.Range;
import org.gvsig.expressionevaluator.Interpreter;
import org.gvsig.expressionevaluator.spi.AbstractFunction;

public class ACosFunction extends AbstractFunction {

    public ACosFunction() {
        super(
            "Numeric", "ACOS", Range.is(1),
            "Returns the arc cosine of a value; the returned angle is in the range 0.0 through pi.",
            "ACOS({{a}})",
            new String[]{
                "value whose arc tangent is to be returned"
            },
            "Double",
            true
        );
    }

    @Override
    public boolean allowConstantFolding() {
        return true;
    }
    
    @Override
    public Object call(Interpreter interpreter, Object[] args) {
        double r = Math.acos(getDouble(args, 0));
        return r;
    }

}
