package org.gvsig.expressionevaluator.impl.function.numeric;

import org.apache.commons.lang3.Range;
import org.gvsig.expressionevaluator.Interpreter;
import org.gvsig.expressionevaluator.spi.AbstractFunction;

public class LogFunction extends AbstractFunction {

    public LogFunction() {
        super("Numeric", "LOG", Range.is(1));
        this.addAlias("LN");
    }

    @Override
    public boolean allowConstantFolding() {
        return true;
    }
    
    @Override
    public Object call(Interpreter interpreter, Object[] args) {
        double r = Math.log(getDouble(args, 0));
        return r;
    }
}
