package org.gvsig.expressionevaluator.impl.function.numeric;

import org.apache.commons.lang3.Range;
import org.gvsig.expressionevaluator.Interpreter;
import org.gvsig.expressionevaluator.spi.AbstractFunction;

public class PowFunction extends AbstractFunction {

    public PowFunction() {
        super("Numeric", "POWER", Range.is(2));
    }

    @Override
    public boolean allowConstantFolding() {
        return true;
    }
    
    @Override
    public Object call(Interpreter interpreter, Object[] args) {
        double r = Math.pow(getDouble(args, 0), getDouble(args, 1));
        return r;
    }
}
