package org.gvsig.expressionevaluator.impl.function.numeric;

import java.util.Random;
import org.apache.commons.lang3.Range;
import org.gvsig.expressionevaluator.Interpreter;
import org.gvsig.expressionevaluator.spi.AbstractFunction;

public class RandFunction extends AbstractFunction {

    private Random random;

    public RandFunction() {
        super("Numeric", "RAND", Range.between(0, 1));
        this.addAlias("RANDOM");        
    }

    @Override
    public Object call(Interpreter interpreter, Object[] args) {
        if( args.length == 1 ) {
            this.random = new Random(getLong(args, 1));
        }
        if( this.random == null ) {
            this.random = new Random();
        }
        return Math.random();
    }
}
