package org.gvsig.expressionevaluator.impl.function.numeric;

import org.apache.commons.lang3.Range;
import org.gvsig.expressionevaluator.Interpreter;
import org.gvsig.expressionevaluator.spi.AbstractFunction;

public class SignFunction extends AbstractFunction {

    public SignFunction() {
        super("Numeric", "SIGN", Range.is(1));
    }

    @Override
    public boolean allowConstantFolding() {
        return true;
    }
    
    @Override
    public Object call(Interpreter interpreter, Object[] args) {
        Object value = args[0];
        
        if( value instanceof Float ) {
            float r = Math.signum(((Number) value).floatValue());
            return r;
        }
        double r = Math.signum(getDouble(args, 0));
        return r;
    }
}
