package org.gvsig.expressionevaluator.impl.function.operator;

import org.apache.commons.lang3.Range;
import org.gvsig.expressionevaluator.Interpreter;
import org.gvsig.expressionevaluator.spi.AbstractFunction;


public abstract class AbstractUnaryOperator extends AbstractFunction implements UnaryOperator {
    
    protected AbstractUnaryOperator(String group, String name, String description, boolean sqlCompatible) {
        super(group, name, Range.is(1), description, name + " {{oper}} ", null, null, sqlCompatible);
    }    

    protected AbstractUnaryOperator(String group, String name, boolean sqlCompatible) {
        this(group, name, null, sqlCompatible);
    }

    @Override
    public Object call(Interpreter interpreter, Object[] args) {
        return call(interpreter, args[0]);
        
    }
    
    @Override
    public boolean isOperator() {
        return true;
    }
}
