package org.gvsig.expressionevaluator.impl.function.operator;

import static org.gvsig.expressionevaluator.ExpressionBuilder.OPERATOR_MOD;
import org.gvsig.expressionevaluator.Function;
import org.gvsig.expressionevaluator.Interpreter;

public class ModOperator extends AbstractBinaryOperator {

    public ModOperator() {
        super(Function.GROUP_NUMERIC, OPERATOR_MOD, false);
    }

    @Override
    public boolean allowConstantFolding() {
        return true;
    }
    
    @Override
    public Object call(Interpreter interpreter, Object op1, Object op2) {       
        int type = this.getType(op1, op2);
        if( (type & TYPE_DOUBLE) == TYPE_DOUBLE ) {
            double value = ((Number) op1).doubleValue() % ((Number) op2).doubleValue();
            return value;
        }
        if( (type & TYPE_FLOAT) == TYPE_FLOAT ) {
            double value = ((Number) op1).floatValue() % ((Number) op2).floatValue();
            return value;
        }
        if( (type & TYPE_LONG) == TYPE_LONG ) {
            long value = ((Number) op1).longValue() % ((Number) op2).longValue();
            return value;
        }
        if( (type & TYPE_INT) == TYPE_INT ) {
            int value = ((Number) op1).intValue() % ((Number) op2).intValue();
            return value;
        }
        throw new IllegalArgumentException("Types not allowed in '"+name()+"' operand.");
    }
    

}
