package org.gvsig.expressionevaluator.impl.function.operator;

import java.math.BigDecimal;
import static org.gvsig.expressionevaluator.ExpressionBuilder.OPERATOR_NEGATE;
import org.gvsig.expressionevaluator.Function;
import org.gvsig.expressionevaluator.Interpreter;


public class NegOperator extends AbstractUnaryOperator {

    public NegOperator() {
        super(Function.GROUP_NUMERIC, OPERATOR_NEGATE, true);   
    }

    @Override
    public boolean allowConstantFolding() {
        return true;
    }
    
    @Override
    public Object call(Interpreter interpreter, Object arg) {
        if( !(arg instanceof Number) ) {
            throw new IllegalArgumentException("NEGATE function require a number");
        }
        return negate((Number) arg);
    }
    
    public static Number negate(Number n) {
        if( n instanceof Double ) {
          return -((Double)n);  
        } 
        if( n instanceof Float ) {
          return -((Float)n);  
        } 
        if( n instanceof Long ) {
          return -((Long)n);  
        } 
        if( n instanceof Integer ) {
          return -((Integer)n);  
        } 
        if( n instanceof BigDecimal ) {
          return ((BigDecimal)n).negate();  
        } 
        return -((Number)n).doubleValue();  
    }
}
