package org.gvsig.expressionevaluator.impl.function.operator;

import static org.gvsig.expressionevaluator.ExpressionBuilder.OPERATOR_NOT;
import org.gvsig.expressionevaluator.Function;
import org.gvsig.expressionevaluator.Interpreter;


public class NotOperator extends AbstractUnaryOperator {

    public NotOperator() {
        super(Function.GROUP_BOOLEAN, OPERATOR_NOT, true);
        this.addAlias("!");        
    }

    @Override
    public boolean allowConstantFolding() {
        return true;
    }
    
    @Override
    public Object call(Interpreter interpreter, Object arg) {
        if( ! (arg instanceof Boolean) ) {
            throw new IllegalArgumentException("NOT operator require a boolean");
        }
        return !((Boolean)arg);
    }
    
}
