package org.gvsig.expressionevaluator.impl.function.operator;

import static org.gvsig.expressionevaluator.ExpressionBuilder.OPERATOR_OR;
import org.gvsig.expressionevaluator.Function;
import org.gvsig.expressionevaluator.Interpreter;

public class OrOperator extends AbstractBinaryOperator {

    public OrOperator() {
        super(Function.GROUP_BOOLEAN, OPERATOR_OR, true);
    }

    @Override
    public boolean allowConstantFolding() {
        return true;
    }
    
    @Override
    public Object call(Interpreter interpreter, Object op1, Object op2) {       
        if( op1 instanceof Boolean && op2 instanceof Boolean ) {
            boolean value = ((Boolean) op1) || ((Boolean) op2);
            return value;
        }
        throw new IllegalArgumentException("Types not allowed in '"+name()+"' operand.");
    }
    

}
