package org.gvsig.expressionevaluator.impl.function.operator;

import java.util.Objects;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import static org.gvsig.expressionevaluator.ExpressionBuilder.OPERATOR_REGEXP;
import org.gvsig.expressionevaluator.Function;
import org.gvsig.expressionevaluator.Interpreter;

public class RegExpOperator extends AbstractBinaryOperator {

    public RegExpOperator() {
        super(Function.GROUP_BOOLEAN, OPERATOR_REGEXP, false);     
    }

    @Override
    public boolean allowConstantFolding() {
        return true;
    }
    
    @Override
    public Object call(Interpreter interpreter, Object op1, Object op2) { 
        String re = Objects.toString(op2, "");
        Pattern exp = (Pattern) interpreter.getCache().get(this.getClass(), re);
        if( exp == null ) {
            exp = Pattern.compile(re);
            interpreter.getCache().put(this.getClass(), re, exp);
        } 
        Matcher m = exp.matcher(Objects.toString(op1,""));
        if( m == null ) {
            return false;
        }
        return m.matches();
    }
    
}
