package org.gvsig.expressionevaluator.impl.function.predicate;

import static org.gvsig.expressionevaluator.ExpressionBuilder.OPERATOR_ILIKE;
import org.gvsig.expressionevaluator.Function;
import org.gvsig.expressionevaluator.Interpreter;
import org.gvsig.expressionevaluator.impl.function.operator.AbstractBinaryOperator;

public class IlikeOperator extends AbstractBinaryOperator {

    public IlikeOperator() {
        super(Function.GROUP_STRING,  OPERATOR_ILIKE, true);
    }
    
    @Override
    public boolean allowConstantFolding() {
        return true;
    }
    
    @Override
    public Object call(Interpreter interpreter, Object op1, Object op2) {       
        if( op1 instanceof CharSequence && op2 instanceof CharSequence ) {
            boolean value = ilike(((CharSequence) op1).toString(), ((CharSequence) op2).toString());
            return value;
        }
        throw new IllegalArgumentException("Types not allowed in '"+name()+"' operand.");
    }
    
    public static boolean ilike(String op1, String op2) {
        return LikeOperator.like(op1.toLowerCase(),op2.toLowerCase());
    }

}
