package org.gvsig.expressionevaluator.impl.function.programming;

import org.apache.commons.lang3.Range;
import org.gvsig.expressionevaluator.Function;
import org.gvsig.expressionevaluator.Interpreter;
import org.gvsig.expressionevaluator.impl.InstanceUtils;
import org.gvsig.expressionevaluator.spi.AbstractFunction;

public class CallMethodFunction extends AbstractFunction {

    public static final String NAME = "CALL_METHOD";
        
    public CallMethodFunction() {
        super(Function.GROUP_PROGRAMMING, 
            NAME, 
            Range.between(0, Integer.MAX_VALUE),
            null,
            null,
            null,
            "Object",
            false
        );
    }

    @Override
    public Object call(Interpreter interpreter, Object[] args) throws Exception {
        Object instance = getObject(args, 0);
        String methodName = getStr(args, 1);
        Object value = InstanceUtils.callmethod(instance, methodName, args);
        return value;
    }
}
