package org.gvsig.expressionevaluator.impl.function.programming;

import org.apache.commons.lang3.Range;
import org.gvsig.expressionevaluator.Code;
import org.gvsig.expressionevaluator.Codes;
import org.gvsig.expressionevaluator.Function;
import org.gvsig.expressionevaluator.Interpreter;
import org.gvsig.expressionevaluator.impl.DefaultInterpreter;
import org.gvsig.expressionevaluator.spi.AbstractFunction;

public class CodeBlockFunction extends AbstractFunction {

    public static final String NAME = "BLOCK";
    
    public CodeBlockFunction() {
        super(Function.GROUP_PROGRAMMING, 
                NAME, 
                Range.between(1,Integer.MAX_VALUE),
                "Evaluate each of the arguments sequentially.",
                NAME+"( {{arguments...}} )",
                null,
                "Object",
                false
        );
    }

    @Override
    public boolean useArgumentsInsteadObjects() {
        return true;
    }

    @Override
    public boolean allowConstantFolding() {
        return false;
    }
    
    @Override
    public Object call(Interpreter interpreter, Object[] args) throws Exception {
        throw new UnsupportedOperationException("Not supported yet.");
    }
    
    @Override
    public Object call(Interpreter interpreter, Codes args) throws Exception {
        Object value = null;
        for (Code arg : args) {
            // LLamamos a runCode para que no atrape los returns.
            value = ((DefaultInterpreter)interpreter).runCode(arg);
        }
        return value;
    }
    
}
