package org.gvsig.expressionevaluator.impl.function.programming;

import org.apache.commons.lang3.Range;
import org.gvsig.expressionevaluator.Expression;
import static org.gvsig.expressionevaluator.ExpressionBuilder.FUNCTION_EVAL;
import org.gvsig.expressionevaluator.ExpressionUtils;
import org.gvsig.expressionevaluator.Function;
import org.gvsig.expressionevaluator.Interpreter;
import org.gvsig.expressionevaluator.spi.AbstractFunction;

public class EvalFunction extends AbstractFunction {

    public EvalFunction() {
        super(
            Function.GROUP_PROGRAMMING, 
            FUNCTION_EVAL, 
            Range.is(1),
            "",
            FUNCTION_EVAL+"({{string}})",
            null,
            "Object",
            false
        );
    }
    
    @Override
    public boolean allowConstantFolding() {
        return false;
    }    
    
    @Override
    public Object call(Interpreter interpreter, final Object[] args) throws Exception {
        String s = this.getStr(args, 0);
        Expression exp = ExpressionUtils.createExpression(s);
        Object v = exp.execute(interpreter.getSymbolTable());
        return v;
        
    }
    

}
