package org.gvsig.expressionevaluator.impl.function.programming;

import java.io.File;
import java.net.URI;
import org.apache.commons.lang3.Range;
import org.gvsig.expressionevaluator.ExpressionRuntimeException;
import org.gvsig.expressionevaluator.Function;
import org.gvsig.expressionevaluator.Interpreter;
import org.gvsig.expressionevaluator.spi.AbstractFunction;

public class FileFunction extends AbstractFunction {

    public static final String NAME = "FILE";
    
    public FileFunction() {
        super(Function.GROUP_PROGRAMMING, 
            NAME, 
            Range.is(1),
            null,
            null,
            null,
            "Object",
            false
        );
    }
    
    @Override
    public boolean allowConstantFolding() {
        return false;
    }
    
    @Override
    public Object call(Interpreter interpreter, Object[] args) throws Exception {
        Object value;
        Object obj = getObject(args, 0);
        if( obj == null ) {
            return 0;
        }        
        if( obj instanceof File ) {
            return obj;
        } else if( obj instanceof CharSequence ) {
            value = new File(((CharSequence)obj).toString());
        } else if( obj instanceof URI ) {
            value = new File(((URI)obj));
        } else {
            throw new ExpressionRuntimeException("The "+NAME+" function require a File or a String and a received a '"+obj.getClass().getSimpleName()+"'.");
        }
        return value;
    }
    
}
