package org.gvsig.expressionevaluator.impl.function.programming;

import org.apache.commons.lang3.Range;
import org.gvsig.expressionevaluator.Codes;
import org.gvsig.expressionevaluator.Function;
import org.gvsig.expressionevaluator.Interpreter;
import org.gvsig.expressionevaluator.spi.AbstractFunction;
import org.gvsig.expressionevaluator.ExpressionRuntimeException;
import org.gvsig.expressionevaluator.MutableSymbolTable;

public class ForEachFunction extends AbstractFunction {
    
    public static final String NAME = "FOREACH";

    public ForEachFunction() {
        super(Function.GROUP_PROGRAMMING, 
                NAME, 
                Range.is(3),
                "The foreach() function evaluate body for every element of the iterable.",
                NAME+"( varname, iterable, body )",
                null,
                "Object",
                false
        );
    }

    @Override
    public boolean useArgumentsInsteadObjects() {
        return true;
    }

    @Override
    public boolean allowConstantFolding() {
        return false;
    }
    
    @Override
    public Object call(Interpreter interpreter, Object[] args) throws Exception {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }
    
    @Override
    public Object call(Interpreter interpreter, Codes args) throws Exception {
        if( !(interpreter.getSymbolTable() instanceof MutableSymbolTable) ) {
            throw new ExpressionRuntimeException("The use of forech loops require a mutable symbol table.");
        }
        MutableSymbolTable symbolTable = (MutableSymbolTable) interpreter.getSymbolTable();
        
        Object body = null;
        String varname = getObject(interpreter, args, 0).toString();
        
        Iterable iterable = (Iterable) getObject(interpreter, args, 1);
        for (Object value : iterable) {
            symbolTable.setVar(varname, value);
            body = getObject(interpreter, args, 2);
        }
        return body;
    }
    
}
