package org.gvsig.expressionevaluator.impl.function.programming;

import org.apache.commons.lang3.Range;
import org.gvsig.expressionevaluator.Codes;
import org.gvsig.expressionevaluator.Function;
import org.gvsig.expressionevaluator.Interpreter;
import org.gvsig.expressionevaluator.spi.AbstractFunction;

public class ForFunction extends AbstractFunction {
    
    public static final String NAME = "FOR";

    public ForFunction() {
        super(Function.GROUP_PROGRAMMING, 
                NAME, 
                Range.is(4),
                "The for() function evaluate body and incr while the condition is true.",
                NAME+"( init, condition, incr, body )",
                null,
                "Object",
                false
        );
    }

    @Override
    public boolean useArgumentsInsteadObjects() {
        return true;
    }

    @Override
    public boolean allowConstantFolding() {
        return false;
    }
    
    @Override
    public Object call(Interpreter interpreter, Object[] args) throws Exception {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }
    
    @Override
    public Object call(Interpreter interpreter, Codes args) throws Exception {
        Object body = null;
        Object init = getObject(interpreter, args, 0);
        boolean condition = getBoolean(interpreter, args, 1);
        while( condition ) {
            body = getObject(interpreter, args, 3);
            Object incr = getObject(interpreter, args, 2);
            condition = getBoolean(interpreter, args, 1);
        }
        return body;
    }
    
}
