package org.gvsig.expressionevaluator.impl.function.programming;

import org.apache.commons.lang3.Range;
import org.gvsig.expressionevaluator.Codes;
import org.gvsig.expressionevaluator.Function;
import org.gvsig.expressionevaluator.Interpreter;
import org.gvsig.expressionevaluator.spi.AbstractFunction;


public class IFNULLFunction extends AbstractFunction {

    public IFNULLFunction() {
        super(Function.GROUP_BOOLEAN, 
                "IFNULL", 
                Range.is(3),
                "The IFNULL() function tests if a specified value is null and returns one of two values, based on whether the value is null was true or false.",
                "IFNULL( {{value}}, true, false )",
                null,
                "Object",
                true
        );
    }

    @Override
    public boolean useArgumentsInsteadObjects() {
        return true;
    }

    @Override
    public boolean allowConstantFolding() {
        return false;
    }
    
    @Override
    public Object call(Interpreter interpreter, Object[] args) throws Exception {
        throw new UnsupportedOperationException("Not supported yet."); 
    }
    
    @Override
    public Object call(Interpreter interpreter, Codes args) throws Exception {
        Object value = getObject(interpreter, args, 0);
        if( value == null ) {
            value = getObject(interpreter, args, 1);
        } else {
            value = getObject(interpreter, args, 2);
        }
        return value;
    }
    
}
