package org.gvsig.expressionevaluator.impl.function.programming;

import org.apache.commons.lang3.Range;
import org.gvsig.expressionevaluator.Codes;
import org.gvsig.expressionevaluator.Function;
import org.gvsig.expressionevaluator.Interpreter;
import org.gvsig.expressionevaluator.spi.AbstractFunction;

public class IIFFunction extends AbstractFunction {

    public static final String NAME = "IFF";
    
    public IIFFunction() {
        super(Function.GROUP_BOOLEAN, 
                NAME, 
                Range.between(2,3),
                "The IFF() function tests a specified numeric expression and returns one of two values, based on whether the expression tested was true or false.",
                NAME+"( {{condition}}, true, false )",
                null,
                "Object",
                true
        );
    }

    @Override
    public boolean useArgumentsInsteadObjects() {
        return true;
    }

    @Override
    public boolean allowConstantFolding() {
        return false;
    }
    
    @Override
    public Object call(Interpreter interpreter, Object[] args) throws Exception {
        throw new UnsupportedOperationException("Not supported yet."); 
    }
    
    @Override
    public Object call(Interpreter interpreter, Codes args) throws Exception {
        Object value;
        boolean condition = getBoolean(interpreter, args, 0);
        if( condition ) {
            value = getObject(interpreter, args, 1);
        } else {
            if( args.size()>2 && args.get(2)!=null ) {
                value = getObject(interpreter, args, 2);
            } else {
                value = null;
            }
        }
        return value;
    }
    
}
