package org.gvsig.expressionevaluator.impl.function.programming;

import org.apache.commons.lang3.Range;
import org.gvsig.expressionevaluator.Function;
import org.gvsig.expressionevaluator.Interpreter;
import org.gvsig.expressionevaluator.spi.AbstractFunction;
import org.gvsig.tools.swing.api.ListElement;

public class LabelValueFunction extends AbstractFunction {

    public static final String NAME = "LABELVALUE";
    
    public LabelValueFunction() {
        super(Function.GROUP_PROGRAMMING, 
            NAME, 
            Range.is(2),
            null,
            null,
            null,
            "Object",
            false
        );
    }
    
    @Override
    public boolean allowConstantFolding() {
        return false;
    }
    
    @Override
    public Object call(Interpreter interpreter, Object[] args) throws Exception {
        String label = getStr(args, 0);
        Object value = getObject(args, 1);
        
        ListElement x = new ListElement(label, value);
        return x;
    }
    
}
