package org.gvsig.expressionevaluator.impl.function.programming;

import java.util.ArrayList;
import java.util.Arrays;
import org.apache.commons.lang3.Range;
import static org.gvsig.expressionevaluator.ExpressionBuilder.FUNCTION_LIST;
import org.gvsig.expressionevaluator.Function;
import org.gvsig.expressionevaluator.Interpreter;
import org.gvsig.expressionevaluator.spi.AbstractFunction;

public class ListFunction extends AbstractFunction {
    
    public ListFunction() {
        super(Function.GROUP_PROGRAMMING, 
                FUNCTION_LIST, 
                Range.between(0, Integer.MAX_VALUE),
                null,
                null,
                null,
                "List",
                false
        );
        this.addAlias("array");
    }

    @Override
    public boolean allowConstantFolding() {
        return false;
    }
    
    @Override
    public Object call(Interpreter interpreter, Object[] args) throws Exception {
        ArrayList<Object> list = new ArrayList<>();
        list.addAll(Arrays.asList(args));
        return list;
    }
}
