package org.gvsig.expressionevaluator.impl.function.programming;

import java.io.Writer;
import java.util.Objects;
import org.apache.commons.lang3.Range;
import org.gvsig.expressionevaluator.Function;
import org.gvsig.expressionevaluator.Interpreter;
import org.gvsig.expressionevaluator.spi.AbstractFunction;

public class PrintFunction extends AbstractFunction {
    
    public static final String NAME = "PRINT";

    public PrintFunction() {
        super(Function.GROUP_PROGRAMMING, 
                NAME, 
                Range.between(0, Integer.MAX_VALUE),
                null,
                null,
                null,
                "Object",
                false
        );
    }

    @Override
    public boolean allowConstantFolding() {
        return false;
    }
    
    @Override
    public Object call(Interpreter interpreter, Object[] args) throws Exception {
        Writer writer = interpreter.getWriter();
        Object value = null;
        for (Object arg : args) {
            value = arg;
            writer.append(Objects.toString(arg, ""));
        }
        writer.append("\n");
        writer.flush();
        return value;
    }
}
