package org.gvsig.expressionevaluator.impl.function.programming;

import org.apache.commons.lang3.Range;
import org.gvsig.expressionevaluator.Codes;
import org.gvsig.expressionevaluator.Function;
import org.gvsig.expressionevaluator.Interpreter;
import org.gvsig.expressionevaluator.spi.AbstractFunction;

public class TryFunction extends AbstractFunction {

    public static final String NAME = "TRY";
    
    public TryFunction() {
        super(Function.GROUP_PROGRAMMING, 
                NAME, 
                Range.between(1,2),
                null,
                NAME+"( {{expression}}, onerror )",
                null,
                "Object",
                true
        );
    }

    @Override
    public boolean useArgumentsInsteadObjects() {
        return true;
    }

    @Override
    public boolean allowConstantFolding() {
        return false;
    }
    
    @Override
    public Object call(Interpreter interpreter, Object[] args) throws Exception {
        throw new UnsupportedOperationException("Not supported yet."); 
    }
    
    @Override
    public Object call(Interpreter interpreter, Codes args) throws Exception {
        Object value = null;
        try {
            value = getObject(interpreter, args, 0);
        } catch(Exception ex) {
            if( args.size()>1 ) {
                value = getObject(interpreter, args, 1);
            }
        }
        return value;
    }
    
}
