package org.gvsig.expressionevaluator.impl.function.programming;

import java.util.ArrayList;
import java.util.Arrays;
import org.apache.commons.lang3.Range;
import static org.gvsig.expressionevaluator.ExpressionBuilder.FUNCTION_TUPLE;
import org.gvsig.expressionevaluator.Function;
import org.gvsig.expressionevaluator.Interpreter;
import org.gvsig.expressionevaluator.spi.AbstractFunction;
import org.gvsig.tools.util.UnmodifiableBasicListAdapter;

public class TupleFunction extends AbstractFunction {
    
    public TupleFunction() {
        super(Function.GROUP_PROGRAMMING, 
                FUNCTION_TUPLE, 
                Range.between(0, Integer.MAX_VALUE),
                null,
                null,
                null,
                "UnmodifiableBasicList",
                false
        );
    }

    @Override
    public boolean allowConstantFolding() {
        return true;
    }
    
    @Override
    public Object call(Interpreter interpreter, Object[] args) throws Exception {
        ArrayList<Object> list = new ArrayList<>();
        list.addAll(Arrays.asList(args));
        return new UnmodifiableBasicListAdapter<>(list);
    }
}
