package org.gvsig.expressionevaluator.impl.function.programming;

import org.apache.commons.lang3.Range;
import org.gvsig.expressionevaluator.Function;
import org.gvsig.expressionevaluator.Interpreter;
import org.gvsig.expressionevaluator.spi.AbstractFunction;
import org.gvsig.tools.ToolsLocator;

public class UserFunction extends AbstractFunction {

    public static final String NAME = "USER";
    
    public UserFunction() {
        super(Function.GROUP_PROGRAMMING, 
            NAME, 
            Range.is(0),
            "Get the current user logged.",
            NAME+"()",
            null,
            "SimpleIdentity",
            false
        );
        this.addAlias("CURRENTUSER");
    }
    
    @Override
    public boolean allowConstantFolding() {
        return false;
    }
    
    @Override
    public Object call(Interpreter interpreter, Object[] args) throws Exception {
        return ToolsLocator.getIdentityManager().getCurrentIdentity();
    }
    
}
