package org.gvsig.expressionevaluator.impl.function.programming;

import org.apache.commons.lang3.Range;
import org.gvsig.expressionevaluator.Codes;
import org.gvsig.expressionevaluator.Function;
import org.gvsig.expressionevaluator.Interpreter;
import org.gvsig.expressionevaluator.spi.AbstractFunction;


public class WhileFunction extends AbstractFunction {

    public static final String NAME = "WHILE";

    public WhileFunction() {
        super(Function.GROUP_PROGRAMMING, 
                NAME, 
                Range.is(2),
                "The while() function evaluate expression while the condition is true.",
                NAME+"( condition, expression )",
                null,
                "Object",
                false
        );
    }

    @Override
    public boolean useArgumentsInsteadObjects() {
        return true;
    }

    @Override
    public Object call(Interpreter interpreter, Object[] args) throws Exception {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }
    
    @Override
    public boolean allowConstantFolding() {
        return false;
    }    
    
    @Override
    public Object call(Interpreter interpreter, Codes args) throws Exception {
        Object body = null;
        boolean condition = getBoolean(interpreter, args, 0);
        while( condition ) {
            body = getObject(interpreter, args, 1);
            condition = getBoolean(interpreter, args, 0);
        }
        return body;
    }
    
}
