package org.gvsig.expressionevaluator.impl.function.spatial;

import static org.gvsig.expressionevaluator.ExpressionBuilder.OPERATOR_AND2;
import org.gvsig.expressionevaluator.impl.function.operator.*;
import org.gvsig.expressionevaluator.Function;
import org.gvsig.expressionevaluator.Interpreter;
import org.gvsig.fmap.geom.Geometry;
import org.gvsig.fmap.geom.GeometryUtils;

public class AndAndOperator extends AbstractBinaryOperator {
    
    public AndAndOperator() {
        super(Function.GROUP_OGC, OPERATOR_AND2, true);
    }

    @Override
    public boolean allowConstantFolding() {
        return true;
    }
    
    @Override
    public Object call(Interpreter interpreter, Object op1, Object op2) {       
        if( op1 instanceof Geometry && op2 instanceof Geometry ) {
            boolean value = GeometryUtils.intersects((Geometry)op1,(Geometry) op2);
            return value;
        }
        throw new IllegalArgumentException("Types not allowed in '"+name()+"' operand.");
    }
    

}
