package org.gvsig.expressionevaluator.impl.function.spatial;

import org.apache.commons.lang3.Range;
import org.gvsig.expressionevaluator.Interpreter;
import org.gvsig.expressionevaluator.spi.AbstractFunction;
import org.gvsig.fmap.geom.Geometry;

public class STBufferFunction extends AbstractFunction {

    public STBufferFunction() {
        super("OGC", "ST_Buffer", Range.is(2));
    }
    
    @Override
    public boolean allowConstantFolding() {
        return true;
    }
    
    @Override
    public Object call(Interpreter interpreter, Object[] args) throws Exception {
        Geometry r = getGeom(args, 0).buffer(getDouble(args, 1));
        return r;
    }
    
}
