package org.gvsig.expressionevaluator.impl.function.spatial;

import org.apache.commons.lang3.Range;
import org.gvsig.expressionevaluator.Interpreter;
import org.gvsig.expressionevaluator.spi.AbstractFunction;
import org.gvsig.fmap.geom.primitive.Point;

public class STCentroidFunction extends AbstractFunction {

    public STCentroidFunction() {
        super("OGC", "ST_Centroid", Range.is(1));
    }
    
    @Override
    public boolean allowConstantFolding() {
        return true;
    }
    
    @Override
    public Object call(Interpreter interpreter, Object[] args) throws Exception {
        Point r = getGeom(args, 0).centroid();
        return r;
    }
    
}
