package org.gvsig.expressionevaluator.impl.function.spatial;

import org.apache.commons.lang3.Range;
import org.gvsig.expressionevaluator.Interpreter;
import org.gvsig.expressionevaluator.spi.AbstractFunction;
import org.gvsig.fmap.geom.Geometry;
import org.gvsig.fmap.geom.type.GeometryType;

public class STDimensionFunction extends AbstractFunction {

    public STDimensionFunction() {
        super("OGC", "ST_Dimension", Range.is(1));
    }

    @Override
    public boolean allowConstantFolding() {
        return true;
    }
    
    @Override
    public Object call(Interpreter interpreter, Object[] args) throws Exception {
        Geometry geom = getGeom(args, 0);
        GeometryType type = geom.getGeometryType();
        if( type.isSubTypeOf(Geometry.TYPES.POINT)
            || type.isSubTypeOf(Geometry.TYPES.MULTIPOINT) ) {
            return 0;
        }
        if( type.isSubTypeOf(Geometry.TYPES.CURVE)
            || type.isSubTypeOf(Geometry.TYPES.MULTICURVE) ) {
            return 1;
        }
        if( type.isSubTypeOf(Geometry.TYPES.SURFACE)
            || type.isSubTypeOf(Geometry.TYPES.MULTISURFACE) ) {
            return 2;
        }
        if( type.isSubTypeOf(Geometry.TYPES.SOLID) ) {
            return 3;
        }
        return -1;
    }

}
