package org.gvsig.expressionevaluator.impl.function.spatial;

import org.apache.commons.lang3.Range;
import org.gvsig.expressionevaluator.Interpreter;
import org.gvsig.expressionevaluator.spi.AbstractFunction;

public class STDisjointFunction extends AbstractFunction {

    public STDisjointFunction() {
        super("OGC", "ST_Disjoint", Range.is(2));
    }
    
    @Override
    public boolean allowConstantFolding() {
        return true;
    }
    
    @Override
    public Object call(Interpreter interpreter, Object[] args) throws Exception {
        boolean r = getGeom(args, 0).disjoint(getGeom(args, 1));
        return r;
    }
    
}
