package org.gvsig.expressionevaluator.impl.function.spatial;

import org.apache.commons.lang3.Range;
import org.gvsig.expressionevaluator.Interpreter;
import org.gvsig.expressionevaluator.spi.AbstractFunction;

public class STDistanceFunction extends AbstractFunction {

    public STDistanceFunction() {
        super("OGC", "ST_Distance", Range.is(2));
    }
    
    @Override
    public boolean allowConstantFolding() {
        return true;
    }
    
    @Override
    public Object call(Interpreter interpreter, Object[] args) throws Exception {
        double r = getGeom(args, 0).distance(getGeom(args, 1));
        return r;
    }
    
}
