package org.gvsig.expressionevaluator.impl.function.spatial;

import org.apache.commons.lang3.Range;
import org.gvsig.expressionevaluator.Interpreter;
import org.gvsig.expressionevaluator.spi.AbstractFunction;
import org.gvsig.fmap.geom.Geometry;
import org.gvsig.fmap.geom.primitive.OrientablePrimitive;
import org.gvsig.fmap.geom.primitive.Point;

public class STEndPointFunction extends AbstractFunction {

    public STEndPointFunction() {
        super("OGC", "ST_EndPoint", Range.is(1));
    }
    
    @Override
    public boolean allowConstantFolding() {
        return true;
    }
    
    @Override
    public Object call(Interpreter interpreter, Object[] args) throws Exception {
        Geometry geom = getGeom(args, 0);
        if ( geom instanceof OrientablePrimitive ) {
            int n = ((OrientablePrimitive) geom).getNumVertices();
            Point p = ((OrientablePrimitive) geom).getVertex(n-1);
            return p;
        }
        return null;
    }
    
}
