package org.gvsig.expressionevaluator.impl.function.spatial;

import org.apache.commons.lang3.Range;
import org.cresques.cts.IProjection;
import org.gvsig.expressionevaluator.Interpreter;
import org.gvsig.expressionevaluator.spi.AbstractFunction;
import org.gvsig.fmap.crs.CRSFactory;
import org.gvsig.fmap.geom.Geometry;
import org.gvsig.fmap.geom.GeometryLocator;
import org.gvsig.fmap.geom.GeometryManager;

public class STGeomFromTextFunction extends AbstractFunction {

    public STGeomFromTextFunction() {
        super("OGC", "ST_GeomFromText", Range.between(1,2));
    }
    
    @Override
    public boolean allowConstantFolding() {
        return true;
    }
    
    @Override
    public Object call(Interpreter interpreter, Object[] args) throws Exception {
        GeometryManager geomManager = GeometryLocator.getGeometryManager();
        String wkt = getStr(args, 0);
        Geometry r = geomManager.createFrom(wkt);
        if( args.length==2 ) {
            int code = getInt(args, 1);
            IProjection proj = CRSFactory.getCRS("EPSG:"+code);
            r.setProjection(proj);
        }
        return r;
    }
    
}
