package org.gvsig.expressionevaluator.impl.function.spatial;

import org.apache.commons.lang3.Range;
import org.gvsig.expressionevaluator.Interpreter;
import org.gvsig.expressionevaluator.spi.AbstractFunction;
import org.gvsig.fmap.geom.Geometry;
import org.gvsig.fmap.geom.aggregate.Aggregate;
import org.gvsig.fmap.geom.primitive.Primitive;

public class STGeometryNFunction extends AbstractFunction {

    public STGeometryNFunction() {
        super("OGC", "ST_GeometryN", Range.is(2));
    }
    
    @Override
    public boolean allowConstantFolding() {
        return true;
    }
    
    @Override
    public Object call(Interpreter interpreter, Object[] args) throws Exception {
        Geometry geom = getGeom(args, 0);
        if( geom instanceof Aggregate ) {
            Primitive r = ((Aggregate) geom).getPrimitiveAt(getInt(args, 1));
            return r;
        }
       return null;
    }
    
}
