package org.gvsig.expressionevaluator.impl.function.spatial;

import org.apache.commons.lang3.Range;
import static org.gvsig.expressionevaluator.ExpressionBuilder.FUNCTION_ST_MAKEPOINT;
import org.gvsig.expressionevaluator.Interpreter;
import org.gvsig.expressionevaluator.spi.AbstractFunction;
import org.gvsig.fmap.geom.Geometry;
import org.gvsig.fmap.geom.GeometryUtils;

public class STMakePointFunction extends AbstractFunction {

    public STMakePointFunction() {
        super("OGC", FUNCTION_ST_MAKEPOINT, Range.between(2,4));
    }
    
    @Override
    public boolean allowConstantFolding() {
        return true;
    }
    
    @Override
    public Object call(Interpreter interpreter, Object[] args) throws Exception {
        double x = this.getDouble(args, 0);
        double y = this.getDouble(args, 1);
        Geometry geom;
        switch(args.length) {
            default:
            case 2:
                geom = GeometryUtils.createPoint(x, y);
                break;
            case 3:
                double z = this.getDouble(args, 2);
                geom = GeometryUtils.createPoint(x, y, z);
                break;
            case 4:
                z = this.getDouble(args, 2);
                double m = this.getDouble(args, 3);
                geom = GeometryUtils.createPoint(x, y, z, m);
                break;
        }
        return geom;
    }
    
}
