package org.gvsig.expressionevaluator.impl.function.spatial;

import org.apache.commons.lang3.Range;
import org.gvsig.expressionevaluator.Interpreter;
import org.gvsig.expressionevaluator.spi.AbstractFunction;
import org.gvsig.fmap.geom.Geometry;
import org.gvsig.fmap.geom.aggregate.Aggregate;

public class STNumGeometriesFunction extends AbstractFunction {

    public STNumGeometriesFunction() {
        super("OGC", "ST_NumGeometries", Range.is(1));
    }
    
    @Override
    public boolean allowConstantFolding() {
        return true;
    }
    
    @Override
    public Object call(Interpreter interpreter, Object[] args) throws Exception {
        Geometry geom = getGeom(args, 0);
        if( geom instanceof Aggregate ) {
            int r = ((Aggregate) geom).getPrimitivesNumber();
            return r;
        }
       return null;
    }
    
}
