package org.gvsig.expressionevaluator.impl.function.spatial;

import org.apache.commons.lang3.Range;
import org.gvsig.expressionevaluator.Interpreter;
import org.gvsig.expressionevaluator.spi.AbstractFunction;
import org.gvsig.fmap.geom.Geometry;
import org.gvsig.fmap.geom.primitive.OrientablePrimitive;

public class STNumPointsFunction extends AbstractFunction {

    public STNumPointsFunction() {
        super("OGC", "ST_NumPoints", Range.is(1));
    }
    
    @Override
    public boolean allowConstantFolding() {
        return true;
    }
    
    @Override
    public Object call(Interpreter interpreter, Object[] args) throws Exception {
        Geometry geom = getGeom(args, 0);
        if ( geom instanceof OrientablePrimitive ) {
            int n = ((OrientablePrimitive) geom).getNumVertices();
            return n;
        }
        return null;
    }
    
}
