package org.gvsig.expressionevaluator.impl.function.spatial;

import org.apache.commons.lang3.Range;
import org.gvsig.expressionevaluator.Interpreter;
import org.gvsig.expressionevaluator.spi.AbstractFunction;
import org.gvsig.fmap.geom.Geometry;

public class STPerimeterFunction extends AbstractFunction {

    public STPerimeterFunction() {
        super("OGC", "ST_Perimeter", Range.is(1));
    }
    
    @Override
    public boolean allowConstantFolding() {
        return true;
    }
    
    @Override
    public Object call(Interpreter interpreter, Object[] args) throws Exception {
        Geometry geom = getGeom(args, 0);
        double r = geom.perimeter();
        return r;
    }
    
}
