package org.gvsig.expressionevaluator.impl.function.spatial;

import org.apache.commons.lang3.Range;
import static org.gvsig.expressionevaluator.ExpressionBuilder.FUNCTION_ST_POINT;
import org.gvsig.expressionevaluator.Interpreter;
import org.gvsig.expressionevaluator.spi.AbstractFunction;
import org.gvsig.fmap.geom.GeometryUtils;
import org.gvsig.fmap.geom.primitive.Point;

public class STPointFunction extends AbstractFunction {

    public STPointFunction() {
        super("OGC", FUNCTION_ST_POINT, Range.is(2));
    }
    
    @Override
    public boolean allowConstantFolding() {
        return true;
    }
    
    @Override
    public Object call(Interpreter interpreter, Object[] args) throws Exception {
        double x = this.getDouble(args, 0);
        double y = this.getDouble(args, 1);
        Point geom = GeometryUtils.createPoint(x, y);
        return geom;
    }
    
}
