package org.gvsig.expressionevaluator.impl.function.spatial;

import org.apache.commons.lang3.Range;
import org.cresques.cts.IProjection;
import org.gvsig.expressionevaluator.Interpreter;
import org.gvsig.expressionevaluator.impl.ProjectionUtils;
import org.gvsig.expressionevaluator.spi.AbstractFunction;
import org.gvsig.fmap.geom.Geometry;

public class STSRIDFunction extends AbstractFunction {

    public STSRIDFunction() {
        super("OGC", "ST_SRID", Range.is(1));
    }
    
    @Override
    public boolean allowConstantFolding() {
        return true;
    }
    
    @Override
    public Object call(Interpreter interpreter, Object[] args) throws Exception {
        Geometry geom = getGeom(args, 0);
        IProjection proj = geom.getProjection();
        return ProjectionUtils.getCode(proj);
    }
    
}
