package org.gvsig.expressionevaluator.impl.function.spatial;

import org.apache.commons.lang3.Range;
import org.gvsig.expressionevaluator.Interpreter;
import org.gvsig.expressionevaluator.spi.AbstractFunction;
import org.gvsig.fmap.geom.Geometry;
import org.gvsig.fmap.geom.primitive.OrientablePrimitive;
import org.gvsig.fmap.geom.primitive.Point;

public class STStartPointFunction extends AbstractFunction {

    public STStartPointFunction() {
        super("OGC", "ST_StartPoint", Range.is(1));
    }
    
    @Override
    public boolean allowConstantFolding() {
        return true;
    }
    
    @Override
    public Object call(Interpreter interpreter, Object[] args) throws Exception {
        Geometry geom = getGeom(args, 0);
        if ( geom instanceof OrientablePrimitive ) {
            Point n = ((OrientablePrimitive) geom).getVertex(0);
            return n;
        }
        return null;
    }
    
}
