package org.gvsig.expressionevaluator.impl.function.spatial;

import org.apache.commons.lang3.Range;
import org.gvsig.expressionevaluator.Interpreter;
import org.gvsig.expressionevaluator.spi.AbstractFunction;
import org.gvsig.fmap.geom.Geometry;

public class STZFunction extends AbstractFunction {

    public STZFunction() {
        super("OGC", "ST_Z", Range.is(1));
    }
    
    @Override
    public boolean allowConstantFolding() {
        return true;
    }
    
    @Override
    public Object call(Interpreter interpreter, Object[] args) throws Exception {
        double r = getPoint(args, 0).getCoordinateAt(Geometry.DIMENSIONS.Z);
        return r;
    }
    
}
