package org.gvsig.expressionevaluator.impl.function.string;

import org.apache.commons.lang3.Range;
import org.gvsig.expressionevaluator.Interpreter;
import org.gvsig.expressionevaluator.spi.AbstractFunction;

public class CharFunction extends AbstractFunction {

    public CharFunction() {
        super("String", "CHAR", Range.is(1));
        this.addAlias("CHR");
    }

    @Override
    public boolean allowConstantFolding() {
        return true;
    }
    
    @Override
    public Object call(Interpreter interpreter, Object[] args) throws Exception {
        int value = getInt(args, 0);
        return Character.toString((char) value);
    }
}
