package org.gvsig.expressionevaluator.impl.function.string;

import java.util.Objects;
import org.apache.commons.lang3.Range;
import org.gvsig.expressionevaluator.Interpreter;
import org.gvsig.expressionevaluator.spi.AbstractFunction;

public class ConcatFunction extends AbstractFunction {

    public ConcatFunction() {
        super("String", "CONCAT", Range.between(1,Integer.MAX_VALUE));
    }

    @Override
    public boolean allowConstantFolding() {
        return true;
    }
    
    @Override
    public Object call(Interpreter interpreter, Object[] args) throws Exception {
        StringBuilder builder = new StringBuilder();
        for( Object arg : args ) {
            if( arg != null ) {
                builder.append(Objects.toString(arg, ""));
            }
        }
        return builder.toString();
    }
    
}
