package org.gvsig.expressionevaluator.impl.function.string;

import org.apache.commons.lang3.ArrayUtils;
import org.apache.commons.lang3.Range;
import org.gvsig.expressionevaluator.Interpreter;
import org.gvsig.expressionevaluator.spi.AbstractFunction;

public class FormatFunction extends AbstractFunction {

    public FormatFunction() {
        super("String", "FORMAT", Range.between(2,Integer.MAX_VALUE));
    }

    @Override
    public boolean allowConstantFolding() {
        return true;
    }
    
    @Override
    public Object call(Interpreter interpreter, Object[] args) throws Exception {
        String format = this.getStr(args, 0);
        Object[] argsformat = ArrayUtils.subarray(args, 1, args.length);
        String value = String.format(format, argsformat);
        return value;
    }
    
}
