package org.gvsig.expressionevaluator.impl.function.string;

import org.apache.commons.lang3.Range;
import org.gvsig.expressionevaluator.Interpreter;
import org.gvsig.expressionevaluator.spi.AbstractFunction;

public class InstrFunction extends AbstractFunction {

    public InstrFunction() {
        super("String", "INSTR", Range.between(2, 3));
    }

    @Override
    public boolean allowConstantFolding() {
        return true;
    }
    
    @Override
    public Object call(Interpreter interpreter, Object[] args) throws Exception {
        String str = getStr(args, 0);
        String search = getStr(args, 1);
        int start = 0;
        if( args.length == 3 ) {
            start = getInt(args, 2);
        }
        return str.indexOf(search, start);
    }
    

}
