package org.gvsig.expressionevaluator.impl.function.string;

import org.apache.commons.lang3.Range;
import org.gvsig.expressionevaluator.Interpreter;
import org.gvsig.expressionevaluator.spi.AbstractFunction;

public class LTrimFunction extends AbstractFunction {

    public LTrimFunction() {
        super("String", "LTRIM", Range.is(1));
    }

    @Override
    public boolean allowConstantFolding() {
        return true;
    }
    
    @Override
    public Object call(Interpreter interpreter, Object[] args) throws Exception {
        String str = getStr(args,0);
        return ltrim(str);
    }

    public static String ltrim(String s) {
        int i = 0;
        while( i < s.length() && Character.isWhitespace(s.charAt(i)) ) {
            i++;
        }
        return s.substring(i);
    }
}
