package org.gvsig.expressionevaluator.impl.function.string;

import org.apache.commons.lang3.Range;
import org.apache.commons.lang3.StringUtils;
import org.gvsig.expressionevaluator.Interpreter;
import org.gvsig.expressionevaluator.spi.AbstractFunction;

public class LeftFunction extends AbstractFunction {

    public LeftFunction() {
        super("String", "LEFT", Range.is(2));
    }

    @Override
    public boolean allowConstantFolding() {
        return true;
    }
    
    @Override
    public Object call(Interpreter interpreter, Object[] args) throws Exception {
        String str = getStr(args,0);
        int len = getInt(args, 1);
        
        String r = StringUtils.left(str, len);
        return r;
    }
    
}
