package org.gvsig.expressionevaluator.impl.function.string;

import org.apache.commons.lang3.Range;
import org.apache.commons.lang3.StringUtils;
import org.gvsig.expressionevaluator.Interpreter;
import org.gvsig.expressionevaluator.spi.AbstractFunction;

public class LocateFunction extends AbstractFunction {

    public LocateFunction() {
        super("String", "LOCATE", Range.between(2,3));
    }

    @Override
    public boolean allowConstantFolding() {
        return true;
    }
    
    @Override
    public Object call(Interpreter interpreter, Object[] args) throws Exception {
        int start = 0;
        String search = getStr(args,0);
        String str = getStr(args,1);
        if( args.length==2 ) {
            start = getInt(args, 2);
        }
        int r = StringUtils.indexOf(str, search, start);
        return r;
    }
    

}
