package org.gvsig.expressionevaluator.impl.function.string;

import org.apache.commons.lang3.Range;
import static org.gvsig.expressionevaluator.ExpressionBuilder.FUNCTION_LOWER;
import org.gvsig.expressionevaluator.Interpreter;
import org.gvsig.expressionevaluator.spi.AbstractFunction;

public class LowerFunction extends AbstractFunction {

    public LowerFunction() {
        super("String", FUNCTION_LOWER, Range.is(1));
        this.addAlias("LCASE");
        this.addAlias("toLowerCase");
    }

    @Override
    public boolean allowConstantFolding() {
        return true;
    }
    
    @Override
    public Object call(Interpreter interpreter, Object[] args) throws Exception {
        String str = getStr(args,0);
        return str.toLowerCase();
    }

}
