package org.gvsig.expressionevaluator.impl.function.string;

import org.apache.commons.lang3.Range;
import org.apache.commons.lang3.StringUtils;
import org.gvsig.expressionevaluator.Interpreter;
import org.gvsig.expressionevaluator.spi.AbstractFunction;

public class LpadFunction extends AbstractFunction {

    public LpadFunction() {
        super("String", "LPAD", Range.between(2,3));
    }

    @Override
    public boolean allowConstantFolding() {
        return true;
    }
    
    @Override
    public Object call(Interpreter interpreter, Object[] args) throws Exception {
        String str = getStr(args,0);
        int len = getInt(args, 1);
        String padstr = " ";
        if( args.length == 3 ) {
            padstr = getStr(args,2);
        }
        String r = StringUtils.leftPad(str, len, padstr);
        return r;
    }
    
}
