package org.gvsig.expressionevaluator.impl.function.string;

import org.apache.commons.lang3.Range;
import org.apache.commons.lang3.StringUtils;
import org.gvsig.expressionevaluator.ExpressionRuntimeException;
import org.gvsig.expressionevaluator.Interpreter;
import org.gvsig.expressionevaluator.spi.AbstractFunction;

public class MidFunction extends AbstractFunction {

    public MidFunction() {
        super("String", "MID", Range.between(2, 3));
    }


    @Override
    public boolean allowConstantFolding() {
        return true;
    }
    
    @Override
    public Object call(Interpreter interpreter, Object[] args) throws Exception {
        String value;
        
        String str = getStr(args,0);
        int start = getInt(args, 1);
        
        switch(args.length) {
            case 2:
                value = StringUtils.substring(str, start);
                return value;
            case 3:
                int len = getInt(args, 2);
                value = StringUtils.mid(str, start, len);
                return value;
        }
        throw new ExpressionRuntimeException("Incorrect arguments number");
    }

}
