package org.gvsig.expressionevaluator.impl.function.string;

import org.apache.commons.lang3.Range;
import org.gvsig.expressionevaluator.Interpreter;
import org.gvsig.expressionevaluator.spi.AbstractFunction;

public class RTrimFunction extends AbstractFunction {

    public RTrimFunction() {
        super("String", "RTRIM", Range.is(1));
    }

    @Override
    public boolean allowConstantFolding() {
        return true;
    }
    
    @Override
    public Object call(Interpreter interpreter, Object[] args) throws Exception {
        String str = getStr(args,0);
        return rtrim(str);
    }

    public static String rtrim(String s) {
        int i = s.length() - 1;
        while( i >= 0 && Character.isWhitespace(s.charAt(i)) ) {
            i--;
        }
        return s.substring(0, i + 1);
    }
}
