package org.gvsig.expressionevaluator.impl.function.string;

import org.apache.commons.lang3.Range;
import org.apache.commons.lang3.StringUtils;
import org.gvsig.expressionevaluator.Interpreter;
import org.gvsig.expressionevaluator.spi.AbstractFunction;

public class ReplaceFunction extends AbstractFunction {

    public ReplaceFunction() {
        super("String", "REPLACE", Range.between(2, 3));
    }

    @Override
    public boolean allowConstantFolding() {
        return true;
    }
    
    @Override
    public Object call(Interpreter interpreter, Object[] args) throws Exception {
        String str = getStr(args,0);
        String search = getStr(args,1);
        String replstr = "";
        if( args.length==3 ) {
            replstr = getStr(args,2);
        }
        String r = StringUtils.replace(str, search, replstr);
        return r;
    }

}
