package org.gvsig.expressionevaluator.impl.function.string;

import org.apache.commons.lang3.Range;
import org.apache.commons.lang3.StringUtils;
import org.gvsig.expressionevaluator.Interpreter;
import org.gvsig.expressionevaluator.spi.AbstractFunction;

public class SpaceFunction extends AbstractFunction {

    public SpaceFunction() {
        super("String", "SPACE", Range.is(1));
    }

    @Override
    public boolean allowConstantFolding() {
        return true;
    }
    
    @Override
    public Object call(Interpreter interpreter, Object[] args) throws Exception {
        int size = getInt(args, 0);
        
        String r = StringUtils.leftPad("", size);
        return r;
    }
    

}
