package org.gvsig.expressionevaluator.impl.function.string;

import org.apache.commons.lang3.Range;
import org.apache.commons.lang3.StringUtils;
import org.gvsig.expressionevaluator.Interpreter;
import org.gvsig.expressionevaluator.spi.AbstractFunction;

public class SubstringFunction extends AbstractFunction {

    public SubstringFunction() {
        super("String", "SUBSTRING", Range.between(2, 3));
        this.addAlias("SUBSTR");
    }


    @Override
    public boolean allowConstantFolding() {
        return true;
    }
    
    @Override
    public Object call(Interpreter interpreter, Object[] args) throws Exception {
        String str = getStr(args,0);
        int start = getInt(args, 1);
        String r = StringUtils.substring(str, start);
        if( args.length == 3 ) {
            int len = getInt(args, 2);
            r = StringUtils.left(r, len);
        }
        return r;
    }

}
