package org.gvsig.expressionevaluator.impl.function.string;

import org.apache.commons.lang3.Range;
import org.gvsig.expressionevaluator.Interpreter;
import org.gvsig.expressionevaluator.spi.AbstractFunction;

public class UpperFunction extends AbstractFunction {

    public UpperFunction() {
        super("String", "UPPER", Range.is(1));
        this.addAlias("UCASE");
        this.addAlias("toUpperCase");
    }

    @Override
    public boolean allowConstantFolding() {
        return true;
    }
    
    @Override
    public Object call(Interpreter interpreter, Object[] args) throws Exception {
        String str = getStr(args,0);
        return str.toUpperCase();
    }
}
