package org.gvsig.expressionevaluator.impl.function.typeconversion;

import org.apache.commons.lang3.Range;
import static org.gvsig.expressionevaluator.ExpressionBuilder.FUNCTION_TOFLOAT;
import org.gvsig.expressionevaluator.Interpreter;
import org.gvsig.expressionevaluator.spi.AbstractFunction;
import org.gvsig.tools.ToolsLocator;
import org.gvsig.tools.dataTypes.DataTypes;
import org.gvsig.tools.dataTypes.DataTypesManager.Coercion;

public class ToFloatFunction extends AbstractFunction {

    public ToFloatFunction() {
        super(GROUP_CONVERSION, FUNCTION_TOFLOAT, Range.is(1));
        this.addAlias("float");
    }

    @Override
    public boolean allowConstantFolding() {
        return true;
    }
    
    @Override
    public Object call(Interpreter interpreter, Object[] args) throws Exception {
        Coercion toStr = ToolsLocator.getDataTypesManager().getCoercion(DataTypes.FLOAT);
        Object value = toStr.coerce(this.getObject(args, 0));
        return value;
    }
    
}
