package org.gvsig.expressionevaluator.impl.function.typeconversion;

import org.apache.commons.lang3.Range;
import static org.gvsig.expressionevaluator.ExpressionBuilder.FUNCTION_TOINTEGER;
import org.gvsig.expressionevaluator.Interpreter;
import org.gvsig.expressionevaluator.spi.AbstractFunction;
import org.gvsig.tools.ToolsLocator;
import org.gvsig.tools.dataTypes.DataTypes;
import org.gvsig.tools.dataTypes.DataTypesManager.Coercion;

public class ToIntegerFunction extends AbstractFunction {

    public ToIntegerFunction() {
        super(GROUP_CONVERSION, FUNCTION_TOINTEGER, Range.is(1));
        this.addAlias("int");
        this.addAlias("toint");
    }

    @Override
    public boolean allowConstantFolding() {
        return true;
    }
    
    @Override
    public Object call(Interpreter interpreter, Object[] args) throws Exception {
        Coercion toInt = ToolsLocator.getDataTypesManager().getCoercion(DataTypes.INT);
        Object value = toInt.coerce(this.getObject(args, 0));
        return value;
    }
    
}
