package org.gvsig.expressionevaluator.impl.javascripting;

import java.util.Collection;
import javax.script.Bindings;
import org.gvsig.expressionevaluator.MutableSymbolTable;
import org.gvsig.expressionevaluator.impl.DefaultSymbolTable;

/**
 *
 * @author jjdelcerro
 */
public class BindingsToSymbolTableAdapter 
        extends DefaultSymbolTable
        implements MutableSymbolTable 
    {
    
    private final Bindings bindings;

    public BindingsToSymbolTableAdapter(Bindings bindings) {
        this.bindings = bindings;
    }
    @Override
    public void setVar(String name, Object value) {
        this.bindings.put(name, value);
    }

    @Override
    public void removeVar(String name) {
        this.bindings.remove(name);
    }

    @Override
    @SuppressWarnings("CloneDoesntCallSuperClone")
    public MutableSymbolTable clone() throws CloneNotSupportedException {
        throw new CloneNotSupportedException();
    }

    @Override
    public String getName() {
        return "Anonimous";
    }

    @Override
    public boolean exists(String name) {
        return this.bindings.containsKey(name);
    }

    @Override
    public Object value(String name) {
        return this.bindings.get(name);
    }

    @Override
    public Collection<String> variables() {
        return this.bindings.keySet();
    }

    @Override
    public Collection<String> localvariables() {
        return this.bindings.keySet();
    }

    
}
