package org.gvsig.expressionevaluator.impl.symboltable;

import org.gvsig.expressionevaluator.Function;
import org.gvsig.expressionevaluator.impl.function.image.AffineTransformFunction;
import org.gvsig.expressionevaluator.impl.function.image.ImageHeightFunction;
import org.gvsig.expressionevaluator.impl.function.image.ImageHorizontalflipFunction;
import org.gvsig.expressionevaluator.impl.function.image.ImageReadFunction;
import org.gvsig.expressionevaluator.impl.function.image.ImageResizeFunction;
import org.gvsig.expressionevaluator.impl.function.image.ImageRotateFunction;
import org.gvsig.expressionevaluator.impl.function.image.ImageTransformFunction;
import org.gvsig.expressionevaluator.impl.function.image.ImageVerticalflipFunction;
import org.gvsig.expressionevaluator.impl.function.image.ImageWidthFunction;
import org.gvsig.expressionevaluator.spi.AbstractSymbolTable;

/**
 *
 * @author jjdelcerro
 */
public class BasicImageSymbolTable extends AbstractSymbolTable {
    static final String NAME = "BasicImage";
    
    @SuppressWarnings("OverridableMethodCallInConstructor")
    public BasicImageSymbolTable() {
        super(NAME);

        this.addFunction(new AffineTransformFunction());

        this.addFunction(new ImageHeightFunction());
        this.addFunction(new ImageHorizontalflipFunction());
        this.addFunction(new ImageReadFunction());
        this.addFunction(new ImageResizeFunction());
        this.addFunction(new ImageRotateFunction());
        this.addFunction(new ImageTransformFunction());
        this.addFunction(new ImageVerticalflipFunction());
        this.addFunction(new ImageWidthFunction());
    }

    private void addOperator(Function operator) {
        this.addFunction(operator);
    }
    
}
