package org.gvsig.expressionevaluator.impl.symboltable;

import org.gvsig.expressionevaluator.Function;
import org.gvsig.expressionevaluator.impl.function.foldersmanager.GetFolderFunction;
import org.gvsig.expressionevaluator.impl.function.foldersmanager.HomeFunction;
import org.gvsig.expressionevaluator.impl.function.foldersmanager.LastPathFunction;
import org.gvsig.expressionevaluator.impl.function.foldersmanager.SetFolderFunction;
import org.gvsig.expressionevaluator.impl.function.foldersmanager.SetLastPathFunction;
import org.gvsig.expressionevaluator.impl.function.foldersmanager.SetTemporaryFolderFunction;
import org.gvsig.expressionevaluator.impl.function.foldersmanager.TemporaryFileFunction;
import org.gvsig.expressionevaluator.impl.function.foldersmanager.TemporaryFolderFunction;
import org.gvsig.expressionevaluator.impl.function.foldersmanager.UniqueTemporaryFileFunction;
import org.gvsig.expressionevaluator.spi.AbstractSymbolTable;

/**
 *
 * @author jjdelcerro
 */
public class FoldersSymbolTable extends AbstractSymbolTable {
    static final String NAME = "Folders";
    
    @SuppressWarnings("OverridableMethodCallInConstructor")
    public FoldersSymbolTable() {
        super(NAME);

        this.addFunction(new GetFolderFunction());

        this.addFunction(new HomeFunction());
        this.addFunction(new LastPathFunction());
        this.addFunction(new SetFolderFunction());
        this.addFunction(new SetLastPathFunction());
        this.addFunction(new SetTemporaryFolderFunction());
        this.addFunction(new TemporaryFileFunction());
        this.addFunction(new TemporaryFolderFunction());
        this.addFunction(new UniqueTemporaryFileFunction());
    }

    private void addOperator(Function operator) {
        this.addFunction(operator);
    }
    
}
