package org.gvsig.expressionevaluator.impl.symboltable;

import org.gvsig.expressionevaluator.impl.function.spatial.AndAndOperator;
import org.gvsig.expressionevaluator.impl.function.spatial.STAreaFunction;
import org.gvsig.expressionevaluator.impl.function.spatial.STAsTextFunction;
import org.gvsig.expressionevaluator.impl.function.spatial.STBufferFunction;
import org.gvsig.expressionevaluator.impl.function.spatial.STCentroidFunction;
import org.gvsig.expressionevaluator.impl.function.spatial.STContainsFunction;
import org.gvsig.expressionevaluator.impl.function.spatial.STConvexHullFunction;
import org.gvsig.expressionevaluator.impl.function.spatial.STCoveredByFunction;
import org.gvsig.expressionevaluator.impl.function.spatial.STCoversFunction;
import org.gvsig.expressionevaluator.impl.function.spatial.STCrossesFunction;
import org.gvsig.expressionevaluator.impl.function.spatial.STDifferenceFunction;
import org.gvsig.expressionevaluator.impl.function.spatial.STDimensionFunction;
import org.gvsig.expressionevaluator.impl.function.spatial.STDisjointFunction;
import org.gvsig.expressionevaluator.impl.function.spatial.STDistanceFunction;
import org.gvsig.expressionevaluator.impl.function.spatial.STEndPointFunction;
import org.gvsig.expressionevaluator.impl.function.spatial.STEnvelopeFunction;
import org.gvsig.expressionevaluator.impl.function.spatial.STGeomFromTextFunction;
import org.gvsig.expressionevaluator.impl.function.spatial.STGeomFromWKBFunction;
import org.gvsig.expressionevaluator.impl.function.spatial.STGeometryNFunction;
import org.gvsig.expressionevaluator.impl.function.spatial.STIntersectionFunction;
import org.gvsig.expressionevaluator.impl.function.spatial.STIntersectsFunction;
import org.gvsig.expressionevaluator.impl.function.spatial.STIsSimpleFunction;
import org.gvsig.expressionevaluator.impl.function.spatial.STIsValidFunction;
import org.gvsig.expressionevaluator.impl.function.spatial.STMakePointFunction;
import org.gvsig.expressionevaluator.impl.function.spatial.STNumGeometriesFunction;
import org.gvsig.expressionevaluator.impl.function.spatial.STNumPointsFunction;
import org.gvsig.expressionevaluator.impl.function.spatial.STOverlapsFunction;
import org.gvsig.expressionevaluator.impl.function.spatial.STPerimeterFunction;
import org.gvsig.expressionevaluator.impl.function.spatial.STPointFunction;
import org.gvsig.expressionevaluator.impl.function.spatial.STPointNFunction;
import org.gvsig.expressionevaluator.impl.function.spatial.STSRIDFunction;
import org.gvsig.expressionevaluator.impl.function.spatial.STSetSRIDFunction;
import org.gvsig.expressionevaluator.impl.function.spatial.STStartPointFunction;
import org.gvsig.expressionevaluator.impl.function.spatial.STTouchesFunction;
import org.gvsig.expressionevaluator.impl.function.spatial.STUnionFunction;
import org.gvsig.expressionevaluator.impl.function.spatial.STWithinFunction;
import org.gvsig.expressionevaluator.impl.function.spatial.STXFunction;
import org.gvsig.expressionevaluator.impl.function.spatial.STYFunction;
import org.gvsig.expressionevaluator.impl.function.spatial.STZFunction;
import org.gvsig.expressionevaluator.spi.AbstractSymbolTable;

/**
 *
 * @author jjdelcerro
 */
public class OGCSymbolTable 
        extends AbstractSymbolTable
    {
    
    static final String NAME = "OGC";

    public OGCSymbolTable() {
        super(NAME);
        this.initFunctions();
    }
    
    private void initFunctions() {
        this.addFunction(new STAreaFunction());
        this.addFunction(new STAsTextFunction());
        this.addFunction(new STBufferFunction());
        this.addFunction(new STCentroidFunction());
        this.addFunction(new STContainsFunction());
        this.addFunction(new STConvexHullFunction());
        this.addFunction(new STCoveredByFunction());
        this.addFunction(new STCoversFunction());
        this.addFunction(new STCrossesFunction());
        this.addFunction(new STDifferenceFunction());
        this.addFunction(new STDimensionFunction());
        this.addFunction(new STDisjointFunction());
        this.addFunction(new STDistanceFunction());
        this.addFunction(new STEndPointFunction());
        this.addFunction(new STEnvelopeFunction());
        this.addFunction(new STGeomFromTextFunction());
        this.addFunction(new STGeomFromWKBFunction());
        this.addFunction(new STGeometryNFunction());
        this.addFunction(new STIntersectionFunction());
        this.addFunction(new STIntersectsFunction());
        this.addFunction(new STIsSimpleFunction());
        this.addFunction(new STIsValidFunction());
        this.addFunction(new STNumGeometriesFunction());
        this.addFunction(new STNumPointsFunction());
        this.addFunction(new STOverlapsFunction());
        this.addFunction(new STPerimeterFunction());
        this.addFunction(new STPointNFunction());
        this.addFunction(new STStartPointFunction());
        this.addFunction(new STTouchesFunction());
        this.addFunction(new STUnionFunction());
        this.addFunction(new STWithinFunction());
        this.addFunction(new STXFunction());
        this.addFunction(new STYFunction());
        this.addFunction(new STZFunction());
        this.addFunction(new STSRIDFunction());
        this.addFunction(new STSetSRIDFunction());
        this.addFunction(new STPointFunction());
        this.addFunction(new STMakePointFunction());
        
        this.addFunction(new AndAndOperator());
    }    
}
