package org.gvsig.expressionevaluator.impl.symboltable;

import org.gvsig.expressionevaluator.Function;
import org.gvsig.expressionevaluator.impl.function.programming.CallMethodFunction;
import org.gvsig.expressionevaluator.impl.function.programming.CaseFunction;
import org.gvsig.expressionevaluator.impl.function.programming.CodeBlockFunction;
import org.gvsig.expressionevaluator.impl.function.programming.ForEachFunction;
import org.gvsig.expressionevaluator.impl.function.programming.ForFunction;
import org.gvsig.expressionevaluator.impl.function.programming.CallStaticMethodFunction;
import org.gvsig.expressionevaluator.impl.function.programming.CodeBlockWithExceptFunction;
import org.gvsig.expressionevaluator.impl.function.programming.CreateFnFunction;
//import org.gvsig.expressionevaluator.impl.function.programming.EvalFunction;
import org.gvsig.expressionevaluator.impl.function.programming.FileFunction;
import org.gvsig.expressionevaluator.impl.function.programming.GetattrFunction;
import org.gvsig.expressionevaluator.impl.function.programming.GetitemFunction;
import org.gvsig.expressionevaluator.impl.function.programming.LabelValueFunction;
import org.gvsig.expressionevaluator.impl.function.programming.LenFunction;
import org.gvsig.expressionevaluator.impl.function.programming.LetFunction;
import org.gvsig.expressionevaluator.impl.function.programming.ListFunction;
import org.gvsig.expressionevaluator.impl.function.programming.PrintFunction;
import org.gvsig.expressionevaluator.impl.function.programming.RangeFunction;
import org.gvsig.expressionevaluator.impl.function.programming.ReturnFunction;
import org.gvsig.expressionevaluator.impl.function.programming.TryFunction;
import org.gvsig.expressionevaluator.impl.function.programming.TupleFunction;
import org.gvsig.expressionevaluator.impl.function.programming.URLFunction;
import org.gvsig.expressionevaluator.impl.function.programming.UserFunction;
import org.gvsig.expressionevaluator.impl.function.programming.WhileFunction;
import org.gvsig.expressionevaluator.spi.AbstractSymbolTable;

/**
 *
 * @author jjdelcerro
 */
public class ProgrammingSymbolTable extends AbstractSymbolTable {
    static final String NAME = "Programming";
    
    @SuppressWarnings("OverridableMethodCallInConstructor")
    public ProgrammingSymbolTable() {
        super(NAME);

        this.addFunction(new CaseFunction());
        this.addFunction(new CodeBlockFunction());
        this.addFunction(new CodeBlockWithExceptFunction());
        this.addFunction(new ForEachFunction());
        this.addFunction(new ForFunction());
        this.addFunction(new LetFunction());
        this.addFunction(new WhileFunction());
        this.addFunction(new CreateFnFunction());
        this.addFunction(new ReturnFunction());
        this.addFunction(new TryFunction());

        this.addFunction(new PrintFunction());
        this.addFunction(new TupleFunction());
        this.addFunction(new ListFunction());
        this.addFunction(new RangeFunction());
        this.addFunction(new GetattrFunction());
        this.addFunction(new GetitemFunction());
        this.addFunction(new CallStaticMethodFunction());
        this.addFunction(new CallMethodFunction());
        this.addFunction(new FileFunction());
        this.addFunction(new LenFunction());
        this.addFunction(new URLFunction());
        this.addFunction(new LabelValueFunction());
//        this.addFunction(new EvalFunction());
        this.addFunction(new UserFunction());
    }

    private void addOperator(Function operator) {
        this.addFunction(operator);
    }
    
}
