package org.gvsig.expressionevaluator.impl.symboltable;

import org.gvsig.expressionevaluator.Function;
import org.gvsig.expressionevaluator.impl.function.date.RelativeInstantFunction;
import org.gvsig.expressionevaluator.impl.function.date.RelativeIntervalFunction;
import org.gvsig.expressionevaluator.impl.function.numeric.DecrFunction;
import org.gvsig.expressionevaluator.impl.function.numeric.IncrFunction;
import org.gvsig.expressionevaluator.impl.function.programming.CodeBlockFunction;
import org.gvsig.expressionevaluator.impl.function.programming.ForEachFunction;
import org.gvsig.expressionevaluator.impl.function.programming.CallStaticMethodFunction;
import org.gvsig.expressionevaluator.impl.function.programming.LetFunction;
import org.gvsig.expressionevaluator.impl.function.programming.WhileFunction;
import org.gvsig.expressionevaluator.impl.function.programming.ForFunction;
import org.gvsig.expressionevaluator.spi.AbstractSymbolTable;

/**
 *
 * @author jjdelcerro
 */
public class UtilsSymbolTable extends AbstractSymbolTable {
    static final String NAME = "Utilities";
    
    @SuppressWarnings("OverridableMethodCallInConstructor")
    public UtilsSymbolTable() {
        super(NAME);

        this.addFunction(new RelativeInstantFunction());
        this.addFunction(new RelativeIntervalFunction());
        
        this.addFunction(new IncrFunction());
        this.addFunction(new DecrFunction());

    }

    private void addOperator(Function operator) {
        this.addFunction(operator);
    }
    
}
