package org.gvsig.expresionevaluator.impl;

import java.io.InputStream;
import junit.framework.TestCase;
import org.apache.commons.io.IOUtils;
import org.apache.commons.lang3.StringUtils;
import org.gvsig.expressionevaluator.Expression;
import org.gvsig.expressionevaluator.ExpressionEvaluatorLocator;
import org.gvsig.expressionevaluator.ExpressionEvaluatorManager;
import org.gvsig.expressionevaluator.impl.javascripting.CosaScriptEngineFactory;
import org.gvsig.tools.library.impl.DefaultLibrariesInitializer;
import org.gvsig.tools.script.Script;

public class TestScript1 extends TestCase {

    public TestScript1(String testName) {
        super(testName);
    }

    @Override
    protected void setUp() throws Exception {
        super.setUp();
        new DefaultLibrariesInitializer().fullInitialize();
    }

    @Override
    protected void tearDown() throws Exception {
        super.tearDown();
    }

    // TODO add test methods here. The name must begin with 'test'. For example:
    // public void testHello() {}
    public void testScript1() throws Exception {
        InputStream is = this.getClass().getResource("/org/gvsig/expressionevaluator/impl/TestScript1_1.txt").openStream();
        String source = StringUtils.join(IOUtils.readLines(is), "\n");
        ExpressionEvaluatorManager manager = ExpressionEvaluatorLocator.getManager();

        Object r;
        Script sc;
        try {
            sc = manager.createScript("test1", source, CosaScriptEngineFactory.LANGUAGE_NAME);
        } catch (Exception ex) {
            System.err.println(ex.getMessage());
            throw ex;
        }
        r = sc.invokeFunction("form_validate", new Object[]{"form"});
        assertEquals(true, r);

        r = sc.invokeFunction("form_isReadOnly", new Object[]{"form"});
        assertEquals(false, r);
    }

    public void testScript2() throws Exception {
        InputStream is = this.getClass().getResource("/org/gvsig/expressionevaluator/impl/TestScript1_2.txt").openStream();
        String source = StringUtils.join(IOUtils.readLines(is), "\n");
        ExpressionEvaluatorManager manager = ExpressionEvaluatorLocator.getManager();

        Object r;
        Script sc;
        try {
            sc = manager.createScript("test2", source, CosaScriptEngineFactory.LANGUAGE_NAME);
        } catch (Exception ex) {
            System.err.println(ex.getMessage());
            throw ex;
        }
        r = sc.invokeFunction("test1", null);
        assertEquals(" hola adios fin", r);

        r = sc.invokeFunction("test2", null);
        assertEquals(" hola adios fin", r);

    }

    public void testScript3() throws Exception {
        InputStream is = this.getClass().getResource("/org/gvsig/expressionevaluator/impl/TestScript1_2.txt").openStream();
        String source = StringUtils.join(IOUtils.readLines(is), "\n");
        ExpressionEvaluatorManager manager = ExpressionEvaluatorLocator.getManager();

        Object r;
        Script sc;
        try {
            sc = manager.createScript("test3", source, CosaScriptEngineFactory.LANGUAGE_NAME);
        } catch (Exception ex) {
            System.err.println(ex.getMessage());
            throw ex;
        }
        r = sc.invokeFunction("test3", null);
        assertEquals("Hola amigos", r);

        r = sc.invokeFunction("saluda", new Object[] { "pato" });
        assertEquals("Hola pato", r);

    }

}
