/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.gvsig.expressionevaluator.main;

import java.io.File;
import java.net.URL;
import org.gvsig.expressionevaluator.ExpressionEvaluatorLocator;
import org.gvsig.expressionevaluator.ExpressionEvaluatorManager;
import org.gvsig.expressionevaluator.SymbolTable;
import org.gvsig.expressionevaluator.swing.Element;
import org.gvsig.expressionevaluator.swing.ExpressionEvaluatorSwingLocator;
import org.gvsig.expressionevaluator.swing.ExpressionEvaluatorSwingManager;
import org.gvsig.expressionevaluator.swing.JExpressionBuilder;
import org.gvsig.fmap.dal.DALLocator;
import org.gvsig.fmap.dal.DataManager;
import org.gvsig.fmap.dal.DataStore;
import org.gvsig.fmap.dal.feature.FeatureStore;
import org.gvsig.fmap.dal.swing.DataSwingManager;
import org.gvsig.tools.library.impl.DefaultLibrariesInitializer;
import org.gvsig.tools.swing.api.ToolsSwingLocator;
import org.gvsig.tools.swing.api.windowmanager.Dialog;
import org.gvsig.tools.swing.api.windowmanager.WindowManager;
import org.gvsig.tools.swing.api.windowmanager.WindowManager_v2;

/**
 *
 * @author jjdelcerro
 */
public class MainDialog {
    public static void main(String[] args) {
        new MainDialog().run(args);
    }
    
    public void run(String[] args) {
        new DefaultLibrariesInitializer().fullInitialize();
        
        WindowManager_v2 windowManager = (WindowManager_v2) ToolsSwingLocator.getWindowManager();
        ExpressionEvaluatorManager manager = ExpressionEvaluatorLocator.getManager();
        ExpressionEvaluatorSwingManager swingManager = ExpressionEvaluatorSwingLocator.getManager();
        
        JExpressionBuilder panel = swingManager.createJExpressionBuilder();
        panel.addSymbolTable(DataManager.DAL_SYMBOL_TABLE_FEATURE);
        Element element = swingManager.createElement(
                DataSwingManager.FEATURE_STORE_EXPRESSION_ELEMENT, 
                panel, 
                openStore()
        );
        if( element != null ) {
            panel.addElement(element);
        }
        Dialog dialog = windowManager.createDialog(
                panel.asJComponent(),
                "Test eexpression builder",
                null, 
                WindowManager_v2.BUTTONS_OK_CANCEL
        );
        dialog.show(WindowManager.MODE.WINDOW);
    }
   
    private FeatureStore openStore() {
        try {
            DataManager dataManager = DALLocator.getDataManager();
            URL url = this.getClass().getResource("/Locations.csv");
            DataStore store = dataManager.openStore(
                    "CSV", 
                    "file",new File(url.toURI()),
                    "firstLineHeader", true,
                    "delimiter",","
            );
            return (FeatureStore) store;
        } catch (Exception ex) {
            throw new RuntimeException(ex);
        }
    }
}
