/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.gvsig.expressionevaluator.main;

import java.awt.Dimension;
import java.io.File;
import java.net.URL;
import javax.swing.JFrame;
import javax.swing.WindowConstants;
import org.gvsig.expressionevaluator.ExpressionEvaluatorLocator;
import org.gvsig.expressionevaluator.ExpressionEvaluatorManager;
import org.gvsig.expressionevaluator.SymbolTable;
import org.gvsig.expressionevaluator.swing.Element;
import org.gvsig.expressionevaluator.swing.ExpressionEvaluatorSwingLocator;
import org.gvsig.expressionevaluator.swing.ExpressionEvaluatorSwingManager;
import org.gvsig.expressionevaluator.swing.JExpressionPicker;
import org.gvsig.fmap.dal.DALLocator;
import org.gvsig.fmap.dal.DataManager;
import org.gvsig.fmap.dal.DataStore;
import org.gvsig.fmap.dal.feature.FeatureStore;
import org.gvsig.tools.library.impl.DefaultLibrariesInitializer;

/**
 *
 * @author jjdelcerro
 */
public class MainPicker {
    public static void main(String[] args) {
        new MainPicker().run(args);
    }
    
    public void run(String[] args) {
        new DefaultLibrariesInitializer().fullInitialize();
        
        ExpressionEvaluatorManager manager = ExpressionEvaluatorLocator.getManager();
        ExpressionEvaluatorSwingManager swingManager = ExpressionEvaluatorSwingLocator.getManager();
        
        JExpressionPicker panel = swingManager.createJExpressionPicker();
//        SymbolTable symbolTable = manager.getSymbolTable("DAL.FeatureSymbolTable");
//        if( symbolTable!=null ) {
//            panel.addSymbolTable(symbolTable);
//        }
        Element element = swingManager.createElement("DAL.FeatureStoreElement", panel, openStore());
        if( element != null ) {
            panel.getElements().add(element);
        }

        JFrame frame = new JFrame("My JFrame Example");
        frame.setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
        frame.setPreferredSize(new Dimension(400, 60));
        frame.add(panel.asJComponent());
        frame.pack();
        frame.setVisible(true);        
    }
   
    private FeatureStore openStore() {
        try {
            DataManager dataManager = DALLocator.getDataManager();
            URL url = this.getClass().getResource("/Locations.csv");
            DataStore store = dataManager.openStore(
                    "CSV", 
                    "file",new File(url.toURI()),
                    "firstLineHeader", true,
                    "delimiter",","
            );
            return (FeatureStore) store;
        } catch (Exception ex) {
            throw new RuntimeException(ex);
        }
    }
}
