package org.gvsig.expressionevaluator.swing;

import org.gvsig.expressionevaluator.MutableSymbolTable;
import org.gvsig.expressionevaluator.SymbolTable;
import org.gvsig.tools.swing.api.ChangeListenerSupport;

/**
 *
 * @author jjdelcerro
 */
public interface CalculatorController<T> extends ChangeListenerSupport {

    public void addSymbolTable(SymbolTable symbolTable);

    public MutableSymbolTable getSymbolTable();

    public T get();

    public T get(T defaultValue);

    public void set(T value);

    public void coerceAndSet(Object value);

    public boolean isEnabled();

    public void setEnabled(boolean enabled);

    public void setEditable(boolean editable);
    
    public boolean isEditable();

    public void setWarning(boolean warning);
    
    public void setWarning(boolean warning, String description);
    
    public boolean getWarning();
}
