package org.gvsig.expressionevaluator.swing;

import java.util.Collection;
import java.util.Iterator;
import java.util.List;
import javax.swing.Icon;
import org.gvsig.expressionevaluator.Function;
import org.gvsig.tools.swing.api.Component;
import org.gvsig.tools.util.LabeledValue;

/**
 *
 * @author jjdelcerro
 */
public interface Element extends LabeledValue, Comparable {

    public interface SimpleElement extends Element {

    }

    public interface GroupElement extends Element, Iterable<Element> {

        public Element get(int index);

        public int size();

        @Override
        public Iterator<Element> iterator();

        public void addElement(Element element);

        public void addElement(Function function);

        public List<Element> getElements();

    }

    public interface FunctionElement extends SimpleElement {

        public Function getFunction();
    }

    public interface ConstantElement extends SimpleElement {

    }

    public interface CalculatedElement extends SimpleElement {

    }

    public String getName();
    
    public String getRenderedValue();
    
    public String getDescription();

    public String getIconName();

    public Icon getIcon();
    
    public Collection<Element> getValues();

    public boolean hasMoreValues();

    public Component getAditionalPanel(JExpressionBuilder expressionBuilder);
    
    public boolean isEnabled();

    public void reload();
    
    public void used();
    
    public Element setConfig(ExpressionBuilderConfig config);
    
    public ExpressionBuilderConfig getConfig();
}
