package org.gvsig.expressionevaluator.swing;

import java.util.Collection;
import java.util.List;
import org.gvsig.expressionevaluator.SymbolTable;
import org.gvsig.tools.util.PropertiesSupport;

/**
 *
 * @author jjdelcerro
 */
public interface ExpressionBuilderConfig extends PropertiesSupport {

    public interface Preferences {
        /**
         * Time in secons to use when obtains the list of elements.
         * 
         * @return time in secons
         */
        public int getSimpleElementsLimit();

        /**
         * Set the time in secons to use to obtain the list of elements.
         * 
         * @param limit 
         */
        public void setSimpleElementsLimit(int limit);

//        public void setScriptsEnabled(boolean enabled);
//
//        public boolean getScriptsEnabled();

        public void setSQLCompatible(boolean sqlCompatible);

        public boolean isSQLCompatible();
        
        public boolean getShowLabelsOfElements();
        
        public void setShowLabelsOfElements(boolean showLabels);
        
    }
    
    public Preferences getPreferences();
    
    public List<Element> getElements();

    public void addElement(Element element);

    public Collection<SymbolTable> getSymbolTables();

    public void addSymbolTable(SymbolTable symbolTable);

    public void addSymbolTable(String name);

    public void removeSymbolTable(String name);

    public void removeAllSymbolTables();
    
    public SymbolTable getPreviewSymbolTable();
    
    public void setPreviewSymbolTable(SymbolTable symbolTable);
    
}
