package org.gvsig.expressionevaluator.swing;

import org.gvsig.tools.locator.AbstractLocator;
import org.gvsig.tools.locator.LocatorException;


public class ExpressionEvaluatorSwingLocator extends AbstractLocator {

    private static final String LOCATOR_NAME = "ExpressionEvaluatorSwingLocator";

    public static final String MANAGER_NAME = "ExpressionEvaluatorSwingManager";

    private static final String MANAGER_DESCRIPTION = "ExpressionEvaluator-Swing of gvSIG";

    /**
     * Unique instance.
     */
    private static final ExpressionEvaluatorSwingLocator instance = new ExpressionEvaluatorSwingLocator();

    /**
     * Return the singleton instance.
     *
     * @return the singleton instance
     */
    public static ExpressionEvaluatorSwingLocator getInstance() {
        return instance;
    }

    /**
     * Returns the Locator name.
     *
     * @return String containing the locator name.
     */
    @Override
    public String getLocatorName() {
        return LOCATOR_NAME;
    }

    public static ExpressionEvaluatorSwingManager getManager() throws LocatorException {
        return (ExpressionEvaluatorSwingManager) getInstance().get(MANAGER_NAME);
    }

    public static void registerManager(Class clazz) {
        getInstance().register(MANAGER_NAME, MANAGER_DESCRIPTION, clazz);
    }

    public static void registerDefaultManager(Class clazz) {
        getInstance().registerDefault(MANAGER_NAME, MANAGER_DESCRIPTION, clazz);
    }

}
