
package org.gvsig.expressionevaluator.swing;

import java.util.Collection;
import java.util.List;
import javax.swing.Action;
import javax.swing.JButton;
import javax.swing.text.JTextComponent;
import org.gvsig.expressionevaluator.Function;
import org.gvsig.expressionevaluator.SymbolTable;
import org.gvsig.expressionevaluator.swing.Element.ConstantElement;
import org.gvsig.expressionevaluator.swing.Element.FunctionElement;
import org.gvsig.expressionevaluator.swing.Element.GroupElement;

public interface ExpressionEvaluatorSwingManager {

    
    public List<Element> createElements(Collection<SymbolTable> symbolTables);
    
    public JExpressionBuilder createJExpressionBuilder();
    
    public Action createJExpressionBuilderAction(JTextComponent jtext);
    
    public JExpressionPicker createJExpressionPicker();

    public void registerElement(ElementFactory factory);
    
    public Collection<ElementFactory> getElementFactories();
    
    public void registerAdditionalPanel(FunctionAdditionalPanelFactory factory);
    
    public FunctionAdditionalPanelFactory getFunctionAdditionalPanelFactory(String functionName);
    
    public Collection<FunctionAdditionalPanelFactory> getFunctionAdditionalPanelFactories();
    
    public Element createElement(String name, Object... parameters);
    
//    public GroupElement createGroupElement(String name);
//    
//    public GroupElement createGroupElement(String name, List<Element> elements);
//
//    public FunctionElement createFunctionElement(Function function);
//
//    public ConstantElement createConstantElement(Object value);
//
//    public ConstantElement createConstantElement(Object value, String description);
//
//    public VariableElement createVariableElement(String label, String source, String name, String typeName, String description);

    public GroupElement createGroupElement(String name);
    
    public GroupElement createGroupElement(String name, List<Element> elements);

    public FunctionElement createFunctionElement(Function function);

    public ConstantElement createConstantElement(Object value, String label);

    public ConstantElement createConstantElement(Object value, String label, String description);

    public ExpressionPickerController createExpressionPickerController(JTextComponent text, JButton button);

    public ExpressionPickerController createExpressionPickerController(JTextComponent text, JButton button, JButton bookmarks, JButton history);

    public CalculatorController createCalculatorController(JTextComponent text, int dataType);

}
