package org.gvsig.expressionevaluator.swing;

import org.gvsig.tools.swing.api.pickercontroller.PickerController;
import org.gvsig.expressionevaluator.Expression;

/**
 *
 * @author jjdelcerro
 */
public interface ExpressionPickerController 
        extends PickerController<Expression>, ExpressionBuilderConfig {

    /**
     * Return the expression in the picker.
     * If a non-null value is assigned as the expression, it will return 
     * this value updated with what the user entered.
     * If a null value is assigned as the expression, when the user did not 
     * enter any value return null. When the user enter values, and the 
     * expression is not empty, it will return a new expression.
     * 
     * @return 
     */
    @Override
    public Expression get();

    public Expression getWithOutHistory();
    
}
