package org.gvsig.expressionevaluator.swing.spi;

import org.gvsig.expressionevaluator.swing.ElementFactory;
import org.gvsig.tools.ToolsLocator;
import org.gvsig.tools.i18n.I18nManager;

/**
 *
 * @author jjdelcerro
 */
public abstract class AbstractElementFactory implements ElementFactory {
    private final String name;
    private final String description;

    public AbstractElementFactory(
            String name,
            String description
        ) {
        I18nManager i18n = ToolsLocator.getI18nManager();
        this.name = name;
        this.description = i18n.getTranslation(description);
    }

    @Override
    public String getName() {
        return this.name;
    }

    @Override
    public String getDescription() {
        return this.description;
    }

    @Override
    public boolean isAutoload() {
        return false;
    }
    
}
