package org.gvsig.expressionevaluator.swing.impl;

import java.net.URL;
import org.cresques.ProjectionLibrary;
import org.gvsig.expressionevaluator.ExpressionEvaluatorLibrary;
import org.gvsig.expressionevaluator.swing.ExpressionEvaluatorSwingLibrary;
import org.gvsig.expressionevaluator.swing.ExpressionEvaluatorSwingLocator;
import org.gvsig.fmap.geom.GeometryLibrary;
import org.gvsig.tools.ToolsLibrary;
import org.gvsig.tools.library.AbstractLibrary;
import org.gvsig.tools.library.LibraryException;
import org.gvsig.tools.swing.api.ToolsSwingLocator;
import org.gvsig.tools.swing.icontheme.IconTheme;

public class ExpressionEvaluatorSwingLibraryImpl extends AbstractLibrary {

    @Override
    public void doRegistration() {
        registerAsImplementationOf(ExpressionEvaluatorSwingLibrary.class);
        require(ToolsLibrary.class);
        require(ProjectionLibrary.class);
        require(GeometryLibrary.class);
        require(ExpressionEvaluatorLibrary.class);
    }

    @Override
    protected void doInitialize() throws LibraryException {
        ExpressionEvaluatorSwingLocator.registerManager(DefaultExpressionEvaluatorSwingManager.class);
    }

    @Override
    protected void doPostInitialize() throws LibraryException {
        String[][] iconNames = new String[][] {
            new String[] { "picker", "picker-expression" },
            new String[] { "element", "expressionbuilder-element-constant" },
            new String[] { "element", "expressionbuilder-element-function" },
            new String[] { "element", "expressionbuilder-element-function-sql" },
            new String[] { "element", "expressionbuilder-element-group" },
            new String[] { "element", "expressionbuilder-element" },
            new String[] { "action", "common-filter" },
            new String[] { "action", "expressionbuilder-insert-text" },
            new String[] { "action", "common-sortdown" },
            new String[] { "action", "common-sortup" },
            new String[] { "action", "expressionbuilder-history" },
            new String[] { "action", "expressionbuilder-bookmarks" },
            new String[] { "action", "expressionbuilder-time-limit" }
        };
        IconTheme theme = ToolsSwingLocator.getIconThemeManager().getCurrent();
        for (String[] icon : iconNames) {
            URL url = this.getClass().getResource(icon[1]+".png");
            theme.registerDefault("ExpressionBuilder", icon[0], icon[1], null, url);
        }
        
    }
}

