/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.gvsig.expressionevaluator.swing.impl.elements;

import java.util.Comparator;
import java.util.Objects;
import org.gvsig.expressionevaluator.swing.Element.ConstantElement;
import org.gvsig.expressionevaluator.swing.ExpressionBuilderConfig;
import org.gvsig.expressionevaluator.swing.impl.Utils;
import org.gvsig.expressionevaluator.swing.spi.AbstractElement;
import org.gvsig.tools.ToolsLocator;
import org.gvsig.tools.i18n.I18nManager;
import org.gvsig.tools.util.LabeledValue;

/**
 *
 * @author jjdelcerro
 */
public class DefaultConstantValueElement
        extends AbstractElement
        implements ConstantElement {

    private final String label;

    public DefaultConstantValueElement(Object value, String label, String description) {
        super(Objects.toString(value,""),  value, "expressionbuilder-element-constant");
        if( label == null ) {
            this.label = Objects.toString(value,"");
        } else {
            this.label = label;
        }
    }

    @Override
    public String getLabel() {
        return this.label;
    }

    @Override
    public String getRenderedValue() {
        return " "+Utils.repr(this.getValue())+" ";
    }

    @Override
    public String getDescription() {
        I18nManager i18n = ToolsLocator.getI18nManager();

        StringBuilder html = new StringBuilder();
        html.append("<html>\n");
        Object theValue = this.getValue();
        if (theValue == null) {
            html.append("<b>").append(i18n.getTranslation("_Constant")).append("</b><br>\n<br>\n");
            html.append("<b>").append(i18n.getTranslation("_Value")).append("</b> NULL<br>\n");
        } else {
            html.append("<b>").append(i18n.getTranslation("_Constant")).append("</b><br>\n<br>\n");
            html.append("<b>").append(i18n.getTranslation("_Value")).append("</b> ").append(Utils.repr(theValue)).append("<br>\n");
            html.append("<b>").append(i18n.getTranslation("_Type")).append("</b> ").append(theValue.getClass().getSimpleName()).append("<br>\n");
        }
        html.append("</html>\n");
        return html.toString();
    }

    @Override
    public int compareTo(Object other) {
        if( !(other instanceof LabeledValue) ) {
            return super.compareTo(other);
        }
        Comparator comparator = Utils.naturalComparator();
        return comparator.compare(this.getValue(), ((LabeledValue)other).getValue());
    }

}
