/**
 * gvSIG. Desktop Geographic Information System.
 *
 * Copyright (C) 2007-2013 gvSIG Association.
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 3 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 51
 * Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 *
 * For any additional information, do not hesitate to contact us at info AT
 * gvsig.com, or visit our website www.gvsig.com.
 */
package org.gvsig.installer.swing.api.execution;

import org.gvsig.installer.swing.api.wizard.InstallerWizardPanel;

public interface InstallWizardPanel
        extends
        InstallerWizardPanel {

    public void setSkipSelectBundleWizardPage(boolean skip);
    
    public boolean getSkipSelectBundleWizardPage();
    
    /**
     * Set if the TypicalOrAdvanced wizard page can be show.
     *
     * @param skip True skip the TypicalOrAdvanced wizard.
     */
    public void setSkipTypicalOrAdvancedWizardPage(boolean skip);

    /**
     * To know if the TypicalOrAdvanced wizard page show.
     *
     * @return True skip the TypicalOrAdvanced wizard.
     */
    public boolean getSkipTypicalOrAdvancedWizardPage();

    public PackageFilter getPackageFilter();

    public void setPackageFilter(PackageFilter filter);
    
    public void setSelectDefaultPackages(boolean isActivated);

    public boolean getSelectDefaultPackages();    
}
