/**
 * gvSIG. Desktop Geographic Information System.
 *
 * Copyright (C) 2007-2013 gvSIG Association.
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 3 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 51
 * Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 *
 * For any additional information, do not hesitate to contact us at info AT
 * gvsig.com, or visit our website www.gvsig.com.
 */
package org.gvsig.installer.swing.impl.execution;

import java.util.List;
import org.gvsig.gui.beans.wizard.WizardPanel;

import org.gvsig.installer.lib.api.PackageInfo;
import org.gvsig.installer.lib.api.execution.InstallPackageService;
import org.gvsig.installer.lib.api.execution.InstallPackageServiceException;
import org.gvsig.installer.swing.api.execution.InstallWizardPanel;
import org.gvsig.installer.swing.impl.execution.panel.SelectBundlesPanel;

public interface InstallWizardPanel_ext
        extends
        InstallWizardPanel, WizardPanel {

    /**
     * If this method is selected the first window of the wizard is not visible
     * and the installation process takes the installers form the default
     * directory.
     *
     * @throws InstallPackageServiceException if there an error reading the
     * default directory.
     */
    public void installFromDefaultDirectory()
            throws InstallPackageServiceException;

    /**
     * @return the installerExecutionService
     */
    public InstallPackageService getInstallerExecutionService();

    /**
     * @return the installersToInstall
     */
    public List<PackageInfo> getPackagesToInstall();

    public SelectBundlesPanel getBundlesPanel();
    
    public String getTranslation(String key);

    public void setSkipSelectPackagesWizardPage(boolean skip);
    
    public boolean getSkipSelectPackagesWizardPage();
}
