package org.gvsig.installer.swing.impl.execution.panel.filters;

import org.gvsig.installer.swing.api.execution.PackageFilter;
import java.util.ArrayList;
import java.util.List;
import org.gvsig.installer.lib.api.PackageInfo;


public class AndFilter implements PackageFilter {
    private final List<PackageFilter> filters;

    public AndFilter() {
        this.filters = new ArrayList<>();
    }
    
    public AndFilter add(PackageFilter filter) {
        if( filter == null ) {
            return this;
        }
        this.filters.add(filter);
        return this;
    }

    @Override
    public boolean match(PackageInfo pkg) {
        for (PackageFilter filter : filters) {
            if( !filter.match(pkg) ) {
                return false;
            }
        }
        return true;
    }    
}
