/**
 * gvSIG. Desktop Geographic Information System.
 *
 * Copyright (C) 2007-2013 gvSIG Association.
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 3 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 51
 * Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 *
 * For any additional information, do not hesitate to contact us at info AT
 * gvsig.com, or visit our website www.gvsig.com.
 */
/*
 * AUTHORS (In addition to CIT):
 * 2010 {Prodevelop}   {Task}
 */
package org.gvsig.installer.swing.impl.execution.wizard;

import java.util.List;

import javax.swing.JPanel;

import org.gvsig.gui.beans.wizard.panel.NotContinueWizardException;
import org.gvsig.gui.beans.wizard.panel.OptionPanel;
import org.gvsig.installer.swing.api.SwingInstallerManager.UrlAndLabel;
import org.gvsig.installer.swing.impl.execution.InstallWizardPanel_ext;
import org.gvsig.installer.swing.impl.execution.panel.SelectBundlesPanel;

public class SelectBundlesWizardPage extends SelectBundlesPanel implements
        OptionPanel {

    private static final long serialVersionUID = -3694039665800882085L;
    private final InstallWizardPanel_ext wizardPanel;

    public SelectBundlesWizardPage(
            InstallWizardPanel_ext wizardPanel,
            List<UrlAndLabel> defaultDownloadURL) {
        super(defaultDownloadURL, wizardPanel.getInstallFolder());
        this.wizardPanel = wizardPanel;
    }

    @Override
    public JPanel getJPanel() {
        return this;
    }

    @Override
    public String getPanelTitle() {
        return wizardPanel.getTranslation("_select_installation_source");
    }

    @Override
    public void lastPanel() {
    }

    @Override
    public void nextPanel() throws NotContinueWizardException {
    }

    @Override
    public void updatePanel() {
        if (wizardPanel.getSkipSelectBundleWizardPage() && this.isNextButtonEnabled()) {
            wizardPanel.skip();
            return;
        }
        wizardPanel.setBackButtonEnabled(false);
        wizardPanel.setNextButtonEnabled(isNextButtonEnabled());
    }

    @Override
    protected void checkNextButtonEnabled() {
        if( wizardPanel!=null ) {
            wizardPanel.setNextButtonEnabled(isNextButtonEnabled());
        }
    }

}
