/**
 * gvSIG. Desktop Geographic Information System.
 *
 * Copyright (C) 2007-2013 gvSIG Association.
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 3 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 51
 * Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 *
 * For any additional information, do not hesitate to contact us at info AT
 * gvsig.com, or visit our website www.gvsig.com.
 */
package org.gvsig.installer.swing.impl.execution.wizard;

import java.io.File;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import java.util.zip.ZipFile;

import javax.swing.JPanel;
import org.gvsig.gui.beans.wizard.panel.NotContinueWizardException;
import org.gvsig.gui.beans.wizard.panel.OptionPanel;
import org.gvsig.installer.swing.impl.execution.InstallWizardPanel_ext;
import org.gvsig.installer.swing.impl.execution.panel.TypicalOrAdvancedPanel;

/**
 * @author gvSIG Team
 * @version $Id$
 *
 */
public class TypicalOrAdvancedWizardPage extends TypicalOrAdvancedPanel implements
        OptionPanel {

    private static final long serialVersionUID = -7151675399781722322L;

    private final InstallWizardPanel_ext wizardPanel;

    public TypicalOrAdvancedWizardPage(
            InstallWizardPanel_ext wizardPanel) {
        super();
        this.wizardPanel = wizardPanel;
    }

    @Override
    public JPanel getJPanel() {
        return this;
    }

    @Override
    public String getPanelTitle() {
        return wizardPanel.getTranslation("_select_installation_mode");
    }

    @Override
    public void lastPanel() {
    }

    @Override
    public void nextPanel() throws NotContinueWizardException {
        if (!wizardPanel.getSkipTypicalOrAdvancedWizardPage()) {
            wizardPanel.setSkipSelectPackagesWizardPage(!isAdvancedModeSelected());
        }
    }

    @Override
    public void updatePanel() {
        boolean enableTypicalMode = false;
        File packages = new File(wizardPanel.getInstallFolder(),"package.gvspks");
        if( packages.exists() ) {
            try {
                ZipFile z = new ZipFile(packages);
                if( z.getEntry("defaultPackages")!=null ) {
                    enableTypicalMode = true;
                }
            } catch (IOException ex) {
            }
        }
        setEnableTypicalMode(enableTypicalMode);
        if (wizardPanel.getSkipTypicalOrAdvancedWizardPage()) {
            wizardPanel.skip();
        }

    }
}
