package org.gvsig.svgsupport;

import java.io.File;
import java.io.IOException;
import java.net.URL;
import org.gvsig.tools.util.Callable;
import org.gvsig.tools.util.ToolsUtilLocator;


public class DefaultSVGSupportManager implements SVGSupportManager {

    @Override
    public SVGRenderer createRenderer() {
        SVGRenderer renderer = new DefaultSVGRenderer();
        return renderer;
    }

    @Override
    public SVGRenderer createRenderer(URL url) throws IOException {
        SVGRenderer renderer = new DefaultSVGRenderer();
        renderer.setSource(url);
        return renderer;
    }

    @Override
    public SVGRenderer createRenderer(File file) throws IOException {
        SVGRenderer renderer = new DefaultSVGRenderer();
        renderer.setSource(file);
        return renderer;
    }
	
    public static class registerSVGSupportManager implements Callable {
        @Override
		public Object call() throws Exception {
            ToolsUtilLocator.registerSVGSupportManager(DefaultSVGSupportManager.class);        
			return Boolean.TRUE;
		}
	}    
    
}
