/**
 * gvSIG. Desktop Geographic Information System.
 *
 * Copyright (C) 2007-2013 gvSIG Association.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 3
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301, USA.
 *
 * For any additional information, do not hesitate to contact us
 * at info AT gvsig.com, or visit our website www.gvsig.com.
 */
package org.gvsig.app.gui.styling;

import java.awt.Color;

import javax.swing.JComboBox;


/**
 * Creates a JComboBox where the user has the option to select different
 * colors.
 */
public class JComboBoxColorScheme extends JComboBox {
	/**
	 * 
	 */
	private static final long serialVersionUID = -749998859270723991L;
    protected final ColorSchemeSelector colorSchemaSelector;

    public JComboBoxColorScheme(boolean interpolateValues) {
        super();
        this.colorSchemaSelector = new ColorSchemeSelector(this, interpolateValues);
    }

	public Color[] getSelectedColors() {
        return this.colorSchemaSelector.getSelectedColors();
    }

    public void setSelectedColors(Color[] colors) {
        this.colorSchemaSelector.setSelectedColors(colors);
    }
	
}
