package org.gvsig.temporarystorage;

import org.gvsig.tools.locator.AbstractLocator;
import org.gvsig.tools.locator.LocatorException;


public class TemporaryStorageLocator extends AbstractLocator {

    private static final String LOCATOR_NAME = "TemporaryStorageLocator";

    public static final String MANAGER_NAME = "TemporaryStorageManager";

    private static final String MANAGER_DESCRIPTION = "TemporaryStorage of gvSIG";

    /**
     * Unique instance.
     */
    private static final TemporaryStorageLocator instance = new TemporaryStorageLocator();

    /**
     * Return the singleton instance.
     *
     * @return the singleton instance
     */
    public static TemporaryStorageLocator getInstance() {
        return instance;
    }

    /**
     * Returns the Locator name.
     *
     * @return String containing the locator name.
     */
    @Override
    public String getLocatorName() {
        return LOCATOR_NAME;
    }

    public static TemporaryStorageManager getTemporaryStorageManager() throws LocatorException {
        return (TemporaryStorageManager) getInstance().get(MANAGER_NAME);
    }

    public static void registerManager(Class clazz) {
        getInstance().register(MANAGER_NAME, MANAGER_DESCRIPTION, clazz);
    }

    public static void registerDefaultManager(Class clazz) {
        getInstance().registerDefault(MANAGER_NAME, MANAGER_DESCRIPTION, clazz);
    }

}
