package org.gvsig.temporarystorage.impl;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import org.gvsig.temporarystorage.TemporaryStorageGroup;
import org.gvsig.temporarystorage.TemporaryStorageManager;

public class DefaultTemporaryStorageManager implements TemporaryStorageManager {

    private final Map<String,TemporaryStorageGroup> groups; 
    
    public DefaultTemporaryStorageManager() {
        this.groups = new HashMap<>();
    }
    
    @Override
    public TemporaryStorageGroup get(String groupName) {
        return this.groups.get(groupName);
    }

    @Override
    public boolean contains(String groupName) {
        return this.groups.containsKey(groupName);
    }

    @Override
    public TemporaryStorageGroup create(String groupName) {
        return this.create(groupName, Object.class);
    }

    @Override
    public TemporaryStorageGroup create(String groupName, Class classOfElements) {
        TemporaryStorageGroup group = this.groups.get(groupName);
        if( group!=null ) {
            return group;
        }
        group = new DefaultTemporaryStorageGroup(groupName, classOfElements);
        this.groups.put(groupName, group);
        return group;
    }

    @Override
    public Iterator<TemporaryStorageGroup> iterator() {
        return this.groups.values().iterator();
    }

    @Override
    public boolean remove(String groupName) {
        return this.groups.remove(groupName)!=null;
    }

}
