package org.gvsig.timesupport.impl.coercion;

import java.util.Locale;
import org.gvsig.timesupport.RelativeInstant;
import org.gvsig.timesupport.RelativeInterval;
import org.gvsig.tools.dataTypes.CoercionException;
import org.gvsig.tools.dataTypes.DataTypesManager.Coercion;
import org.gvsig.tools.dataTypes.DataTypesManager.CoercionWithLocale;

/**
 *
 * @author jjdelcerro
 */
public class CoerceToDate implements CoercionWithLocale{

 
    public CoerceToDate() {
    }

    @Override
    public Object coerce(Object o) throws CoercionException {
        return this.coerce(o, null);
    }
    
    @Override
    public Object coerce(Object o, Locale locale) throws CoercionException {
        if( o instanceof RelativeInstant ) {
            return ((RelativeInstant) o).toDate();
        }
        if( o instanceof RelativeInterval ) {
            return ((RelativeInterval) o).getStart().toDate();
        }
        throw new CoercionException("Can't convert object to date");
    }
    
}
