package org.gvsig.app.project.documents.table.gui;

import com.jeta.open.i18n.I18NUtils;
import com.jgoodies.forms.layout.CellConstraints;
import com.jgoodies.forms.layout.FormLayout;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.ComponentOrientation;
import java.awt.Container;
import java.awt.Dimension;
import javax.swing.Box;
import javax.swing.ImageIcon;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;


public class GeneralTablePropertiesPageLayout extends JPanel
{
   JLabel lblName = new JLabel();
   JLabel lblDate = new JLabel();
   JLabel lblOwner = new JLabel();
   JLabel lblLocaleOfData = new JLabel();
   JLabel lblDataSource = new JLabel();
   JLabel lblComments = new JLabel();
   JLabel lblColumns = new JLabel();
   JPanel pnlColumns = new JPanel();
   JTextField txtName = new JTextField();
   JTextField txtDate = new JTextField();
   JTextField txtOwner = new JTextField();
   JComboBox cboLocaleOfData = new JComboBox();
   JTextField txtDataSource = new JTextField();
   JTextArea txtComments = new JTextArea();

   /**
    * Default constructor
    */
   public GeneralTablePropertiesPageLayout()
   {
      initializePanel();
   }

   /**
    * Adds fill components to empty cells in the first row and first column of the grid.
    * This ensures that the grid spacing will be the same as shown in the designer.
    * @param cols an array of column indices in the first row where fill components should be added.
    * @param rows an array of row indices in the first column where fill components should be added.
    */
   void addFillComponents( Container panel, int[] cols, int[] rows )
   {
      Dimension filler = new Dimension(10,10);

      boolean filled_cell_11 = false;
      CellConstraints cc = new CellConstraints();
      if ( cols.length > 0 && rows.length > 0 )
      {
         if ( cols[0] == 1 && rows[0] == 1 )
         {
            /** add a rigid area  */
            panel.add( Box.createRigidArea( filler ), cc.xy(1,1) );
            filled_cell_11 = true;
         }
      }

      for( int index = 0; index < cols.length; index++ )
      {
         if ( cols[index] == 1 && filled_cell_11 )
         {
            continue;
         }
         panel.add( Box.createRigidArea( filler ), cc.xy(cols[index],1) );
      }

      for( int index = 0; index < rows.length; index++ )
      {
         if ( rows[index] == 1 && filled_cell_11 )
         {
            continue;
         }
         panel.add( Box.createRigidArea( filler ), cc.xy(1,rows[index]) );
      }

   }

   /**
    * Helper method to load an image file from the CLASSPATH
    * @param imageName the package and name of the file to load relative to the CLASSPATH
    * @return an ImageIcon instance with the specified image file
    * @throws IllegalArgumentException if the image resource cannot be loaded.
    */
   public ImageIcon loadImage( String imageName )
   {
      try
      {
         ClassLoader classloader = getClass().getClassLoader();
         java.net.URL url = classloader.getResource( imageName );
         if ( url != null )
         {
            ImageIcon icon = new ImageIcon( url );
            return icon;
         }
      }
      catch( Exception e )
      {
         e.printStackTrace();
      }
      throw new IllegalArgumentException( "Unable to load image: " + imageName );
   }

   /**
    * Method for recalculating the component orientation for 
    * right-to-left Locales.
    * @param orientation the component orientation to be applied
    */
   public void applyComponentOrientation( ComponentOrientation orientation )
   {
      // Not yet implemented...
      // I18NUtils.applyComponentOrientation(this, orientation);
      super.applyComponentOrientation(orientation);
   }

   public JPanel createPanel()
   {
      JPanel jpanel1 = new JPanel();
      FormLayout formlayout1 = new FormLayout("FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:GROW(1.0),FILL:4DLU:NONE","CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,FILL:DEFAULT:GROW(0.1),CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,FILL:DEFAULT:GROW(0.9),CENTER:2DLU:NONE");
      CellConstraints cc = new CellConstraints();
      jpanel1.setLayout(formlayout1);

      lblName.setName("lblName");
      lblName.setText("Name");
      jpanel1.add(lblName,cc.xy(2,2));

      lblDate.setName("lblDate");
      lblDate.setText("Date");
      jpanel1.add(lblDate,cc.xy(2,4));

      lblOwner.setName("lblOwner");
      lblOwner.setText("Owner");
      jpanel1.add(lblOwner,cc.xy(2,6));

      lblLocaleOfData.setName("lblLocaleOfData");
      lblLocaleOfData.setText("Locale");
      jpanel1.add(lblLocaleOfData,cc.xy(2,8));

      lblDataSource.setName("lblDataSource");
      lblDataSource.setText("Data source");
      jpanel1.add(lblDataSource,cc.xy(2,10));

      lblComments.setName("lblComments");
      lblComments.setText("Coments");
      jpanel1.add(lblComments,cc.xy(2,12));

      lblColumns.setName("lblColumns");
      lblColumns.setText("Columns");
      jpanel1.add(lblColumns,cc.xy(2,16));

      pnlColumns.setName("pnlColumns");
      jpanel1.add(pnlColumns,cc.xywh(2,18,3,1));

      txtName.setName("txtName");
      jpanel1.add(txtName,cc.xy(4,2));

      txtDate.setName("txtDate");
      jpanel1.add(txtDate,cc.xy(4,4));

      txtOwner.setName("txtOwner");
      jpanel1.add(txtOwner,cc.xy(4,6));

      cboLocaleOfData.setName("cboLocaleOfData");
      jpanel1.add(cboLocaleOfData,cc.xy(4,8));

      txtDataSource.setBackground(new Color(236,233,216));
      txtDataSource.setEditable(false);
      txtDataSource.setName("txtDataSource");
      jpanel1.add(txtDataSource,cc.xy(4,10));

      txtComments.setName("txtComments");
      JScrollPane jscrollpane1 = new JScrollPane();
      jscrollpane1.setViewportView(txtComments);
      jscrollpane1.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
      jscrollpane1.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
      jpanel1.add(jscrollpane1,cc.xywh(2,14,3,1));

      addFillComponents(jpanel1,new int[]{ 1,2,3,4,5 },new int[]{ 1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19 });
      return jpanel1;
   }

   /**
    * Initializer
    */
   protected void initializePanel()
   {
      setLayout(new BorderLayout());
      add(createPanel(), BorderLayout.CENTER);
   }


}
