package org.gvsig.app.gui.preferencespage.dal;

import javax.swing.ImageIcon;
import javax.swing.JPanel;
import org.apache.commons.lang3.StringUtils;
import org.gvsig.andami.IconThemeHelper;
import org.gvsig.andami.preferences.IPreference;
import org.gvsig.andami.preferences.StoreException;
import org.gvsig.expressionevaluator.ExpressionEvaluatorLocator;
import org.gvsig.tools.ToolsLocator;
import org.gvsig.tools.i18n.I18nManager;
import org.gvsig.tools.swing.api.ToolsSwingLocator;
import org.gvsig.tools.swing.api.ToolsSwingManager;


@SuppressWarnings("UseSpecificCatch")
public class DALPage extends DALView implements IPreference {

    //
    // The class DALView can extend from AbstractPreferencePage, not JPanel,
    // if recreate it from the GUI builder change te class declaration to:
    //    public abstract class DALView extends AbstractPreferencePage

    private ImageIcon icon;
    private static final long serialVersionUID = -1592454009494400591L;
    public static String id = DALPage.class.getName();

    public DALPage() {
        setParentID("org.gvsig.coreplugin.preferences.general.GeneralPage");
        icon = IconThemeHelper.getImageIcon("dal-preferences");
        initComponents();
    }

    @Override
    public boolean isResizeable() {
        return true;
    }
    
    private void initComponents() {
//        EvaluatorFactory factory;
//        
//        factory = new SQLJEPEvaluatorFactory();
//        this.cboDALEvaluator.addItem(new ListElement<>(factory.getName(), factory));
//        factory = DALLocator.getDataManager().createEvaluatorFactory();
//        this.cboDALEvaluator.addItem(new ListElement<>(factory.getName(), factory));
//        this.cboDALEvaluator.setSelectedIndex(0);
        this.cboDALEvaluator.setEnabled(false);

        this.translateAll();
    }

    private void translateAll() {
        ToolsSwingManager manager = ToolsSwingLocator.getToolsSwingManager();

        manager.translate(lblDALEvaluator);
    }
    
    @Override
    public void storeValues() throws StoreException {
//        ListElement<EvaluatorFactory> n = (ListElement<EvaluatorFactory>) this.cboDALEvaluator.getSelectedItem();
//        if( n!=null ) {
//            DataManager dataManager = DALLocator.getDataManager();
//            dataManager.registerDefaultEvaluator(n.getValue());
//        }
        String s = this.txtAccuracy.getText();
        if( !StringUtils.isEmpty(s) ) {
            try {
                double accuracy = Double.parseDouble(s);
                ExpressionEvaluatorLocator.getManager().setAccuracy(accuracy);
            } catch(Exception ex) {
                throw new StoreException("Incorrect accuracy value.");
            }
        }
    }

    @Override
    public void setChangesApplied() {
    }

    @Override
    public String getID() {
        return id;
    }

    @Override
    public String getTitle() {
        I18nManager i18nManager = ToolsLocator.getI18nManager();
        return i18nManager.getTranslation("_Data_access_services");
    }

    @Override
    public JPanel getPanel() {
        return this;
    }

    @Override
    public void initializeValues() {
    }

    @Override
    public void initializeDefaults() {
    }

    @Override
    public ImageIcon getIcon() {
        return this.icon;
    }

    @Override
    public boolean isValueChanged() {
        return true;
    }
   
}
