package org.gvsig.app.project.documents.gui.projectpanel;

import com.jeta.forms.components.separator.TitledSeparator;
import com.jeta.open.i18n.I18NUtils;
import com.jgoodies.forms.layout.CellConstraints;
import com.jgoodies.forms.layout.FormLayout;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.ComponentOrientation;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import javax.swing.Box;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextField;


public class ProjectDocumentsPanelPageView extends JPanel
{
   TitledSeparator lblDocumentTypes = new TitledSeparator();
   TitledSeparator lblDocument = new TitledSeparator();
   TitledSeparator lblSessionProperties = new TitledSeparator();
   JList lstDocuments = new JList();
   JButton btnDocumentNew = new JButton();
   JButton btnDocumentOpen = new JButton();
   JButton btnDocumentRename = new JButton();
   JButton btnDocumentDelete = new JButton();
   JButton btnDocumentProperties = new JButton();
   JLabel lblSessionName = new JLabel();
   JLabel lblSavedIn = new JLabel();
   JLabel lblCreationDate = new JLabel();
   JTextField txtSessionName = new JTextField();
   JTextField txtSavedIn = new JTextField();
   JTextField txtCreationDate = new JTextField();
   JButton btnProjectProperties = new JButton();
   JPanel documentTypesContainer = new JPanel();

   /**
    * Default constructor
    */
   public ProjectDocumentsPanelPageView()
   {
      initializePanel();
   }

   /**
    * Main method for panel
    */
   public static void main(String[] args)
   {
      JFrame frame = new JFrame();
      frame.setSize(600, 400);
      frame.setLocation(100, 100);
      frame.getContentPane().add(new ProjectDocumentsPanelPageView());
      frame.setVisible(true);

      frame.addWindowListener( new WindowAdapter()
      {
         public void windowClosing( WindowEvent evt )
         {
            System.exit(0);
         }
      });
   }

   /**
    * Adds fill components to empty cells in the first row and first column of the grid.
    * This ensures that the grid spacing will be the same as shown in the designer.
    * @param cols an array of column indices in the first row where fill components should be added.
    * @param rows an array of row indices in the first column where fill components should be added.
    */
   void addFillComponents( Container panel, int[] cols, int[] rows )
   {
      Dimension filler = new Dimension(10,10);

      boolean filled_cell_11 = false;
      CellConstraints cc = new CellConstraints();
      if ( cols.length > 0 && rows.length > 0 )
      {
         if ( cols[0] == 1 && rows[0] == 1 )
         {
            /** add a rigid area  */
            panel.add( Box.createRigidArea( filler ), cc.xy(1,1) );
            filled_cell_11 = true;
         }
      }

      for( int index = 0; index < cols.length; index++ )
      {
         if ( cols[index] == 1 && filled_cell_11 )
         {
            continue;
         }
         panel.add( Box.createRigidArea( filler ), cc.xy(cols[index],1) );
      }

      for( int index = 0; index < rows.length; index++ )
      {
         if ( rows[index] == 1 && filled_cell_11 )
         {
            continue;
         }
         panel.add( Box.createRigidArea( filler ), cc.xy(1,rows[index]) );
      }

   }

   /**
    * Helper method to load an image file from the CLASSPATH
    * @param imageName the package and name of the file to load relative to the CLASSPATH
    * @return an ImageIcon instance with the specified image file
    * @throws IllegalArgumentException if the image resource cannot be loaded.
    */
   public ImageIcon loadImage( String imageName )
   {
      try
      {
         ClassLoader classloader = getClass().getClassLoader();
         java.net.URL url = classloader.getResource( imageName );
         if ( url != null )
         {
            ImageIcon icon = new ImageIcon( url );
            return icon;
         }
      }
      catch( Exception e )
      {
         e.printStackTrace();
      }
      throw new IllegalArgumentException( "Unable to load image: " + imageName );
   }

   /**
    * Method for recalculating the component orientation for 
    * right-to-left Locales.
    * @param orientation the component orientation to be applied
    */
   public void applyComponentOrientation( ComponentOrientation orientation )
   {
      // Not yet implemented...
      // I18NUtils.applyComponentOrientation(this, orientation);
      super.applyComponentOrientation(orientation);
   }

   public JPanel createPanel()
   {
      JPanel jpanel1 = new JPanel();
      FormLayout formlayout1 = new FormLayout("FILL:4DLU:NONE,FILL:DEFAULT:GROW(1.0),FILL:4DLU:NONE","CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,FILL:115PX:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,FILL:DEFAULT:GROW(1.0),CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE");
      CellConstraints cc = new CellConstraints();
      jpanel1.setLayout(formlayout1);

      lblDocumentTypes.setName("lblDocumentTypes");
      lblDocumentTypes.setText("tipos_de_documentos");
      jpanel1.add(lblDocumentTypes,cc.xy(2,2));

      lblDocument.setName("lblDocument");
      lblDocument.setText("documentos_existentes");
      jpanel1.add(lblDocument,cc.xy(2,6));

      lblSessionProperties.setName("lblSessionProperties");
      lblSessionProperties.setText("propiedades_sesion");
      jpanel1.add(lblSessionProperties,cc.xy(2,10));

      jpanel1.add(createPanel1(),cc.xy(2,8));
      jpanel1.add(createPanel3(),cc.xy(2,12));
      documentTypesContainer.setName("documentTypesContainer");
      jpanel1.add(documentTypesContainer,cc.xy(2,4));

      addFillComponents(jpanel1,new int[]{ 1,2,3 },new int[]{ 1,2,3,4,5,6,7,8,9,10,11,12,13 });
      return jpanel1;
   }

   public JPanel createPanel1()
   {
      JPanel jpanel1 = new JPanel();
      FormLayout formlayout1 = new FormLayout("FILL:DEFAULT:GROW(1.0),FILL:4DLU:NONE,FILL:DEFAULT:NONE","FILL:DEFAULT:GROW(1.0)");
      CellConstraints cc = new CellConstraints();
      jpanel1.setLayout(formlayout1);

      lstDocuments.setName("lstDocuments");
      JScrollPane jscrollpane1 = new JScrollPane();
      jscrollpane1.setViewportView(lstDocuments);
      jscrollpane1.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
      jscrollpane1.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
      jpanel1.add(jscrollpane1,cc.xy(1,1));

      jpanel1.add(createPanel2(),cc.xy(3,1));
      addFillComponents(jpanel1,new int[]{ 2,3 },new int[0]);
      return jpanel1;
   }

   public JPanel createPanel2()
   {
      JPanel jpanel1 = new JPanel();
      FormLayout formlayout1 = new FormLayout("FILL:DEFAULT:NONE","CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE");
      CellConstraints cc = new CellConstraints();
      jpanel1.setLayout(formlayout1);

      btnDocumentNew.setActionCommand("JButton");
      btnDocumentNew.setName("btnDocumentNew");
      btnDocumentNew.setText("nuevo");
      jpanel1.add(btnDocumentNew,cc.xy(1,1));

      btnDocumentOpen.setActionCommand("JButton");
      btnDocumentOpen.setName("btnDocumentOpen");
      btnDocumentOpen.setText("abrir");
      jpanel1.add(btnDocumentOpen,cc.xy(1,3));

      btnDocumentRename.setActionCommand("JButton");
      btnDocumentRename.setName("btnDocumentRename");
      btnDocumentRename.setText("renombrar");
      jpanel1.add(btnDocumentRename,cc.xy(1,5));

      btnDocumentDelete.setActionCommand("JButton");
      btnDocumentDelete.setName("btnDocumentDelete");
      btnDocumentDelete.setText("borrar");
      jpanel1.add(btnDocumentDelete,cc.xy(1,7));

      btnDocumentProperties.setActionCommand("JButton");
      btnDocumentProperties.setName("btnDocumentProperties");
      btnDocumentProperties.setText("propiedades");
      jpanel1.add(btnDocumentProperties,cc.xy(1,9));

      addFillComponents(jpanel1,new int[0],new int[]{ 2,4,6,8 });
      return jpanel1;
   }

   public JPanel createPanel3()
   {
      JPanel jpanel1 = new JPanel();
      FormLayout formlayout1 = new FormLayout("FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:GROW(1.0)","CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE");
      CellConstraints cc = new CellConstraints();
      jpanel1.setLayout(formlayout1);

      lblSessionName.setName("lblSessionName");
      lblSessionName.setText("nombre_sesion");
      jpanel1.add(lblSessionName,cc.xy(1,1));

      lblSavedIn.setName("lblSavedIn");
      lblSavedIn.setText("guardado");
      jpanel1.add(lblSavedIn,cc.xy(1,3));

      lblCreationDate.setName("lblCreationDate");
      lblCreationDate.setText("creation_date");
      jpanel1.add(lblCreationDate,cc.xy(1,5));

      txtSessionName.setBackground(new Color(236,233,216));
      txtSessionName.setEditable(false);
      txtSessionName.setName("txtSessionName");
      jpanel1.add(txtSessionName,cc.xy(3,1));

      txtSavedIn.setBackground(new Color(236,233,216));
      txtSavedIn.setEditable(false);
      txtSavedIn.setName("txtSavedIn");
      jpanel1.add(txtSavedIn,cc.xy(3,3));

      txtCreationDate.setBackground(new Color(236,233,216));
      txtCreationDate.setEditable(false);
      txtCreationDate.setName("txtCreationDate");
      jpanel1.add(txtCreationDate,cc.xy(3,5));

      btnProjectProperties.setActionCommand("JButton");
      btnProjectProperties.setName("btnProjectProperties");
      btnProjectProperties.setText("propiedades");
      jpanel1.add(btnProjectProperties,new CellConstraints(3,7,1,1,CellConstraints.RIGHT,CellConstraints.DEFAULT));

      addFillComponents(jpanel1,new int[]{ 2 },new int[]{ 2,4,6,7 });
      return jpanel1;
   }

   /**
    * Initializer
    */
   protected void initializePanel()
   {
      setLayout(new BorderLayout());
      add(createPanel(), BorderLayout.CENTER);
   }


}
