package org.gvsig.app.project.documents.view.expressionevaluator.savedpoints;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;
import org.apache.commons.lang3.tuple.Pair;
import org.gvsig.expressionevaluator.Function;
import org.gvsig.expressionevaluator.swing.Element;
import org.gvsig.expressionevaluator.swing.Element.GroupElement;
import org.gvsig.expressionevaluator.swing.spi.AbstractElement;
import org.gvsig.fmap.geom.primitive.Point;
import org.gvsig.temporarystorage.TemporaryStorageGroup;
import org.gvsig.temporarystorage.TemporaryStorageLocator;
import org.gvsig.temporarystorage.TemporaryStorageManager;
import org.gvsig.tools.ToolsLocator;

/**
 *
 * @author jjdelcerro
 */
public class SavedPointsElement
        extends AbstractElement
        implements GroupElement {

    private class PointEntryElement
            extends AbstractElement
            implements ConstantElement {

        public PointEntryElement(Object value, String name) {
            super(name, value, "expressionbuilder-element-constant");
        }

    }

    private final List<Element> childs;

    public SavedPointsElement() {
        super(
                "SavedPoints",
                ToolsLocator.getI18nManager().getTranslation("Saved points"), 
                "view-query-coordinate-capture"
        );

        TemporaryStorageManager manager = TemporaryStorageLocator.getTemporaryStorageManager();
        TemporaryStorageGroup storage = manager.create("Points", Point.class);

        this.childs = new ArrayList<>();
        for (Pair<String, Object> entry : storage.asList()) {
            ConstantElement e = new PointEntryElement(entry.getValue(),entry.getKey());
            this.childs.add(e);
        }
    }

    @Override
    public Element get(int index) {
        return this.childs.get(index);
    }

    @Override
    public int size() {
        return this.childs.size();
    }

    @Override
    public Iterator<Element> iterator() {
        return this.childs.iterator();
    }

    @Override
    public void addElement(Element element) {
        this.childs.add(element);
    }

    @Override
    public void addElement(Function function) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public List<Element> getElements() {
        return this.childs;
    }

    @Override
    public Collection<Element> getValues() {
        return this.childs;
    }

}
