package org.gvsig.app.project.documents.view.expressionevaluator.viewcapturerectangle;

import com.jeta.open.i18n.I18NUtils;
import com.jgoodies.forms.layout.CellConstraints;
import com.jgoodies.forms.layout.FormLayout;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.ComponentOrientation;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Font;
import javax.swing.Box;
import javax.swing.ButtonGroup;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTextField;


public class ViewCaptureRectanglePanelView extends JPanel
{
   JLabel lblConstantRectangle = new JLabel();
   JTextField txtBox = new JTextField();
   JLabel lblValue = new JLabel();
   JButton btnToggleCapture = new JButton();
   JLabel lblDescription = new JLabel();
   JLabel lblCaptureAPointFromCurrentView = new JLabel();
   JLabel lblUseWktOrWkb = new JLabel();
   JRadioButton rdoInsertAsWKT = new JRadioButton();
   ButtonGroup buttongroup1 = new ButtonGroup();
   JRadioButton rdoInsertAsWKB = new JRadioButton();
   JLabel lblUseGeometryOrText = new JLabel();
   JRadioButton rdoInsertAsGeometry = new JRadioButton();
   ButtonGroup buttongroup2 = new ButtonGroup();
   JRadioButton rdoInsertAsString = new JRadioButton();

   /**
    * Default constructor
    */
   public ViewCaptureRectanglePanelView()
   {
      initializePanel();
   }

   /**
    * Adds fill components to empty cells in the first row and first column of the grid.
    * This ensures that the grid spacing will be the same as shown in the designer.
    * @param cols an array of column indices in the first row where fill components should be added.
    * @param rows an array of row indices in the first column where fill components should be added.
    */
   void addFillComponents( Container panel, int[] cols, int[] rows )
   {
      Dimension filler = new Dimension(10,10);

      boolean filled_cell_11 = false;
      CellConstraints cc = new CellConstraints();
      if ( cols.length > 0 && rows.length > 0 )
      {
         if ( cols[0] == 1 && rows[0] == 1 )
         {
            /** add a rigid area  */
            panel.add( Box.createRigidArea( filler ), cc.xy(1,1) );
            filled_cell_11 = true;
         }
      }

      for( int index = 0; index < cols.length; index++ )
      {
         if ( cols[index] == 1 && filled_cell_11 )
         {
            continue;
         }
         panel.add( Box.createRigidArea( filler ), cc.xy(cols[index],1) );
      }

      for( int index = 0; index < rows.length; index++ )
      {
         if ( rows[index] == 1 && filled_cell_11 )
         {
            continue;
         }
         panel.add( Box.createRigidArea( filler ), cc.xy(1,rows[index]) );
      }

   }

   /**
    * Helper method to load an image file from the CLASSPATH
    * @param imageName the package and name of the file to load relative to the CLASSPATH
    * @return an ImageIcon instance with the specified image file
    * @throws IllegalArgumentException if the image resource cannot be loaded.
    */
   public ImageIcon loadImage( String imageName )
   {
      try
      {
         ClassLoader classloader = getClass().getClassLoader();
         java.net.URL url = classloader.getResource( imageName );
         if ( url != null )
         {
            ImageIcon icon = new ImageIcon( url );
            return icon;
         }
      }
      catch( Exception e )
      {
         e.printStackTrace();
      }
      throw new IllegalArgumentException( "Unable to load image: " + imageName );
   }

   /**
    * Method for recalculating the component orientation for 
    * right-to-left Locales.
    * @param orientation the component orientation to be applied
    */
   public void applyComponentOrientation( ComponentOrientation orientation )
   {
      // Not yet implemented...
      // I18NUtils.applyComponentOrientation(this, orientation);
      super.applyComponentOrientation(orientation);
   }

   public JPanel createPanel()
   {
      JPanel jpanel1 = new JPanel();
      FormLayout formlayout1 = new FormLayout("FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:GROW(1.0),FILL:4DLU:NONE","CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:4DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE");
      CellConstraints cc = new CellConstraints();
      jpanel1.setLayout(formlayout1);

      lblConstantRectangle.setFont(new Font("Dialog",Font.BOLD,11));
      lblConstantRectangle.setName("lblConstantRectangle");
      lblConstantRectangle.setText("_Constant_Rectangle");
      jpanel1.add(lblConstantRectangle,cc.xywh(2,2,3,1));

      txtBox.setBackground(new Color(236,233,216));
      txtBox.setEditable(false);
      txtBox.setName("txtBox");
      jpanel1.add(txtBox,cc.xywh(2,6,3,1));

      lblValue.setFont(new Font("Dialog",Font.BOLD,11));
      lblValue.setName("lblValue");
      lblValue.setText("_Value");
      jpanel1.add(lblValue,cc.xy(2,4));

      btnToggleCapture.setActionCommand("Toggle point capture");
      btnToggleCapture.setName("btnToggleCapture");
      btnToggleCapture.setText("_Start_capture");
      jpanel1.add(btnToggleCapture,new CellConstraints(4,8,1,1,CellConstraints.RIGHT,CellConstraints.DEFAULT));

      lblDescription.setFont(new Font("Dialog",Font.BOLD,11));
      lblDescription.setName("lblDescription");
      lblDescription.setText("_Description");
      jpanel1.add(lblDescription,cc.xy(2,10));

      lblCaptureAPointFromCurrentView.setName("lblCaptureAPointFromCurrentView");
      lblCaptureAPointFromCurrentView.setText("_Capture_a_point_from_current_view");
      jpanel1.add(lblCaptureAPointFromCurrentView,cc.xywh(2,11,3,1));

      jpanel1.add(createPanel1(),cc.xywh(2,13,3,1));
      addFillComponents(jpanel1,new int[]{ 1,2,3,4,5 },new int[]{ 1,2,3,4,5,6,7,8,9,10,11,12,13,14 });
      return jpanel1;
   }

   public JPanel createPanel1()
   {
      JPanel jpanel1 = new JPanel();
      FormLayout formlayout1 = new FormLayout("FILL:DEFAULT:GROW(1.0),FILL:8DLU:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE","CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE");
      CellConstraints cc = new CellConstraints();
      jpanel1.setLayout(formlayout1);

      lblUseWktOrWkb.setName("lblUseWktOrWkb");
      lblUseWktOrWkb.setText("_Use_WKT_or_WKB");
      jpanel1.add(lblUseWktOrWkb,cc.xywh(2,1,2,1));

      rdoInsertAsWKT.setActionCommand("Insert as WKT");
      rdoInsertAsWKT.setName("rdoInsertAsWKT");
      rdoInsertAsWKT.setOpaque(false);
      rdoInsertAsWKT.setText("_Insert_as_WKT");
      buttongroup1.add(rdoInsertAsWKT);
      jpanel1.add(rdoInsertAsWKT,cc.xy(3,2));

      rdoInsertAsWKB.setActionCommand("Insert as WKB");
      rdoInsertAsWKB.setName("rdoInsertAsWKB");
      rdoInsertAsWKB.setOpaque(false);
      rdoInsertAsWKB.setSelected(true);
      rdoInsertAsWKB.setText("_Insert_as_WKB");
      buttongroup1.add(rdoInsertAsWKB);
      jpanel1.add(rdoInsertAsWKB,cc.xy(3,4));

      lblUseGeometryOrText.setName("lblUseGeometryOrText");
      lblUseGeometryOrText.setText("_Use_Geometry_or_Text");
      jpanel1.add(lblUseGeometryOrText,cc.xywh(2,6,2,1));

      rdoInsertAsGeometry.setActionCommand("Insert as geometry");
      rdoInsertAsGeometry.setName("rdoInsertAsGeometry");
      rdoInsertAsGeometry.setOpaque(false);
      rdoInsertAsGeometry.setSelected(true);
      rdoInsertAsGeometry.setText("_Insert_as_Geometry");
      buttongroup2.add(rdoInsertAsGeometry);
      jpanel1.add(rdoInsertAsGeometry,cc.xy(3,8));

      rdoInsertAsString.setActionCommand("Insert as String");
      rdoInsertAsString.setName("rdoInsertAsString");
      rdoInsertAsString.setOpaque(false);
      rdoInsertAsString.setText("_Insert_as_Text");
      buttongroup2.add(rdoInsertAsString);
      jpanel1.add(rdoInsertAsString,cc.xy(3,10));

      addFillComponents(jpanel1,new int[]{ 1,3,4 },new int[]{ 1,2,3,4,5,6,7,8,9,10 });
      return jpanel1;
   }

   /**
    * Initializer
    */
   protected void initializePanel()
   {
      setLayout(new BorderLayout());
      add(createPanel(), BorderLayout.CENTER);
   }


}
