package org.gvsig.app.project.symboltables;

import org.gvsig.expressionevaluator.ExpressionEvaluatorLocator;
import org.gvsig.expressionevaluator.ExpressionEvaluatorManager;
import org.gvsig.expressionevaluator.SymbolTable;
import org.gvsig.expressionevaluator.spi.AbstractSymbolTableFactory;

/**
 *
 * @author jjdelcerro
 */
public class ProjectSymbolTableFactory extends AbstractSymbolTableFactory {

    private SymbolTable symbolTable;
    
    public ProjectSymbolTableFactory() {
        super(ProjectSymbolTable.NAME, true);
    }
    
    @Override
    public SymbolTable create(Object... args) {
        if( this.symbolTable==null ) {
            this.symbolTable = new ProjectSymbolTable();
        }
        return this.symbolTable;
    }

    public static void selfRegister() {
        ExpressionEvaluatorManager manager = ExpressionEvaluatorLocator.getManager();
        manager.registerSymbolTable(new ProjectSymbolTableFactory());
    }
    
}
