package org.gvsig.app.project.symboltables.functionPanels.area;

import org.gvsig.app.project.symboltables.functionPanels.perimeter.PerimeterAditionalPanelFactory;
import org.gvsig.app.project.symboltables.functionPanels.perimeter.PerimeterAditionalPanel;
import org.gvsig.app.project.symboltables.ProjectSymbolTable;
import org.gvsig.expressionevaluator.swing.ExpressionEvaluatorSwingLocator;
import org.gvsig.expressionevaluator.swing.ExpressionEvaluatorSwingManager;
import org.gvsig.expressionevaluator.swing.FunctionAdditionalPanelFactory;
import org.gvsig.expressionevaluator.swing.JExpressionBuilder;
import org.gvsig.expressionevaluator.swing.spi.AbstractFunctionAdditionalPanelFactory;
import org.gvsig.tools.swing.api.Component;

/**
 *
 * @author jjdelcerro
 */
public class AreaAditionalPanelFactory extends AbstractFunctionAdditionalPanelFactory {
    
    public AreaAditionalPanelFactory() {
        super(ProjectSymbolTable.AREA_NAME);
    }

    @Override
    public Component createAdditionalPanel(JExpressionBuilder expressionBuilder, Object... args) {
        Component p = new AreaAditionalPanel(expressionBuilder);
        return p;
    }

    public static void selfRegister() {
        ExpressionEvaluatorSwingManager manager = ExpressionEvaluatorSwingLocator.getManager();
        FunctionAdditionalPanelFactory factory = new AreaAditionalPanelFactory();
        manager.registerAdditionalPanel(factory);
    }
    
}
