package org.gvsig.app.project.symboltables.functionPanels.firstlayerfeature;

import com.jeta.open.i18n.I18NUtils;
import com.jgoodies.forms.layout.CellConstraints;
import com.jgoodies.forms.layout.FormLayout;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.ComponentOrientation;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Font;
import javax.swing.Box;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.border.EmptyBorder;


public class FirstLayerFeatureAditionalPanelView extends JPanel
{
   JComboBox cboViews = new JComboBox();
   JComboBox cboLayers = new JComboBox();
   JComboBox cboFields = new JComboBox();
   JTextField txtPreview = new JTextField();
   JButton btnInsertFunction = new JButton();
   JTextField txtFilter = new JTextField();
   JButton btnFilter = new JButton();
   JPanel btnOrder = new JPanel();
   JTextField txtOrder = new JTextField();
   JButton jbutton1 = new JButton();

   /**
    * Default constructor
    */
   public FirstLayerFeatureAditionalPanelView()
   {
      initializePanel();
   }

   /**
    * Adds fill components to empty cells in the first row and first column of the grid.
    * This ensures that the grid spacing will be the same as shown in the designer.
    * @param cols an array of column indices in the first row where fill components should be added.
    * @param rows an array of row indices in the first column where fill components should be added.
    */
   void addFillComponents( Container panel, int[] cols, int[] rows )
   {
      Dimension filler = new Dimension(10,10);

      boolean filled_cell_11 = false;
      CellConstraints cc = new CellConstraints();
      if ( cols.length > 0 && rows.length > 0 )
      {
         if ( cols[0] == 1 && rows[0] == 1 )
         {
            /** add a rigid area  */
            panel.add( Box.createRigidArea( filler ), cc.xy(1,1) );
            filled_cell_11 = true;
         }
      }

      for( int index = 0; index < cols.length; index++ )
      {
         if ( cols[index] == 1 && filled_cell_11 )
         {
            continue;
         }
         panel.add( Box.createRigidArea( filler ), cc.xy(cols[index],1) );
      }

      for( int index = 0; index < rows.length; index++ )
      {
         if ( rows[index] == 1 && filled_cell_11 )
         {
            continue;
         }
         panel.add( Box.createRigidArea( filler ), cc.xy(1,rows[index]) );
      }

   }

   /**
    * Helper method to load an image file from the CLASSPATH
    * @param imageName the package and name of the file to load relative to the CLASSPATH
    * @return an ImageIcon instance with the specified image file
    * @throws IllegalArgumentException if the image resource cannot be loaded.
    */
   public ImageIcon loadImage( String imageName )
   {
      try
      {
         ClassLoader classloader = getClass().getClassLoader();
         java.net.URL url = classloader.getResource( imageName );
         if ( url != null )
         {
            ImageIcon icon = new ImageIcon( url );
            return icon;
         }
      }
      catch( Exception e )
      {
         e.printStackTrace();
      }
      throw new IllegalArgumentException( "Unable to load image: " + imageName );
   }

   /**
    * Method for recalculating the component orientation for 
    * right-to-left Locales.
    * @param orientation the component orientation to be applied
    */
   public void applyComponentOrientation( ComponentOrientation orientation )
   {
      // Not yet implemented...
      // I18NUtils.applyComponentOrientation(this, orientation);
      super.applyComponentOrientation(orientation);
   }

   public JPanel createPanel()
   {
      JPanel jpanel1 = new JPanel();
      FormLayout formlayout1 = new FormLayout("FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:GROW(1.0),FILL:4DLU:NONE","CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,FILL:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:4DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE");
      CellConstraints cc = new CellConstraints();
      jpanel1.setLayout(formlayout1);

      JLabel jlabel1 = new JLabel();
      jlabel1.setFont(new Font("Tahoma",Font.BOLD,11));
      jlabel1.setText("FistLayerFeature");
      jpanel1.add(jlabel1,cc.xywh(2,2,3,1));

      cboViews.setName("cboViews");
      jpanel1.add(cboViews,cc.xy(4,4));

      JLabel jlabel2 = new JLabel();
      jlabel2.setText("_View");
      jpanel1.add(jlabel2,cc.xy(2,4));

      JLabel jlabel3 = new JLabel();
      jlabel3.setText("_Layer");
      jpanel1.add(jlabel3,cc.xy(2,6));

      cboLayers.setName("cboLayers");
      jpanel1.add(cboLayers,cc.xy(4,6));

      JLabel jlabel4 = new JLabel();
      jlabel4.setText("_Field");
      jpanel1.add(jlabel4,cc.xy(2,8));

      cboFields.setName("cboFields");
      jpanel1.add(cboFields,cc.xy(4,8));

      JLabel jlabel5 = new JLabel();
      jlabel5.setText("_Filter");
      jpanel1.add(jlabel5,cc.xy(2,10));

      JLabel jlabel6 = new JLabel();
      jlabel6.setText("_Order");
      jpanel1.add(jlabel6,cc.xy(2,12));

      txtPreview.setBackground(new Color(236,233,216));
      txtPreview.setEditable(false);
      txtPreview.setName("txtPreview");
      jpanel1.add(txtPreview,cc.xy(4,14));

      btnInsertFunction.setActionCommand("_Insert_function");
      btnInsertFunction.setName("btnInsertFunction");
      btnInsertFunction.setText("_Insert_function");
      jpanel1.add(btnInsertFunction,new CellConstraints(4,16,1,1,CellConstraints.RIGHT,CellConstraints.DEFAULT));

      jpanel1.add(createPanel1(),cc.xy(4,10));
      jpanel1.add(createbtnOrder(),cc.xy(4,12));
      addFillComponents(jpanel1,new int[]{ 1,2,3,4,5 },new int[]{ 1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17 });
      return jpanel1;
   }

   public JPanel createPanel1()
   {
      JPanel jpanel1 = new JPanel();
      FormLayout formlayout1 = new FormLayout("FILL:DEFAULT:GROW(1.0),FILL:4DLU:NONE,FILL:DEFAULT:NONE","CENTER:DEFAULT:NONE");
      CellConstraints cc = new CellConstraints();
      jpanel1.setLayout(formlayout1);

      txtFilter.setName("txtFilter");
      jpanel1.add(txtFilter,cc.xy(1,1));

      btnFilter.setName("btnFilter");
      EmptyBorder emptyborder1 = new EmptyBorder(2,2,2,2);
      btnFilter.setBorder(emptyborder1);
      jpanel1.add(btnFilter,cc.xy(3,1));

      addFillComponents(jpanel1,new int[]{ 2 },new int[0]);
      return jpanel1;
   }

   public JPanel createbtnOrder()
   {
      btnOrder.setName("btnOrder");
      FormLayout formlayout1 = new FormLayout("FILL:DEFAULT:GROW(1.0),FILL:4DLU:NONE,FILL:DEFAULT:NONE","CENTER:DEFAULT:NONE");
      CellConstraints cc = new CellConstraints();
      btnOrder.setLayout(formlayout1);

      txtOrder.setEnabled(false);
      txtOrder.setName("txtOrder");
      btnOrder.add(txtOrder,cc.xy(1,1));

      jbutton1.setActionCommand("...");
      jbutton1.setEnabled(false);
      jbutton1.setText("...");
      EmptyBorder emptyborder1 = new EmptyBorder(2,2,2,2);
      jbutton1.setBorder(emptyborder1);
      btnOrder.add(jbutton1,cc.xy(3,1));

      addFillComponents(btnOrder,new int[]{ 2 },new int[0]);
      return btnOrder;
   }

   /**
    * Initializer
    */
   protected void initializePanel()
   {
      setLayout(new BorderLayout());
      add(createPanel(), BorderLayout.CENTER);
   }


}
