package org.gvsig.fmap.dal.serverexplorer.filesystem.swing;

import java.io.File;

import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.TableCellRenderer;

import org.cresques.cts.IProjection;

import org.gvsig.fmap.dal.DataStore;
import org.gvsig.fmap.dal.DataStoreParameters;
import org.gvsig.fmap.dal.serverexplorer.filesystem.FilesystemStoreParameters;
import org.gvsig.fmap.mapcontext.MapContext;
import org.gvsig.tools.ToolsLocator;
import org.gvsig.tools.i18n.I18nManager;


/**
 * @author fdiaz
 *
 */
public class FilesystemStoreParameteresCellRenderer extends DefaultTableCellRenderer implements TableCellRenderer {

    /**
     *
     */
    private static final long serialVersionUID = 3360312241312140371L;

    MapContext mapContext;

    /**
     * @param mapContext
     */
    public FilesystemStoreParameteresCellRenderer(MapContext mapContext) {
        super();
        this.mapContext = mapContext;
    }


    @Override
    protected void setValue(Object value) {
        FilesystemStoreParameters params = (FilesystemStoreParameters)value;

        I18nManager i18nManager = ToolsLocator.getI18nManager();

        File file = params.getFile();

        StringBuilder builder = new StringBuilder();
        builder.append("<html><p>");
        builder.append("<b>");
        builder.append(file.getName());
        builder.append("</b></p>");//<font size=+2>");
        builder.append("<p>");
        builder.append("<font size=-2>");

        IProjection projection = null;
        if(params instanceof DataStoreParameters){
            DataStoreParameters parameters = (DataStoreParameters)params;
            if(parameters.getDynClass().getDynField(DataStore.METADATA_CRS)!=null){
                projection = (IProjection) parameters.getDynValue(DataStore.METADATA_CRS);
                String crsText;
                if (mapContext != null) {
                    if (projection == null) {
                        crsText =
                            i18nManager.getTranslation("_Unknown_CRS_so_assumed") + " " + mapContext.getProjection().getAbrev();

                    } else {
                        if (!projection.equals(mapContext.getProjection())) {
                            crsText =
                                projection.getAbrev() + " (" + i18nManager.getTranslation("_reprojected_on_the_fly") + ") ";
                        } else {
                            crsText = projection.getAbrev();
                        }
                    }
                    builder.append(crsText);
                }
            };
        }
        builder.append("</font></p>");
        builder.append("</html>");

        super.setValue(builder.toString());
    }

}
