/* gvSIG. Desktop Geographic Information System.
 *
 * Copyright  2007-2017 gvSIG Association
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301, USA.
 *
 * For any additional information, do not hesitate to contact us
 * at info AT gvsig.com, or visit our website www.gvsig.com.
 */
package org.gvsig.fmap.dal.serverexplorer.filesystem.swing;

import java.awt.BorderLayout;
import java.awt.Component;

import javax.swing.JCheckBox;
import javax.swing.JPanel;
import javax.swing.JTable;
import javax.swing.table.TableCellRenderer;

/**
 * @author fdiaz
 *
 */
public class TiledCellRenderer extends JPanel implements TableCellRenderer {

    /**
     *
     */
    private static final long serialVersionUID = 3875203211014535067L;

    private JCheckBox checkBox;

    /**
     *
     */
    public TiledCellRenderer() {
        super(new BorderLayout()); //new FlowLayout(FlowLayout.CENTER, 0, 0));
        checkBox = new JCheckBox();
        checkBox.setOpaque(false);
        checkBox.setHorizontalAlignment(JCheckBox.CENTER);
        add(checkBox, BorderLayout.CENTER);
    }

    public Component getTableCellRendererComponent(JTable table, Object value, boolean isSelected, boolean hasFocus,
        int row, int column) {
        if (isSelected) {
            checkBox.setForeground(table.getSelectionForeground());
            checkBox.setBackground(table.getSelectionBackground());
            setForeground(table.getSelectionForeground());
            setBackground(table.getSelectionBackground());
        } else {
            checkBox.setForeground(table.getForeground());
            checkBox.setBackground(table.getBackground());
            setForeground(table.getForeground());
            setBackground(table.getBackground());
        }

        boolean booleanValue = ((Boolean) value).booleanValue();
        boolean cellEditable = table.getModel().isCellEditable(row, column);
        if(!cellEditable && !booleanValue){
            checkBox.setVisible(false);
        } else {
            checkBox.setVisible(true);
        }
        checkBox.setEnabled(cellEditable);
        checkBox.setSelected((value != null && booleanValue));
        return this;
    }
}
