/**
 * gvSIG. Desktop Geographic Information System.
 *
 * Copyright (C) 2007-2013 gvSIG Association.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 3
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301, USA.
 *
 * For any additional information, do not hesitate to contact us
 * at info AT gvsig.com, or visit our website www.gvsig.com.
 */
package org.gvsig.export.app.extension;

import javax.swing.Action;
import org.gvsig.andami.IconThemeHelper;
import org.gvsig.andami.plugins.Extension;
import org.gvsig.app.ApplicationLocator;
import org.gvsig.app.ApplicationManager;
import org.gvsig.app.project.documents.table.TableDocument;
import org.gvsig.app.project.documents.table.TableManager;
import org.gvsig.export.app.extension.FeatureStoreSearchExportAction.FeatureStoreSearchExportActionFactory;
import org.gvsig.fmap.dal.swing.DALSwingLocator;
import org.gvsig.fmap.dal.swing.DataSwingManager;
import org.gvsig.fmap.dal.swing.searchpanel.FeatureStoreSearchPanel;

/**
 * @author gvSIG Team
 * @version $Id$
 * 
 */
public class ExportTableExtension extends Extension {

    @Override
    public void initialize() {
        IconThemeHelper.registerIcon("action", "table-export", this);
    }

    @Override
    public void postInitialize() {
        super.postInitialize();
        FeatureStoreSearchExportActionFactory.selfRegister();
    }
    
    @Override
    public void execute(String actionCommand) {
        ApplicationManager application = ApplicationLocator.getManager();
        TableDocument tableDoc = (TableDocument) application.getActiveDocument(TableManager.TYPENAME);
        if( tableDoc == null ) {
            return;
        }
        ExportTable exportTable = new ExportTable();
        exportTable.showExport(tableDoc.getStore(), null);
    }

    @Override
    public boolean isEnabled() {
        return true;
    }

    @Override
    public boolean isVisible() {
        ApplicationManager application = ApplicationLocator.getManager();
        TableDocument tableDoc = (TableDocument) application.getActiveDocument(TableManager.TYPENAME);
        return tableDoc != null;
    }
}
