/**
 * gvSIG. Desktop Geographic Information System.
 *
 * Copyright (C) 2007-2013 gvSIG Association.
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 3 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 51
 * Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 *
 * For any additional information, do not hesitate to contact us at info AT
 * gvsig.com, or visit our website www.gvsig.com.
 */
package org.gvsig.geodb;

import org.gvsig.andami.IconThemeHelper;
import org.gvsig.andami.PluginsLocator;
import org.gvsig.andami.PluginsManager;
import org.gvsig.andami.plugins.Extension;
import org.gvsig.app.ApplicationLocator;
import org.gvsig.app.ApplicationManager;
import org.gvsig.app.extension.AddLayer;
import org.gvsig.fmap.dal.DALLocator;
import org.gvsig.fmap.dal.DataManager;
import org.gvsig.tools.dynobject.DynObject;
import org.gvsig.fmap.dal.DataServerExplorerPool;

/**
 * This extension adds the export-to-oracle button.
 *
 * @author jldominguez
 *
 */
public class ExtDB_Spatial extends Extension {

    @Override
    public void initialize() {
        IconThemeHelper.registerIcon("geodb", "geodb-connection-add", this);
        IconThemeHelper.registerIcon("geodb", "geodb-advanced-properties", this);
        IconThemeHelper.registerIcon("geodb", "geodb-get-view-extent", this);
        
        DataManager dataManager = DALLocator.getDataManager();
        PluginsManager manager = PluginsLocator.getManager();
        DynObject pluginProperties = manager.getPlugin(ExtDB_Spatial.class).getPluginProperties();
        if( pluginProperties.getDynValue("explorersPool")==null ) {
            pluginProperties.setDynValue("explorersPool", dataManager.getDataServerExplorerPool());
        } else {
            dataManager.setDataServerExplorerPool((DataServerExplorerPool)pluginProperties.getDynValue("explorersPool"));
        }
        
    }

    @Override
    public void execute(String actionCommand) {
        //do nothing
    }

    @Override
    public boolean isEnabled() {
        return isVisible();
    }

    @Override
    public boolean isVisible() {
        return false;
    }

    @Override
    public void postInitialize() {
        super.postInitialize();

//        ApplicationLocator.getManager().registerAddTableWizard("DB","DB Tables", WizardDB.class);
//        AddLayer.addWizard(WizardVectorialDB.class);

        ApplicationLocator.getManager().registerAddTableWizard("DB","DB Tables", WizardDBTabular.class);
        AddLayer.addWizard(WizardDBVectorial.class);

    }

}
