package org.gvsig.geodb;

import java.util.ArrayList;
import java.util.List;
import org.gvsig.app.ApplicationLocator;
import org.gvsig.app.ApplicationManager;
import org.gvsig.app.prepareAction.PrepareContextView;
import org.gvsig.app.project.documents.table.TableDocument;
import org.gvsig.app.project.documents.table.TableManager;
import org.gvsig.fmap.dal.DALLocator;
import org.gvsig.fmap.dal.DataManager;
import org.gvsig.fmap.dal.feature.FeatureStore;
import org.gvsig.fmap.dal.store.db.DBStoreParameters;

/**
 *
 * @author jjdelcerro
 */
public class WizardDBTabular extends AbstractWizardDB {

    public WizardDBTabular() {
        super();
    }

    @Override
    protected boolean requireGeometry() {
        return false;
    }

    @Override
    public Object executeWizard() {
        DataManager man = DALLocator.getDataManager();
        ApplicationManager application = ApplicationLocator.getManager();

        List<TableDocument> tabledocs= new ArrayList<>();
        for ( TableInfo tableInfo : this.getTablesInformation() ) {
            if (!tableInfo.isSelected()) {
                continue;
            }
            DBStoreParameters storeParams = tableInfo.getParameters();
            FeatureStore store;
            try {
                store = (FeatureStore) man.openStore(
                        storeParams.getDataStoreName(), 
                        storeParams
                );
            } catch (Exception e) {
                LOGGER.warn("Can't open store ", e);
                return null;
            }
            TableDocument document = (TableDocument) application.getProjectManager().createDocument(
                    TableManager.TYPENAME, 
                    tableInfo.getDocumentName()
            );
            document.setStore(store);
            tabledocs.add(document);
        }
        return tabledocs;
    }
    
    
}
