package org.gvsig.geodb.databaseworkspace;

import com.jeta.open.i18n.I18NUtils;
import com.jgoodies.forms.layout.CellConstraints;
import com.jgoodies.forms.layout.FormLayout;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.ComponentOrientation;
import java.awt.Container;
import java.awt.Dimension;
import javax.swing.Box;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;


public class WorkspaceConfigurationPanelView extends JPanel
{
   JButton btnCreateResourceTable = new JButton();
   JButton btnDropResourceTable = new JButton();
   JButton btnSearchResourceTable = new JButton();
   JButton btnShowResourceTable = new JButton();
   JComboBox cboConnections = new JComboBox();
   JButton btnAddConnection = new JButton();
   JButton btnShowRepositoryTable = new JButton();
   JButton btnSearchRepositoryTable = new JButton();
   JButton btnCreateRepositoryTable = new JButton();
   JButton btnDropRepositoryTable = new JButton();
   JButton btnRepositoryAddTable = new JButton();
   JButton btnConnectToRepository = new JButton();
   JButton btnCreateConfigurationTable = new JButton();
   JButton btnDropConfigurationTable = new JButton();
   JButton btnSearchConfigurationTable = new JButton();
   JButton btnShowConfigurationTable = new JButton();
   JTextField txtStoresRepositoryId = new JTextField();
   JTextField txtStoresRepositoryLabel = new JTextField();

   /**
    * Default constructor
    */
   public WorkspaceConfigurationPanelView()
   {
      initializePanel();
   }

   /**
    * Adds fill components to empty cells in the first row and first column of the grid.
    * This ensures that the grid spacing will be the same as shown in the designer.
    * @param cols an array of column indices in the first row where fill components should be added.
    * @param rows an array of row indices in the first column where fill components should be added.
    */
   void addFillComponents( Container panel, int[] cols, int[] rows )
   {
      Dimension filler = new Dimension(10,10);

      boolean filled_cell_11 = false;
      CellConstraints cc = new CellConstraints();
      if ( cols.length > 0 && rows.length > 0 )
      {
         if ( cols[0] == 1 && rows[0] == 1 )
         {
            /** add a rigid area  */
            panel.add( Box.createRigidArea( filler ), cc.xy(1,1) );
            filled_cell_11 = true;
         }
      }

      for( int index = 0; index < cols.length; index++ )
      {
         if ( cols[index] == 1 && filled_cell_11 )
         {
            continue;
         }
         panel.add( Box.createRigidArea( filler ), cc.xy(cols[index],1) );
      }

      for( int index = 0; index < rows.length; index++ )
      {
         if ( rows[index] == 1 && filled_cell_11 )
         {
            continue;
         }
         panel.add( Box.createRigidArea( filler ), cc.xy(1,rows[index]) );
      }

   }

   /**
    * Helper method to load an image file from the CLASSPATH
    * @param imageName the package and name of the file to load relative to the CLASSPATH
    * @return an ImageIcon instance with the specified image file
    * @throws IllegalArgumentException if the image resource cannot be loaded.
    */
   public ImageIcon loadImage( String imageName )
   {
      try
      {
         ClassLoader classloader = getClass().getClassLoader();
         java.net.URL url = classloader.getResource( imageName );
         if ( url != null )
         {
            ImageIcon icon = new ImageIcon( url );
            return icon;
         }
      }
      catch( Exception e )
      {
         e.printStackTrace();
      }
      throw new IllegalArgumentException( "Unable to load image: " + imageName );
   }

   /**
    * Method for recalculating the component orientation for 
    * right-to-left Locales.
    * @param orientation the component orientation to be applied
    */
   public void applyComponentOrientation( ComponentOrientation orientation )
   {
      // Not yet implemented...
      // I18NUtils.applyComponentOrientation(this, orientation);
      super.applyComponentOrientation(orientation);
   }

   public JPanel createPanel()
   {
      JPanel jpanel1 = new JPanel();
      FormLayout formlayout1 = new FormLayout("FILL:4DLU:NONE,FILL:DEFAULT:GROW(1.0),FILL:4DLU:NONE","CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:4DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:4DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:4DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE");
      CellConstraints cc = new CellConstraints();
      jpanel1.setLayout(formlayout1);

      JLabel jlabel1 = new JLabel();
      jlabel1.setText("Resources");
      jpanel1.add(jlabel1,cc.xy(2,5));

      JLabel jlabel2 = new JLabel();
      jlabel2.setText("Tables repository");
      jpanel1.add(jlabel2,cc.xy(2,9));

      JLabel jlabel3 = new JLabel();
      jlabel3.setText("Configuraction");
      jpanel1.add(jlabel3,cc.xy(2,15));

      JLabel jlabel4 = new JLabel();
      jlabel4.setText("Connection");
      jpanel1.add(jlabel4,cc.xy(2,1));

      jpanel1.add(createPanel1(),cc.xy(2,7));
      jpanel1.add(createPanel2(),cc.xy(2,3));
      jpanel1.add(createPanel3(),cc.xy(2,13));
      jpanel1.add(createPanel4(),cc.xy(2,17));
      jpanel1.add(createPanel5(),cc.xy(2,11));
      addFillComponents(jpanel1,new int[]{ 1,3 },new int[]{ 1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18 });
      return jpanel1;
   }

   public JPanel createPanel1()
   {
      JPanel jpanel1 = new JPanel();
      FormLayout formlayout1 = new FormLayout("FILL:DEFAULT:GROW(1.0),FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:NONE","CENTER:DEFAULT:NONE");
      CellConstraints cc = new CellConstraints();
      jpanel1.setLayout(formlayout1);

      btnCreateResourceTable.setActionCommand("Create");
      btnCreateResourceTable.setName("btnCreateResourceTable");
      btnCreateResourceTable.setText("Create");
      jpanel1.add(btnCreateResourceTable,cc.xy(4,1));

      btnDropResourceTable.setActionCommand("Create");
      btnDropResourceTable.setName("btnDropResourceTable");
      btnDropResourceTable.setText("Drop");
      jpanel1.add(btnDropResourceTable,cc.xy(2,1));

      btnSearchResourceTable.setActionCommand("Edit");
      btnSearchResourceTable.setName("btnSearchResourceTable");
      btnSearchResourceTable.setText("Search");
      jpanel1.add(btnSearchResourceTable,cc.xy(6,1));

      btnShowResourceTable.setActionCommand("Edit");
      btnShowResourceTable.setName("btnShowResourceTable");
      btnShowResourceTable.setText("Show form");
      jpanel1.add(btnShowResourceTable,cc.xy(8,1));

      addFillComponents(jpanel1,new int[]{ 1,3,5,7 },new int[]{ 1 });
      return jpanel1;
   }

   public JPanel createPanel2()
   {
      JPanel jpanel1 = new JPanel();
      FormLayout formlayout1 = new FormLayout("FILL:DEFAULT:GROW(1.0),FILL:4DLU:NONE,FILL:DEFAULT:NONE","CENTER:DEFAULT:NONE");
      CellConstraints cc = new CellConstraints();
      jpanel1.setLayout(formlayout1);

      cboConnections.setName("cboConnections");
      jpanel1.add(cboConnections,cc.xy(1,1));

      btnAddConnection.setActionCommand("...");
      btnAddConnection.setName("btnAddConnection");
      btnAddConnection.setText("...");
      jpanel1.add(btnAddConnection,cc.xy(3,1));

      addFillComponents(jpanel1,new int[]{ 2 },new int[0]);
      return jpanel1;
   }

   public JPanel createPanel3()
   {
      JPanel jpanel1 = new JPanel();
      FormLayout formlayout1 = new FormLayout("FILL:DEFAULT:GROW(1.0),FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:NONE","CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE");
      CellConstraints cc = new CellConstraints();
      jpanel1.setLayout(formlayout1);

      btnShowRepositoryTable.setActionCommand("Edit");
      btnShowRepositoryTable.setName("btnShowRepositoryTable");
      btnShowRepositoryTable.setText("Show form");
      jpanel1.add(btnShowRepositoryTable,cc.xy(10,1));

      btnSearchRepositoryTable.setActionCommand("Edit");
      btnSearchRepositoryTable.setName("btnSearchRepositoryTable");
      btnSearchRepositoryTable.setText("Search");
      jpanel1.add(btnSearchRepositoryTable,cc.xy(8,1));

      btnCreateRepositoryTable.setActionCommand("Create");
      btnCreateRepositoryTable.setName("btnCreateRepositoryTable");
      btnCreateRepositoryTable.setText("Create");
      jpanel1.add(btnCreateRepositoryTable,cc.xy(6,1));

      btnDropRepositoryTable.setActionCommand("Create");
      btnDropRepositoryTable.setName("btnDropRepositoryTable");
      btnDropRepositoryTable.setText("Drop");
      jpanel1.add(btnDropRepositoryTable,cc.xy(4,1));

      btnRepositoryAddTable.setActionCommand("Edit");
      btnRepositoryAddTable.setName("btnRepositoryAddTable");
      btnRepositoryAddTable.setText("Add table");
      jpanel1.add(btnRepositoryAddTable,cc.xy(8,3));

      btnConnectToRepository.setActionCommand("Connect");
      btnConnectToRepository.setName("btnConnectToRepository");
      btnConnectToRepository.setText("Connect");
      jpanel1.add(btnConnectToRepository,cc.xy(10,3));

      addFillComponents(jpanel1,new int[]{ 1,2,3,5,7,9 },new int[]{ 1,2,3 });
      return jpanel1;
   }

   public JPanel createPanel4()
   {
      JPanel jpanel1 = new JPanel();
      FormLayout formlayout1 = new FormLayout("FILL:DEFAULT:GROW(1.0),FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:NONE","CENTER:DEFAULT:NONE");
      CellConstraints cc = new CellConstraints();
      jpanel1.setLayout(formlayout1);

      btnCreateConfigurationTable.setActionCommand("Create");
      btnCreateConfigurationTable.setName("btnCreateConfigurationTable");
      btnCreateConfigurationTable.setText("Create");
      jpanel1.add(btnCreateConfigurationTable,cc.xy(4,1));

      btnDropConfigurationTable.setActionCommand("Create");
      btnDropConfigurationTable.setName("btnDropConfigurationTable");
      btnDropConfigurationTable.setText("Drop");
      jpanel1.add(btnDropConfigurationTable,cc.xy(2,1));

      btnSearchConfigurationTable.setActionCommand("Edit");
      btnSearchConfigurationTable.setName("btnSearchConfigurationTable");
      btnSearchConfigurationTable.setText("Search");
      jpanel1.add(btnSearchConfigurationTable,cc.xy(6,1));

      btnShowConfigurationTable.setActionCommand("Edit");
      btnShowConfigurationTable.setName("btnShowConfigurationTable");
      btnShowConfigurationTable.setText("Show form");
      jpanel1.add(btnShowConfigurationTable,cc.xy(8,1));

      addFillComponents(jpanel1,new int[]{ 1,3,5,7 },new int[]{ 1 });
      return jpanel1;
   }

   public JPanel createPanel5()
   {
      JPanel jpanel1 = new JPanel();
      FormLayout formlayout1 = new FormLayout("FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:GROW(1.0)","CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE");
      CellConstraints cc = new CellConstraints();
      jpanel1.setLayout(formlayout1);

      JLabel jlabel1 = new JLabel();
      jlabel1.setText("Id");
      jpanel1.add(jlabel1,cc.xy(1,1));

      JLabel jlabel2 = new JLabel();
      jlabel2.setText("Label");
      jpanel1.add(jlabel2,cc.xy(1,3));

      txtStoresRepositoryId.setBackground(new Color(236,233,216));
      txtStoresRepositoryId.setEditable(false);
      txtStoresRepositoryId.setName("txtStoresRepositoryId");
      jpanel1.add(txtStoresRepositoryId,cc.xy(3,1));

      txtStoresRepositoryLabel.setBackground(new Color(236,233,216));
      txtStoresRepositoryLabel.setEditable(false);
      txtStoresRepositoryLabel.setName("txtStoresRepositoryLabel");
      jpanel1.add(txtStoresRepositoryLabel,cc.xy(3,3));

      addFillComponents(jpanel1,new int[]{ 2 },new int[]{ 2 });
      return jpanel1;
   }

   /**
    * Initializer
    */
   protected void initializePanel()
   {
      setLayout(new BorderLayout());
      add(createPanel(), BorderLayout.CENTER);
   }


}
