package org.gvsig.geodb.databaseworkspace;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import org.apache.commons.lang3.StringUtils;
import org.gvsig.andami.IconThemeHelper;
import org.gvsig.andami.plugins.Extension;
import org.gvsig.tools.swing.api.ToolsSwingLocator;
import org.gvsig.tools.swing.api.windowmanager.Dialog;
import org.gvsig.tools.swing.api.windowmanager.WindowManager;
import org.gvsig.tools.swing.api.windowmanager.WindowManager_v2;

/**
 *
 * @author jjdelcerro
 */
public class WorkspaceExtension extends Extension {

    @Override
    public void initialize() {
        IconThemeHelper.registerIcon("action", "database-workspace-connect", this);
    }

    @Override
    public void execute(String actionCommand) {
        if( StringUtils.equalsIgnoreCase(actionCommand, "database-workspace-manage") ) {
            WindowManager winManager = ToolsSwingLocator.getWindowManager();
            WorkspaceConfigurationPanel panel = new WorkspaceConfigurationPanel();
            winManager.showWindow(
                    panel.asJComponent(), 
                    "Manage Dabatase workspace", 
                    WindowManager.MODE.WINDOW
            );
        } else if( StringUtils.equalsIgnoreCase(actionCommand, "database-workspace-connect") ) {
            WindowManager_v2 winManager = (WindowManager_v2) ToolsSwingLocator.getWindowManager();
            final ConnectToDatabaseWorkspacePanel panel = new ConnectToDatabaseWorkspacePanel();
            final Dialog dialog = winManager.createDialog(
                    panel.asJComponent(),
                    "Connect",
                    "Connect to database workspapce", 
                    WindowManager_v2.BUTTONS_OK_CANCEL
            );
            panel.setDialog(dialog);
            dialog.setButtonLabel(WindowManager_v2.BUTTONS_OK, "Connect");
            dialog.addActionListener(new ActionListener() {
                @Override
                public void actionPerformed(ActionEvent e) {
                    if( dialog.getAction() == WindowManager_v2.BUTTONS_OK ) {
                        panel.connect();
                    }
                }
            });
            dialog.show(WindowManager.MODE.WINDOW);
        }
    }

    @Override
    public boolean isEnabled() {
        return true;
    }

    @Override
    public boolean isVisible() {
        return true;
    }
    
}
